# JLD2

[![](https://img.shields.io/badge/docs-online-blue.svg)](https://JuliaIO.github.io/JLD2.jl/dev)
[![CI](https://github.com/JuliaIO/JLD2.jl/actions/workflows/ci.yml/badge.svg)](https://github.com/JuliaIO/JLD2.jl/actions/workflows/ci.yml)
[![codecov.io](https://codecov.io/github/JuliaIO/JLD2.jl/coverage.svg?branch=master)](https://codecov.io/github/JuliaIO/JLD2.jl?branch=master)
[![JLD2 Downloads](https://img.shields.io/badge/dynamic/json?url=http%3A%2F%2Fjuliapkgstats.com%2Fapi%2Fv1%2Fmonthly_downloads%2FJLD2&query=total_requests&suffix=%2Fmonth&label=Downloads)](http://juliapkgstats.com/pkg/JLD2)
[![Aqua QA](https://raw.githubusercontent.com/JuliaTesting/Aqua.jl/master/badge.svg)](https://github.com/JuliaTesting/Aqua.jl)


JLD2 is a package for the [julia programming language](https://julialang.org/) for saving and loading data.
Highlights include:

- Simple API for basic usage: `jldsave(filename; data)` and `load(filename, "data")`
- JLD2 can serialize complex nested structures out of the box.
- JLD2 files adhere to the HDF5 format specification making it compatible with HDF5 tooling
and H5 libraries in other languages. (Can also read HDF5 files.)
- It is fast. JLD2 uses the julia compiler to generate efficient code for serializing complex structures.
- Users may provide custom serialization procedures to control how data gets stored.
- JLD2 provides *upgrade* mechanisms for data structures that need post-processing on load (for example when the julia types have changed)

For details on usage see the [documentation](https://JuliaIO.github.io/JLD2.jl/dev).

# JLD2Bzip2.jl

Implements the bzip2 (compression) filter for [JLD2.jl](https://github.com/JuliaIO/JLD2.jl).

For more information see e.g.
[JLD2 Docs](https://juliaio.github.io/JLD2.jl/dev/)
[Using HDF5 Filters](https://hdfgroup.github.io/hdf5/develop/_h5_d__u_g.html#title6).

## Left over header message parsing that does not have a good place.

struct DataLayout
    version::UInt8
    storage_type::LayoutClass
    data_length::Int64
    data_offset::Int64
    dimensionality::UInt8
    chunk_indexing_type::UInt8 # only in version 4
    chunk_dimensions::Vector{UInt64} # only defined if dimensionality > 0
    DataLayout(version, storage_type, data_length, data_offset) = 
        new(version, storage_type, data_length, data_offset, 0, 0)
    DataLayout(version, storage_type, data_length, data_offset, dimensionality, chunk_indexing_type, chunk_dimensions) = 
        new(version, storage_type, data_length, data_offset, dimensionality, chunk_indexing_type, chunk_dimensions)
end

ischunked(dl::DataLayout) = dl.storage_type == LcChunked
DataLayout(f::JLD2.JLDFile, msg_::Hmessage) =
    DataLayout(f, HmWrap(HmDataLayout, msg_))

function DataLayout(f::JLD2.JLDFile, msg::HmWrap{HmDataLayout})
    version = msg.version::UInt8
    storage_type = msg.layout_class::LayoutClass
    rf = msg.data_address::RelOffset
    data_offset::Int64 = rf != UNDEFINED_ADDRESS ? fileoffset(f, rf) : typemax(Int64)
    if version == 4 || version == 3
        if storage_type == LcCompact
            data_length = Int64(msg.data_size)
            return DataLayout(version, storage_type, data_length, data_offset) 
        elseif storage_type == LcContiguous
            data_length = Int64(msg.data_size)
            return DataLayout(version, storage_type, data_length, data_offset) 
        elseif version == 4 && storage_type == LcChunked
            chunk_dimensions = Int[msg.dimensions...]
            chunk_indexing_type = msg.chunk_indexing_type
            chunk_indexing_type == 1 || throw(UnsupportedFeatureException("Unknown chunk indexing type"))
            data_length = Int64(msg.data_size)

            #filters = msg.filters#jlread(cio, UInt32)
            chunked_storage = true
            DataLayout(version, storage_type, data_length, data_offset, msg.dimensionality, msg.chunk_indexing_type, chunk_dimensions) 
        elseif version == 3 && storage_type == LcChunked
            data_length = Int64(msg.data_size)

            chunk_dimensions = Int[msg.dimensions[1:end-1]...] # drop element size as last dimension
            chunked_storage = true
            DataLayout(version, storage_type, data_length, data_offset, msg.dimensionality, 0, chunk_dimensions) 
        else
            throw(UnsupportedFeatureException("Unknown data layout"))
        end
    else
        throw(UnsupportedVersionException("Data layout message version $version is not supported"))
    end
end

import FileIO
using FileIO: File, @format_str

# Save all the key-value pairs in the dict as top-level variables of the JLD
function fileio_save(f::File{format"JLD2"}, dict::AbstractDict; kwargs...)
    jldopen(FileIO.filename(f), "w"; kwargs...) do file
        wsession = JLDWriteSession()
        for (k,v) in dict
            if isa(k, Symbol)
                @warn "you passed a key as a symbol instead of a string, it has been automatically converted"
            elseif !isa(k, AbstractString)
                throw(ArgumentError("keys must be strings (the names of variables), got $k"))
            end
            write(file, String(k), v, wsession)
        end
    end
end

# Or the names and values may be specified as alternating pairs
function fileio_save(f::File{format"JLD2"}, name::AbstractString, value, pairs...; kwargs...)
    if isodd(length(pairs)) || !isa(pairs[1:2:end], Tuple{Vararg{AbstractString}})
        throw(ArgumentError("arguments must be in name-value pairs"))
    end
    jldopen(FileIO.filename(f), "w"; kwargs...) do file
        wsession = JLDWriteSession()
        write(file, String(name), value, wsession)
        for i = 1:2:length(pairs)
            write(file, String(pairs[i]), pairs[i+1], wsession)
        end
    end
end

fileio_save(f::File{format"JLD2"}, value...; kwargs...) = error("must supply a name for each variable")


# load with just a filename returns a dictionary containing all the variables
function fileio_load(f::File{format"JLD2"}; nested::Bool=false, kwargs...)
    file = jldopen(FileIO.filename(f), "r"; kwargs...)
    try
        if nested
            return loadnesteddict(file)
        else
            return loadtodict!(Dict{String,Any}(), file)
        end
    finally
        close(file)
    end
end

# When called with explicitly requested variable names, return each one
function fileio_load(f::File{format"JLD2"}, varname::AbstractString; kwargs...)
    file = jldopen(FileIO.filename(f), "r"; kwargs...)
    try
        return load_data_or_dict(file, varname)
    finally
        close(file)
    end
end

fileio_load(f::File{format"JLD2"}, varnames::AbstractString...; kwargs...) =
    fileio_load(f, varnames; kwargs...)

function fileio_load(f::File{format"JLD2"}, varnames::Tuple{Vararg{AbstractString}}; kwargs...)
    file = jldopen(FileIO.filename(f), "r"; kwargs...)
    try
        return map(var -> load_data_or_dict(file, var),  varnames)
    finally
        close(file)
    end
end

const Initialized = Union{Type{Val{true}}, Type{Val{false}}}

const Pointers = Union{Ptr{Cvoid}, IndirectPointer}

struct OnDiskRepresentation{Offsets,JLTypes,H5Types, Size} end
odr_sizeof(::Nothing) = 0
odr_sizeof(x::DataType) = Core.sizeof(x)

struct UnknownType{T, P} end
struct Vlen{T}
    size::UInt32
    id::GlobalHeapID
end
odr_sizeof(::Type{T}) where {T<:Vlen} = 4 + jlsizeof(GlobalHeapID)

# Look up the corresponding committed datatype for a given type
macro lookup_committed(f, T)
    quote
        cdt = get($(esc(f)).jlh5type, $(esc(T)), nothing)
        cdt !== nothing && return cdt::CommittedDatatype
    end
end

using JLD2, Test

fn = joinpath(mktempdir(), "test.jld")
f = jldopen(fn, "w")
write(f, "/test_group_1/x1", 1)
@test !isempty(read(f, "test_group_1"))
write(f, "test_group_1/x2", 2)
write(f, "/test_group_2/x1", 3)
write(f, "test_group_3/x1", 4)
read(f, "test_group_3")["contained_group/x1"] = 5
JLD2.Group(f, "test_group_4")["x1"] = 6
JLD2.Group(read(f, "test_group_4"), "contained_group")["x1"] = 7
@test isempty(JLD2.Group(f, "empty_group"))
JLD2.Group(f, "group_with_one_group_child/empty_group")
@test !isempty(read(f, "group_with_one_group_child"))
@test_throws ArgumentError JLD2.Group(f, "test_group_4")
@test_throws ArgumentError write(f, "test_group_4/contained_group", 0)
@test !haskey(f, "path_that_does_not_exist")
@test !haskey(f, "/test_group_1/x1/path/that/does/not/exist")
@test !haskey(f["test_group_1"], "/test_group_1/x1/path/that/does/not/exist")
@test !haskey(f["test_group_1"], "x1/path/that/does/not/exist")
@test haskey(f, "/test_group_1/x1")
close(f)
f = jldopen(fn, "a")
@test haskey(f, "test_group_1")
@test haskey(f, "test_group_1/x1")

@test get(f, "path_that_does_not_exist", 2.0) == 2.0
@test get!(f, "path_created_by_get!", "x") == "x"
@test f["path_created_by_get!"] == "x"
@test get(JLD2.Group(f, "test_group_5"), "path_that_does_not_exist", 3.0) == 3.0
@test get!(f["test_group_5"], "path_created_by_get!", 4.0) == 4.0
@test f["test_group_5"]["path_created_by_get!"] == 4.0

# Test that the default element constructor is called only when necessary
# First, we'll access a group which *does* exist, so the default constructor is not called:
@test get(() -> error("this should not be called because the key exists"), f["test_group_5"], "path_created_by_get!") == 4.0

# Then we'll access a few keys that do not exist, and verify that the default
# constructor was called:
default_called = false
get(f, "path_that_does_not_exist") do
    global default_called
    default_called = true
end
@test default_called

default_called = false
get!(JLD2.Group(f, "test_group_6"), "path_created_by_get!") do
    global default_called
    default_called = true
end
@test default_called
close(f)

f = jldopen(fn, "r")
@test read(f, "/test_group_1/x1") == 1
@test read(f, "/test_group_1/x2") == 2
@test read(f, "/test_group_2/x1") == 3
@test read(f, "/test_group_3/x1") == 4
@test read(f, "/test_group_3/contained_group/x1") == 5
@test_throws KeyError read(f, "/test_group_3/contained_group/x2")
@test_throws KeyError read(f, "/test_group_3/contained_group/x2/oops")

@test read(f, "test_group_1/x1") == 1
@test read(f, "test_group_1/x2") == 2
@test read(f, "test_group_2/x1") == 3
@test read(f, "test_group_3/x1") == 4
@test read(f, "test_group_3/contained_group/x1") == 5

@test read(f, "test_group_1")["x1"]  == 1
@test read(f, "test_group_1")["x2"]  == 2
@test read(f, "test_group_2")["x1"]  == 3
@test read(f, "test_group_3")["x1"]  == 4
@test read(f, "test_group_3")["contained_group"]["x1"]  == 5

@test read(f, "test_group_1")["/test_group_2/x1"]  == 3
@test read(f, "test_group_3/contained_group")["x1"]  == 5
@test read(f, "test_group_3")["contained_group/x1"]  == 5

@test !isempty(read(f, "group_with_one_group_child"))
@test !isempty(read(f, "test_group_1"))
@test isempty(read(f, "empty_group"))
@test isempty(read(f, "group_with_one_group_child/empty_group"))

@test get(f, "path_that_does_not_exist", 1.0) == 1.0
@test get(f["test_group_5"], "path_that_does_not_exist", 1.0) == 1.0
@test f["test_group_5"]["path_created_by_get!"] == 4.0

# Throws an ArgumentError because the element doesn't exist and cannot
# be created for a read-only file:
@test_throws ArgumentError get!(f, "path_that_does_not_exist", 1.0)
@test_throws ArgumentError get!(f["test_group_5"], "path_that_does_not_exist", 1.0)
# Does not throw an ArgumentError because the element does exist:
@test get!(f["test_group_1"], "x1", 2) == 1

# Make sure printing doesn't error
show(IOBuffer(), f)
close(f)


# Test for non-default group size
@testset "Custom estimated Group size" begin
    fn = joinpath(mktempdir(), "test.jld2")

    # It is difficult to test the behaviour 
    # of non-default group allocation size
    # as results should always be independent of this.
    # Test against regressions by comparing to current number of allocated bytes.
    # This may need to be updated if the relevant code sections are changed.
    # Also test for persistence of the settings when loading a file again.

    # An empty group leaves has 151 bytes by default
    jldopen(fn, "w") do f
        JLD2.Group(f, "g")
    end
    jldopen(fn, "r") do f
        g = f["g"]
        chunk_length = g.last_chunk_checksum_offset - g.last_chunk_start_offset
        @test chunk_length == 151
    end

    # An empty group with non-default size allocates more space
    jldopen(fn, "w") do f
        g = JLD2.Group(f, "g"; est_num_entries=42, est_link_name_len=21)
        @test g.est_link_name_len == 21
        @test g.est_num_entries == 42
    end
    jldopen(fn, "r") do f
        g = f["g"]
        @test g.est_link_name_len == 21
        @test g.est_num_entries == 42
        chunk_length = g.last_chunk_checksum_offset - g.last_chunk_start_offset
        @test chunk_length == 1614
    end
end


# Test for Issue #307
@testset "Repeatedly appending to file" begin
    fn = joinpath(mktempdir(), "test.jld2")   
    for n = 1:25
        jldopen(fn, "a") do fid
            group = JLD2.Group(fid, string(n))
            group["result"] = 1
            @test keys(fid) == string.(1:n)
        end
    end
end


# Test for Base.keytype
@testset "Base.keytype" begin
    fn = joinpath(mktempdir(), "test.jld2")
    jldopen(fn, "w") do f
        @test Base.keytype(f) == String
        @test Base.keytype(f.root_group) == String
    end
end

# Test show method
@testset "Show a group / file" begin
    fn = joinpath(mktempdir(), "test.jld2")   
    f = jldopen(fn, "w")
    f["a"] = 1
    f["b"] = 2

    filestr = let
        io = IOBuffer()
        show(io, f)
        String(take!(io))
    end
    @test !(match(r"^JLDFile.*\(read/write\)$", filestr) === nothing)

    groupstr = let
        io = IOBuffer()
        show(io, f.root_group)
        String(take!(io))
    end
    @test groupstr == "JLD2.Group"


    groupstr = let
        io = IOBuffer()
        show(io, MIME("text/plain"), f.root_group)
        String(take!(io))
    end
    @test groupstr == "JLD2.Group\n ├─🔢 a\n └─🔢 b"

    close(f)      
end

using JLD2, FileIO, Test

fn = joinpath(mktempdir(), "test.jld2")

# test iotype fallback
#  no fallback specified → throw method error
@test_throws MethodError JLD2.openfile(ArgumentError, fn, true, true, false, nothing)
#  fallback specified → switch to fallback
fh = JLD2.openfile(ArgumentError, fn, true, true, false, JLD2.MmapIO)
@test fh isa JLD2.MmapIO
# To avoid an mmap error on mac, have to write something to the stream before closing
JLD2.ensureroom(fh, 8)
write(fh, 42)
JLD2.truncate_and_close(fh, 8)

# test file path checking
Sys.isunix() && @test_throws ArgumentError jldopen("/dev/null", "r")
@test_throws ArgumentError jldopen(dirname(fn), "r")

# Test load macros
jldopen(fn, "w") do f
    write(f, "loadmacrotestvar1", ['a', 'b', 'c'])
    write(f, "loadmacrotestvar2", 1)
end

@eval begin # wrapped in eval since @load with no args needs file at compile time
function func1()
    @load $fn
    @test loadmacrotestvar1 == ['a', 'b', 'c']
    @test loadmacrotestvar2 == 1
end
end

func1()

function func2()
    @load fn loadmacrotestvar1 loadmacrotestvar2
    @test loadmacrotestvar1 == ['a', 'b', 'c']
    @test loadmacrotestvar2 == 1
end

func2()

@test !isdefined(@__MODULE__, :loadmacrotestvar1) # should not be in global scope
@test (@eval @load $fn) == [:loadmacrotestvar1, :loadmacrotestvar2]
@test loadmacrotestvar1 == ['a', 'b', 'c']
@test loadmacrotestvar2 == 1

#Test load_object/save_object function Issue#210

@testset "load_object / save_object" begin
  @test_throws ArgumentError load_object(fn) #fn already has two objects
  #Create a file with no objects
  jldopen(fn, "w") do f
  end
  @test_throws ArgumentError load_object(fn) #fn no objects

  save_object(fn, ['a', 'b', 'c']) #rewrite fn to have one object
  l1 = jldopen(fn, "r") do f
    @test length(keys(f)) == 1
    f[JLD2.SINGLE_OBJECT_NAME]
  end
  @test l1 == ['a', 'b', 'c']

  #Test with default name
  l1 = load_object(fn)
  @test l1 == ['a', 'b', 'c']

  #Test with non-default name
  jldopen(fn, "w") do f
    write(f, "loadobjecttestvar2", 1)
  end
  l2 = load_object(fn)
  @test l2 == 1
end

# Test save macros
hello = "world"
@save fn hello
jldopen(fn, "r") do f
    @test read(f, "hello") == "world"
end

cmd = """
using JLD2
hello = "there"
@save $(repr(fn))
"""
run(`$(julia_proj_cmd) -e $cmd`)
jldopen(fn, "r") do f
    @test read(f, "hello") == "there"
end

# Test Dict save/load
save(format"JLD2", fn, Dict("the"=>"quick", "brown"=>"fox", "stuff"=>reshape(1:4, (2, 2))))
@test load(fn) == Dict("the"=>"quick", "brown"=>"fox", "stuff"=>reshape(1:4, (2, 2)))

# Test Dict/save load with symbol keys
save(format"JLD2", fn, Dict(:the=>"quick", :brown=>"fox", :stuff=>reshape(1:4, (2, 2))))
@test load(fn) == Dict("the"=>"quick", "brown"=>"fox", "stuff"=>reshape(1:4, (2, 2)))

# Test load/save with pairs
save(format"JLD2", fn, "jumps", "over", "the", "lazy", "dog", reshape(1:4, (2, 2)))
@test load(fn, "jumps", "the", "dog") == ("over", "lazy", reshape(1:4, (2, 2)))
@test load(fn, "jumps") == "over"

jldopen(fn, "r+") do f
    @test !isempty(f)
    @test haskey(f, "dog")
    @test !haskey(f, "notdog")
    @test keys(f) == ["jumps", "the", "dog"]
    x1 = rand(UInt8, 1024^2+1024)
    x2 = rand(UInt8, 1024)
    f["x1"] = x1
    f["x2"] = x2
    @test f["x1"] == x1
    @test f["x2"] == x2
end

# Issue #33
d = Dict("params/p1" => 1,
         "params/p2" => 2.,
         "params/p3/p1" => 94,
         "data" => [[1,2,3], [4.,5.,6]])
save(fn, d)
@test load(fn) == d

# Issue #106
mutable struct MyMutableTest
    a::Int
    b::Vector{Int}
end
Base.getproperty(df::MyMutableTest, s::Symbol) =
    throw(ArgumentError("should not be called"))
Base.setproperty!(df::MyMutableTest, s::Symbol, x::Int) =
    throw(ArgumentError("should not be called"))
Base.isequal(x::MyMutableTest, y::MyMutableTest) =
    isequal(getfield(x, :a), getfield(y, :a)) && isequal(getfield(x, :b), getfield(y, :b))
mmtd = Dict("A" => MyMutableTest(1, [10]))
save(fn, mmtd)
@test isequal(load(fn), mmtd)

# Issue #125
len = 2^16
longstring = prod(fill("*",len));
lsd = Dict("longstring" => longstring)
save(fn, lsd)
@test isequal(load(fn), lsd)


# Testing Save macro
hello = "world"
num = 1.5

@save fn hello num
@test load(fn) == Dict("hello"=>"world", "num"=>1.5)

@save fn {compress=true} hello num
@test load(fn) == Dict("hello"=>"world", "num"=>1.5)

@save fn {compress=true, mmaparrays=false} hello num
@test load(fn) == Dict("hello"=>"world", "num"=>1.5)

@save fn {iotype=IOStream} hello num
@test load(fn) == Dict("hello"=>"world", "num"=>1.5)

@save fn bye = hello num
@test load(fn) == Dict("bye"=>"world", "num"=>1.5)

@save fn bye = hello num = 10
@test load(fn) == Dict("bye"=>"world", "num"=>10)

@test_throws ArgumentError @save fn {compress} hello

@test_throws ArgumentError @save fn hello=>"error"


# Issue # 189
struct RecursiveStruct
    x::RecursiveStruct
    RecursiveStruct() = new()
    RecursiveStruct(x) = new(x)
end


@testset "Recursive Immutable Types" begin
    x = RecursiveStruct()
    y = RecursiveStruct(x)

    @save fn x y
    JLD2.jldopen(fn, "r") do f
        @test f["x"] == x
        @test f["y"] == y
    end
end

# Issue #131
# write/read a Union{T,Missing}
len = 10_000
vect = Vector{Union{Bool,Missing}}(undef,len)
vect .= true
jldopen(fn,"w") do f
  f["vect"] = vect
end
vect_read = jldopen(fn,"r") do f
  f["vect"]
end
@test !any(ismissing.(vect_read))

# Also related to issue #131, but more types
len = 10_000
vect = Vector{Union{Missing,Float32,Float64,Int32}}(missing,len)
vect[vcat(1:10,33,44,55)] .= Int32(21)
vect[vcat(11:20,66,77,88)] .= 33.
vect[vcat(21:30,99)] .= Float32(123.)
jldopen(fn,"w") do f
  f["vect"] = vect
end
vect_read = jldopen(fn,"r") do f
  f["vect"]
end
@test all(findall(ismissing,vect) == findall(ismissing,vect_read))
@test all( skipmissing(vect) .=== skipmissing(vect_read))

# Issue #183
jfn, _ = mktemp()
@test_throws SystemError jldopen(jfn, "r", fallback = nothing)

# PR #206 Allow serialization of UnionAll in Union
struct UA1{T}; x::T; end
struct UA2{T}; y::T; end
@testset "UnionAll in Union" begin
    fn = joinpath(mktempdir(), "test.jld2")

    U1 = Union{Float64, Int}
    U2 = Union{Int, Vector}
    U3 = Union{UA1, UA2, Int}

    # Test types
    jldopen(fn, "w") do f
        f["u1"] = U1
        f["u2"] = U2
        f["u3"] = U3
    end

    u1, u2, u3 = jldopen(fn, "r") do f
        f["u1"], f["u2"], f["u3"]
    end
    @test u1 === U1
    @test u2 === U2
    @test u3 === U3
    # Test Vector with that eltype
    jldopen(fn, "w") do f
        f["u1"] = U1[1.0, 2, 3.0]
        f["u2"] = U2[1, [2.0], 3, ["4"]]
        f["u3"] = U3[UA1(1), UA2(2.0), 3, UA1("4")]
    end

    u1, u2, u3 = jldopen(fn, "r") do f
        f["u1"], f["u2"], f["u3"]
    end

    @test u1 == U1[1.0, 2, 3.0]
    @test u2 == U2[1, [2.0], 3, ["4"]]
    @test u3 == U3[UA1(1), UA2(2.0), 3, UA1("4")]
end



# Test for Issue #247
@testset "Tuple of Empty Structs" begin
    fn = joinpath(mktempdir(), "test.jld2")
    @save fn tup=(EmptyImmutable(), EmptyImmutable())
    @load fn tup

    @test tup == (EmptyImmutable(), EmptyImmutable())

    # Test for Recursively Empty struct
    @save fn tup=(EmptyII(EmptyImmutable()), EmptyImmutable())
    @load fn tup

    @test tup == (EmptyII(EmptyImmutable()), EmptyImmutable())
end


# Test for storing pointers
@testset "Pointer Serialization" begin
    fn = joinpath(mktempdir(), "test.jld2")
    @save fn ptr=pointer(zeros(5))
    @load fn ptr

    @test ptr == Ptr{Float64}(0)

    # Test for pointer inside structure
    @save fn tup=(; ptr = pointer(zeros(5)))
    @load fn tup

    @test tup == (; ptr = Ptr{Float64}(0))
end


# Test jldsave
@testset "jldsave API" begin
    fn = joinpath(mktempdir(), "test.jld2")

    jldsave(fn; a=1, b=2)
    jldopen(fn, "r") do f
        @test f["a"] == 1
        @test f["b"] == 2
    end

    jldsave(fn, IOStream; a=1, b=2)
    jldopen(fn, "r") do f
        @test f["a"] == 1
        @test f["b"] == 2
    end
end

# Test for object deletion
@testset "Object Deletion" begin
    fn = joinpath(mktempdir(), "test.jld2")
    # To hit all code paths, need to write sufficiently many entries
    jldopen(fn, "w") do f
        write(f, "a", 1)
        write(f, "b", 2)
        write(f, "g/a", 3)
        write(f, "g/b", 4)
    end
    jldopen(fn, "a") do f
        write(f, "c", 5)
        write(f, "d", 6)
        write(f, "e", 7)
        write(f, "f", 9)
    end
    jldopen(fn, "a") do f
        write(f, "h", 6)
        write(f, "i", 7)
        write(f, "j", 9)
    end


    data = FileIO.load(fn)
    @test all(["a", "b", "g/a", "g/b"] .∈ Ref(collect(keys(data))))

    # test read-only
    jldopen(fn, "r") do f
        @test_throws ArgumentError delete!(f, "a")
    end

    # test delete and write again
    jldopen(fn, "a") do f
        @test haskey(f, "g")
        delete!(f, "g")
        @test !haskey(f, "g")
    end
    jldopen(fn, "a") do f
        @test !haskey(f, "g")
        write(f, "g", 10)
        @test haskey(f, "g")
    end

    # test delete of group
    jldopen(fn, "a") do f
        delete!(f, "g")
    end
    jldopen(fn, "r") do f
        @test !haskey(f, "g")
    end
end

## Test for Issue #329

struct SingleUnionallField
    x::IdDict
end

@testset "Issue #329" begin
    fn = joinpath(mktempdir(), "test.jld2")
    jldsave(fn; a = SingleUnionallField(IdDict()))
    # Shouldn't throw
    a = load(fn, "a")
    @test a isa SingleUnionallField
    @test a.x isa IdDict{Any,Any}
end

@testset "Issue #327" begin
    path = tempname()
    x = (1,2)
    JLD2.@save path x
    @test load(path, "x") === (1,2)

    D = Dict("a"=>"Hazel")
    JLD2.@save path D
    @test load(path, "D") == D
end

# Test for saving long NTuples
@testset "Long NTuples" begin
    cd(mktempdir()) do
        tup = ntuple(i->i^2, 5000)
        jldsave("test.jld2"; tup)
        @test tup == load_object("test.jld2")
    end
end


# Test for explicit type remapping
struct A1
    x::Int
end

struct A2
    x::Int
end

@testset "Explicit Type remapping" begin
    cd(mktempdir()) do
        jldsave("test.jld2", a=A1(42))
        @test A1(42) == load("test.jld2", "a")
        @test A2(42) == load("test.jld2", "a"; typemap=Dict("Main.A1" => A2))

        jldsave("test.jld2", a=(A1(42),))
        @test Tuple{A1} == typeof(load("test.jld2", "a"))
        @test Tuple{A2} == typeof(load("test.jld2", "a"; typemap=Dict("Main.A1" => A2)))
    end
end


# Not fully initialized mutable types
mutable struct FirstUninitialized
    x::Any
    y::Int
    FirstUninitialized(y) = (fu=new(); fu.y=y; fu)
end

@testset "Load incomplete mutable types" begin
    mktempdir() do folder
        fu = FirstUninitialized(42)
        jldsave(joinpath(folder,"test.jld2"); fu)
        fu_loaded = load(joinpath(folder,"test.jld2"), "fu")
        @test fu.y == fu_loaded.y
        @test_throws UndefRefError fu.x

    end
end

if VERSION ≥ v"1.8"

    struct SingletonStruct end

    # This is a workaround since for old julia versions this syntax is not allowed and the parser
    # is eager and attempts to parse this piece of code anyway
    eval(Meta.parse("""mutable struct WrappedSingleton
                  x::Int
                  const y::Vector{Int}
                  const z::SingletonStruct
              end
              """))

    @testset "Constant fields in mutable structs (>v1.8) - Issue #410" begin
        mktempdir() do folder
            # The real test here is that it doesn't fail in v1.8
            b = WrappedSingleton(1, [2,3], SingletonStruct())
            save("test.jld2", "b", b)
            bloaded = load("test.jld2", "b")
            @test b.x == bloaded.x
            @test b.y == bloaded.y
            @test b.z == bloaded.z
        end
    end

end

## Issue #431 Identity-Preservation of nested structs with CustomSerialization

abstract type AT end
Base.@kwdef mutable struct T1 <: AT
    f
end
Base.@kwdef mutable struct T2 <: AT
    t1::T1
end
Base.@kwdef mutable struct T3 <: AT
    t1::T1
    t2::T2
end

# Custom Serialization is not transitive, so using a custom serialization via a type
# that is custom serialized itself will not work
mutable struct PseudoDict{K,V}
    kv::Vector{Pair{K,V}}
end

DSA=PseudoDict{Symbol, Any}
JLD2.writeas(::Type{T}) where {T <: AT} = DSA
JLD2.wconvert(::Type{DSA}, t::AT) = DSA([f => getproperty(t, f) for f in fieldnames(typeof(t))])
JLD2.rconvert(::Type{T}, dsa::DSA) where {T <: AT} = T(; dsa.kv...)

@testset "Issue #431 Identity-Preservation" begin
    cd(mktempdir()) do
        t1 = T1(1)
        t2 = T2(t1)
        t3 = T3(t1, t2)
        save_object("kk.jld2", t3)

        t3 = load_object("kk.jld2")
        @test t3.t1 === t3.t2.t1
    end
end

## Issue #433 circular references with custom serialization


mutable struct CR
    r::CR
    CR() = new()
    CR(x) = new(x)
end

mutable struct CRSerialized
    r::CR
end

JLD2.writeas(::Type{CR}) = CRSerialized
JLD2.wconvert(::Type{CRSerialized}, t::CR) = CRSerialized(t.r)
JLD2.rconvert(::Type{CR}, dsa::CRSerialized) = CR(dsa.r)
@testset "Issue #433 circular references with custom serialization" begin
    cd(mktempdir()) do
        cr = CR()
        cr.r = cr
        save_object("kk.jld2", cr)

        t1 = load_object("kk.jld2")
        @test t1 === t1.r
    end
end

# Test jldsave
@testset "Multi-threaded read" begin
    fn = joinpath(mktempdir(), "test.jld2")

    jldsave(fn; a=1, b=2)

    #########################
    # Valid access patterns #
    #########################

    #Normal read
    jldopen(fn, "r"; parallel_read = true) do f
        @test f["a"] == 1
        @test f["b"] == 2
        @test fn ∉ keys(JLD2.OPEN_FILES)
    end

    # Can read in parallel and serial (read-only)
    f1 = jldopen(fn)
    f2 = jldopen(fn; parallel_read = true)
    @test JLD2.OPEN_FILES[realpath(fn)] == f1
    @test f1 != f2
    close(f1); close(f2)

    f1 = jldopen(fn, "a")
    @test_throws ArgumentError jldopen(fn; parallel_read = true)
    close(f1)

    ###########################
    # Invalid access patterns #
    ###########################

    # Open for non-read in parallel context
    @test_throws ArgumentError jldopen(fn, "w"; parallel_read = true) do f end
    @test_throws ArgumentError jldopen(fn, "w+"; parallel_read = true) do f end
    @test_throws ArgumentError jldopen(fn, "r+"; parallel_read = true) do f end
    @test_throws ArgumentError jldopen(fn, "a+"; parallel_read = true) do f end
    @test_throws ArgumentError jldopen(fn, "a"; parallel_read = true) do f end


    rm(fn; force = true, recursive = true)
end


###################################################################################################
##             `Upgrade` Tests
###################################################################################################

struct OldStructVersion
    x::Int
    y::Float64
end

struct UpdatedStruct
    x::Float64 # no longer int
    y::Float64
    z::Float64 # x*y
end
JLD2.rconvert(::Type{UpdatedStruct}, nt::NamedTuple) = UpdatedStruct(Float64(nt.x), nt.y, nt.x*nt.y)
# Dummy Upgrade, keeps struct but changes values
JLD2.rconvert(::Type{OldStructVersion}, nt::NamedTuple) = OldStructVersion(nt.x, 2*nt.y)


@testset "Explicit `Upgrade`ing" begin
    cd(mktempdir()) do
        orig = OldStructVersion(1,2.0)
        newver = UpdatedStruct(1.0, 2.0, 2.0)
        save_object("test.jld2", orig)
        @test orig == load_object("test.jld2")
        @test newver == JLD2.load("test.jld2", "single_stored_object"; typemap=Dict("Main.OldStructVersion" => JLD2.Upgrade(UpdatedStruct)))

        # Test for container with vector elements being upgraded
        wrapped_orig = ([orig,],)
        wrapped_newver = ([OldStructVersion(1,4.0),],)
        save_object("test.jld2", wrapped_orig)
        @test wrapped_orig == load_object("test.jld2")
        @test wrapped_newver == JLD2.load("test.jld2", "single_stored_object"; typemap=Dict("Main.OldStructVersion" => JLD2.Upgrade(OldStructVersion)))
    end
end

@testset "Issue #484 round-trip Tuple{Type{Int}}" begin
    cd(mktempdir()) do
        T = Tuple{Type{Int}}
	jldsave("test.jld2"; T)
	@test T == load("test.jld2", "T")
    end
end


@testset "Issue #510 uninitialized Dicts" begin
    cd(mktempdir()) do
        save_object("test.jld2", Vector{Dict{String,Float64}}(undef, 10))
        o = load_object("test.jld2")
        @test !any(isassigned.(Ref(o), eachindex(o)))
    end
end

@testset "Issue 486 store NTuple type with indeterminate length" begin
    cd(mktempdir()) do
        s_type = Tuple{Int, Tuple{Vararg{Int, T}} where T}
        a = Dict{s_type, Int}()
        a[(0, (1, 2, 3))] = 4
        @test a == (save_object("test.jld2", a); load_object("test.jld2"))
    end
end

@testset "FileIO.load of (nested) groups" begin
    cd(mktempdir()) do
        # create a file
        fn = "test.jld2"
        f = jldopen(fn, "w")
        f["a"] = 1
        f["b/c"] = 2
        close(f)
        @test load(fn) == Dict("a" => 1, "b/c" => 2)
        @test load(fn; nested=true) == Dict("a" => 1, "b" => Dict("c" => 2))

        f = jldopen(fn, "a")
        f["b/d/e"] = 3
        f["b/d/f/g"] = 4
        close(f)
        @test load(fn, "b/d/f") == Dict("g" => 4)
        @test load(fn, "b/d/f", "a") == (Dict("g" => 4), 1)
        @test load(fn, "b/d") == Dict("e" => 3, "f" => Dict("g"=> 4))
    end
end

@testset "Union{} in type signature Issue #532" begin
    cd(mktempdir()) do
        op = (1, pairs((;)))
        jldsave("testopempty.jld2"; op)
        @test op == load("testopempty.jld2", "op")
    end
end

@testset "Issue #536 reading directly after writing" begin
    cd(mktempdir()) do
        x = (1, Dict(2=>3))
        jldopen("test.jld2", "w") do f
            f["x"] = x
            @test x == f["x"]
        end
    end
end

@testset "Issue #558 a struct with 256 fields" begin
    fields = [Symbol("field",i) for i in 1:256]
    @eval struct Structwithmanyfields
        $(fields...)
    end
    # Fill the struct
    obj = Structwithmanyfields(ntuple(i -> i, 256)...)

    cd(mktempdir()) do
        save_object("myStruct.jld2", obj)
        loaded = load_object("myStruct.jld2")
        @test loaded isa Structwithmanyfields
    end
end

# @testset "Issue #466 non-normalized unicode string identifiers" begin
#     ahat_unnormalized = String([0x61, 0xcc, 0x82])
#     ahat_normalized = String([0xc3, 0xa2])
#     dummy_data = 42
#     fn = "test.jld2"
#     cd(mktempdir()) do
#         jldopen(fn, "w") do f
#             f[ahat_unnormalized] = dummy_data
#             @test haskey(f, ahat_normalized)
#             @test haskey(f, ahat_unnormalized)
#             @test f[ahat_normalized] == dummy_data
#             @test f[ahat_unnormalized] == dummy_data
#         end
#         jldopen(fn) do f
#             @test haskey(f, ahat_normalized)
#             @test haskey(f, ahat_unnormalized)
#             @test f[ahat_normalized] == dummy_data
#             @test f[ahat_unnormalized] == dummy_data
#         end
#     end
# end

module DummyModule
    using ..JLD2
    struct AA end
    struct BB end
    Base.@kwdef struct CC
        x::Any = 1
    end
    JLD2.rconvert(::Type{CC}, nt::NamedTuple) = CC()
    JLD2.rconvert(::Type{BB}, nt::NamedTuple) = BB()
    mutable struct DD end
    JLD2.rconvert(::Type{DD}, nt::NamedTuple) = DD()
end
@testset "Upgrading a struct that was formerly singleton" begin
    cd(mktempdir()) do
        jldsave("testing.jld2"; a = DummyModule.AA())
        @test DummyModule.BB() == load("testing.jld2", "a"; typemap = Dict("Main.DummyModule.AA" => JLD2.Upgrade(DummyModule.BB)))
        @test DummyModule.BB() == load("testing.jld2", "a"; typemap = Dict("Main.DummyModule.AA" => DummyModule.BB))
        @test DummyModule.CC() == load("testing.jld2", "a"; typemap = Dict("Main.DummyModule.AA" => JLD2.Upgrade(DummyModule.CC)))
    end
end

@testset "Issue #628 Upgrading structs that contains unions" begin
    cd(mktempdir()) do
        @testset "immutable" begin
            a1 = Dict("a" => [nothing DummyModule.AA()])
            save("a.jld2", a1)
            a2 = load("a.jld2"; typemap = Dict("Main.DummyModule.AA" => JLD2.Upgrade(DummyModule.AA)))
            @test only(keys(a1)) == "a"
            @test keys(a1) == keys(a2)
            @test a1["a"] == a2["a"]
        end
        @testset "mutable" begin
            a1 = Dict("a" => [nothing DummyModule.DD()])
            save("a.jld2", a1)
            a2 = load("a.jld2"; typemap = Dict("Main.DummyModule.DD" => JLD2.Upgrade(DummyModule.DD)))
            @test only(keys(a1)) == "a"
            @test keys(a1) == keys(a2)
            @test typeof(a1["a"]) == typeof(a2["a"])
        end
    end
end

@testset "Issue #571 Loading Vararg NTuples" begin
    tst = [("a",), ("a", "b")]
    cd(mktempdir()) do
        save_object("tst.jld2", tst)
        @test tst == load_object("tst.jld2")
    end
end

@testset "Disable committing datatypes" begin
    fn = joinpath(mktempdir(), "disable_committing_datatypes.jld2")
    jldopen(fn, "w") do f
        f.disable_commit = true

        @test_throws ArgumentError f["1"] = Dict(1=>2)
        @test_throws ArgumentError f["2"] = Vector{Float64}
        @test_throws ArgumentError f["3"] = (1,2,3)
        @test_throws ArgumentError f["4"] = :asymbol
        # No throw
        f["5"] = "a string"
        # this could eventually be allowed
        @test_throws ArgumentError f["4"] = (; a=1, b=2)
    end
end


@testset "Missing Types in Tuples" begin
    fn = joinpath(mktempdir(), "missing_types_in_tuple.jld2")
    eval(:(module ModuleWithFunction
        fun(x) = x+1
    end))
    eval(:(save_object($fn, (1, ModuleWithFunction.fun, 2))))
    obj = load_object(fn)
    @test length(obj) == 3
    @test obj[1] == 1
    @test obj[2] == eval(:(ModuleWithFunction.fun))
    @test obj[3] == 2

    eval(:(module ModuleWithFunction end))
    obj = load_object(fn)
    @test length(obj) == 3
    @test obj[1] == 1
    @test JLD2.isreconstructed(obj[2])
    @test obj[3] == 2

end

if VERSION ≥ v"1.7"
    @testset "Storing an anonymous function" begin
        fn = joinpath(mktempdir(), "storing_anon_function.jld2")
        f = x -> x+1
        @test_warn contains("Attempting to store") save_object(fn, f)
    end
end

struct Foo601 <: Function
    x::Int
end

@testset "Issue #601: Storing <: Function objects" begin
    foo = Foo601(2)
    tempfile = tempname()
    jldsave(tempfile; foo)
    loaded_foo = load(tempfile, "foo")
    @test loaded_foo isa Foo601
end


@testset "Issue #603 - reused objectids" begin
    fn = joinpath(mktempdir(), "issue603_reused_objectids.jld2")

    function create_large_dict(levels::Int, items_per_level::Int, item_size::Int)
        # Create a nested dictionary with the specified number of levels
        function create_nested_dict(current_level, max_level)
            if current_level > max_level
                return Dict("x" => rand(Int, item_size))
            else
                return Dict(
                    string(i) => create_nested_dict(current_level + 1, max_level)
                    for i in 1:items_per_level
                )
            end
        end
        # Create the top-level dictionary
        return create_nested_dict(1, levels)
    end

    obj = create_large_dict(3, 30, 1);
    jldsave(fn; obj)
    res = load(fn, "obj")
    function recursive_test(obj, res)
        @test length(keys(obj)) == length(keys(res))
        for (k, v) in obj
            @test haskey(res, k)
            if isa(v, Dict)
                recursive_test(v, res[k])
            else
                @test v == res[k]
            end
        end
    end
    recursive_test(obj, res)
end

@testset "Issue #611 - non-initialized Symbol field" begin
    fn = joinpath(mktempdir(), "non-init-symbolfield.jld2")
    data = Vector{Symbol}(undef, 2)
    data[1] = :a
    jldsave(fn; data)
    loaded_data = load(fn, "data")
    @test !isassigned(loaded_data, 2)
    @test loaded_data[1] == :a
end

@testset "Issue #619 - Number type turnaround" begin
    fn = joinpath(mktempdir(), "number_type_turnaround.jld2")
    types = [UInt8, Int8, UInt16, Int16, UInt32, Int32, UInt64, Int64, UInt128, Int128, Float16, Float32, Float64]
    jldopen(fn, "w") do f
        for t in types
            f[string(t)] = typemax(t)
        end
    end
    jldopen(fn) do f
        for t in types
            v = f[string(t)]
            @test v isa t
            @test v == typemax(t)
        end
    end
end

@static if VERSION >= v"1.11"
    @testset "Support for Memory" begin
        fn = joinpath(mktempdir(), "memorytype.jld2")
        m = Memory{Int}(undef, 10)
        mr = memoryref(m, 5)
        jldsave(fn; m, mr)
        d = load(fn)
        @test d["m"] isa Memory
        @test d["m"] == m
        @test d["mr"][] == mr[]
        @test d["mr"].mem === d["m"]

        m = Memory{String}(undef, 2)
        m[1] = "1"
        m[2] = "2"
        mr = memoryref(m, 2)
        jldsave(fn; m, mr)
        d = load(fn)
        @test d["m"] isa Memory
        @test d["m"] == m
        @test d["mr"][] == mr[]
        @test d["mr"].mem === d["m"]
    end
end


@testset "Advanced typemap" begin
    fn = joinpath(mktempdir(), "advancedtypemap.jld2")
    z = 1 + 2im # Complex{Int}
    zf = 1f0 + 2f0*im # Complex{Float32}
    jldsave(fn; z, type = Complex{Int}, zf)

    typemap = function(f, typepath, params)
        @info "typepath: $typepath, params: $params"
        if typepath == "Base.Complex" && params == [Int]
            return JLD2.Upgrade(Complex{Float64})
        end
        JLD2.default_typemap(f, typepath, params)
    end

    JLD2.rconvert(::Type{Complex{Float64}}, nt::NamedTuple) =
        Complex{Float64}(nt.re + 1, nt.im)

    d = load(fn; typemap)
    @test d["z"] isa Complex{Float64}
    @test d["z"] == 2.0 + 2.0im
    @test d["type"] == Complex{Float64}
    @test d["zf"] isa Complex{Float32}
    @test d["zf"] == 1.0 + 2.0im
end

@testset "Issue #673: Union{} edgecase" begin
    fn = joinpath(mktempdir(), "emptyunion_edgecase.jld2")
    x = [ _  for _ in ()]
    # Need a bogus dispatch here to trigger the edge case
    JLD2.writeas(::Type{<:JLD2.JLDFile}) = error("Should not be called")
    jldsave(fn; x)
    loaded_x = load(fn, "x")
    @test loaded_x == x
end

using JLD2, Test

struct SingleFieldWrapper{T}
    x::T
end
Base.:(==)(a::SingleFieldWrapper, b::SingleFieldWrapper) = a.x == b.x

struct MultiFieldWrapper{T}
    x::T
    y::Int
end
Base.:(==)(a::MultiFieldWrapper, b::MultiFieldWrapper) = (a.x == b.x && a.y == b.y)

struct UntypedWrapper
    x
end
Base.:(==)(a::UntypedWrapper, b::UntypedWrapper) = a.x == b.x

# Mutable field wrapper
mutable struct MutableFieldWrapper{T}
    x::T
end
Base.:(==)(a::MutableFieldWrapper, b::MutableFieldWrapper) = a.x == b.x


# This is a type with a custom serialization, where the original type has data
# but the custom serialization is empty
struct CSA
    x::Ptr{Cvoid}
end
a = CSA(Ptr{Cvoid}(0))

struct CSASerialization end
JLD2.writeas(::Type{CSA}) = CSASerialization
function JLD2.wconvert(::Type{CSASerialization}, x::CSA)
    global converted = true
    CSASerialization()
end
function JLD2.rconvert(::Type{CSA}, x::CSASerialization)
    global converted = true
    CSA(Ptr{Cvoid}(0))
end

# This is a type with a custom serialization, where the original type has no
# data but the custom serialization does
struct CSB end
b = CSB()

struct CSBSerialization
    x::Int64
end
JLD2.writeas(::Type{CSB}) = CSBSerialization
function JLD2.wconvert(::Type{CSBSerialization}, x::CSB)
    global converted = true
    CSBSerialization(9018620829326368991)
end
function JLD2.rconvert(::Type{CSB}, x::CSBSerialization)
    global converted = true
    x.x == 9018620829326368991 ? CSB() : error("invalid deserialized data")
end

# This is a type where the custom serialized data can be stored inline when it
# is a field of another type, but the original data could not
mutable struct CSC
    x::Vector{Int}
end
Base.:(==)(a::CSC, b::CSC) = a.x == b.x
c = CSC(rand(Int, 2))

struct CSCSerialization
    a::Int
    b::Int
end
JLD2.writeas(::Type{CSC}) = CSCSerialization
function JLD2.wconvert(::Type{CSCSerialization}, x::CSC)
    global converted = true
    CSCSerialization(x.x[1], x.x[2])
end
function JLD2.rconvert(::Type{CSC}, x::CSCSerialization)
    global converted = true
    CSC([x.a, x.b])
end

# This is a type where the original data could be stored inline when it is a
# field of another type, but the custom serialized data cannot
struct CSD
    a::Int
    b::Int
end
d = CSD(rand(Int), rand(Int))

struct CSDSerialization
    x::Vector{Int}
end
JLD2.writeas(::Type{CSD}) = CSDSerialization
function JLD2.wconvert(::Type{CSDSerialization}, x::CSD)
    global converted = true
    CSDSerialization([x.a, x.b])
end
function JLD2.rconvert(::Type{CSD}, x::CSDSerialization)
    global converted = true
    CSD(x.x[1], x.x[2])
end

# This is a type that gets written as an array
struct CSE
    a::Int
    b::Int
    c::Int
end
e = CSE(rand(Int), rand(Int), rand(Int))

JLD2.writeas(::Type{CSE}) = Vector{Int}
function JLD2.wconvert(::Type{Vector{Int}}, x::CSE)
    global converted = true
    [x.a, x.b, x.c]
end
function JLD2.rconvert(::Type{CSE}, x::Vector{Int})
    global converted = true
    CSE(x[1], x[2], x[3])
end

# This is a type that is custom-serialized as an Int
struct CSF
    x::Int
end
f = CSF(rand(Int))

JLD2.writeas(::Type{CSF}) = Int
function Base.convert(::Type{Int}, x::CSF)
    global converted = true
    x.x
end
function Base.convert(::Type{CSF}, x::Int)
    global converted = true
    CSF(x)
end

# This is a type that is custom-serialized as a String
struct CSG
    x::Int
end
g = CSG(rand(Int))

JLD2.writeas(::Type{CSG}) = String
function Base.convert(::Type{String}, x::CSG)
    global converted = true
    convert(String, string(x.x))
end
function Base.convert(::Type{CSG}, x::String)
    global converted = true
    CSG(parse(Int, x))
end

# This is a type that is custom-serialized as a DataType
struct CSH
    T::DataType
    N::Int
end
h = CSH(Int, 2)

JLD2.writeas(::Type{CSH}) = DataType
function Base.convert(::Type{DataType}, x::CSH)
    global converted = true
    Array{x.T, x.N}
end
function Base.convert(::Type{CSH}, x::Type{Array{T,N}}) where {T,N}
    global converted = true
    CSH(T,N)
end

# This is a type that is custom-serialized as a Union
struct CSK
    T::DataType
    S::DataType
end
k = CSK(Int, Float64)
Base.:(==)(x::CSK, y::CSK) = (x.T == y.T && x.S == y.S) ||
                             (x.T == y.S && x.S == y.T)

JLD2.writeas(::Type{CSK}) = Union
function Base.convert(::Type{Union}, x::CSK)
    global converted = true
    Union{x.T,x.S}
end
function Base.convert(::Type{CSK}, x::Union)
    global converted = true
    CSK(Base.uniontypes(x)...)
end

function write_tests(file, prefix, obj)
    write(file, prefix, obj)
    write(file, "$(prefix)_singlefieldwrapper", SingleFieldWrapper(obj))
    write(file, "$(prefix)_multifieldwrapper", MultiFieldWrapper(obj, 2147483645))
    write(file, "$(prefix)_untypedwrapper", UntypedWrapper(obj))
    write(file, "$(prefix)_arr", [obj])
    write(file, "$(prefix)_empty_arr", typeof(obj)[])
    write(file, "$(prefix)_tuple", (obj,))
    write(file, "$(prefix)_mutablefieldwrapper", MutableFieldWrapper(obj))
end

function read_tests(file, prefix, obj)
    global converted = false
    @test read(file, prefix) == obj
    @test converted
    @test read(file, "$(prefix)_singlefieldwrapper") == SingleFieldWrapper(obj)
    @test read(file, "$(prefix)_multifieldwrapper") == MultiFieldWrapper(obj, 2147483645)
    @test read(file, "$(prefix)_untypedwrapper") == UntypedWrapper(obj)
    arr = read(file, "$(prefix)_arr")
    @test typeof(arr) == Vector{typeof(obj)} && length(arr) == 1 && arr[1] == obj
    empty_arr = read(file, "$(prefix)_empty_arr")
    @test typeof(empty_arr) == Vector{typeof(obj)} && length(empty_arr) == 0
    @test read(file, "$(prefix)_tuple") == (obj,) 
    @test read(file, "$(prefix)_mutablefieldwrapper") == MutableFieldWrapper(obj)
end

@testset "Custom Serialization" begin
    fn = joinpath(mktempdir(),"test.jld")
    file = jldopen(fn, "w")
    write_tests(file, "a", a)
    write_tests(file, "b", b)
    write_tests(file, "c", c)
    write_tests(file, "d", d)
    write_tests(file, "e", e)
    write_tests(file, "f", f)
    write_tests(file, "g", g)
    write_tests(file, "h", h)
    write_tests(file, "k", k)
    close(file)


    file = jldopen(fn, "r")
    read_tests(file, "a", a)
    read_tests(file, "b", b)
    read_tests(file, "c", c)
    read_tests(file, "d", d)
    read_tests(file, "e", e)
    read_tests(file, "f", f)
    read_tests(file, "g", g)
    read_tests(file, "h", h)
    read_tests(file, "k", k)
    close(file)
end


# Function Reconstruction (does not strictly belong to custom serialization but was
# broken by it)
struct S1
    a
    f
end

struct S2{F}
    a
    f::F
end

struct S3{F}
    f::F
end

λ() = 42

function round_trip(x)
    mktempdir() do dir
        fn = joinpath(dir, "test.jld2")
        @save fn grp=x
        @load fn grp
        return grp
    end
end

@testset "round trip Function values" begin
    @test 42 == round_trip(λ)()
    @test 42 == first(round_trip((λ,)))()
    @test 42 == first(round_trip((λ, λ)))()
    @test 42 == first(round_trip((λ, 42)))()
    @test 42 == first(round_trip([λ]))()
    @test 42 == first(round_trip([λ, λ]))()
    @test 42 == first(round_trip([λ, 42]))()
    @test 42 == round_trip(S1(42, λ)).f()
    @test 42 == round_trip(S2(42, λ)).f()
    @test 42 == round_trip(S3(λ)).f()
end

## Custom serialization

# The default, write a type as itself
writeas(T::Type) = T
# Union{} behaves oddly during dispatch. Define explicitly:
writeas(::Type{Union{}}) = Union{}

# wconvert and rconvert do type conversion before reading and writing,
# respectively. These fall back to convert.
wconvert(T, x) = convert(T, x)
rconvert(T, x) = convert(T, x)
rconvert(::Type{Array{T,N}}, x::Array{T,N}) where {T,N} = x
function rconvert(::Type{Array{T,N}}, x::Array{T2,N}) where {T, T2, N}
    res = Array{T,N}(undef, size(x)...)
    for i in eachindex(x)
        if isassigned(x, i)
            res[i] = rconvert(T, x[i])
        end
    end
    res
end

# Select an ODR, incorporating custom serialization only if the types do not
# match
CustomSerialization(::Type{WrittenAs}, ::Type{WrittenAs}, odr) where {WrittenAs} = odr
CustomSerialization(::Type{WrittenAs}, ::Type{ReadAs}, odr) where {WrittenAs,ReadAs} =
    CustomSerialization{WrittenAs,odr}

odr_sizeof(::Type{CustomSerialization{T,ODR}}) where {T,ODR} = odr_sizeof(ODR)::Int

# Usually we want to convert the object and then write it.
h5convert!(out::Pointers, ::Type{CustomSerialization{T,ODR}}, f::JLDFile,
                   x, wsession::JLDWriteSession) where {T,ODR} =
    h5convert!(out, ODR, f, wconvert(T, x)::T, wsession)

# When writing as a reference, we don't want to convert the object first. That
# should happen automatically after write_dataset is called so that the written
# object gets the right written_type attribute.
h5convert!(out::Pointers, odr::Type{CustomSerialization{T,RelOffset}},
                   f::JLDFile, x, wsession::JLDWriteSession) where {T} =
    h5convert!(out, RelOffset, f, x, wsession)

# When writing as a reference to something that's being custom-serialized as an
# array, we have to convert the object first.
h5convert!(out::Pointers, odr::Type{CustomSerialization{T,RelOffset}},
            f::JLDFile, x, wsession::JLDWriteSession) where {T<:Array} =
    h5convert!(out, RelOffset, f, wconvert(T, x)::T, wsession)

h5convert_uninitialized!(out::Pointers, odr::Type{CustomSerialization{T,ODR}}) where {T,ODR} =
    h5convert_uninitialized!(out, ODR)

jlconvert_canbeuninitialized(::MappedRepr{T,CustomSerialization{S,ODR}}) where {T,S,ODR} =
    jlconvert_canbeuninitialized(MappedRepr{S,ODR}())
jlconvert_isinitialized(::MappedRepr{T,CustomSerialization{S,ODR}}, ptr::Ptr) where {T,S,ODR} =
    jlconvert_isinitialized(MappedRepr{S,ODR}(), ptr)

function jlconvert(::MappedRepr{T,CustomSerialization{S,RelOffset}},
        f::JLDFile, ptr::Ptr, header_offset::RelOffset) where {T,S}
    # Concerns objects whose custom serialization is itself only referenced by a RelOffset
    # This be important when the original object is mutable
    offset = jlunsafe_load(pconvert(Ptr{RelOffset}, ptr))
    return rconvert(T, load_dataset(f, offset))
end

function jlconvert(::MappedRepr{T,CustomSerialization{S,ODR}},
          f::JLDFile, ptr::Ptr, header_offset::RelOffset) where {T,S,ODR}

    if ismutabletype(T) && !(T <: Core.SimpleVector)
        # May encounter a self-referential struct that used custom serialization
        # provide an uninitialized struct and later fill it with values
        obj = newstruct(T)
        track_weakref!(f, header_offset, obj)

        # actually load the data
        v = rconvert(T, jlconvert(ReadRepresentation(S,ODR), f, ptr, header_offset))::T
        # copy fields to initial struct
        for i in 0:nfields(obj)-1
            fieldval = ccall(:jl_get_nth_field, Any, (Any, Csize_t), v, i)
            ccall(:jl_set_nth_field, Nothing, (Any, Csize_t, Any), obj, i, fieldval)
        end
        return obj
    else
        v = rconvert(T, jlconvert(ReadRepresentation(S,ODR), f, ptr, header_offset))::T
        track_weakref!(f, header_offset, v)
        return v
    end
end

using JLD2, Test

function writeloop(f, sz)
    for i = 1:sz
        JLD2.jlwrite(f, UInt8(6))
    end
end

# Force growing an MmapIO
name, io = mktemp()
f = JLD2.MmapIO(name, true, true, true)
close(io)
sz = JLD2.MMAP_GROW_SIZE+5
writeloop(f, sz)
JLD2.truncate_and_close(f, position(f))

@test filesize(name) == sz
f = open(name)
rd = read!(f, Array{UInt8}(undef, sz))
@test all(rd .== UInt8(6))
close(f)

f = JLD2.MmapIO(name, true, true, true)
JLD2.jlwrite(f, rd)
JLD2.truncate_and_close(f, position(f))

@test filesize(name) == sz
f = open(name)
rd = read!(f, Array{UInt8}(undef, sz))
@test all(rd .== UInt8(6))
close(f)

@test JLD2.size_flag(1) === UInt8(0)
@test JLD2.size_flag(256) === UInt8(1)
@test JLD2.size_flag(65536) === UInt8(2)
@test JLD2.size_flag(UInt64(4294967296)) === UInt8(3)

buf = IOBuffer()
JLD2.write_size(buf, 175)
seek(buf, 0)
@test read(buf, UInt8) == 175
seek(buf, 0)
@test JLD2.read_size(buf, UInt8(0)) == 175
seek(buf, 0)

JLD2.write_size(buf, 42580)
seek(buf, 0)
@test read(buf, UInt16) == 42580
seek(buf, 0)
@test JLD2.read_size(buf, UInt8(1)) == 42580
seek(buf, 0)

JLD2.write_size(buf, 1902153053)
seek(buf, 0)
@test read(buf, UInt32) == 1902153053
seek(buf, 0)
@test JLD2.read_size(buf, UInt8(2)) == 1902153053
seek(buf, 0)

if Int == Int64
    # Only test this on 64-bit platforms. We can't read data of size >4GB on 32-bit anyway.
    JLD2.write_size(buf, 3804306107)
    seek(buf, 0)
    @test read(buf, UInt32) == 3804306107
    seek(buf, 0)
    @test JLD2.read_size(buf, UInt8(2)) == 3804306107
    seek(buf, 0)

    JLD2.write_size(buf, 7832227080891617460)
    seek(buf, 0)
    @test read(buf, UInt64) == 7832227080891617460
    seek(buf, 0)
    @test JLD2.read_size(buf, UInt8(3)) == 7832227080891617460
    seek(buf, 0)
end

@test JLD2.size_size(1) === 1
@test JLD2.size_size(256) === 2
@test JLD2.size_size(65536) === 4
@test JLD2.size_size(UInt64(4294967296)) === 8

# test with one of its own types
@test JLD2.typename(JLD2.BasicDatatype) == "JLD2.BasicDatatype"
@test JLD2.typename(String) == "Core.String"

module Foo
    module Bar
        struct Baz end
    end
end

@test endswith(JLD2.typename(Foo.Bar.Baz), "Foo.Bar.Baz")

###########################################################################################
# The following macro is used for declarative definition of Header Messages
###########################################################################################
"""
    @pseudostruct name begin ... end

The `@pseudostruct` macro is used to define constructor, size computation, show, and
and optimized getproperty function for `Message`s.
The allowed syntax elements are:
- `@skip(n)`: Mark `n` bytes as empty.
"""
macro pseudostruct(name, blck)
    constructor_body, size_body, messageshow_body = 
        build_fun_body((Any[], Any[], Any[]), blck)

    get_prop_exprs = generate_getprop(blck.args)
    quote
        function $(esc(:jlwrite))(io, ::Val{$name}, $(esc(:hflags)), $(esc(:hsize)), $(esc(:kw)))
            $(constructor_body...)
        end

        function $(esc(:compute_size))(::Val{$name}, $(esc(:hflags)), $(esc(:hsize)), $(esc(:kw)))
            $(esc(:offset)) = 0
            $(size_body...)
            return $(esc(:offset))
        end

        function $(esc(:messageshow))(::Val{$name}, $(esc(:m))::Message, $(esc(:hflags))=0x0, $(esc(:hsize))=0x0000)
            $(esc(:io)) = m.io
            seek($(esc(:io)), m.address)
            $(esc(:offset)) = 0
            keyvalue = Pair{Symbol,Any}[]
            $(messageshow_body...)
            return keyvalue
        end

        function $(esc(:(Base.getproperty)))(tw::HmWrap{$name, iot}, s::Symbol) where iot
            s == :size && return getfield(tw, s)
            s ==:hflags && return getfield(tw, s)
            s==:m && return getfield(tw, s)
            m = getfield(tw, :m)::Message{iot}
            hflags = getfield(tw, :hflags)
            hsize = getfield(tw, :size)
            io = getfield(m, :io)::iot
            $(get_prop_exprs)
            throw(ArgumentError("property $s not found"))
        end
        nothing
    end
end

function compute_size end
function messageshow end

function build_fun_body(accs, blk)
    for ex in blk.args
        rets = linefun(ex)
        for i in 1:length(accs)
            push!(accs[i], rets[i])
        end
    end
    return accs
end

function linefun(ex)
    v = nothing
    kw = esc(:kw)
    io = esc(:io)
    offset = esc(:offset)
    if ex isa LineNumberNode
        return [ex, ex, ex]
    elseif @capture(ex, cond_ && body_)
        rets = linefun(ex.args[2])
        return [ Expr(:&&, esc(cond), ret ) for ret in rets ]
    elseif @capture(ex, if cond_; body_; end )
        accs = build_fun_body((Any[], Any[], Any[]), body)
        return [ Expr(:if, esc(cond), Expr(:block, accs[i]...)) for i in 1:length(accs) ]
    elseif @capture(ex, @skip(n_))
        increment = esc(n)
        off_inc = :($offset += $increment)
        write_inc = :(write_zerobytes(io, $increment))
        return [write_inc, off_inc, :(skip($io, $increment))]
    elseif @capture(ex, s_Symbol::T_) || @capture(ex, s_Symbol::T_ = v_)
        getprop_ = :($(esc(s)) = $kw.$(s))
        default = Symbol(s,"_default")
        default_ = :($default = $(esc(v)))
        get_ = :($(esc(s)) = get($kw, $(QuoteNode(s)), $default))
        haskey_ = :(haskey($kw, $(QuoteNode(s))) || throw(ArgumentError($("Argument $(QuoteNode(s)) is required"))))

        if @capture(T, @FixedLengthString(len_))
            len = esc(len)
            read_io = :(String(jlread($io, UInt8, $(len))))
            increment = :($len)
            write_statement = :(jlwrite(io, $(esc(s))))
        elseif @capture(T, @Blob(len_))
            len = esc(len)
            read_io = :(jlread($io, UInt8, $(len)))
            increment = :($len)
            write_statement = :(jlwrite(io, $(esc(s))))
        elseif @capture(T, @Int(len_))
            len = esc(len)
            read_io = :(read_nb_uint($io, $(len))::UInt64)
            increment = :($len)
            write_statement = :(write_nb_int(io, $(esc(s)), $len))
        elseif @capture(T, @Offset)
            read_io = :(RelOffset(getfield(m,:offset) + position($io) - getfield(m,:address)))
            increment = 0
            getprop_ = nothing
            haskey_=nothing
            write_statement = nothing
        elseif @capture(T, @computed(expr_))
            @assert isnothing(v) "Defaults for @computed fields are not supported"
            read_io = esc(expr)
            getprop_ = :($(esc(s)) = $(esc(expr)))
            increment = 0
            write_statement = nothing
            haskey_ = nothing
        elseif @capture(T, @read(type_, rsize_)) || @capture(T, @read(type_))
            read_io = :(jlread($io, $(esc(type))))
            write_statement = :(jlwrite(io, $(esc(s))))
            increment = isnothing(rsize) ? :(jlsizeof($(esc(s)))) : rsize
        else
            T = esc(T)
            read_io = :(jlread($io, $T))
            increment = :(sizeof($(T)))
            write_statement = :(jlwrite(io, $T($(esc(s)))))
        end

        io_assign = :($(esc(s)) = $read_io)
        offset_incr = :($offset += $increment)
        
        return [
            # writing function
            if !isnothing(v)
                Expr(:block, default_, get_, write_statement)
            else
                Expr(:block, haskey_, getprop_, write_statement)
            end,
            # size function
            if !isnothing(v)
                Expr(:block, default_, get_, offset_incr)
            else
                Expr(:block, haskey_, getprop_, offset_incr)
            end,
            # pretty printer
            Expr(:block, io_assign,
                :(push!(keyvalue, $(QuoteNode(s)) => $(esc(s)))))
        ]
    end
    throw(ArgumentError("Invalid field syntax: $ex"))
end



function generate_getprop(exprs, fields=[], precond=true)
    if exprs isa Expr && exprs.head==:block 
        return generate_getprop(exprs.args, fields, precond)
    end
    io = :io
    for ex in exprs
        s = T = io_assign = nothing
        if ex isa LineNumberNode
            continue
        elseif @capture(ex, cond_ && body_)
            combined_cond = precond==true ? cond : :($precond && $cond)
            generate_getprop([body], fields, combined_cond)
            continue
        elseif @capture(ex, if cond_; body_; end )
            combined_cond = precond==true ? cond : :($precond && $cond)
            generate_getprop(body.args, fields, combined_cond)
            continue
        elseif @capture(ex, @skip(n_))
            increment = n
        elseif @capture(ex, s_Symbol::T_) || @capture(ex, s_Symbol::T_ = v_)
            if @capture(T, @FixedLengthString(len_))
                read_io = :(String(jlread($io, UInt8, $(len))))
                increment = :($len)
            elseif @capture(T, @Blob(len_))
                read_io = :(jlread($io, UInt8, $(len))::Vector{UInt8})
                increment = :($len)
            elseif @capture(T, @Int(len_))
                read_io = :(read_nb_uint($io, $len)::UInt64)
                increment = :($len)
            elseif @capture(T, @Offset)
                read_io = :(RelOffset(getfield(m,:offset) + position($io) - getfield(m,:address)))
                increment = 0
            elseif @capture(T, @computed(expr_))
                read_io = expr
                increment = 0
            elseif @capture(T, @read(type_, rsize_)) || @capture(T, @read(type_))
                read_io = :(jlread($io, $(type)))
                increment = !isnothing(rsize) ? rsize :  :(sizeof(typeof(s)))
            else
                read_io = :(jlread($io, $T)::$(T))
                increment = :(sizeof($(T)))
            end

            io_assign = :($(s) = $read_io)
        else
            throw(ArgumentError("Invalid field syntax: $ex"))
        end

        push!(fields, (s, T, :(offset +=$increment), io_assign, precond))
    end
    return assemble_getprop(fields)
end

function filter_symbols(important_names, ex) 
    MacroTools.postwalk(ex) do ex
        if @capture(ex, s_Symbol)
            push!(important_names, s)
        end
    end
end

function assemble_getprop(fields_list)
    expr = Expr(:block)
    prep_statements = []
    important_names = Symbol[]
    for (s, T, increment, io_assign, cond) in fields_list
        filter_symbols(important_names, increment)
        filter_symbols(important_names, cond)
        filter_symbols(important_names, T)

        if isnothing(s)
            # must be a skip or so
            if cond == true
                push!(prep_statements, increment)
            else
                push!(prep_statements, Expr(:&&, cond, increment))
            end
            continue
        end

        filtered_exps = Expr[]
        for prep in prep_statements
            if prep isa Expr
                push!(filtered_exps, prep)
            else
                sym, ex = prep
                if sym in important_names
                    push!(filtered_exps, ex)
                end
            end
        end

        condexp = [io_assign,  :(return $s)]
        cond != true && (condexp = [:(if $(cond); $(condexp...) end)])

        push!(expr.args, :(
            if s == $(QuoteNode(s))
                offset = getfield(m, :address)
                $(filtered_exps...)
                seek(io, offset)
                $(condexp...)
            end))

        if cond == true
            push!(prep_statements, 
                (s,:(seek(io, offset))),
                (s, io_assign),
                increment)
        else
            push!(prep_statements, (s, Expr(:if, cond, 
                Expr(:block, 
                    :(seek(io, offset)),
                    io_assign))),
                Expr(:&&, cond, increment))
        end
    end
    return expr
end

@static if VERSION < v"1.7.0-A"
    # Location of `mutable` flag is moved from datatype to typename in julia v1.7
    # Switch to using accessor function added in v1.7

    # Borrowed from julia base
    function ismutabletype(@nospecialize(t::Type))
        t = Base.unwrap_unionall(t)
        # TODO: what to do for `Union`?
        return isa(t, DataType) && t.mutable
    end
end

@static if VERSION < v"1.7.0-A"
    #if :ninitialized in fieldnames(DataType)
    # https://github.com/JuliaIO/JLD2.jl/issues/327
    function ninitialized(@nospecialize(T::Type))::Int
        T.ninitialized
    end
else
    function ninitialized(@nospecialize(T::Type))::Int
        fieldcount(T) - T.name.n_uninitialized
    end
end

@static if VERSION < v"1.10.0"
    macro nospecializeinfer(exp)
        esc(exp)
    end
else
    using Base: @nospecializeinfer
end

@static if VERSION < v"1.7.0"
    isgensym(s::Symbol) = '#' in string(s)
else
    using Base: isgensym
end

module JLD2
using OrderedCollections: OrderedDict
using MacroTools: MacroTools, @capture
using Mmap: Mmap
using FileIO: load, save
export load, save
using ScopedValues: ScopedValue, with
using PrecompileTools: @setup_workload, @compile_workload
export jldopen, @load, @save, save_object, load_object, jldsave
export Shuffle, Deflate, ZstdFilter

include("types.jl")
include("macros_utils.jl")
include("io/mmapio.jl")
include("io/bufferedio.jl")
include("julia_compat.jl")
include("file_header.jl")
include("Lookup3.jl")
include("superblock.jl")
include("misc.jl")

# Windows 7 doesn't support mmap, falls back to IOStream
is_win7() = Sys.iswindows() && Sys.windows_version().major <= 6 && Sys.windows_version().minor <= 1
default_iotype() = is_win7() ? IOStream : MmapIO

"""
    Group(file::JLDFile, name::String)
    Group(file::Group, name::String)

Construct a `Group` in `file` with name `name`.
`Group`s are JLD2s equivalent of folders and may be nested, so `file` itself may alread be a `Group` or a `JLDFile` file handle.

## Example usage
```
jldopen("example.jld2", "w") do f
    g = Group(f, "subgroup")
    g["data"] = 42
end

jldopen("example.jld2") do f
    g = f["subgroup"]
    f["subgroup/data"] == g["data"]
end
```

## Keyword arguments:

- `est_num_entries::Int` = 4
- `est_link_name_len::Int` = 8

Determine how much (additional) empty space should be allocated for the group description. (list of entries)
This can be useful for performance when one expects to append many additional datasets after first writing the file.
"""
mutable struct Group{T}
    f::T
    last_chunk_start_offset::Int64
    continuation_message_goes_here::Int64
    last_chunk_checksum_offset::Int64
    next_link_offset::Int64
    est_num_entries::Int
    est_link_name_len::Int
    unwritten_links::OrderedDict{String,RelOffset}
    unwritten_child_groups::OrderedDict{String,Group{T}}
    written_links::OrderedDict{String,RelOffset}

    Group{T}(f; est_num_entries::Int=4, est_link_name_len::Int=8) where T =
        new(f, -1, -1, -1, -1, est_num_entries, est_link_name_len,
        OrderedDict{String,RelOffset}(), OrderedDict{String,Group{T}}())

    Group{T}(f, last_chunk_start_offset, continuation_message_goes_here,
             last_chunk_checksum_offset, next_link_offset,
             est_num_entries, est_link_name_len,
             unwritten_links, unwritten_child_groups,
             written_links) where T =
        new(f, last_chunk_start_offset, continuation_message_goes_here,
            last_chunk_checksum_offset, next_link_offset,
            est_num_entries, est_link_name_len,
            unwritten_links, unwritten_child_groups,
            written_links)
end



"""
    JLDFile{T<:IO}

JLD file object.
"""
mutable struct JLDFile{T<:IO}
    io::T
    path::String
    writable::Bool
    written::Bool
    plain::Bool
    compress#::Union{Bool,Symbol}
    mmaparrays::Bool
    n_times_opened::Int
    # Experimental feature: disable committing structs
    disable_commit::Bool
    datatype_locations::OrderedDict{RelOffset,CommittedDatatype}
    datatypes::Vector{H5Datatype}
    datatype_wsession::JLDWriteSession{Dict{UInt,Tuple{RelOffset,WeakRef}}}
    typemap
    jlh5type::IdDict{Any,Any}
    h5jltype::IdDict{Any,Any}
    jloffset::Dict{RelOffset,WeakRef}
    end_of_data::Int64
    global_heaps::Dict{RelOffset,GlobalHeap}
    global_heap::GlobalHeap
    loaded_groups::Dict{RelOffset,Group{JLDFile{T}}}
    root_group_offset::RelOffset
    root_group::Group{JLDFile{T}}
    types_group::Group{JLDFile{T}}
    base_address::UInt64


    function JLDFile{T}(io::IO, path::AbstractString, writable::Bool, written::Bool,
                        plain::Bool,
                        compress,#::Union{Bool,Symbol},
                        mmaparrays::Bool,
                        typemap=default_typemap) where T
        f = new(io, path, writable, written, plain, compress, mmaparrays, 1, false,
            OrderedDict{RelOffset,CommittedDatatype}(), H5Datatype[],
            JLDWriteSession(), typemap, IdDict(), IdDict(), Dict{RelOffset,WeakRef}(),
            DATA_START, Dict{RelOffset,GlobalHeap}(),
            GlobalHeap(0, 0, 0, Int64[]), Dict{RelOffset,Group{JLDFile{T}}}(), UNDEFINED_ADDRESS)
        finalizer(jld_finalizer, f)
        f
    end
end
JLDFile(io::IO, path::AbstractString, writable::Bool, written::Bool, plain::Bool, compress, mmaparrays::Bool, typemap=default_typemap) =
    JLDFile{typeof(io)}(io, path, writable, written, plain, compress, mmaparrays, typemap)

"""
    fileoffset(f::JLDFile, x::RelOffset)

Converts an offset `x` relative to the superblock of file `f` to an absolute offset.
"""
fileoffset(f::JLDFile, x::RelOffset) = Int64(x.offset + f.base_address)

"""
    h5offset(f::JLDFile, x::Integer)

Converts an absolute file offset `x` to an offset relative to the superblock of file `f`.
"""
h5offset(f::JLDFile, x::Integer) = RelOffset(UInt64(x - f.base_address))

#
# File
#

openfile(::Type{IOStream}, fname, wr, create, truncate, fallback::Nothing = nothing) =
    open(fname, read = true, write = wr, create = create,
         truncate = truncate, append = false)
openfile(::Type{MmapIO}, fname, wr, create, truncate, fallback::Nothing = nothing) =
    MmapIO(fname, wr, create, truncate)

function openfile(T::Type, fname, wr, create, truncate, fallback::Type)
    try
         openfile(T, fname, wr, create, truncate, nothing)
    catch
        @warn "Opening file with $T failed, falling back to $fallback"
        openfile(fallback, fname, wr, create, truncate, nothing)
    end
end

# default fallback behaviour : MmapIO -> IOStream -> failure
FallbackType(::Type{MmapIO}) = IOStream
FallbackType(::Type{IOStream}) = nothing

const OPEN_FILES = Dict{String,WeakRef}()
const OPEN_FILES_LOCK = ReentrantLock()

function jldopen(fname::AbstractString, wr::Bool, create::Bool, truncate::Bool,
    iotype::T=default_iotype();
    fallback::Union{Type,Nothing}=FallbackType(iotype),
    compress=false,
    mmaparrays::Bool=false,
    typemap=default_typemap,
    parallel_read::Bool=false,
    plain::Bool=false
) where T<:Union{Type{IOStream},Type{MmapIO}}
  
    mmaparrays && @warn "mmaparrays keyword is currently ignored" maxlog = 1
    filters = Filters.normalize_filters(compress)

    # Can only open multiple in parallel if mode is "r"
    if parallel_read && (wr, create, truncate) != (false, false, false)
        throw(ArgumentError("Cannot open file in a parallel context unless mode is \"r\""))
    end

    lock(OPEN_FILES_LOCK)

    f = try
        exists = ispath(fname)
        if exists
            rname = realpath(fname)
            # catch existing file system entities that are not regular files
            !isfile(rname) && throw(ArgumentError("not a regular file: $fname"))

            f = get(OPEN_FILES, rname, (; value=nothing)).value
            # If in serial, return existing handle. In parallel always generate a new handle
            if !isnothing(f)
                if parallel_read
                    f.writable && throw(ArgumentError("Tried to open file in a parallel context but it is open in write-mode elsewhere in a serial context."))
                else
                    if truncate
                        throw(ArgumentError("attempted to truncate a file that was already open"))
                    elseif !isa(f, JLDFile{iotype})
                        throw(ArgumentError("attempted to open file with $iotype backend, but already open with a different backend"))
                    elseif f.writable != wr
                        current = wr ? "read/write" : "read-only"
                        previous = f.writable ? "read/write" : "read-only"
                        throw(ArgumentError("attempted to open file $(current), but file was already open $(previous)"))
                    elseif f.compress != filters
                        throw(ArgumentError("attempted to open file with compress=$(filters), but file was already open with compress=$(f.compress)"))
                    elseif f.mmaparrays != mmaparrays
                        throw(ArgumentError("attempted to open file with mmaparrays=$(mmaparrays), but file was already open with mmaparrays=$(f.mmaparrays)"))
                    end
                    f = f::JLDFile{iotype}
                    f.n_times_opened += 1
                    return f
                end
            end
        end

        io = openfile(iotype, fname, wr, create, truncate, fallback)
        created = !exists || truncate
        rname = realpath(fname)
        f = JLDFile(io, rname, wr, created, plain, filters, mmaparrays, typemap)

        !parallel_read && (OPEN_FILES[rname] = WeakRef(f))

        f
    finally
        unlock(OPEN_FILES_LOCK)
    end
    try
        initialize_fileobject!(f)
    catch e
        close(f)
        throw(e)
    end
    return f
end

function initialize_fileobject!(f::JLDFile)
    if f.written
        f.base_address = 512
        f.root_group = Group{typeof(f)}(f)
        f.types_group =  Group{typeof(f)}(f)
        return
    end
    superblock = find_superblock(f)
    f.end_of_data = superblock.end_of_file_address
    f.base_address = superblock.base_address
    f.root_group_offset = superblock.root_group_object_header_address
    if superblock.version >= 2
        verify_file_header(f)
    elseif f.writable
        close(f)
        throw(UnsupportedVersionException("This file can not be edited by JLD2. Please open in read-only mode."))
    end
    f.root_group = load_group(f, f.root_group_offset)

    types_offset = get(f.root_group.written_links, "_types", UNDEFINED_ADDRESS)
    if types_offset != UNDEFINED_ADDRESS
        f.types_group = f.loaded_groups[types_offset] = load_group(f, types_offset)
        for (i, offset::RelOffset) in enumerate(values(f.types_group.written_links))
            f.datatype_locations[offset] = CommittedDatatype(offset, i)
        end
        resize!(f.datatypes, length(f.datatype_locations))
    else
        f.types_group = Group{typeof(f)}(f)
    end
end

"""
    jldopen(file, mode::AbstractString; iotype=MmapIO, compress=false, typemap=JLD2.default_typemap)

Opens a JLD2 file at path `file`. Alternatively `file` may be a suitable IO object.

Options for `mode`:
- `"r"`: Open for reading only, failing if no file exists
- `"r+"`: Open for reading and writing, failing if no file exists
- `"w"`/`"w+"`: Open for reading and writing, overwriting the file if it already exists
- `"a"`/`"a+"`: Open for reading and writing, creating a new file if none exists, but
                preserving the existing file if one is present
"""
function jldopen(fname::AbstractString, mode::AbstractString="r"; iotype=default_iotype(), kwargs...)
    (wr, create, truncate) = mode == "r"  ? (false, false, false) :
                             mode == "r+" ? (true, false, false) :
                             mode == "a" || mode == "a+" ? (true, true, false) :
                             mode == "w" || mode == "w+" ? (true, true, true) :
                             throw(ArgumentError("invalid open mode: $mode"))
    jldopen(fname, wr, create, truncate, iotype; kwargs...)
end

# Base.isseekable does not exist, so we implement a check
isseekable(io) = false
isseekable(io::IOStream) = true
isseekable(io::IOBuffer) = io.seekable

# Internal function that wraps various IO types into a MemoryBackedIO suitable for JLD2.
# This provides a unified interface for all non-file IO operations.
function _wrap_io(data::Vector{UInt8}, writable::Bool, truncate::Bool)
    truncate && empty!(data)
    io = ByteVectorIO(data, writable)
    return (io, "ByteVector", isempty(data))
end

function _wrap_io(io::IO, writable::Bool, truncate::Bool)
    !isreadable(io) && throw(ArgumentError("IO object is not readable"))

    # Check if it's seekable and writable
    if isseekable(io)
        if writable && !iswritable(io)
             throw(ArgumentError("IO object is not writable"))
        end
        if truncate
            Base.truncate(io, 0)
            seekstart(io)
        end
        # Read/write capable IO (e.g., IOBuffer in r+ mode)
        wrapped = RWBuffer(io)
        created = truncate
        return (wrapped, "RWBuffer", created)
    elseif !writable
        # Read-only IO
        wrapped = ReadOnlyBuffer(io)
        return (wrapped, "ReadOnlyBuffer", false)
    else
        throw(ArgumentError("IO object does not support the requested access mode"))
    end
end

"""
    jldopen(io::Union{IO,Vector{UInt8}}, mode::AbstractString="r"; kwargs...)

Open a JLD2 file from a non-file IO source (IOBuffer, Vector{UInt8}, or other IO).
"""
function jldopen(io::Union{IO,Vector{UInt8}}, mode::AbstractString="r"; kwargs...)
    # Parse mode string
    (wr, create, truncate) = mode == "r"  ? (false, false, false) :
                             mode == "r+" ? (true, false, false) :
                             mode == "a" || mode == "a+" ? (true, true, false) :
                             mode == "w" || mode == "w+" ? (true, true, true) :
                             throw(ArgumentError("invalid open mode: $mode"))
    return jldopen(io, wr, create, truncate; kwargs...)
end

function jldopen(io::Union{IO,Vector{UInt8}}, writable::Bool, create::Bool, truncate::Bool;
                plain::Bool=false,
                compress=false,
                typemap=default_typemap)
    wrapped_io, path_name, created = _wrap_io(io, writable, truncate)
    filters = Filters.normalize_filters(compress)
    f = JLDFile(wrapped_io, path_name, writable, created, plain, filters, false, typemap)
    initialize_fileobject!(f)
    return f
end

"""
    load_datatypes(f::JLDFile)

Populate `f.datatypes` and `f.jlh5types` with all of the committed datatypes from a file.
We need to do this before writing to make sure we reuse written datatypes.
"""
function load_datatypes(f::JLDFile)
    dts = f.datatypes
    cdts = f.datatype_locations
    @assert length(dts) == length(cdts)
    i = 1
    for cdt in values(cdts)
        !isassigned(dts, i) && jltype(f, cdt)
        i += 1
    end
end

"""
    prewrite(f::JLDFile)

Check that a JLD file is actually writable, and throw an error if not. Sets the `written`
flag on the file.
"""
function prewrite(f::JLDFile)
    f.n_times_opened == 0 && throw(ArgumentError("file is closed"))
    !f.writable && throw(ArgumentError("file was opened read-only"))
    !f.written && load_datatypes(f)
    f.written = true
end

@nospecializeinfer function Base.write(
    f::JLDFile,
    name::AbstractString,
    @nospecialize(obj),
    wsession::JLDWriteSession=JLDWriteSession();
    kwargs...
)
    write(f.root_group, name, obj, wsession; kwargs...)
end

Base.read(f::JLDFile, name::AbstractString) = Base.inferencebarrier(f.root_group[name])
Base.getindex(f::JLDFile, name::AbstractString) = Base.inferencebarrier(f.root_group[name])
Base.setindex!(f::JLDFile, obj, name::AbstractString) = (f.root_group[name] = obj; f)
Base.haskey(f::JLDFile, name::AbstractString) = haskey(f.root_group, name)
Base.isempty(f::JLDFile) = isempty(f.root_group)
Base.keys(f::JLDFile) = filter!(x->x != "_types", keys(f.root_group))
Base.keytype(f::JLDFile) = String
Base.length(f::Union{JLDFile, Group}) = length(keys(f))

Base.get(default::Function, f::Union{JLDFile, Group}, name::AbstractString) =
    haskey(f, name) ? f[name] : default()
Base.get(f::Union{JLDFile, Group}, name::AbstractString, default) =
    haskey(f, name) ? f[name] : default
Base.get!(f::Union{JLDFile, Group}, name::AbstractString, default) =
    get!(() -> default, f, name)
function Base.get!(default::Function, f::Union{JLDFile, Group}, name::AbstractString)
    if haskey(f, name)
        return f[name]
    else
        default_value = default()
        f[name] = default_value
        return default_value
    end
end

function Base.close(f::JLDFile)
    if f.n_times_opened != 1
        f.n_times_opened == 0 && return
        f.n_times_opened -= 1
        return
    end

    io = f.io
    if f.written
        # Save any groups we know of that have been modified
        for group in values(f.loaded_groups)
            save_group(group)
        end
        if !isempty(f.types_group) && !haskey(f.root_group, "_types")
            f.root_group["_types"] = f.types_group
        end
        res = save_group(f.root_group)
        if f.root_group_offset == UNDEFINED_ADDRESS
            f.root_group_offset = res
        end

        write_file_header(f)
        truncate_and_close(io, f.end_of_data)
    else
        close(io)
    end
    lock(OPEN_FILES_LOCK) do
        delete!(OPEN_FILES, f.path)
        f.n_times_opened = 0
    end
    nothing
end

"""
    jld_finalizer(f::JLDFile)

When a JLDFile is finalized, it is possible that the `MmapIO` has been munmapped, since
Julia does not guarantee finalizer order. This means that the underlying file may be closed
before we get a chance to write to it.
"""
function jld_finalizer(f::JLDFile{MmapIO})
    f.n_times_opened == 0 && return
    if f.written && !isopen(f.io.f)
        f.io.f = open(f.path, "r+")
    end
    f.n_times_opened = 1
    close(f)
end

function jld_finalizer(f::JLDFile{IOStream})
    f.n_times_opened == 0 && return
    if f.written && !isopen(f.io)
        f.io = openfile(IOStream, f.path, true, false, false)
    end
    f.n_times_opened = 1
    close(f)
end

function jld_finalizer(f::JLDFile)
    f.n_times_opened == 0 && return
    close(f)
end
# Display functions

# simple one-line display (without trailing line break)
function Base.show(io::IO, f::JLDFile)
    print(io, "JLDFile $(f.path)")
    if get(io, :compact, false)
        return
    else
        print(io, f.writable ? " (read/write)" : " (read-only)")
    end
end

# fancy multi-line display (unless an IOContext requests compactness)
function Base.show(io::IO, ::MIME"text/plain", f::JLDFile)
    show(io, f)
    if !get(io, :compact, false)
        print(io, "\n")
        printtoc(io, f; numlines = get(io, :jld2_numlines, 10))
    end
    return nothing
end

"""
    printtoc([io::IO,] f::JLDFile [; numlines])

Prints an overview of the contents of `f` to the `IO`.

Use the optional `numlines` parameter to restrict the amount of items listed.
"""
printtoc(f::JLDFile; kwargs...) = printtoc(Base.stdout, f; kwargs...)
function printtoc(io::IO, f::JLDFile; numlines = typemax(Int64))
    show_group(io, f.root_group, numlines, " ", true)
    return nothing
end



include("object_headers.jl")
include("headermessages.jl")
include("groups.jl")
include("dataspaces.jl")
include("attributes.jl")
include("datatypes.jl")
include("datalayouts.jl")

include("Filters.jl")
using .Filters: WrittenFilterPipeline, FilterPipeline, iscompressed
using .Filters: Shuffle, Deflate, ZstdFilter

include("datasets.jl")
include("global_heaps.jl")
include("fractal_heaps.jl")

include("data/type_defs.jl")
include("data/specialcased_types.jl")
include("data/number_types.jl")
include("data/custom_serialization.jl")
include("data/writing_datatypes.jl")
include("data/reconstructing_datatypes.jl")


include("io/dataio.jl")
include("io/io_wrappers.jl")
include("loadsave.jl")
include("backwards_compatibility.jl")
include("inlineunion.jl")
include("fileio.jl")
include("explicit_datasets.jl")
include("committed_datatype_introspection.jl")


if ccall(:jl_generating_output, Cint, ()) == 1   # if we're precompiling the package
    include("precompile.jl")
end

end

using Test, JLD2
using LazyArtifacts

# NOTE: Keep this artifact version in sync with test_files.jl
testfiles = artifact"testfiles/JLD2TestFiles-0.1.9/artifacts"

# Helper functions for testing
function test_dataset_show_basic(dset, key, filename)
    # Test that show doesn't throw errors
    if filename in ["test_dataset_show_structs.jld2", "test_dataset_show_nested.jld2"]
        show_success = try
            show(IOBuffer(), MIME("text/plain"), dset)
            true
        catch
            false
        end
        @test show_success
    else
        @test_nowarn show(IOBuffer(), MIME("text/plain"), dset)
    end
end

function get_dataset_show_output(dset)
    io = IOBuffer()
    show(io, MIME("text/plain"), dset)
    String(take!(io))
end

function test_dataset_format_structure(output, key)
    @test startswith(output, "┌─ Dataset:")
    @test contains(output, "\"$key\"")
    @test endswith(strip(output), "└─")

    # Check proper indentation
    lines = split(output, '\n')
    content_lines = filter(line -> contains(line, "│"), lines)
    !isempty(content_lines) && @test all(line -> startswith(line, "│"), content_lines)
end

function test_dataset_written_info(dset, output)
    if JLD2.iswritten(dset)
        @test contains(output, "datatype:")
        @test contains(output, "type name:")
        !isnothing(dset.dataspace) && @test contains(output, "dataspace:")
        !isnothing(dset.layout) && @test contains(output, "layout:")
    else
        @test contains(output, "(unwritten)")
    end
end

function test_dataset_detailed_output(dset, key, output)
    @testset "Detailed output validation for $key" begin
        lines = split(output, '\n')
        @test length(lines) >= 2

        # Test header and footer
        @test startswith(lines[1], "┌─ Dataset:") && contains(lines[1], "\"$key\"")

        non_empty_lines = filter(line -> !isempty(strip(line)), lines)
        !isempty(non_empty_lines) && @test strip(non_empty_lines[end]) == "└─"

        # Test content lines structure
        length(non_empty_lines) > 2 && foreach(line -> @test(startswith(line, "│")), non_empty_lines[2:end-1])

        # Test dimension information
        if contains(key, "scalar")
            @test contains(output, "dimensions: ()")
        elseif contains(key, "array") || contains(key, "matrix")
            @test contains(output, "dimensions:")
        end

        # Test type information presence (relaxed)
        if JLD2.iswritten(dset) && contains(output, "written structure:")
            type_patterns = ["::", "Int", "Float", "String", "Bool", "Nothing", "Symbol"]
            type_info_present = any(pattern -> any(line -> contains(line, pattern), lines), type_patterns)
            !type_info_present && @test_skip "Type information not always recognizable in display"
        end
    end
end

function test_dataset_display_modes(dset, key)
    @testset "Display modes for $key" begin
        # Test compact display
        compact_output = sprint(show, dset)
        @test !isempty(compact_output)
        @test contains(compact_output, "Dataset") || contains(compact_output, key)
    end
end

function test_dataset_edge_cases(dset)
    @testset "Edge cases" begin
        # Test with different IO contexts
        for io_context in [IOBuffer(), IOContext(IOBuffer(), :color => false)]
            @test_nowarn show(io_context, MIME("text/plain"), dset)
            output = String(take!(io_context isa IOContext ? io_context.io : io_context))
            @test !isempty(output) && startswith(output, "┌─ Dataset:")
        end

        # Test string representation
        str_repr = string(dset)
        @test !isempty(str_repr) && contains(str_repr, "Dataset")
    end
end

@testset "Dataset Show Function Tests" begin
    # Test dataset show functionality with comprehensive test files

    test_files = [
        ("test_dataset_show_basic.jld2", ["int_scalar", "float_scalar", "string_scalar", "bool_scalar", "int_array", "float_matrix", "string_array"]),
        ("test_dataset_show_structs.jld2", ["simple_struct", "mutable_struct", "parametric_int", "parametric_string"]),
        ("test_dataset_show_nested.jld2", ["nested_basic", "simple_tuple", "named_tuple", "union_type"]),
        ("test_dataset_show_special.jld2", ["empty_array", "empty_string", "nothing_val", "symbol_val", "small_matrix"])
    ]

    for (filename, expected_keys) in test_files
        @testset "Show output for $filename" begin
            fn = joinpath(testfiles, filename)
            jldopen(fn, "r") do f
                # Verify all expected keys are present
                @test all(key -> haskey(f, key), expected_keys)

                for key in keys(f)
                    @testset "Dataset: $key" begin
                        dset = JLD2.get_dataset(f, key)

                        # Test show functionality
                        test_dataset_show_basic(dset, key, filename)
                        output = get_dataset_show_output(dset)
                        test_dataset_format_structure(output, key)
                        test_dataset_written_info(dset, output)
                        test_dataset_detailed_output(dset, key, output)
                        test_dataset_display_modes(dset, key)
                        test_dataset_edge_cases(dset)
                    end
                end
            end
        end
    end

    # Additional comprehensive test suites to match original coverage
    @testset "Attribute Display Tests" begin
        # Test datasets with attributes
        for filename in ["test_dataset_show_basic.jld2", "test_dataset_show_structs.jld2"]
            fn = joinpath(testfiles, filename)
            jldopen(fn, "r") do f
                for key in keys(f)
                    dset = JLD2.get_dataset(f, key)
                    # Test attribute display if any exist
                    if !isempty(dset.attributes)
                        io = IOBuffer()
                        show(io, MIME("text/plain"), dset)
                        output = String(take!(io))
                        @test contains(output, "attributes:") ||
                              !isempty(dset.attributes)  # Should show attributes if they exist
                    end
                end
            end
        end
    end

    @testset "Committed Datatype Display" begin
        # Test committed datatype information
        for filename in ["test_dataset_show_structs.jld2", "test_dataset_show_nested.jld2"]
            fn = joinpath(testfiles, filename)
            jldopen(fn, "r") do f
                for key in keys(f)
                    dset = JLD2.get_dataset(f, key)
                    if dset.datatype isa JLD2.SharedDatatype
                        io = IOBuffer()
                        show(io, MIME("text/plain"), dset)
                        output = String(take!(io))
                        @test contains(output, "committed")
                        @test contains(output, "RelOffset")
                    end
                end
            end
        end
    end

    @testset "Error Handling Tests" begin
        # Test error handling for edge cases
        fn = joinpath(testfiles, "test_dataset_show_special.jld2")
        jldopen(fn, "r") do f
            # Test with nothing value
            if haskey(f, "nothing_val")
                dset = JLD2.get_dataset(f, "nothing_val")
                @test_nowarn show(IOBuffer(), MIME("text/plain"), dset)
            end

            # Test with empty containers
            if haskey(f, "empty_array")
                dset = JLD2.get_dataset(f, "empty_array")
                io = IOBuffer()
                show(io, MIME("text/plain"), dset)
                output = String(take!(io))
                @test contains(output, "dimensions:")
            end
        end
    end

    @testset "Output Format Consistency" begin
        # Test that output format is consistent across all datasets
        all_outputs = String[]

        for (filename, expected_keys) in test_files
            fn = joinpath(testfiles, filename)
            jldopen(fn, "r") do f
                for key in keys(f)
                    dset = JLD2.get_dataset(f, key)
                    io = IOBuffer()
                    show(io, MIME("text/plain"), dset)
                    output = String(take!(io))
                    push!(all_outputs, output)

                    # Test consistent formatting
                    lines = split(output, '\n')
                    @test startswith(lines[1], "┌─ Dataset:")

                    # Check footer properly (handle trailing newlines)
                    non_empty_lines = [line for line in lines if !isempty(strip(line))]
                    if !isempty(non_empty_lines)
                        @test strip(non_empty_lines[end]) == "└─"
                    end

                    # Test consistent indentation (excluding header and footer)
                    if length(non_empty_lines) > 2
                        content_lines = non_empty_lines[2:end-1]
                        for line in content_lines
                            @test startswith(line, "│")
                        end
                    end

                    # Test consistent spacing
                    @test !contains(output, "│ \t")  # No mixed tabs/spaces
                    @test !contains(output, "  \n")  # No trailing spaces

                    # Test proper line endings
                    @test !contains(output, "\r")   # No Windows line endings

                    # Test Unicode box drawing characters are used correctly
                    @test contains(output, "┌─") && contains(output, "└─") && contains(output, "│")
                end
            end
        end

        # Test that we have comprehensive coverage
        @test length(all_outputs) >= 20  # Should test at least 20 different datasets

        # Test that outputs have variety (not all identical)
        unique_outputs = unique(all_outputs)
        @test length(unique_outputs) >= 15  # Should have varied content
    end

    @testset "Performance and Memory Tests" begin
        # Test that show operations don't consume excessive memory or time
        fn = joinpath(testfiles, "test_dataset_show_basic.jld2")
        jldopen(fn, "r") do f
            for key in keys(f)
                dset = JLD2.get_dataset(f, key)

                # Test performance
                @test (@elapsed show(IOBuffer(), MIME("text/plain"), dset)) < 1.0  # Should be fast

                # Test memory usage is reasonable
                io = IOBuffer()
                show(io, MIME("text/plain"), dset)
                output = String(take!(io))
                @test length(output) < 10000  # Should not be excessively long
                @test sizeof(output) < 50000  # Should not use excessive memory
            end
        end
    end
end

#
# Global heap
#

const GLOBAL_HEAP_SIGNATURE = htol(0x4c4f4347) # "GCOL"

struct GlobalHeapID
    heap_offset::RelOffset
    index::UInt32
end
define_packed(GlobalHeapID)

isatend(f::JLDFile, gh::GlobalHeap) =
    gh.offset != 0 && f.end_of_data == gh.offset + 8 + jlsizeof(Length) + gh.length

heap_object_length(data::AbstractArray) = length(data)
heap_object_length(::Any) = 1

function write_heap_object(f::JLDFile, odr::ODR, data, wsession::JLDWriteSession) where ODR
    # The type parameter ODR is needed to convince the compiler to specialize on ODR.
    psz = odr_sizeof(odr) * heap_object_length(data)
    objsz = 8 + jlsizeof(Length) + psz
    objsz += 8 - mod1(objsz, 8)
    io = f.io

    # This is basically a memory allocation problem. Right now we do it
    # in a pretty naive way. We:
    #
    # 1. Put the object in the last created global heap if it fits
    # 2. Extend the last global heap if it's at the end of the file
    # 3. Create a new global heap if we can't do 1 or 2
    #
    # This is not a great approach if we're writing objects of
    # different sizes interspersed with new datasets. The torture case
    # would be a Vector{Any} of mutable objects, some of which contain
    # large (>4080 byte) strings and some of which contain small
    # strings. In that case, we'd be better off trying to put the small
    # strings into existing heaps, rather than writing new ones. This
    # should be revisited at a later date.

    # Can only fit up to typemax(UInt16) items in a single heap
    heap_filled = length(f.global_heap.objects) >= typemax(UInt16)
    if objsz + 8 + jlsizeof(Length) < f.global_heap.free && !heap_filled
        # Fits in existing global heap
        gh = f.global_heap
    elseif isatend(f, f.global_heap) && !heap_filled
        # Global heap is at end and can be extended
        gh = f.global_heap
        delta = objsz - gh.free + 8 + jlsizeof(Length)
        gh.free += delta
        gh.length += delta
        seek(io, gh.offset + 8)
        jlwrite(io, gh.length)
        f.end_of_data += delta
    else
        # Need to create a new global heap
        heapsz = max(objsz, 4096)
        offset = f.end_of_data + 8 - mod1(f.end_of_data, 8)
        seek(io, offset)
        jlwrite(io, GLOBAL_HEAP_SIGNATURE)
        jlwrite(io, UInt32(1))      # Version & Reserved
        jlwrite(io, Length(heapsz)) # Collection size
        f.end_of_data = position(io) + heapsz
        gh = f.global_heap = f.global_heaps[h5offset(f, offset)] =
            GlobalHeap(offset, heapsz, heapsz, Int64[])
    end

    # Write data
    index = length(gh.objects) + 1
    objoffset = gh.offset + 8 + jlsizeof(Length) + gh.length - gh.free
    seek(io, objoffset)
    jlwrite(io, UInt16(index))           # Heap object index
    jlwrite(io, UInt16(1))               # Reference count
    jlwrite(io, UInt32(0))               # Reserved
    jlwrite(io, Length(psz))             # Object size

    # Update global heap object
    gh.free -= objsz
    push!(gh.objects, objoffset)

    # Write free space object
    if gh.free >= 8 + jlsizeof(Length)
        seek(io, objoffset + objsz)
        jlwrite(io, UInt64(0))           # Object index, reference count, reserved
        jlwrite(io, Length(gh.free - 8 - jlsizeof(Length))) # Object size
    end

    # Write data
    seek(io, objoffset + 8 + jlsizeof(Length))
    write_data(io, f, data, odr, datamode(odr), wsession) # Object data

    GlobalHeapID(h5offset(f, gh.offset), index)
end

# Force specialization on DataType
write_heap_object(f::JLDFile, odr::Type{Union{}}, data, wsession::JLDWriteSession) =
    error("ODR is invalid")

function jlread(io::IO, ::Type{GlobalHeap})
    offset = position(io)
    jlread(io, UInt32) == GLOBAL_HEAP_SIGNATURE || throw(InvalidDataException())
    jlread(io, UInt32) == 1 || throw(UnsupportedVersionException())
    heapsz = jlread(io, Length)
    index = 1
    objects = Int64[]
    startpos = position(io)
    free = heapsz
    while free > 8 + jlsizeof(Length)
        curpos = position(io)
        objidx = jlread(io, UInt16)
        objidx == 0 && break
        if objidx > index 
            append!(objects, fill(typemax(Int), objidx-index))
            index = objidx
        elseif objidx < index
            throw(InvalidDataException("Encountered unordered list of global heap objects."))
        end
        push!(objects, curpos)
        skip(io, 6)                    # Reference count and reserved
        sz = jlread(io, Length)          # Length
        skip(io, sz + 8 - mod1(sz, 8)) # Payload
        free = heapsz - Length(position(io) - startpos)
        index += 1
    end
    GlobalHeap(offset, heapsz, free, objects)
end

function read_heap_object(f::JLDFile, hid::GlobalHeapID, rr::ReadRepresentation)
    io = f.io
    if haskey(f.global_heaps, hid.heap_offset)
        gh = f.global_heaps[hid.heap_offset]
    else
        seek(io, fileoffset(f, hid.heap_offset))
        f.global_heaps[hid.heap_offset] = gh = jlread(io, GlobalHeap)
    end
    seek(io, gh.objects[hid.index]+8)
    len = Int(jlread(io, Length))
    n = div(len, odr_sizeof(rr))
    len == n * odr_sizeof(rr) || throw(InvalidDataException())

    read_array!(Vector{julia_repr(rr)}(undef, n), f, rr)
end

#
# Dataspaces
#

const DS_SCALAR = 0x00
const DS_SIMPLE = 0x01
const DS_NULL = 0x02
const DS_V1 = 0xff

struct WriteDataspace{N,A<:Tuple}
    dataspace_type::UInt8
    size::NTuple{N,Length}
    attributes::A
end

struct ReadDataspace
    dataspace_type::UInt8
    dimensionality::UInt8
    dimensions_offset::Int64
end
ReadDataspace() = ReadDataspace(DS_SCALAR, 0, -1)

ReadDataspace(f, msg_::Union{Hmessage, Message}) = 
    ReadDataspace(f,  HmWrap(HmDataspace, msg_))
ReadDataspace(f, msg::HmWrap{HmDataspace}) =
    ReadDataspace(msg.dataspace_type, msg.dimensionality, fileoffset(f, msg.dim_offset))

struct DataspaceStart
    version::UInt8
    dimensionality::UInt8
    flags::UInt8
    dataspace_type::UInt8
end
define_packed(DataspaceStart)

const EMPTY_DIMENSIONS = Int64[]

# Pass-through for custom serializations
# Need a bunch of methods to avoid ambiguity
WriteDataspace(f::JLDFile, x, ::Type{CustomSerialization{S,ODR}}) where {S,ODR} =
    WriteDataspace(f, x, ODR)
WriteDataspace(f::JLDFile, x::Array, ::Type{CustomSerialization{S,ODR}}) where {S,ODR} =
    WriteDataspace(f, x, ODR)
WriteDataspace(f::JLDFile, x::Array{T,0}, ::Type{CustomSerialization{S,ODR}}) where {T,S,ODR} =
    WriteDataspace(f, x, ODR)

WriteDataspace() = WriteDataspace(DS_NULL, (), ())
WriteDataspace(::JLDFile, ::Any, odr::Nothing) = WriteDataspace()
WriteDataspace(::JLDFile, ::Any, ::Any) = WriteDataspace(DS_SCALAR, (), ())

# Ghost type array
WriteDataspace(f::JLDFile, x::Array{T}, ::Nothing) where {T} =
   WriteDataspace(DS_NULL, (),
             (WrittenAttribute(f, :dimensions, collect(Int64, reverse(size(x)))),))

# Reference array
WriteDataspace(f::JLDFile, x::Array{T,N}, ::Type{RelOffset}) where {T,N} =
    WriteDataspace(DS_SIMPLE, convert(Tuple{Vararg{Length}}, reverse(size(x))),
              (WrittenAttribute(f, :julia_type, write_ref(f, T, f.datatype_wsession)),))

# isbitstype array
WriteDataspace(f::JLDFile, x::Array, ::Any) =
    WriteDataspace(DS_SIMPLE, convert(Tuple{Vararg{Length}}, reverse(size(x))), ())

# Zero-dimensional arrays need an empty dimensions attribute
WriteDataspace(f::JLDFile, x::Array{T,0}, ::Nothing) where {T} =
    WriteDataspace(DS_NULL, (Length(1),),
              (WrittenAttribute(f, :dimensions, EMPTY_DIMENSIONS)))
WriteDataspace(f::JLDFile, x::Array{T,0}, ::Type{RelOffset}) where {T} =
    WriteDataspace(DS_SIMPLE, (Length(1),),
              (WrittenAttribute(f, :julia_type, write_ref(f, T, f.datatype_wsession)),
               WrittenAttribute(f, :dimensions, EMPTY_DIMENSIONS)))
WriteDataspace(f::JLDFile, x::Array{T,0}, ::Any) where {T} =
    WriteDataspace(DS_SIMPLE, (Length(1),),
              (WrittenAttribute(f, :dimensions, EMPTY_DIMENSIONS),))

@static if VERSION >= v"1.11"
    # Memory is basically a vector but needs an additional attribute
    # Ghost type array
    WriteDataspace(f::JLDFile, x::Memory{T}, ::Nothing) where {T} =
    WriteDataspace(DS_NULL, (),
                (WrittenAttribute(f, :dimensions, collect(Int64, reverse(size(x)))),
                WrittenAttribute(f, :Memory, true)))

    # Reference array
    WriteDataspace(f::JLDFile, x::Memory{T}, ::Type{RelOffset}) where {T} =
        WriteDataspace(DS_SIMPLE, convert(Tuple{Vararg{Length}}, reverse(size(x))),
                (WrittenAttribute(f, :julia_type, write_ref(f, T, f.datatype_wsession)),
                WrittenAttribute(f, :Memory, true)))

    # isbitstype array
    WriteDataspace(f::JLDFile, x::Memory, ::Any) =
        WriteDataspace(DS_SIMPLE, convert(Tuple{Vararg{Length}}, reverse(size(x))),
        (WrittenAttribute(f, :Memory, true),))
end


jlsizeof(::Union{WriteDataspace{N},Type{WriteDataspace{N}}}) where {N} = 4 + jlsizeof(Length)*N
numel(x::WriteDataspace{0}) = x.dataspace_type == DS_SCALAR ? 1 : 0
numel(x::WriteDataspace) = Int(prod(x.size))

function jlwrite(io::IO, dspace::WriteDataspace{N}) where N
    jlwrite(io, DataspaceStart(2, N, 0, dspace.dataspace_type))
    for x in dspace.size
        jlwrite(io, x::Length)
    end
end

"""
    MemoryBackedIO <: IO

Abstract type for IO objects that are backed by memory in such a way that
one can use pointer based `unsafe_load` and `unsafe_store!` operations
after ensuring that there is enough memory allocated.

It needs to provide:
 - `getproperty(io, :curptr)` to get the current pointer
 - `ensureroom(io, nb)` to ensure that there are at least nb bytes available
 - `position(io)` to get the current (zero-based) position
 - `seek(io, pos)` to set the current position (zero-based)
"""
abstract type MemoryBackedIO <: IO end



# Define custom `jlread`, `jlwrite`, `jlunsafe_load`, `jlunsafe_store!` functions for a struct
# this needs to be called immediately after the struct definition (since it itself calls `jlsizeof`)
function define_packed(ty::DataType)
    @assert isbitstype(ty)
    packed_offsets = cumsum([jlsizeof(x) for x in ty.types])
    sz = pop!(packed_offsets)
    pushfirst!(packed_offsets, 0)

    if sz != jlsizeof(ty)
        @eval begin
            function jlunsafe_store!(p::Ptr{$ty}, x::$ty)
                $([:(jlunsafe_store!(pconvert(Ptr{$(ty.types[i])}, p+$(packed_offsets[i])), getfield(x, $i)))
                   for i = 1:length(packed_offsets)]...)
            end
            function jlunsafe_load(p::Ptr{$ty})
                $(Expr(:new, ty, [:(jlunsafe_load(pconvert(Ptr{$(ty.types[i])}, p+$(packed_offsets[i]))))
                                   for i = 1:length(packed_offsets)]...))
            end
            jlsizeof(::Union{$ty,Type{$ty}}) = $(Int(sz))::Int
        end
    end

    @eval begin
        @inline jlwrite(io::MemoryBackedIO, x::$ty) = _write(io, x)
        @inline jlread(io::MemoryBackedIO, x::Type{$ty}) = _read(io, x)
        function jlread(io::IO, ::Type{$ty})
            $(Expr(:new, ty, [:(jlread(io, $(ty.types[i]))) for i = 1:length(packed_offsets)]...))
        end
        function jlwrite(io::IO, x::$ty)
            $([:(jlwrite(io, getfield(x, $i))) for i = 1:length(packed_offsets)]...)
            nothing
        end
    end
    nothing
end

jlsizeof(x) = Base.sizeof(x)
jlunsafe_store!(p, x) = Base.unsafe_store!(p, x)
jlunsafe_load(p) = Base.unsafe_load(p)


## Signatures
const OBJECT_HEADER_SIGNATURE = htol(0x5244484f) # "OHDR"
const OH_ATTRIBUTE_CREATION_ORDER_TRACKED = 2^2
const OH_ATTRIBUTE_CREATION_ORDER_INDEXED = 2^3
const OH_ATTRIBUTE_PHASE_CHANGE_VALUES_STORED = 2^4
const OH_TIMES_STORED = 2^5
const OBJECT_HEADER_CONTINUATION_SIGNATURE = htol(0x4b48434f) # "OCHK"

## Enums
@enum LayoutClass::UInt8 begin
    LcCompact = 0x00
    LcContiguous = 0x01
    LcChunked = 0x02
    LcVirtual = 0x03
end
LayoutClass(lc::LayoutClass) = lc
jlwrite(io, lc::LayoutClass) = jlwrite(io, UInt8(lc))

@enum(CharacterSet::UInt8,
      CSET_ASCII,
      CSET_UTF8)


# Header Message Types
# These are identified by their UInt8 value in the file
@enum HeaderMessageType::UInt8 begin
    HmNil = 0x00
    HmDataspace = 0x01
    HmLinkInfo = 0x02
    HmDatatype = 0x03
    HmFillValueOld = 0x04
    HmFillValue = 0x05
    HmLinkMessage = 0x06
    HmExternalFileList = 0x07
    HmDataLayout = 0x08
    HmBogus = 0x09
    HmGroupInfo = 0x0a
    HmFilterPipeline = 0x0b
    HmAttribute = 0x0c
    HmObjectComment = 0x0d
    HmSharedMessageTable = 0x0f
    HmObjectHeaderContinuation = 0x10
    HmSymbolTable = 0x11
    HmModificationTime = 0x12
    HmBtreeKValues = 0x13
    HmDriverInfo = 0x14
    HmAttributeInfo = 0x15
    HmReferenceCount = 0x16
end


## Exceptions

struct UnsupportedVersionException <: Exception
    msg::String
end
struct UnsupportedFeatureException <: Exception
    msg::String
end
struct InvalidDataException <: Exception
    msg::String
end
struct InternalError <: Exception
    msg::String
end

# In the future a more descriptive error should be returned
UnsupportedVersionException() = UnsupportedVersionException("")
UnsupportedFeatureException() = UnsupportedFeatureException("")
InvalidDataException() = InvalidDataException("")
InternalError() = InternalError("")

Base.showerror(io::IO, ex::UnsupportedVersionException) =
    print(io, "UnsupportedVersionException: ", ex.msg)
Base.showerror(io::IO, ex::UnsupportedFeatureException) =
    print(io, "UnsupportedFeatureException: ", ex.msg)
Base.showerror(io::IO, ex::InvalidDataException) =
    print(io, "InvalidDataException: ", ex.msg)
Base.showerror(io::IO, ex::InternalError) =
    print(io, "InternalError: ", ex.msg)

## Internal types

# Currently we specify that all offsets and lengths are 8 bytes
const Length = UInt64

"""
    RelOffset

Represents an HDF5 relative offset. This differs from a file offset (used elsewhere) in
that it is relative to the superblock base address. `fileoffset` and `h5offset` convert between
`RelOffset`s and file offsets.
"""
struct RelOffset
    offset::UInt64
end
define_packed(RelOffset)

RelOffset(r::RelOffset) = r
Base.:(==)(x::RelOffset, y::RelOffset) = x === y
Base.hash(x::RelOffset, h::UInt) = hash(x.offset, h)
Base.:(+)(x::RelOffset, y::Integer) = RelOffset(UInt64(x.offset + y))
Base.:(-)(x::RelOffset, y::Integer) = RelOffset(UInt64(x.offset - y))

const UNDEFINED_ADDRESS = RelOffset(0xffffffffffffffff)
const NULL_REFERENCE = RelOffset(0)

function Base.show(io::IO, x::RelOffset)
    if x == UNDEFINED_ADDRESS
        print(io, "UNDEFINED_ADDRESS")
    else
        print(io, "RelOffset(", x.offset, ")")
    end
end

"""
    JLDWriteSession{T}

A `JLDWriteSession` keeps track of references to serialized objects. If `T` is a Dict,
`h5offset` maps an object ID (returned by calling `objectid`) to th `RelOffset` of the
written dataset. If it is `Union{}`, then references are not tracked, and objects
referenced multiple times are written multiple times.
"""
struct JLDWriteSession{T<:Union{Dict{UInt,Tuple{RelOffset,WeakRef}},Union{}}}
    h5offset::T
    JLDWriteSession{T}() where T = new{T}()
    JLDWriteSession(h5offset::T) where T = new{T}(h5offset)
end
JLDWriteSession() = JLDWriteSession(Dict{UInt,Tuple{RelOffset,WeakRef}}())
track!(::JLDWriteSession{Union{}}, args...) = nothing
function track!(s::JLDWriteSession, data, offset::RelOffset)
    if ismutabletype(typeof(data))
        s.h5offset[objectid(data)] = (offset, WeakRef(data))
    end
    nothing
end
get_tracked(::JLDWriteSession{Union{}}, data) = UNDEFINED_ADDRESS
function get_tracked(wsession::JLDWriteSession, data)
    !ismutabletype(typeof(data)) && return UNDEFINED_ADDRESS
    offset, wref = get(wsession.h5offset, objectid(data), (UNDEFINED_ADDRESS, WeakRef(nothing)))
    isnothing(wref.value) && return UNDEFINED_ADDRESS
    return offset
end
"""
    GlobalHeap

Represents an HDF5 global heap structure.
"""
mutable struct GlobalHeap
    offset::Int64
    length::Length
    free::Length
    objects::Vector{Int64}
end

"""
    abstract type H5Datatype

Supertype of all HDF5 datatypes.
"""
abstract type H5Datatype end

struct PlaceholderH5Datatype <: H5Datatype end

"""
    SharedDatatype <: H5Datatype

Reference to a shared datatype message (stored elsewhere in a file).
"""
struct SharedDatatype <: H5Datatype
    header_offset::RelOffset
end
define_packed(SharedDatatype)

isshared(_) = false
isshared(::SharedDatatype) = true

"""
    CommittedDatatype <: H5Datatype

Reference to a shared datatype message (stored elsewhere in a file).
These are stored in the `_types` group and indexed.
"""
struct CommittedDatatype <: H5Datatype
    header_offset::RelOffset
    index::Int
end

# Allow dropping the index field
SharedDatatype(dt::CommittedDatatype) = SharedDatatype(dt.header_offset)

isshared(::CommittedDatatype) = true


"""
    ReadRepresentation{T,ODR}

A type encoding both the Julia type `T` and the on-disk (HDF5) representation `ODR`.
"""
abstract type ReadRepresentation{T, ODR} end
julia_repr(::ReadRepresentation{T}) where T = T
file_repr(::ReadRepresentation{T,ODR}) where {T,ODR} = ODR

struct SameRepr{T} <: ReadRepresentation{T,T} end
struct MappedRepr{T,ODR} <: ReadRepresentation{T,ODR} end

ReadRepresentation(::Type{T}, ::Type{T}) where T = SameRepr{T}()
ReadRepresentation(T, ODR) = MappedRepr{T,ODR}()

"""
    CustomSerialization{T,S}

On-disk representation for data that is written as if it were of Julia type `T`, but is
read as type `S`.
"""
struct CustomSerialization{T,S} end

"""
    Upgrade(T)

Specify an upgrade path for serialized structs using the `typemap` keyword argument
and `rconvert`.
"""
struct Upgrade
    target
end

"""
    HeaderMessage

Helper struct to read and write the first part of a header message.
"""
struct HeaderMessage
    msg_type::HeaderMessageType
    size::UInt16
    flags::UInt8
end
define_packed(HeaderMessage)

## Object header continuation
# object headers can be split into multiple chunks
# the HmObjectHeaderContinuation message is used to link them
# it has constant size and a placeholder is put into every header
# by JLD2 to allow later additions.
const CONTINUATION_MSG_SIZE = jlsizeof(HeaderMessage) + jlsizeof(RelOffset) + jlsizeof(Length)


"""
    Message{IO}

Representation of a Message in memory. Provides `getproperty` access
"""
struct Message{IO}
    type::HeaderMessageType
    address::UInt64
    offset::RelOffset
    io::IO
    Message(type::HeaderMessageType, address::Integer, o::RelOffset, io::IO) =
        new{typeof(io)}(type, UInt64(address), o, io)
end
Message(type::UInt8, args...) = Message(HeaderMessageType(type), args...)
Message(type::HeaderMessageType, f, offset::RelOffset) =
    Message(type, fileoffset(f, offset), offset, f.io)
Message(type::HeaderMessageType, io::IO) = Message(type, position(io), UNDEFINED_ADDRESS, io)
Message(type::HeaderMessageType, data::Vector{UInt8}) = Message(type, 0, UNDEFINED_ADDRESS, IOBuffer(data))


"""
    IndirectPointer

When writing data, we may need to enlarge the memory mapping, which would invalidate any
memory addresses arising from the old `mmap` pointer. `IndirectPointer` holds an offset relative to the
MemoryBackedIO. It defers computing a memory address until converted to a `Ptr{T}`,
so the memory mapping can be enlarged and addresses will remain valid.
"""
struct IndirectPointer{P<:MemoryBackedIO}
    io::P
    offset::Int
end

IndirectPointer(io::MemoryBackedIO) = IndirectPointer(io, Int(bufferpos(io)))

Base.:+(x::IndirectPointer, y::Integer) = IndirectPointer(x.io, x.offset+y)
pconvert(::Type{Ptr{T}}, x::IndirectPointer) where {T} = Ptr{T}(x.io.curptr - bufferpos(x.io) + x.offset)

# Use internal convert function (for pointer conversion) to avoid invalidations
pconvert(T, x) = Base.convert(T, x)


# This function writes a julia object to file or a buffers and first applies the required
# conversions to the on-disk representation.
function h5convert! end

# This file declares the format specification for header messages.


@pseudostruct HmNil begin @skip(hsize) end

@pseudostruct HmDataspace begin
    version::UInt8 = 2
    dimensionality::UInt8 = length(kw.dimensions)
    flags::UInt8 = 0
    (version == 2) && dataspace_type::UInt8
    (version == 1) && dataspace_type::@computed(DS_V1)
    version == 1 && @skip(5)
    dim_offset::@Offset
    dimensions::NTuple{Int(dimensionality), Int64}
    isset(flags,0) && max_dimension_size::NTuple{Int(dimensionality), Int64}
end

@pseudostruct HmLinkInfo begin
    version::UInt8 = 0x00
    flags::UInt8 = 0x00
    isset(flags,0) && max_creation_index::Int64
    fractal_heap_address::RelOffset = UNDEFINED_ADDRESS
    v2_btree_name_index::RelOffset = UNDEFINED_ADDRESS
    isset(flags, 1) && (v2_btree_creation_order_index::RelOffset = UNDEFINED_ADDRESS)
end

@pseudostruct HmDatatype begin
    if isset(hflags,1)
        version::UInt8 = 3
        msgtype::UInt8 = 2
        dt::SharedDatatype
        datatype_offset::@computed(dt.header_offset)
    end
    if !isset(hflags,1)
        datatype_offset::@Offset
        dt::@read(H5Datatype)
    end
end

@pseudostruct HmFillValueOld begin
    size::UInt32
    fill_value::@Blob(size)
end

@pseudostruct HmFillValue begin
    version::UInt8 = 3
    if version == 1 || version == 2
        space_allocation_time::UInt8
        fill_value_write_time::UInt8
        fill_value_defined::UInt8
        if !(version > 1 && fill_value_defined==0)
            size::UInt32
            fill_value::@Blob(size)
        end
    end
    if version == 3
        flags::UInt8
        isset(flags, 5) && size::UInt32
        isset(flags, 5) && fill_value::@Blob(size)
    end
end

@pseudostruct HmLinkMessage begin
    version::UInt8 = 1
    flags::UInt8 = (0x10 | size_flag(sizeof(kw.link_name)))
    isset(flags, 3) && link_type::UInt8
    isset(flags, 2) && creation_order::Int64
    isset(flags, 4) && (link_name_charset::UInt8 = CSET_UTF8)
    link_name_len::@Int(2^(flags%4)) = sizeof(kw.link_name)
    link_name::@FixedLengthString(link_name_len) # non-null-terminated
    (!isset(flags, 3) || link_type==0) && (target::RelOffset = UNDEFINED_ADDRESS)
    if isset(flags, 3) && link_type == 1
        link_info_size::UInt16
        soft_link::@Blob(link_info_size) # non-null terminated string
    end
    if isset(flags, 3) && link_type == 64
        link_info_size::UInt16
        external_link::@Blob(link_info_size) # two null-terminated strings
    end
end

@pseudostruct HmExternalFileList begin
    version::UInt8
    @skip(3)
    allocated_slots::UInt16
    used_slots::UInt16
    heap_address::RelOffset
    external_file_list::@Blob(allocated_slots*3*8)
end

@pseudostruct HmDataLayout begin
    version::UInt8 = 4
    if version == 1 || version == 2
        dimensionality::UInt8
        layout_class::LayoutClass
        @skip(5)
        (layout_class != LcCompact) && data_address::RelOffset
        dimensions::NTuple{Int(dimensionality), Int32}
        (layout_class == LcChunked) && element_size::UInt32
        if (layout_class == LcCompact)
            data_size::@Int(4)
            data_address::@Offset
            data::@Blob(data_size)
        end
    end
    if version == 3 || version == 4
        layout_class::LayoutClass
        if layout_class == LcCompact
            data_size::@Int(2)
            data_address::@Offset
            data::@Blob(data_size) = UInt8[] # don't write anything if nothing is passed
        end
        if layout_class == LcContiguous
            data_address::RelOffset = UNDEFINED_ADDRESS
            data_size::@Int(8) = 0# Lengths
        end
        if version == 3 && layout_class == LcChunked
            dimensionality::UInt8
            data_address::RelOffset
            dimensions::NTuple{Int(dimensionality), Int32}
            data_size::@Int(4)#UInt32#element_size::UInt32
        end
        if version == 4 && layout_class == LcChunked
            flags::UInt8 = 2 # Single index with filter
            dimensionality::UInt8 = length(kw.dimensions)
            dim_size::UInt8 = 8 # 8 bytes per dimension
            dimensions::NTuple{Int(dimensionality), uintofsize(dim_size)}
            chunk_indexing_type::UInt8 = 1 # Single Chunk
            if chunk_indexing_type == 1 # Single Chunk
                data_size::@Int(8)#Int64 # Lengths
                filters::UInt32 = 0
            end
            if chunk_indexing_type == 3
                page_bits::UInt8
            end
            if chunk_indexing_type == 4
                maxbits::UInt8
                index_elements::UInt8
                minpointers::UInt8
                minelements::UInt8
                page_bits:::UInt16
            end
            if chunk_indexing_type == 5
                node_size::UInt32
                splitpercent::UInt8
                mergepercent::UInt8
            end
            data_address::RelOffset
        end
        if layout_class == LcVirtual # Virtual Storage
            data_address::RelOffset
            index::UInt32
        end
    end
end

@pseudostruct HmGroupInfo begin
    version::UInt8 = 0
    flags::UInt8 = 0b10*(get(kw, :est_num_entries, 4) != 4 || get(kw, :est_link_name_len, 8) != 8)
    if isset(flags, 0)
        link_phase_change_max_compact::UInt16
        link_phase_change_min_dense::UInt16
    end
    if isset(flags, 1)
        est_num_entries::UInt16
        est_link_name_len::UInt16
    end
end

@pseudostruct HmFilterPipeline begin
    version::UInt8
    nfilters::UInt8
    @skip(hsize-2)
end

@pseudostruct HmAttribute begin
    version::UInt8
    flags::UInt8
    name_size::UInt16
    datatype_size::UInt16
    dataspace_size::UInt16
    version == 3 && name_charset_encoding::UInt8
    name::@FixedLengthString(name_size-1)
    @skip(1)
    (version == 1) && @skip(8-mod1(name_size,8))
    # committed if isset(hm.flags, 0)
    if isset(flags, 0) #this is slightly more complicated in general
        vshared::UInt8
        sharedtype::UInt8
        datatype::SharedDatatype
    end
    if !isset(flags, 0)
        datatype_offset::@Offset
        datatype::@read(H5Datatype, datatype_size)
    end
    (version == 1) && @skip(8-mod1(datatype_size,8))
    dataspace_offset::@Offset
    dataspace_message::@Blob(Int(dataspace_size))
    (version == 1) && @skip(8-mod1(dataspace_size,8))
    data_offset::@Offset
    #data::@Blob(hsize- (data_offset.offset - getfield(hm,:payload_offset).offset))#+getfield(hm,:base_address)+hsize-position(io))
end

@pseudostruct HmObjectHeaderContinuation begin
    continuation_offset::RelOffset
    continuation_length::Int64# Length
end

@pseudostruct HmSymbolTable begin
    v1btree_address::RelOffset
    name_index_heap::RelOffset
end

@pseudostruct HmAttributeInfo begin
    @skip(hsize)
end

@pseudostruct HmBogus begin @skip(hsize) end
@pseudostruct HmObjectComment begin @skip(hsize) end
@pseudostruct HmSharedMessageTable begin @skip(hsize) end
@pseudostruct HmModificationTime begin @skip(hsize) end
@pseudostruct HmBtreeKValues begin @skip(hsize) end
@pseudostruct HmDriverInfo begin @skip(hsize) end
@pseudostruct HmReferenceCount begin @skip(hsize) end

# This file implements methods to look up the type signatures
# of committed julia data types in JLD2 files without
# needing the types to exist in the current session.

function stringify_h5datatype(f, dt; showfields=false)
    io = f.io
    attrs = ReadAttribute[]
    if isshared(dt)
        dt, attrs = read_shared_datatype(f, dt)
    end

    written_type_str = ""
    julia_type_str = ""
    for attr in attrs
        if !(attr.name == :julia_type || attr.name == :written_type)
            continue
        end
        datatype = attr.datatype
        @assert datatype isa SharedDatatype
        rr = jltype(f, f.datatype_locations[datatype.header_offset])
        @assert attr.dataspace.dataspace_type == DS_SCALAR
        str = jlconvert_string_wrap(rr, f, attr.data_offset)

        if attr.name == :written_type
            written_type_str = str
        elseif attr.name ==:julia_type
            julia_type_str = str
        end
    end

    if !(dt isa CompoundDatatype)
        type = jltype(f, dt)
        julia_type_str = string(julia_repr(type))
    end

    if !showfields ||
        !isa(dt, CompoundDatatype)
        dt isa VariableLengthDatatype ||
        startswith(julia_type_str, r"Tuple|Union") ||
        julia_type_str == "DataType"
        return julia_type_str, written_type_str, String[]
    end

    field_datatypes = read_field_datatypes(f, dt, attrs)
    field_strs = String[]
    for (i, key) in enumerate(keys(field_datatypes))
        # Find the corresponding index in dt.names
        name_index = findfirst(name -> string(name) == string(key), dt.names)
        if name_index === nothing
            continue  # Skip if name not found
        end

        if (ref = field_datatypes[string(key)]) != NULL_REFERENCE
            fieldtype = stringify_h5datatype(f, f.datatype_locations[ref])[1]
            fieldtype *= " (committed at $(ref))"
        else
            # These are normal julia types
            if name_index <= length(dt.members)
                dtrr = jltype(f, dt.members[name_index])
                fieldtype = string(julia_repr(dtrr))
                if fieldtype == "Any"
                    fieldtype = "Any (untyped reference)"
                end
            else
                fieldtype = "unknown"
            end
        end
        push!(field_strs, "$(dt.names[name_index])::$(fieldtype)")
    end
    return julia_type_str, written_type_str, field_strs
end

function stringify_object(f, offset)
    # Messages
    dataspace = ReadDataspace()
    attrs = EMPTY_READ_ATTRIBUTES
    datatype::H5Datatype = PlaceholderH5Datatype()
    layout::DataLayout = DataLayout(0,LcCompact,0,-1)
    filter_pipeline::WrittenFilterPipeline = WrittenFilterPipeline()
    for msg in HeaderMessageIterator(f, offset)
        if msg.type == HmDataspace
            dataspace = ReadDataspace(f, msg)
        elseif msg.type == HmDatatype
            datatype = HmWrap(HmDatatype, msg).dt
        elseif msg.type == HmDataLayout
            layout = DataLayout(f, msg)
        elseif msg.type == HmFilterPipeline
            filter_pipeline = WrittenFilterPipeline(msg)
        elseif msg.type == HmAttribute
            if attrs === EMPTY_READ_ATTRIBUTES
                attrs = ReadAttribute[read_attribute(f, msg)]
            else
                push!(attrs, read_attribute(f,msg))
            end
        elseif (msg.hflags & 2^3) != 0
            throw(UnsupportedFeatureException())
        end
    end

    iscompressed(filter_pipeline) && !ischunked(layout)  && throw(InvalidDataException("Compressed data must be chunked"))

    if datatype isa SharedDatatype && haskey(f.datatype_locations, datatype.header_offset)
        # Committed datatype
        rr = jltype(f, f.datatype_locations[datatype.header_offset])
        jlconvert_string_wrap(rr, f, layout.data_offset)
    else
        rr = jltype(f, datatype)
        seek(f.io, layout.data_offset)
        read_dataspace = (dataspace, NULL_REFERENCE, layout, FilterPipeline(filter_pipeline))
        res = read_data(f, rr, read_dataspace, nothing)
        string(res)
    end
end

function typestring_from_refs(f::JLDFile, ptr::Ptr)
    # Test for a potential null pointer indicating an empty array
    isinit = jlunsafe_load(convert(Ptr{UInt32}, ptr)) != 0
    if isinit
        refs = jlconvert(MappedRepr{RelOffset, Vlen{RelOffset}}(), f, ptr, NULL_REFERENCE)
        params =  Any[let
            # If the reference is to a committed datatype, read the datatype
            nulldt = CommittedDatatype(UNDEFINED_ADDRESS, 0)
            cdt = get(f.datatype_locations, ref, nulldt)
            res = if cdt !== nulldt
                stringify_h5datatype(f, cdt)[1]
            else
                stringify_object(f, ref)
            end
            if startswith(res, r"Core|Main")
                res = last(split(res, "."; limit=2))
            end
            res
        end for ref in refs]
        return params
    end
    return []
end

function jlconvert_string_wrap(rr, f, offset)
    seek(f.io, offset)
    r = Vector{UInt8}(undef, odr_sizeof(rr))
    @GC.preserve r begin
        unsafe_read(f.io, pointer(r), odr_sizeof(rr))
        jlconvert_string(rr, f, pointer(r))
    end
end

function jlconvert_string(::MappedRepr{T,DataTypeODR},
                        f::JLDFile,
                        ptr::Ptr) where T
    mypath = String(jlconvert(MappedRepr{UInt8,Vlen{UInt8}}(), f, ptr, NULL_REFERENCE))
    params = typestring_from_refs(f, ptr+odr_sizeof(Vlen{UInt8}))
    if startswith(mypath, r"Core|Main")
        mypath = last(split(mypath, "."; limit=2))
    end
    if !isempty(params)
        mypath *= "{"*join(params, ",")*"}"
    end
    return mypath
end

function jlconvert_string(::MappedRepr{Union, UnionTypeODR}, f::JLDFile,
    ptr::Ptr)#, header_offset::RelOffset)
    # Skip union type description in the beginning
    ptr += odr_sizeof(Vlen{String})
    # Reconstruct a Union by reading a list of DataTypes and UnionAlls
    # Lookup of RelOffsets is taken from jlconvert of DataTypes
    datatypes = typestring_from_refs(f, ptr)
    unionalls = typestring_from_refs(f, ptr+odr_sizeof(Vlen{RelOffset}))
    "Union{"*join(vcat(datatypes, unionalls), ",")*"}"
end

function jlconvert_string(rr::ReadRepresentation, f::JLDFile, ptr::Ptr)
    # so apparently this is a custom struct with plain fields that wants to be loaded
    string(jlconvert(rr, f, ptr, UNDEFINED_ADDRESS))
end

# Safe attribute reading that provides useful info without risking reconstruction errors
function safe_read_attribute_info(f::JLDFile, attr::ReadAttribute)
    (; dataspace, datatype) = attr
    layout =  DataLayout(0,LcCompact,-1,attr.data_offset)

    if isshared(datatype)
        # Retrieve committed datatype if it is committed
        dt = get(f.datatype_locations, datatype.header_offset, dt)
        rr = jltype(f, dt)
        jlconvert_string_wrap(rr, f, layout.data_offset)
    else
        rr = jltype(f, datatype)
        seek(f.io, layout.data_offset)
        read_dataspace = (dataspace, NULL_REFERENCE, layout, FilterPipeline())
        res = read_data(f, rr, read_dataspace, nothing)
        string(res)
    end
end

using Test, JLD2
using LazyArtifacts
#=
When adding test files to the JLD2Testfiles repo tag a new
release and adapt Artifacts.toml and the line below accordingly.
    git clone git@github.com:JonasIsensee/JLD2TestFiles.git
add file & commit
    git tag v0.1.X
    git push
    git push --tags
go to github and create a new release with name "v0.1.x"
update Artifacts.toml:
1) navigate to testdir
2) launch repl and run
    using Pkg
    Pkg.activate(; temp=true)
    Pkg.add("ArtifactUtils")
    using ArtifactUtils
    add_artifact!(
        "Artifacts.toml",
        "testfiles",
        "https://github.com/JonasIsensee/JLD2TestFiles/archive/refs/tags/v0.1.x.tar.gz", # replace version here
        force=true,
        lazy=true)
update artifact string below to reflect new version number
=#
# NOTE: Keep this artifact version in sync with test_dataset_show.jl
testfiles = artifact"testfiles/JLD2TestFiles-0.1.9/artifacts"

@testset "HDF5 compat test files" begin
    # These are test files copied from the HDF5.jl test suite

    fn = joinpath(testfiles,"compound.h5")
    jldopen(fn) do f
        data = f["data"]
        @test data[1] == data[2]
        nt = data[1]
        @test nt.wgt == 1.0
        @test nt.xyz == [-2.4559041161056125, 0.43236207188504794, -0.5088338908493437]
        @test nt.uvw == [-0.44966656055677057, 0.6453930541533174, 0.6174688574881305]
        @test nt.E == 1.1915731810042547
    end

    # Should return some enum type and load names correctly
    fn = joinpath(testfiles,"h5ex_t_enum.h5")
    jldopen(fn) do f
        @test size(f["DS1"]) == (7,4)
    end

    fn = joinpath(testfiles,"h5ex_t_array.h5")
    jldopen(fn) do f
        @test f["DS1"][1] == (0:-1:-4) .* [0,1,2]'
        @test f["DS1"][2] == hcat(collect(0:4), ones(Int,5), collect(2:-1:-2))
    end

    fn = joinpath(testfiles,"h5ex_t_float.h5")
    jldopen(fn) do f
        @test size(f["DS1"]) == (7,4)
        @test f["DS1"][9] ≈ 5/3
    end

    # Big Endian Integers are not implemented
    fn = joinpath(testfiles,"h5ex_t_int.h5")
    jldopen(fn) do f
        @test f["DS1"] == [0:-1:-6 zeros(Int,7) 0:6 0:2:12]
    end

    fn = joinpath(testfiles,"h5ex_t_objref.h5")
    jldopen(fn) do f
        @test f["DS1"][1] === f["G1"]
        @test f["DS1"][2] === f["DS2"]
    end

    fn = joinpath(testfiles,"h5ex_t_opaque.h5")
    jldopen(fn) do f
        @test f["DS1"][1].data == [0x4f, 0x50, 0x41, 0x51, 0x55, 0x45, 0x30]
        @test f["DS1"][2].data == [0x4f, 0x50, 0x41, 0x51, 0x55, 0x45, 0x31]
        @test f["DS1"][3].data == [0x4f, 0x50, 0x41, 0x51, 0x55, 0x45, 0x32]
        @test f["DS1"][4].data == [0x4f, 0x50, 0x41, 0x51, 0x55, 0x45, 0x33]
    end

    fn = joinpath(testfiles,"h5ex_t_string.h5")
    jldopen(fn) do f
        @test f["DS1"] == ["Parting", "is such", "sweet", "sorrow."]
    end

    fn = joinpath(testfiles,"h5ex_t_vlen.h5")
    jldopen(fn) do f
        @test f["DS1"][1] == [3, 2, 1]
        @test f["DS1"][2] == [1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144]
    end

    fn = joinpath(testfiles,"h5ex_t_vlstring.h5")
    jldopen(fn) do f
        @test f["DS1"] == ["Parting", "is such", "sweet", "sorrow."]
    end

    fn = joinpath(testfiles,"nullterm_ascii.h5")
    jldopen(fn) do f
        @test f["test"] == "Hello World"
    end

    fn = joinpath(testfiles,"large_fractal_heap.h5")
    jldopen(fn) do f
        @test length(keys(f)) == 200000
    end

    fn = joinpath(testfiles,"netcdf.nc")
    jldopen(fn) do f
        @test f["hello"] == ones(5)
        #@test_broken f["x"]
        #@test_broken f["z"]
        @test f["grouped/data"] == 0:9
        #@test_broken f["grouped/y"]
    end

    fn = joinpath(testfiles,"simple.nc")
    jldopen(fn) do f
        @test f["dim1"] == [2, 4, 6]
        @test f["dim2"] == ["a", "b", "c", "d"]
        @test f["mydata"] == Matrix(reshape(1:12, 4, 3))
        JLD2.load_attributes(f, "dim1") # not sure what to test for. just not erroring so far
        JLD2.load_attributes(f, "dim2")
        JLD2.load_attributes(f, "mydata")
        JLD2.load_attributes(f.root_group)
    end

    # julia> using JLD
    # julia> struct A; x::Int; y::Float64; z::String; end
    # julia> save("jldstruct.jld", "a", A(1,2.0,"3"))
    fn = joinpath(testfiles,"jldstruct.jld")
    jldopen(fn) do f
        a = f["a"]
        @test a.x == 1
        @test a.y == 2.0
        @test a.z == "3"
    end

    fn = joinpath(testfiles,"chunking1.h5")
    jldopen(fn) do f
        @test f["uncompressed_chunks"] == reshape(1:1000., 25, 40)
        @test f["compressed_chunks"] == reshape(1:1000., 25, 40)
        @test f["shuffle_compressed_chunks"] == reshape(1:1000, 25, 40)
        @test size(f["incomplete_allocation"]) == (50,50,10)
        @test f["incomplete_allocation"][1:50,1:50, 2] == reshape(1:2500, 50,50)
        #f["incomplete_allocation"][1,1,1] == 0
    end
end

@testset "Opening corrupted files" begin
    mktemp() do path, io
        close(io)
        @test_throws EOFError jldopen(path)
        # We want to make sure that this didn't accidentally add itself to the open
        # files cache
        @test_throws EOFError jldopen(path)
        # Opening for overwriting should succeed
        close(jldopen(path, "w+"))
    end
end

@testset "Mutable Struct Reconstruction Issue #506" begin
    fn = joinpath(testfiles,"struct_reconstruction.jld2")
    data = load(fn)
    @test data["dms"] isa JLD2.SerializedDict
    @test JLD2.isreconstructed(data["dms"].kvvec[1].second)
    @test data["ds"] isa JLD2.SerializedDict
    @test JLD2.isreconstructed(data["ds"].kvvec[1].second)
    @test JLD2.isreconstructed(data["tms"][2])
end

@testset "Issue #538 Reconstruction of UnionAll type parameter" begin
    fn = joinpath(testfiles, "unionall_typeparam.jld2")
    data = load(fn, "test")
    @test propertynames(data) == (:val,)
    @test data.val == 4
end

module RecoverableChangesInStructs
    using JLD2, Test
    fn = joinpath(Main.testfiles, "recoverable_changes_in structs.jld2")
    # for saving:
    # struct A; x::Int; end
    # struct B; a::A; end

    # struct C; x::Int; end
    # struct D; c::C; end
    # jldsave("$(my_object_filename)"; b=B(A(42)), d=D(C(42)))


    struct A; x::Float64; end
    struct B; a::A; end

    struct C; x::Tuple{Int,Int}; end
    struct D; c::C; end
    @testset "Recoverable changes in structs, Issue #354" begin
        b = load(fn, "b")
        @test b == B(A(42.0))

        d = load(fn, "d")
        # Reconstructed type has correct value
        @test d.c.x == 42
        # This is evil
        #Base.convert(::Type{Tuple{Int,Int}}, x::Int) = (x, 2x)
        #d = load(fn, "d")
        #@test d.c.x == (42, 84)
    end
end



module Readas
    using JLD2
    struct UndefinedFunction <:Function
        fun
    end
    (f::UndefinedFunction)(args...; kwargs...) = error("The function \$(f.fun) is not defined")

    # Case when readas is defined
    # If `F` doesn't exist when reading, should be read as `Foo{UndefinedFunction}`
    struct Foo{F<:Function}
        fun::F
    end
    struct FooSerialization
        fun
    end
    JLD2.writeas(::Type{<:Foo}) = FooSerialization
    Base.convert(::Type{<:FooSerialization}, f::Foo) = FooSerialization(f.fun)

    JLD2.readas(::Type{<:FooSerialization}) = Foo
    function Base.convert(::Type{<:Foo}, f::FooSerialization)
        isa(f.fun, Function) && return Foo(f.fun)
        return Foo(UndefinedFunction(f.fun))
    end

    # Case when readas is not defined (N)
    # If `F` doesn't exist when reading, should be read as `FooNSerialization`
    struct FooN{F<:Function}
        fun::F
    end
    struct FooNSerialization
        fun
    end
    JLD2.writeas(::Type{<:FooN}) = FooNSerialization
    Base.convert(::Type{<:FooNSerialization}, f::FooN) = FooNSerialization(f.fun)
    Base.convert(::Type{<:FooN}, f::FooNSerialization) = FooN(f.fun)
end

# jldsave("readas_foo_sin.jld2"; foo=Readas.Foo(sin))
# fun(x) = x^2
# jldsave("readas_foo_a.jld2"; foo=Readas.Foo(fun))
# jldsave("readas_foo_n_sin.jld2"; foo=Readas.FooN(sin))
# jldsave("readas_foo_n_a.jld2"; foo=Readas.FooN(fun))

@testset "readas api for struct upgrades" begin
    getfoo(file) = jldopen(joinpath(testfiles,file)) do io; io["foo"]; end
    @test getfoo("readas_foo_sin.jld2") isa Readas.Foo{typeof(sin)}
    @test getfoo("readas_foo_n_sin.jld2") isa Readas.FooN{typeof(sin)}
    @test getfoo("readas_foo_a.jld2") isa Readas.Foo{Readas.UndefinedFunction}
    @test getfoo("readas_foo_n_a.jld2") isa Readas.FooNSerialization
end


@testset "plain reconstruction" begin
    fn = joinpath(testfiles,"struct_reconstruction.jld2")
    data = load(fn; plain=true)
    # This is somewhat broken: Tuples are committed with field names "1", "2",...
    # these are valid names but break most of the common API incl. the @NamedTuple macro
    #@test data["tms"] == @NamedTuple{1::Int64, 2}((1, (a = 1,)))
    @test getproperty(data["tms"], Symbol(1)) == 1
    @test data["s"]   == (a = 1,)
    @test data["ds"].kvvec[1]  == (; first = "a", second = (a = 1,))
end

@testset "Reconstruct struct with singleton fields" begin
    fn = joinpath(testfiles,"singleton_struct_fields.jld2")
    if VERSION ≥ v"1.7"
        @test_warn "type Main.MissingStruct does not exist in workspace; reconstructing" ms = load(fn, "ms")
    else # @test_warn works differently on 1.6
        ms = load(fn, "ms")
    end
    @test ms.a == 1
    @test ms.b === nothing
    @test ms.c === missing
    @test ms.d == 2.0
    @test typeof(ms).parameters[1] == :MissingStruct

    @test_nowarn ms = load(fn, "ms"; typemap=Dict("Main.MissingStruct" => JLD2.Upgrade(NamedTuple)))
    @test ms.a == 1
    @test ms.b === nothing
    @test ms.c === missing
    @test ms.d == 2.0

    ms = load(fn, "ms"; plain=true)
    @test ms == (; a=1, d=2.0)
end

@testset "Mmap with misaligned data" begin
    fn = joinpath(testfiles, "mmapfile.h5")
    f = jldopen(fn)
    ds = JLD2.get_dataset(f, "arr")
    arr = JLD2.readmmap(ds)
    @test arr isa Base.ReinterpretArray
    @test arr == 1:100
    close(f)
end

@testset "data created with JLD2@0.5 filters" begin
    fn = joinpath(testfiles, "jld2-0.5-filters.jld2")
    f = jldopen(fn)
    @testset "$(cname)" for (cname) in ["bzip2", "zlib", "lz4f", "zstd"]
        @test f["$(cname)-1"] == zeros(10000)
        @test f["$(cname)-2"] == ones(10000)
        @test f["$(cname)-3"] == zeros(1)
        @test f["$(cname)-4"] == zeros(UInt8, 1)
        @test f["$(cname)-5"] == f["random_numbers_uncompressed"]
    end
    close(f)
end

## Requirements for an IO object
#=

Implement for Reading:
Base.position(io)::Int
Base.bufferpos(io)::Int (if applicable)
Base.close(io)
Base.seek(io, pos::Int)
read_bytestring(io)::String # read a null-terminated byte string
Base.skip(io, n::Int)
_read(io, ::Type{T}) for [U]Int8 and `PlainType`
_write(io, x::T) for [U]Int8 and `PlainType`
begin_checksum_read(io) # see existing implementations
end_checksum(io)
=#

## Create an IO object which wraps a non-seekable read-only buffer
const MINBUFFERSIZE = 2^9 # should maybe be 2^16 

mutable struct ReadOnlyBuffer{B <: IO} <: MemoryBackedIO
    _buf::B
    offset::UInt64 # position of file start in wrapped stream
    data::Vector{UInt8}
    startptr::Ptr{Cvoid}
    curptr::Ptr{Cvoid}
    size::UInt64
    checksum_pos::Vector{Int64}
    nchecksum::Int64
    function ReadOnlyBuffer(_buf::IO) 
        offset = position(_buf)
        nb = min(MINBUFFERSIZE, bytesavailable(_buf))
        data = read(_buf, nb)
        curptr = startptr = pointer(data)
        new{typeof(_buf)}(_buf, offset, data, 
            startptr, curptr, length(data), Int[], 0)
    end
end

Base.position(io::ReadOnlyBuffer) = Int(io.curptr-io.startptr)
bufferpos(io::ReadOnlyBuffer) = Int(io.curptr-io.startptr)
Base.close(::ReadOnlyBuffer) = nothing
Base.isreadable(::ReadOnlyBuffer) = true
Base.iswritable(::ReadOnlyBuffer) = false
isseekable(::ReadOnlyBuffer) = true

function Base.resize!(io::ReadOnlyBuffer, newend::Integer)
    newend < io.size && return
    nb = min(bytesavailable(io._buf), max(newend-io.size, MINBUFFERSIZE))
    bts = read(io._buf, nb)
    append!(io.data, bts)
    io.size += length(bts)
    newend ≤ io.size || throw(EOFError())
    # update pointers
    oldstart = io.startptr
    io.startptr = pointer(io.data)
    io.curptr = io.curptr - oldstart + io.startptr
    nothing
end
Base.resize!(io::ReadOnlyBuffer, p::Ptr) = resize!(io, p - io.startptr)

ensureroom(io::ReadOnlyBuffer, n::Integer) = resize!(io, bufferpos(io) + n)

# Read a null-terminated string
function read_bytestring(io::ReadOnlyBuffer)
    # Find the null terminator position
    nb = 0
    while true
        idx = position(io)+1+nb
        idx > io.size && resize!(io, idx)
        io.data[idx] == 0x00 && break
        nb += 1
    end

    pos = position(io)
    data = io.data
    str = GC.@preserve data unsafe_string(pointer(data, pos+1), nb)
    skip(io, nb+1)
    return str
end

function begin_checksum_read(io::ReadOnlyBuffer)
    idx = io.nchecksum += 1
    if idx > length(io.checksum_pos)
        push!(io.checksum_pos, position(io))
    else
        io.checksum_pos[idx] = position(io)
    end
    io
end

function end_checksum(io::ReadOnlyBuffer)
    v = io.checksum_pos[io.nchecksum]
    io.nchecksum -= 1
    Lookup3.hash(Ptr{UInt8}(io.startptr + v), position(io) - v)
end

###########################################################################################
## RWBuffer
###########################################################################################

mutable struct RWBuffer{B <: IO} <: IO
    _buf::B
    offset::UInt64 # position of file start in wrapped stream
    pos::UInt64
    size::UInt64
    RWBuffer(_buf::IO) = new{typeof(_buf)}(_buf, position(_buf), 0, _getsize(_buf))
end

Base.position(io::RWBuffer) = Int(io.pos)
Base.close(::RWBuffer) = nothing
function truncate_and_close(io::RWBuffer, endpos::Integer)
    #truncate(io, endpos)
    close(io)
end

function Base.seek(io::RWBuffer, n::Integer)
    n > io.size && resize!(io, n)
    seek(io._buf, n + io.offset)
    @assert position(io._buf) == n+io.offset
    io.pos = n
end

function Base.resize!(io::RWBuffer, newend::Integer)
    newend < io.size && return
    buf = io._buf
    pos = position(buf)
    seek(buf, io.size+io.offset)
    write(buf, zeros(UInt8, newend-io.size))
    seek(buf, pos)
    io.size = newend
end
ensureroom(io::RWBuffer, n::Integer) = resize!(io, position(io) + n)

# Read a null-terminated string
function read_bytestring(io::RWBuffer)
    v = readuntil(io._buf, 0x00)
    io.pos = position(io._buf) - io.offset
    return String(v)
end

Base.skip(io::RWBuffer, offset::Integer) = seek(io, position(io)+offset)

function _read(io::RWBuffer, T::DataType)
    n = jlsizeof(T)
    ensureroom(io, n)
    io.pos += jlsizeof(T)
    read(io._buf, T)
end
# needed explicitly for avoiding ambiguities
Base.read(io::RWBuffer, T::Type{UInt8}) = _read(io, T)
#Base.read(io::RWBuffer, T::PlainType) = _read(io, T)
Base.write(io::RWBuffer, x::UInt8) = _write(io, x)
jlwrite(io::RWBuffer, x::String) = _write(io, x)

function jlwrite(io::RWBuffer, x::Array{T}) where T
    for y in x
        jlwrite(io, y)
    end
    return length(x) * jlsizeof(T)
end

function _write(io::RWBuffer, x)
    posprev = position(io)
    jlwrite(io._buf, x)    
    io.pos = position(io._buf) - io.offset
    io.size = max(io.size, io.pos)
    return io.pos-posprev
end

Base.bytesavailable(io::RWBuffer) = io.size-io.pos
Base.isreadable(::RWBuffer) = true
Base.iswritable(::RWBuffer) = true
isseekable(::RWBuffer) = true

_getsize(io::RWBuffer) = io.size

function _getsize(io::IO)
    pos = position(io)
    seekend(io)
    sz = position(io)
    seek(io, pos)
    return sz
end

###########################################################################################
## ByteVectorIO - Optimized wrapper for Vector{UInt8}
###########################################################################################

"""
    ByteVectorIO

High-performance memory-backed IO for reading and writing JLD2 files to/from `Vector{UInt8}`.
This provides direct memory access similar to `MmapIO` but for in-memory byte vectors.

# Examples
```julia
# Writing to a byte vector
data = UInt8[]
f = jldopen(data, "w")
f["mydata"] = [1, 2, 3]
close(f)

# Reading from a byte vector
f = jldopen(data, "r")
recovered = f["mydata"]
close(f)
```
"""
mutable struct ByteVectorIO <: MemoryBackedIO
    data::Vector{UInt8}
    writable::Bool
    curptr::Ptr{Nothing}
    startptr::Ptr{Nothing}
    # For checksum computation
    checksum_pos::Vector{Int64}
    nchecksum::Int64
end

function ByteVectorIO(data::Vector{UInt8}, writable::Bool)
    startptr = isempty(data) ? Ptr{Nothing}(0) : pointer(data)
    ByteVectorIO(data, writable, startptr, startptr, Int64[], 0)
end

Base.show(io::IO, ::ByteVectorIO) = print(io, "ByteVectorIO")
Base.isreadable(::ByteVectorIO) = true
Base.iswritable(io::ByteVectorIO) = io.writable
isseekable(io::ByteVectorIO) = true

Base.position(io::ByteVectorIO) = Int64(io.curptr - io.startptr)
bufferpos(io::ByteVectorIO) = Int64(io.curptr - io.startptr)

function Base.seek(io::ByteVectorIO, offset::Integer)
    offset < 0 && throw(ArgumentError("cannot seek to negative position"))
    offset > length(io.data) && ensureroom(io, offset - position(io))
    io.curptr = io.startptr + offset
    nothing
end

function Base.resize!(io::ByteVectorIO, newend::Ptr{Nothing})
    io.writable || throw(EOFError())

    # Calculate new size needed
    newsz = Int(max(newend - io.startptr, io.curptr - io.startptr))
    oldlen = length(io.data)

    if newsz > oldlen
        # Resize the vector
        resize!(io.data, newsz)
        # Update pointer (resize! may have moved the data)
        oldstartptr = io.startptr
        io.startptr = pointer(io.data)
        io.curptr = io.curptr - oldstartptr + io.startptr
    end

    io
end

function ensureroom(io::ByteVectorIO, n::Integer)
    ep = io.curptr + n
    endptr = io.startptr + length(io.data)
    ep > endptr && resize!(io, ep)
end

function truncate_and_close(io::ByteVectorIO, endpos::Integer)
    if io.writable && endpos < length(io.data)
        resize!(io.data, endpos)
    end
    close(io)
end

Base.close(::ByteVectorIO) = nothing

# Read a null-terminated string
function read_bytestring(io::ByteVectorIO)
    pos = position(io)
    idx = findfirst(==(0x00), view(io.data, pos+1:length(io.data)))
    idx === nothing && throw(EOFError())
    str = String(io.data[pos+1:pos+idx-1])
    io.curptr += idx
    str
end

# Checksum support
function begin_checksum_read(io::ByteVectorIO)
    idx = io.nchecksum += 1
    if idx > length(io.checksum_pos)
        push!(io.checksum_pos, position(io))
    else
        @inbounds io.checksum_pos[idx] = position(io)
    end
    io
end

function begin_checksum_write(io::ByteVectorIO, sz::Integer)
    ensureroom(io, sz)
    begin_checksum_read(io)
end

function end_checksum(io::ByteVectorIO)
    @inbounds v = io.checksum_pos[io.nchecksum]
    io.nchecksum -= 1
    Lookup3.hash(Ptr{UInt8}(io.startptr + v), position(io) - v)
end

using JLD2, Test

@testset "Mmapped Arrays" begin
    cd(mktempdir()) do

        a = rand(100,100);
        b = rand(ComplexF64, 5,5)
        c = 42
        d = [ntuple(x->Bool(x%2), Val(24))  for i=1:100]

        fn = "test.jld2"
        jldsave(fn; a, b, c, d)

        jldopen(fn, "r") do f
            dset = JLD2.get_dataset(f, "a")
            @test JLD2.ismmappable(dset)
            @test JLD2.readmmap(dset) == a
            dset = JLD2.get_dataset(f, "b")
            @test JLD2.ismmappable(dset)
            @test JLD2.readmmap(dset) == b
            dset = JLD2.get_dataset(f, "c")
            @test JLD2.ismmappable(dset) == false
            dset = JLD2.get_dataset(f, "d")
            @test JLD2.ismmappable(dset) == true
        end

        if Sys.iswindows()
            jldopen(fn, "a") do f
                dset = JLD2.get_dataset(f, "a")
                @test JLD2.ismmappable(dset) == false
                @test_logs (:warn, "On Windows memory-mapping is only possible for files in read-only mode.") JLD2.ismmappable(dset)
                dset = JLD2.get_dataset(f, "c")
                @test JLD2.ismmappable(dset) == false
                @test_nowarn JLD2.ismmappable(dset)
            end
        else
            jldopen(fn, "a") do f
                dset = JLD2.get_dataset(f, "a")
                @test JLD2.ismmappable(dset)
                @test JLD2.readmmap(dset) == a
                JLD2.readmmap(dset)[1,1] = 42.0

                dset = JLD2.get_dataset(f, "b")
                @test JLD2.ismmappable(dset)
                @test JLD2.readmmap(dset) == b
                JLD2.readmmap(dset)[1,1] = 4.0 + 2.0im

                dset = JLD2.get_dataset(f, "c")
                @test JLD2.ismmappable(dset) == false

                dset = JLD2.get_dataset(f, "d")
                @test JLD2.ismmappable(dset) == true
            end

            jldopen(fn, "r") do f
                @test f["a"][1,1] == 42.0
                @test f["b"][1,1] == 4.0 + 2.0im
                @test f["d"] == d
            end
        end
    end
end


@testset "Early Allocation" begin
    fn = tempname() * ".jld2"
    # Update this for proper API eventually
    if !Sys.iswindows()
        jldopen(fn, "w") do f
            dset = JLD2.create_dataset(f, "data")

            dset.datatype = JLD2.h5fieldtype(f, Float64, Float64, Val{false})

            dims = (100,100)
            dset.dataspace = JLD2.WriteDataspace(JLD2.DS_SIMPLE, UInt64.(reverse(dims)), ())

            JLD2.allocate_early(dset, Float64)

            @test JLD2.ismmappable(dset)

            emptyarr = JLD2.readmmap(dset)

            emptyarr[1:2:100] .= 1:50
        end

        data = JLD2.load(fn, "data")
        @test all(data[2:2:100] .== 0.0)
        @test all(data[1:2:100] .== 1:50)
    end

    jldopen(fn, "w") do f
        dset = JLD2.create_dataset(f, "data", Float64, (20,20); allocate=true)
        dset[1:20, 1] .= 10.0
        dset[20,20] = 20.0
    end
    data = load(fn, "data")
    @test all(data[1:20] .== 10.0)
    @test data[20,20] == 20.0
end

struct ObjectStart
    signature::UInt32
    version::UInt8
    flags::UInt8
end
ObjectStart(flags::UInt8) = ObjectStart(OBJECT_HEADER_SIGNATURE, 2, flags)
define_packed(ObjectStart)

"""
    Hmessage{IO}

Representation of a Header Message in memory. Provides `getproperty` access
to the fields of the message.
Can also be used to construct and write custom messages.
"""
struct Hmessage{IO}
    type::HeaderMessageType
    size::UInt16
    hflags::UInt8
    offset::RelOffset
    payload_offset::RelOffset
    m::Message{IO}
end

function write_header_message(io, vtype::Val{HMT}, hflags::Integer=0x00, size=0; kwargs...) where HMT
    kw = (; kwargs...)
    size = compute_size(vtype, hflags, size, kw)
    jlwrite(io, UInt8(HMT))
    jlwrite(io, UInt16(size))
    jlwrite(io, UInt8(hflags))
    jlwrite(io, vtype, hflags, size, kw)
    nothing
end

# Returns size of the actual message + 4 bytes for the type, size, and flags
jlsizeof(vtype::Val, hflags=0x00, size=0; kwargs...) = 
    compute_size(vtype, hflags, size, (; kwargs...)) + 4

struct HmWrap{HM, IOT}
    m::Message{IOT}
    hflags::UInt8
    size::UInt16
    HmWrap(type::HeaderMessageType, hm::Hmessage{IOT}) where IOT =
        new{type,IOT}(hm.m, hm.hflags, hm.size)
    HmWrap(type::HeaderMessageType, m::Message{IOT}) where IOT =
        new{type,IOT}(m, 0x0, 0x0)
end

write_continuation_placeholder(io::IO) = write_header_message(io, Val(HmNil), 0, 16)

function Base.show(io::IO, hm::Hmessage)
    println(io, 
     """┌─ Header Message: $(hm.type)
        │ ┌─ offset:\t$(hm.offset)
        │ │  size:\t$(hm.size)
        │ └─ flags:\t$(hm.hflags)""")
    keyvalue = messageshow(Val(hm.type), hm.m, hm.hflags, hm.size)

    N = length(keyvalue)
    for n = 1:N
        k, v = keyvalue[n]
        print(io, n < N ? "│    " : "└─   ") 
        println(io, "$k:\t$v")
    end
    if N == 0
        println(io, "└─")
    end
end

"""
    print_header_messages(f::JLDFile, name::AbstractString)
    print_header_messages(g::Group, name::AbstractString)
    print_header_messages(f::JLDFile, offset::RelOffset)

Prints the header messages of a group or dataset in a file.
"""
print_header_messages(f::JLDFile, name::AbstractString) = 
    print_header_messages(f.root_group, name)

function print_header_messages(g::Group, name::AbstractString)
    g.f.n_times_opened == 0 && throw(ArgumentError("file is closed"))
    (g, name) = pathize(g, name, false)
    roffset = lookup_offset(g, name)
    if roffset == UNDEFINED_ADDRESS
        if isempty(name)
            roffset = g.f.root_group_offset
        else
            throw(ArgumentError("did not find a group or dataset named \"$name\""))
        end
    end
    return print_header_messages(g.f, roffset)
end

function print_header_messages(f::JLDFile, offset::RelOffset)
    hmitr = HeaderMessageIterator(f, offset)
    for msg in hmitr
        print(msg)
        if msg.type == HmFilterPipeline
            filter_pipeline = WrittenFilterPipeline(msg)
            @info filter_pipeline
        elseif msg.type == HmAttribute
            attr = read_attribute(f, msg)
            data = read_attr_data(f, attr)
            println("""    data: "$data" """)
        elseif (msg.hflags & 2^3) != 0
            throw(UnsupportedFeatureException())
        end
    end
    nothing
end

function read_header_message(f, io, header_version, chunk_start, groupflags)
    msgpos = h5offset(f, position(io))
    if header_version == 1
        # Message start 8byte aligned relative to object start
        skip_to_aligned!(io, chunk_start)
        msgpos = h5offset(f, position(io))
        # Version 1 header message is padded
        msg = HeaderMessage(HeaderMessageType(jlread(io, UInt16)), jlread(io, UInt16), jlread(io, UInt8))
        skip(io, 3)
    else # header_version == 2
        msg = jlread(io, HeaderMessage)
        (groupflags & 4) == 4 && skip(io, 2) 
    end
    payload_address = position(io)
    payload_offset = h5offset(f, position(io))
    Hmessage(
        msg.msg_type,
        msg.size, msg.flags, msgpos, payload_offset,
        Message(msg.msg_type, payload_address, payload_offset, io))
end

"""
    mutable struct HeaderMessageIterator{IO}
    HeaderMessageIterator(f::JLDFile, offset::RelOffset)

Implements an iterator over header messages.
"""
mutable struct HeaderMessageIterator{IOT}
    f::JLDFile{IOT}
    curpos::Int64
    header_version::UInt8
    objflags::UInt8
    chunk::@NamedTuple{chunk_start::Int64, chunk_end::Int64}
    next_chunk::@NamedTuple{chunk_start::Int64, chunk_end::Int64}
    second_to_next_chunk::@NamedTuple{chunk_start::Int64, chunk_end::Int64}
end

function HeaderMessageIterator(f::JLDFile{IOT}, offset::RelOffset) where {IOT}
    io = f.io
    chunk_start::Int64 = fileoffset(f, offset)
    seek(io, chunk_start)
    # Version 1 object header have no signature and start with version
    header_version = jlread(io, UInt8)
    if header_version == 1
        cio = io
        skip(cio, 7)
        sz = jlread(cio, UInt32)
        skip(cio, 4)
        flags = 0x0
    else
        header_version = 0x2
        seek(io, chunk_start)
        cio = begin_checksum_read(io)
        jlread(cio, UInt32) == OBJECT_HEADER_SIGNATURE || throw(InvalidDataException("Invalid Object header signature"))
        jlread(cio, UInt8) == 2 || throw(InvalidDataException("Invalid Object header version"))
        flags = jlread(cio, UInt8)
        # Skip access, modification, change and birth times
        (flags & OH_TIMES_STORED) != 0 && skip(cio, 16)
        # Skip maximum # of attributes fields
        (flags & OH_ATTRIBUTE_PHASE_CHANGE_VALUES_STORED) != 0 && skip(cio, 4)
        sz = read_size(cio, flags)
    end
    chunk = (; chunk_start, chunk_end = position(cio) + sz)
    pos = position(cio)

    if header_version == 2
        # Verify correctness now
        seek(cio, chunk.chunk_end)
        end_checksum(cio) == jlread(io, UInt32)
        seek(io, pos)
    end

    HeaderMessageIterator{IOT}(
        f, pos, header_version, flags,
        chunk, (; chunk_start = -1, chunk_end = -1), (; chunk_start = -1, chunk_end = -1))
end
    
Base.IteratorSize(::HeaderMessageIterator) = Base.SizeUnknown()

function Base.iterate(itr::HeaderMessageIterator{IO}, state=nothing) where IO
    io = itr.f.io
    chunk = itr.chunk
    if itr.curpos > chunk.chunk_end
        throw(InternalError("This should not happen"))
    elseif itr.curpos > (chunk.chunk_end - 4 - 2*((itr.objflags & 4) == 4))
        if itr.next_chunk.chunk_start == -1
            return nothing
        end
        itr.chunk = chunk = itr.next_chunk
        itr.next_chunk = itr.second_to_next_chunk
        itr.second_to_next_chunk = (; chunk_start=-1, chunk_end=-1)

        seek(io, chunk.chunk_start)
        if itr.header_version == 2
            # Verify integrity of new chunk
            cio = begin_checksum_read(io)
            jlread(cio, UInt32) == OBJECT_HEADER_CONTINUATION_SIGNATURE || throw(InvalidDataException())
            seek(cio, chunk.chunk_end-4)
            end_checksum(cio) == jlread(io, UInt32)
            seek(io, chunk.chunk_start + 4)
            chunk = itr.chunk = (; chunk.chunk_start, chunk_end=chunk.chunk_end-4)
        end        
        itr.curpos = position(io)
    end
    seek(io, itr.curpos)
    msg = read_header_message(itr.f, io, itr.header_version, chunk.chunk_start, itr.objflags)::Hmessage{IO}
    itr.curpos = fileoffset(itr.f, msg.payload_offset)+msg.size
    if msg.type == HmObjectHeaderContinuation
        wmsg = HmWrap(HmObjectHeaderContinuation, msg)
        chunk_start = fileoffset(itr.f, wmsg.continuation_offset::RelOffset)
        chunk_end = chunk_start + wmsg.continuation_length::Int64
        new_chunk =  (; chunk_start, chunk_end)
        if itr.next_chunk.chunk_start == -1
            itr.next_chunk = new_chunk
        elseif itr.second_to_next_chunk.chunk_start == -1
            itr.second_to_next_chunk = new_chunk
        else
            throw(InternalError("This should not happen"))
        end
    end
    return msg, nothing
end

const FRACTAL_HEAP_HEADER_SIGNATURE = htol(0x50485246) # UInt8['F','R','H','P']
const FRACTAL_HEAP_INDIRECT_BLOCK_SIGNATURE = htol(0x42494846) # UInt8['F','H','I','B']
const FRACTAL_HEAP_DIRECT_BLOCK_SIGNATURE = htol(0x42444846) # UInt8['F', 'H', 'D', 'B']

struct FractalHeapHeader
    offset::RelOffset
    table_width::Int
    starting_block_size::Int
    max_direct_block_size::Int
    max_heap_size::Int
    root_block_address::RelOffset
    cur_num_rows_in_root_iblock::Int
    has_io_filter::Bool
    max_dblock_rows::Int
    max_size_managed_objects::Int
    # could add the rest of the fields if they ever become necessary
end

struct FractalHeapDirectBlock
    offset::RelOffset # position of block in file
    # block offset in heaps address space 
    # WARNING: don't use. sometimes wrong in long files
    block_offset::UInt64 
    size::UInt64
    filtered_size::UInt64 # set to typemax if not filtered
    filter_mask::UInt32  # set to typemax if not filtered
end

struct FractalHeapIndirectBlock
    offset::RelOffset # position of iblock in file
    block_offset::UInt64 # block offset in heaps address space
    dblocks::Vector{FractalHeapDirectBlock}
    iblocks::Vector{FractalHeapIndirectBlock}
end

function blocksize(blocknum, starting_size, table_width)
    #block numbering starts at zero
    rownum = Int(blocknum ÷ table_width)
    (2^(max(0,rownum-1))) * starting_size
end

function block_num_size_start(offset, hh)
    width = hh.table_width
    # first compute row number
    r = Int(offset ÷ (hh.starting_block_size*width))
    r > 2 && (r = ceil(Int, log2(r+1)))
    # row start offset
    row_startoffset = (r>1 ? 2^(r-1) : r)*hh.starting_block_size*width
    block_size = (2^(max(0,r-1))) * hh.starting_block_size
    block_num = width*r + (offset-row_startoffset) ÷ block_size
    block_start = row_startoffset + block_size*(block_num-width*r)
    block_num, block_size, block_start
end


function read_fractal_heap_header(f, offset)
    io = f.io
    seek(io, fileoffset(f, offset)) # may need to compute fileoffset
    cio = begin_checksum_read(io)

    signature = jlread(cio, UInt32)
    signature == FRACTAL_HEAP_HEADER_SIGNATURE || throw(InvalidDataException("Signature does not match."))

    version = jlread(cio, UInt8)
    heap_id_length = jlread(cio, UInt16)
    io_filter_encoded_length = jlread(cio, UInt16)
    flags = jlread(cio, UInt8)
    max_size_managed_objects = jlread(cio, UInt32)
    next_huge_object_id = jlread(cio, Length)
    huge_object_v2btree_address = jlread(cio, RelOffset)
    free_space_in_managed_blocks = jlread(cio, Length)
    managed_block_free_space_manager = jlread(cio, RelOffset)
    managed_space_in_heap = jlread(cio, Length)
    allocated_space_in_heap = jlread(cio, Length)
    direct_block_allocation_iterator_offset = jlread(cio, Length)
    managed_objects_number_in_heap = jlread(cio, Length)
    huge_objects_size_in_heap = jlread(cio, Length)
    huge_objects_number_in_heap = jlread(cio, Length)
    tiny_objects_size_in_heap = jlread(cio, Length)
    tiny_objects_number_in_heap = jlread(cio, Length)

    table_width = jlread(cio, UInt16)
    starting_block_size = jlread(cio, Length)
    max_direct_block_size = jlread(cio, Length)
    max_heap_size = jlread(cio, UInt16)
    num_starting_rows_in_root_iblock = jlread(cio, UInt16)
    root_block_address = jlread(cio, RelOffset)
    cur_num_rows_in_root_iblock = jlread(cio, UInt16)

    has_io_filter = io_filter_encoded_length > 0
    if has_io_filter
        filtered_root_direct_block_size = jlread(cio, Length)
        io_filter_mask = jlread(cio, UInt32)
        io_filter_information = jlread(cio, UInt8, io_filter_encoded_length)
    else
        filtered_root_direct_block_size = typemax(Length)
        io_filter_mask = typemax(UInt32)
        io_filter_information = UInt8[]
    end

    # Checksum
    end_checksum(cio) == jlread(io, UInt32) || throw(InvalidDataException("Invalid Checksum"))

    max_dblock_rows = (log2(max_direct_block_size) - log2(starting_block_size))+2 |> Int

    FractalHeapHeader(offset, table_width, starting_block_size, max_direct_block_size, max_heap_size,
        root_block_address, cur_num_rows_in_root_iblock, has_io_filter, max_dblock_rows,
        max_size_managed_objects)
end

function read_indirect_block(f, offset, hh, nrows::Int)
    io = f.io
    seek(io, fileoffset(f, offset))
    cio = begin_checksum_read(io)

    signature = jlread(cio, UInt32)
    signature == FRACTAL_HEAP_INDIRECT_BLOCK_SIGNATURE || throw(InvalidDataException("Signature does not match."))

    version = jlread(cio, UInt8)
    heap_header_address = jlread(cio, RelOffset)
    # number of bytes for block offset
    offset_byte_num = ceil(Int, hh.max_heap_size / 8)
    block_offset = read_nb_uint(cio, offset_byte_num)

    # Read child direct blocks
    block_start = block_offset
    K = min(nrows, hh.max_dblock_rows)*hh.table_width
    dblocks = map(1:K) do k
        dblock_address = jlread(cio, RelOffset)
        dblock_size = blocksize(k-1, hh.starting_block_size, hh.table_width)
        if hh.has_io_filter > 0
            filtered_size = jlread(cio, Length)
            filter_mask = jlread(cio, UInt32)
        else
            filtered_size = typemax(Length)
            filter_mask = typemax(UInt32)
        end
        dblock = FractalHeapDirectBlock(dblock_address, block_start, dblock_size, filtered_size, filter_mask)
        block_start += dblock_size
        return dblock
    end
    N = (nrows <= hh.max_dblock_rows) ? 0 :  (nrows-hh.max_dblock_rows)*hh.table_width
    iblock_addresses = map(1:N) do n
        jlread(cio, RelOffset)
    end

    # Checksum
    end_checksum(cio) == jlread(io, UInt32) || throw(InvalidDataException()) 
    
    iblocks = Vector{FractalHeapIndirectBlock}(undef, N)
    for n=1:N
        iblock_offset = iblock_addresses[n] 
        iblock_offset == UNDEFINED_ADDRESS && break
        # figure out iblock size / nrows
        block_num = K+(n-1)
        rownum = block_num ÷ hh.table_width
        block_size = (2^(max(0,rownum-1))) * hh.starting_block_size
        sub_iblock_nrows::Int = (log2(block_size)-log2(hh.starting_block_size* hh.table_width))+1
        iblocks[n] = read_indirect_block(f, iblock_offset , hh, sub_iblock_nrows)
    end
    FractalHeapIndirectBlock(offset, block_offset, dblocks, iblocks)
end

#####################################################################################################
## Version 2 B-trees 
#####################################################################################################

const V2_BTREE_HEADER_SIGNATURE = htol(0x44485442) # UInt8['B','T','H','D']
const V2_BTREE_INTERNAL_NODE_SIGNATURE = htol(0x4e495442) # UInt8['B', 'T', 'I', 'N']
const V2_BTREE_LEAF_NODE_SIGNATURE = htol(0x464c5442) # UInt8['B', 'T', 'L', 'F']

struct BTreeHeaderV2
    offset::RelOffset
    type::Int
    node_size::Int
    record_size::Int
    depth::Int
    split_percent::Int
    merge_percent::Int
    root_node_address::RelOffset
    num_records_in_root_node::Int
    num_records_in_tree::Int
end

abstract type BTreeNodeV2 end
abstract type BTreeRecordV2 end

struct BTreeInternalNodeV2 <: BTreeNodeV2
    offset::RelOffset
    type::UInt8
    records::Vector{Any}
    child_nodes::Vector #abstract to defer loading
end

struct BTreeLeafNodeV2 <: BTreeNodeV2
    offset::RelOffset
    type::UInt8
    records::Vector{<:BTreeRecordV2}
end

struct BTreeType5RecordV2 <: BTreeRecordV2
    hash::UInt32
    offset::UInt64
    length::Int
end

function read_v2btree_header(f, offset)
    io = f.io
    seek(io, fileoffset(f, offset))
    cio = begin_checksum_read(io)

    signature = jlread(cio, UInt32)
    signature == V2_BTREE_HEADER_SIGNATURE || throw(InvalidDataException("Signature does not match."))

    version = jlread(cio, UInt8)
    type = jlread(cio, UInt8)
    node_size = jlread(cio, UInt32)
    record_size = jlread(cio, UInt16)
    depth = jlread(cio, UInt16)
    split_percent = jlread(cio, UInt8)
    merge_percent = jlread(cio, UInt8)
    root_node_address = jlread(cio, RelOffset)
    num_records_in_root_node = jlread(cio, UInt16)
    num_records_in_tree = jlread(cio, Length)

    end_checksum(cio) == jlread(io, UInt32) || throw(InvalidDataException())    
    BTreeHeaderV2(  offset,
                    type,
                    node_size,
                    record_size,
                    depth,
                    split_percent,
                    merge_percent,
                    root_node_address,
                    num_records_in_root_node,
                    num_records_in_tree)
end


function read_v2btree_node(f, offset, num_records, depth, bh, hh)
    if depth == 0
        return read_v2btree_leaf_node(f, offset, num_records, bh, hh)
    end
    io = f.io
    seek(io, fileoffset(f, offset)) # may need to compute fileoffset
    cio = begin_checksum_read(io)

    signature = jlread(cio, UInt32)
    signature == V2_BTREE_INTERNAL_NODE_SIGNATURE || throw(InvalidDataException("Signature does not match."))

    version = jlread(cio, UInt8)
    type = jlread(cio, UInt8)

    records = map(1:num_records) do n 
        read_record(cio, type, hh)
    end

    # determine number of bytes used to encode `num_records`
    # this has to be done iteratively
    # leaf node:
    space = bh.node_size - 4 - 1 - 1 - 4
    max_records = space ÷ bh.record_size
    max_records_total = 0
    numbytes = size_size(max_records)
    numbytes_total = 0

    for d = 1:depth
        space = bh.node_size - 4-1-1-4 - sizeof(RelOffset) - (d>1)*numbytes_total
        max_records = space ÷ (bh.record_size + sizeof(RelOffset) + numbytes+(d>1)*numbytes_total)
        numbytes = size_size(max_records)
        max_records_total = max_records + (max_records+1)*max_records_total
        numbytes_total = size_size(max_records_total)
    end
    numbytes_total = size_size2(max_records_total)
    child_nodes = map(1:num_records+1) do _
        child_node_pointer = jlread(cio, RelOffset) # offset type
        num_records = Int(read_nb_uint(cio, numbytes))
        if depth > 1
            total_records = Int(read_nb_uint(cio, numbytes_total))
            return (; child_node_pointer, num_records, total_records)
        end
        (; child_node_pointer, num_records)
    end
    end_checksum(cio) == jlread(io, UInt32) || throw(InvalidDataException())    
    
    BTreeInternalNodeV2(offset, type, records, child_nodes)
end


function read_v2btree_leaf_node(f, offset, num_records, bh, hh)
    io = f.io
    seek(io, fileoffset(f, offset)) # may need to compute fileoffset
    cio = begin_checksum_read(io)

    signature = jlread(cio, UInt32)
    signature == V2_BTREE_LEAF_NODE_SIGNATURE || throw(InvalidDataException("Signature does not match."))
    version = jlread(cio, UInt8)
    type = jlread(cio, UInt8)
    records = map(1:num_records) do n 
        read_record(cio, type, hh)
    end
  
    end_checksum(cio) == jlread(io, UInt32) || throw(InvalidDataException())    
    BTreeLeafNodeV2(offset, type, records)
end



function read_record(io, type, hh)
    if type == 5 # link name for indexed group
        hash_of_name = jlread(io, UInt32)
        # read Heap id for managed object
        version_type = jlread(io, UInt8)

        offbytes = hh.max_heap_size÷8
        offset =Int(read_nb_uint(io, offbytes))
        lnbytes = min(hh.max_direct_block_size, hh.max_size_managed_objects) |> size_size2
        length = Int(read_nb_uint(io, lnbytes))
        skip(io, 6-offbytes-lnbytes)
        return BTreeType5RecordV2(hash_of_name, offset, length)
    else
        throw(error("Not implemented record type"))
    end
end

function read_records_in_node(f, offset, num_records, depth, bh, hh)
    if depth == 0
        return read_v2btree_leaf_node(f, offset, num_records, bh, hh).records
    end
    
    node = read_v2btree_node(f, offset, num_records, depth, bh, hh)::BTreeInternalNodeV2

    records = []
    for n=1:num_records+1
        child_offset = node.child_nodes[n].child_node_pointer
        child_records = node.child_nodes[n].num_records
        records_in_child = read_records_in_node(f, child_offset, child_records, depth-1, bh, hh)
        append!(records, records_in_child)
        n<=num_records && (push!(records, node.records[n]))
    end
    return records
end

function get_block_offset(f, iblock, roffset, hh)
    block_num, block_size, block_start = block_num_size_start(roffset, hh)
    K = length(iblock.dblocks)
    if block_num < K
        dblock = iblock.dblocks[block_num+1]
        return dblock.offset + roffset - block_start
    end
    sub_iblock =  iblock.iblocks[block_num-K+1]
    get_block_offset(f, sub_iblock, roffset-block_start, hh)
end

function read_btree(f, offset_hh, offset_bh)
    hh = read_fractal_heap_header(f, offset_hh)
    bh = read_v2btree_header(f, offset_bh)
    
    records = read_records_in_node(f, bh.root_node_address, bh.num_records_in_root_node, bh.depth, bh, hh)
    if hh.cur_num_rows_in_root_iblock > 0
        indirect_rb = read_indirect_block(f, hh.root_block_address, hh, hh.cur_num_rows_in_root_iblock)
        links = map(records) do r
            offset = get_block_offset(f, indirect_rb, r.offset, hh)
            m = HmWrap(HmLinkMessage, Message(HmLinkMessage, f, offset))
            m.link_name, m.target
        end
    else # there's only a single direct block at hh.root_block_address
        links = map(records) do r
            offset = hh.root_block_address + r.offset
            m = HmWrap(HmLinkMessage, Message(HmLinkMessage, f, offset))
            m.link_name, m.target
        end
    end
    links::Vector{Tuple{String, RelOffset}}
end

###########################################################################################
##                        Old Style Group: V1 B-Tree & Name Index Heap                   ##
###########################################################################################

function read_oldstyle_group(f, v1btree_address, name_index_heap)
    local_heap = read_local_heap_header(f, name_index_heap)
    links = read_v1btree(f, v1btree_address)
    map(links) do link
        link_name = read_in_local_heap(f, local_heap, link.link_name_offset)
        (link_name, link.obj_header_address::RelOffset)
    end::Vector{Tuple{String, RelOffset}}
end

const LOCAL_HEAP_SIGNATURE = htol(0x50414548) # UInt8['H', 'E', 'A', 'P']
function read_local_heap_header(f, offset)
    io = f.io
    seek(io, fileoffset(f, offset))

    signature = jlread(io, UInt32)
    signature == LOCAL_HEAP_SIGNATURE || throw(InvalidDataException("Signature does not match."))

    version = jlread(io, UInt8)
    version == 0 || throw(UnsupportedVersionException("Local heap with version $version detected."))
    skip(io, 3)
    data_segment_size = jlread(io, Length)

    # This field is important for computing where to add to the heap. Let's ignore that
    offset_head_free_list = jlread(io, Length)
    data_segment_offset = jlread(io, RelOffset)
    (; offset=data_segment_offset, size=data_segment_size)
end

function read_in_local_heap(f, local_heap, pos)
    io = f.io
    offset = local_heap.offset + pos
    seek(io, fileoffset(f, offset))
    return read_bytestring(io)
end

const V1_BTREE_NODE_SIGNATURE = htol(0x45455254) # UInt8['T', 'R', 'E', 'E']
function read_v1btree(f, offset)
    io = f.io
    seek(io, fileoffset(f, offset))

    signature = jlread(io, UInt32)
    signature == V1_BTREE_NODE_SIGNATURE || throw(InvalidDataException("Signature does not match."))

    # 0 for internal node, 1 for chunked datasets
    node_type = jlread(io, UInt8)
    node_type == 0 || throw(InvalidDataException("Expected a v1 btree for group nodes"))
    # level of node. 0 implies leaf node
    node_level = jlread(io, UInt8)
    # how many entries are used
    entries_used = jlread(io, UInt16)
    # maximum value appears to be the one from superblock
    # but this is irrelevant for reading
    left_sibling = jlread(io, RelOffset)
    right_sibling = jlread(io, RelOffset)
    links = []
    keys = []
    children = RelOffset[]
    for _ = 1:entries_used
        push!(keys, jlread(io, Length))
        push!(children, jlread(io, RelOffset))
    end
    push!(keys, jlread(io, Length))

    for child in children
        if node_level > 0
            append!(links, read_v1btree(f, child))
        else
            append!(links, read_symbol_table_node(f, child))
        end
    end
    return links
end

function read_v1btree_dataset_chunks(f, offset, dimensionality)
    io = f.io
    seek(io, fileoffset(f, offset))

    signature = jlread(io, UInt32)
    signature == V1_BTREE_NODE_SIGNATURE || throw(InvalidDataException("Signature does not match."))

    # 0 for internal node, 1 for chunked datasets
    node_type = jlread(io, UInt8)
    node_type == 1 || throw(InvalidDataException("Expected a v1 btree for dataset chunks"))
    # level of node. 0 implies leaf node
    node_level = jlread(io, UInt8)
    # how many entries are used
    entries_used = jlread(io, UInt16)
    # maximum value appears to be the one from superblock
    # but this is irrelevant for reading
    left_sibling = jlread(io, RelOffset)
    right_sibling = jlread(io, RelOffset)
    children = Any[]
    for _ = 1:entries_used
        chunk_size = Int(jlread(io, UInt32))
        filter_mask = Int(jlread(io, UInt32))
        index = jlread(io, UInt64, dimensionality)
        push!(children, (offset=jlread(io, RelOffset), node_level, chunk_size, filter_mask, idx=tuple(Int.(index)...)))
    end

    chunks = Any[]
    for child in children
        if child.node_level > 0
            append!(chunks, read_v1btree_dataset_chunks(f, child.offset, dimensionality))
        else
            push!(chunks, child)
        end
    end
    return chunks
end


const SYMBOL_TABLE_NODE_SIGNATURE = htol(0x444f4e53) # UInt8['S', 'N', 'O', 'D']

function read_symbol_table_node(f, offset)
    io = f.io
    seek(io, fileoffset(f, offset))

    signature = jlread(io, UInt32)
    signature == SYMBOL_TABLE_NODE_SIGNATURE || throw(InvalidDataException("Signature does not match."))

    version = jlread(io, UInt8)
    skip(io, 1)
    num_symbols = jlread(io, UInt16)
    links = []

    for _=1:num_symbols
        link_name_offset =  jlread(io, Length) # RelOffset but this is probably wrong
        obj_header_address = jlread(io, RelOffset)
        skip(io, 24)
        push!(links, (; link_name_offset, obj_header_address))
    end
    return links
end

using JLD2, Test
using Pkg: Pkg
using JLD2Bzip2, JLD2Lz4


# This is for testing the different syntax versions as well as the library
@testset "Compression with Deflate" begin
    fn = joinpath(mktempdir(), "test.jld2")

    randomdata = repeat(rand(2000), 10)
    @save fn {compress=true} randomdata
    r = jldopen(f -> f["randomdata"], fn, "r")
    @test r == randomdata

    jldopen(fn, "w"; compress=Deflate()) do f
        f["randomdata"] = randomdata
    end
    @test load(fn, "randomdata") == randomdata

    jldopen(fn, "w") do f
        write(f, "randomdata", randomdata; compress=Deflate())
    end
    @test load(fn, "randomdata") == randomdata
end


@testset "Compression with Filters" begin
    fn = joinpath(mktempdir(), "test.jld2")
    filters = [
        Deflate(),
        Bzip2Filter(),
        Lz4Filter(),
        Lz4Filter(10^5),
        ZstdFilter(),
        #= BloscFilter(),
        BitshuffleFilter(),
        BitshuffleFilter(compressor=:lz4),
        BitshuffleFilter(compressor=:zstd), =#
        [Shuffle(), Deflate()]
    ]

    randomdata = repeat(rand(200), 100)
    for filter in filters
        @save fn {compress=filter} randomdata
        r = jldopen(f -> f["randomdata"], fn, "r")
        @test r == randomdata
    end
end

@testset "Compress Arrays with non-trivial layout" begin
    fn = joinpath(mktempdir(), "compress_with_conversion.jld2")
    fn2 = joinpath(mktempdir(), "no_compress_with_conversion.jld2")

    data = [(nothing, 0x00) for n in 1:1000]
    @save fn {compress=true} data
    @save fn2 {compress=false} data
    r = jldopen(f -> f["data"], fn, "r")
    @test r == data
    @test filesize(fn) < filesize(fn2)

    data = [(1, 0x00) for n in 1:1000]
    @save fn {compress=true} data
    @save fn2 {compress=false} data
    r = jldopen(f -> f["data"], fn, "r")
    @test r == data
    @test filesize(fn) < filesize(fn2)
end

@testset "Verify Correctness of Compressor" begin
    fn = joinpath(mktempdir(), "test.jld2")

    @test_throws ArgumentError jldopen(fn, "w"; compress = 42)

    jldopen(fn, "w") do f
        @test_throws ArgumentError write(f, "x", zeros(10); compress = π)
    end
end

@testset "Filter Constructor API" begin
    # Test that both positional and keyword constructors work for all filters

    # Test Deflate filter
    @test Deflate(3).level == 3
    @test Deflate(level=3).level == 3
    @test Deflate(level=7).level == 7

    # Test ZstdFilter
    @test ZstdFilter(10).level == 10
    @test ZstdFilter(level=10).level == 10
    @test (ZstdFilter(-10) |> JLD2.Filters.client_values) == (-10 % UInt32, )

    # Test Shuffle filter
    @test Shuffle(UInt32(8)).element_size == 8

    # Test Bzip2Filter
    @test Bzip2Filter(5).blocksize100k == 5
    @test Bzip2Filter(blocksize100k=5).blocksize100k == 5

    # Test Lz4Filter
    @test Lz4Filter(12345).blocksize == 12345
    if pkgversion(JLD2Lz4) > v"0.1.1"
        @test Lz4Filter(blocksize=12345).blocksize == 12345
    end
end

@testset "Compression level is applied" begin
    # Regression test: ZstdEncodeOptions names its keyword `compressionLevel`
    # and silently discards unknown keywords, so passing the level as `level`
    # made every ZstdFilter compress at the default level regardless of the
    # requested one. Check that the encode options constructed for a filter
    # actually carry the requested level.
    F = JLD2.Filters
    for level in (-100, 1, 3, 22)
        @test F.encode_options(ZstdFilter(level)).compressionLevel == level
    end
    for level in (1, 5, 9)
        @test F.encode_options(Deflate(level)).level == level
    end

    # Round-trip through the file API at non-default levels
    dir = mktempdir()
    data = repeat(rand(2000), 50)
    for filter in (ZstdFilter(1), ZstdFilter(22), Deflate(1), Deflate(9))
        fn = joinpath(dir, "leveltest.jld2")
        jldsave(fn, filter; data)
        @test load(fn, "data") == data
    end
end

@testset "Compression Filters Coverage" begin
    using JLD2.Filters

    # Test data
    data = UInt8[i % 256 for i in 1:10000]

    pipelines = [
        # Double compression (unknown intermediate size)
        Filters.FilterPipeline(Deflate(), ZstdFilter()),
        # Shuffle + Compression
        Filters.FilterPipeline(Shuffle(4), Deflate()),
        Filters.FilterPipeline(Shuffle(4), ZstdFilter()),
        Filters.FilterPipeline(Shuffle(4), Bzip2Filter()),
        Filters.FilterPipeline(Shuffle(4), Lz4Filter()),
    ]

    for pipeline in pipelines
        # Manually compress
        buf = copy(data)
        ref = Ref(buf)

        for filter in pipeline.filters
             Filters.apply_filter!(filter, ref, true)
        end
        compressed_data = ref[]

        # Decompress using Filters.decompress with unknown size (nothing)
        # This ensures we hit the branch where output_size is nothing in apply_filter!
        io = IOBuffer(compressed_data)
        decompressed = Filters.decompress(pipeline, io, length(compressed_data), nothing)

        @test decompressed == data
    end
end

#
# BufferedIO
#

mutable struct BufferedWriter{io} <: MemoryBackedIO
    f::io
    buffer::Vector{UInt8}
    file_position::Int64
    curptr::Ptr{Nothing}
    extensible::Bool
end

function BufferedWriter(io, buffer_size::Integer = 0; extensible::Bool=false)
    pos = position(io)
    skip(io, buffer_size)
    buf = Vector{UInt8}(undef, buffer_size)
    BufferedWriter(io, buf, Int64(pos), Ptr{Nothing}(pointer(buf)), extensible)
end
Base.show(io::IO, ::BufferedWriter) = print(io, "BufferedWriter")

function ensureroom(io::BufferedWriter, n::Integer)
    if bufferpos(io) + n > length(io.buffer)
        if io.extensible
            pos = bufferpos(io)
            resize!(io.buffer, length(io.buffer) + n)
            io.curptr = pointer(io.buffer, pos+1)
        else
            throw(InternalError("BufferedWriter: not enough room"))
        end
    end
end

Base.position(io::BufferedWriter) = io.file_position + bufferpos(io)

function Base.seek(io::BufferedWriter, offset::Integer)
    buffer_offset = offset - io.file_position
    buffer_offset < 0 && throw(ArgumentError("cannot seek before start of buffer"))
    ensureroom(io, buffer_offset - bufferpos(io))
    io.curptr = pointer(io.buffer) + buffer_offset
end

function finish!(io::BufferedWriter)
    bufferpos(io) == length(io.buffer) ||
        throw(InternalError("BufferedWriter: buffer not written to end; position is $(bufferpos(io)) but length is $(length(io.buffer))"))
    seek(io.f, io.file_position)
    jlwrite(io.f, io.buffer)
    nothing
end

mutable struct BufferedReader{io} <: MemoryBackedIO
    f::io
    buffer::Vector{UInt8}
    file_position::Int64
    curptr::Ptr{Nothing}
end

function BufferedReader(io)
    buf = Vector{UInt8}()
    BufferedReader(io, buf, Int64(position(io)), Ptr{Nothing}(pointer(buf)))
end

Base.show(io::IO, ::BufferedReader) = print(io, "BufferedReader")

function ensureroom(io::BufferedReader, n::Integer)
    buf_end = length(io.buffer)
    bufferpos(io) + n > buf_end || return  # already have enough data ahead of cursor
    needed = n - (buf_end - bufferpos(io))
    f = io.f
    sz = _getsize(f)
    amount = min(max(needed, 2^14), sz - position(f))
    amount < needed && throw(EOFError())
    pos = bufferpos(io)
    resize!(io.buffer, buf_end + amount)
    io.curptr = pointer(io.buffer, pos + 1)         # restore after potential realloc
    unsafe_read(f, pointer(io.buffer, buf_end + 1), amount)  # append at end of buffer
end


Base.position(io::BufferedReader) = io.file_position + bufferpos(io)

"""
    bufferpos(io::Union{BufferedReader, BufferedWriter})

Get the current position in the buffer.
"""
bufferpos(io::Union{BufferedReader, BufferedWriter}) = Int(io.curptr - pointer(io.buffer))

function Base.seek(io::BufferedReader, offset::Integer)
    pos =  offset - io.file_position
    pos < 0 && throw(ArgumentError("cannot seek before start of buffer"))
    ensureroom(io, offset - position(io))
    io.curptr = pointer(io.buffer) + pos
    nothing
end
finish!(io::BufferedReader) = seek(io.f, io.file_position + bufferpos(io))

function truncate_and_close(io::IOStream, endpos::Integer)
    truncate(io, endpos)
    close(io)
end

Base.close(::BufferedReader) = nothing

begin_checksum_read(io::IO) = BufferedReader(io)

function begin_checksum_write(io::IO, sz::Integer)
    BufferedWriter(io, sz)
end
function end_checksum(io::Union{BufferedReader,BufferedWriter})
    ret = Lookup3.hash(io.buffer, 1, bufferpos(io))
    finish!(io)
    ret
end

function update_checksum(io, chunk_start, chunk_end)
    seek(io, chunk_start)
    cio = begin_checksum_read(io)
    seek(cio, chunk_end)
    seek(io, chunk_end)
    jlwrite(io, end_checksum(cio))
end

#
# MmapIO
#
# An IO built on top of mmap to avoid the overhead of ordinary disk IO
if Sys.iswindows()
    const MMAP_GROW_SIZE = 2^19
    const FILE_GROW_SIZE = 2^19
else
    const MMAP_GROW_SIZE = 2^24
    const FILE_GROW_SIZE = 2^18
end

mutable struct MmapIO <: MemoryBackedIO
    f::IOStream
    write::Bool
    n::Int
    startptr::Ptr{Cvoid}
    curptr::Ptr{Cvoid}
    endptr::Ptr{Cvoid}
    @static if Sys.iswindows()
        mapping::Ptr{Cvoid}
    end
    # The following two fields used to be global constants but
    # that breaks concurrent writes on separate threads
    checksum_pos::Vector{Int64}
    nchecksum::Int64
end

if Sys.isunix()
    function mmap!(io::MmapIO, n::Int)
        oldptr = io.startptr
        newptr = ccall(:jl_mmap, Ptr{Cvoid}, (Ptr{Cvoid}, Csize_t, Cint, Cint, Cint, Int64),
                       C_NULL, n, Mmap.PROT_READ | (io.write*Mmap.PROT_WRITE),
                       Mmap.MAP_SHARED, fd(io.f), 0)
        systemerror("mmap", newptr == Ptr{Nothing}(-1))
        io.n = n
        io.curptr += newptr - oldptr
        io.startptr = newptr
    end

    munmap(io::MmapIO) =
        systemerror("munmap",
                    ccall(:munmap, Cint, (Ptr{Cvoid}, Int), io.startptr, io.n) != 0)

    function msync(io::MmapIO, offset::Integer=0, len::Integer=UInt(io.endptr - io.startptr),
                   invalidate::Bool=false)
        # shift `offset` to start of page boundary
        offset_page::Int64 = div(offset, Mmap.PAGESIZE) * Mmap.PAGESIZE
        # add (offset - offset_page) to `len` to get total length of memory-mapped region
        mmaplen::Int64 = (offset - offset_page) + len
        # Edge case: calling msync with 0 mmaplen fails on mac
        mmaplen == 0 && return nothing
        systemerror("msync",
                    ccall(:msync, Cint, (Ptr{Cvoid}, Csize_t, Cint),
                          io.startptr + offset_page, mmaplen,
                          invalidate ? Mmap.MS_INVALIDATE : Mmap.MS_SYNC) != 0)
    end
elseif Sys.iswindows()
    const DWORD = Culong
    function mmap!(io::MmapIO, n::Int)
        oldptr = io.startptr
        mapping = ccall(:CreateFileMappingW, stdcall, Ptr{Cvoid},
                        (Base.Libc.WindowsRawSocket, Ptr{Cvoid}, DWORD, DWORD, DWORD, Ptr{Cvoid}),
                        Mmap.gethandle(io.f), C_NULL,
                        io.write ? Mmap.PAGE_READWRITE : Mmap.PAGE_READONLY, n >> 32,
                        n % UInt32, C_NULL)
        systemerror("CreateFileMappingW", mapping == C_NULL)
        newptr = ccall(:MapViewOfFile, stdcall, Ptr{Cvoid},
                       (Ptr{Cvoid}, DWORD, DWORD, DWORD, Csize_t),
                        mapping, io.write ? Mmap.FILE_MAP_WRITE : Mmap.FILE_MAP_READ, 0, 0,
                        n)
        systemerror("MapViewOfFile", newptr == C_NULL)
        io.n = n
        io.curptr += newptr - oldptr
        io.mapping = mapping
        io.startptr = newptr
    end

    function munmap(io::MmapIO)
        systemerror("UnmapViewOfFile",
                    ccall(:UnmapViewOfFile, stdcall, Cint, (Ptr{Cvoid},), io.startptr) == 0)
        systemerror("CloseHandle",
                    ccall(:CloseHandle, stdcall, Cint, (Ptr{Cvoid},), io.mapping) == 0)
    end

    function msync(io::MmapIO, offset::Integer=0, len::Integer=UInt(io.endptr - io.startptr),
                   invalidate::Bool=false)
        # shift `offset` to start of page boundary
        offset_page::Int64 = div(offset, Mmap.PAGESIZE) * Mmap.PAGESIZE
        # add (offset - offset_page) to `len` to get total length of memory-mapped region
        mmaplen::Int64 = (offset - offset_page) + len
        systemerror("FlushViewOfFile",
                    ccall(:FlushViewOfFile, stdcall, Cint,
                          (Ptr{Cvoid}, Csize_t), io.startptr + offset_page, mmaplen) == 0)
    end
end

function MmapIO(fname::AbstractString, write::Bool, create::Bool, truncate::Bool)
    truncate && !write && throw(ArgumentError("cannot truncate file that is not writable"))

    f = open(fname, read = true, write = write,
             create = create, truncate = truncate, append = false)
    initialsz = truncate ? Int64(0) : filesize(fname)
    @static if Int == Int32
        initialsz > typemax(Int) && error("cannot read a file greater than 2GB on a 32-bit system")
    end
    n = (initialsz % Int) + (write ? MMAP_GROW_SIZE : 0)
    n < 0 && (n = typemax(Int))

    @static if Sys.iswindows()
        io = MmapIO(f, write, 0, C_NULL, C_NULL, C_NULL, C_NULL, Int64[], 0)
    else
        io = MmapIO(f, write, 0, C_NULL, C_NULL, C_NULL, Int64[], 0)
    end
    mmap!(io, n)
    io.endptr = io.startptr + (initialsz % Int)

    io
end

Base.show(io::IO, ::MmapIO) = print(io, "MmapIO")

function grow(io::IOStream, sz::Integer)
    @static if Sys.islinux()
        systemerror("ftruncate",
            ccall(:ftruncate, Cint, (Cint, Int64), fd(io), sz) != 0)
    else
        truncate(io, sz)
    end
end


function Base.resize!(io::MmapIO, newend::Ptr{Cvoid})
    io.write || throw(EOFError())

    # Resize file
    ptr = io.startptr
    newsz = Int(max(newend - ptr, io.curptr - ptr + FILE_GROW_SIZE))
    @static if !Sys.iswindows()
        grow(io.f, newsz)
    end

    if newsz > io.n
        # If we have not mapped enough memory, map more
        munmap(io)
        ptr = mmap!(io, max(newsz, io.n + MMAP_GROW_SIZE))
    end

    # Set new end
    io.endptr = ptr + newsz
    io
end

function ensureroom(io::MmapIO, n::Integer)
    ep = io.curptr + n
    ep > io.endptr && resize!(io, ep)
end

function truncate_and_close(io::MmapIO, endpos::Integer)
    io.write && msync(io)
    munmap(io)
    truncate(io.f, endpos)
    close(io.f)
end

function Base.close(io::MmapIO)
    io.write && msync(io)
    munmap(io)
    close(io.f)
end

@static if Sys.isunix()
    function Base.unsafe_write(io::MmapIO, ptr::Ptr{UInt8}, nb::UInt)
        if nb > MMAP_CUTOFF
            pos = position(io)

            # Ensure that the current page has been flushed to disk
            msync(io, pos, min(io.endptr - io.curptr, nb))

            # Write to the underlying IOStream
            regulario = io.f
            seek(regulario, pos)
            unsafe_write(regulario, ptr, nb)

            # Invalidate cache of any pages that were just written to
            msync(io, pos, min(io.n - pos, nb), true)

            # Make sure the mapping encompasses the written data
            ensureroom(io, nb + 1)

            # Seek to the place we just wrote
            seek(io, pos + nb)
        else
            ensureroom(io, nb)
            unsafe_copyto!(Ptr{UInt8}(io.curptr), ptr, nb)
            io.curptr += nb
        end
        nb
    end
end

# Read a null-terminated string
function read_bytestring(io::MmapIO)
    ptr = pconvert(Ptr{UInt8}, io.curptr)
    maxbytes = io.endptr - io.curptr + 1
    q = @ccall memchr(ptr::Ptr{UInt8}, 0::Int32, maxbytes::Csize_t)::Ptr{UInt8}
    q == C_NULL && throw(EOFError())

    str = unsafe_string(ptr, (q - ptr) % Int)
    io.curptr += (q - ptr) % Int + 1
    str
end

Base.position(io::MmapIO) = Int64(io.curptr - io.startptr)
bufferpos(io::MmapIO) = Int64(io.curptr - io.startptr)

# We sometimes need to compute checksums. We do this by first calling begin_checksum when
# starting to handle whatever needs checksumming, and calling end_checksum afterwards. Note
# that we never compute nested checksums, but we may compute multiple checksums
# simultaneously. This strategy is not thread-safe.

function begin_checksum_read(io::MmapIO)
    idx = io.nchecksum += 1
    if idx > length(io.checksum_pos)
        push!(io.checksum_pos, position(io))
    else
        @inbounds io.checksum_pos[idx] = position(io)
    end
    io
end

function begin_checksum_write(io::MmapIO, sz::Integer)
    ensureroom(io, sz)
    begin_checksum_read(io)
end

function end_checksum(io::MmapIO)
    @inbounds v = io.checksum_pos[io.nchecksum]
    io.nchecksum -= 1
    Lookup3.hash(Ptr{UInt8}(io.startptr + v), position(io) - v)
end

using JLD2, Test
@test JLD2.Lookup3.hash(UInt8[]) == 0xdeadbeef
@test JLD2.Lookup3.hash(UInt8[], 1, 0, 0xdeadbeef) == 0xbd5b7dde
@test JLD2.Lookup3.hash(UInt8[23]) == 0xa209c931
@test JLD2.Lookup3.hash(UInt8[0]) == 0x8ba9414b
@test JLD2.Lookup3.hash(UInt8[23, 187]) == 0x8ba7a6c9
@test JLD2.Lookup3.hash(UInt8[0, 0]) == 0x62cd61b3
@test JLD2.Lookup3.hash(UInt8[23, 187, 98]) == 0xcebdf4f0
@test JLD2.Lookup3.hash(UInt8[0, 0, 0]) == 0x6bd0060f
@test JLD2.Lookup3.hash(UInt8[23, 187, 98, 217]) == 0x2c88bb51
@test JLD2.Lookup3.hash(UInt8[0, 0, 0, 0]) == 0x049396b8
large_buf = Vector{UInt8}(undef, 3093)
for i = 1:length(large_buf)
    large_buf[i] = ((i-1) * 3) % UInt8
end
@test JLD2.Lookup3.hash(large_buf) == 0x1bd2ee7b
@test JLD2.Lookup3.hash(fill!(large_buf, 0)) == 0x930c7afc

lookup3_test_hashes = [
    0x276a0407, 0xc4f3b847, 0x3253e887, 0xf0dbeea6, 0xa496ca89, 0xa2773e81,
    0xa88b6e6c, 0x2ca474f0, 0xe38ce8aa, 0xdb610bd1, 0x17f84daf, 0xccda323b,
    0x114345a2, 0xc01e7c57, 0x636342ab, 0x17bd0180, 0xbed86ff9, 0xae721167,
    0x9bc026d8, 0xaf53f65a, 0xbad83ad7, 0xcf6e279e, 0x8806c437, 0x4eaa9b13,
    0x2b885021, 0x769e8a62, 0x7e5372be, 0xa70fa8be, 0x8b7a3c59, 0x17770551,
]
for (i, h) in enumerate(lookup3_test_hashes)
    @test JLD2.Lookup3.hash(b"Four score and seven years ago"[begin:i]) == h
end

function read_field_datatypes(f::JLDFile, dt::CompoundDatatype, attrs::Vector{ReadAttribute})
    offsets = nothing
    namevec = nothing
    for attr in attrs
        if attr.name == :field_types
            offsets = read_attr_data(f, attr, ReferenceDatatype(),
                            SameRepr{RelOffset}())
        elseif attr.name == :field_names
            namevec = read_attr_data(f, attr, H5TYPE_VLEN_UTF8,
                            MappedRepr{String,Vlen{String}}())
        elseif attr.name == :field_datatypes
            # Legacy: Files written before JLD2 v0.4.54
            offsets = read_attr_data(f, attr, ReferenceDatatype(),
                            SameRepr{RelOffset}())
        end
    end
    isnothing(namevec) && (namevec = string.(dt.names))
    isnothing(offsets) && (offsets = fill(NULL_REFERENCE, length(namevec)))
    namevec::Vector{String}
    offsets::Vector{RelOffset}
    v = [n=>v for (n,v) in zip(namevec,offsets)]
    OrderedDict{String, RelOffset}(v)
end

"""
    readas(::Type)::Type

**Experimental feature**: 
`JLD2.readas` can be overloaded to override which type a saved type is read as,
and is used together with custom serialization using [`JLD2.writeas`](@ref).

The typical case is custom serialization of parametric types,
where not all type parameters are available during reading. 
Consider the following example for an anonymous function `fun` inside a `Foo`
```julia
struct Foo{F<:Function}
    fun::F
end
struct FooSerialization
    fun
end
JLD2.writeas(::Type{<:Foo}) = FooSerialization
Base.convert(::Type{<:FooSerialization}, f::Foo) = FooSerialization(f.fun)

JLD2.readas(::Type{<:FooSerialization}) = Foo
struct UndefinedFunction <:Function
    fun
end
(f::UndefinedFunction)(args...; kwargs...) = error("The function \$(f.fun) is not defined")
function Base.convert(::Type{<:Foo}, f::FooSerialization)
    isa(f.fun, Function) && return Foo(f.fun)
    return Foo(UndefinedFunction(f.fun))
end
```
If we include these definitions, call `jldsave("foo.jld2"; foo=Foo(x->x^2))`,
restart julia, include the definitions again, and call
`foo = jldopen("foo.jld2") do io; io["foo"]; end`, we get
`foo::Foo{UndefinedFunction}` and `foo::FooSerialization`
with and without defining the `JLD2.readas` above, respectively.
"""
readas(::Any) = nothing # default to nothing to do nothing if no overload is specified. 

function _readas(T_custom, T_in)
    T_out = readas(T_custom)::Union{Type,Nothing}
    return ifelse(isnothing(T_out), T_in, T_out)
end

# jltype is the inverse of h5type, providing a ReadRepresentation for an
# H5Datatype. We handle committed datatypes here, and other datatypes below.
function jltype(f::JLDFile, sdt::Union{SharedDatatype,CommittedDatatype})
    cdt = get(f.datatype_locations, sdt.header_offset, sdt)
    haskey(f.h5jltype, cdt) && return f.h5jltype[cdt]::ReadRepresentation
    
    dt, attrs = read_shared_datatype(f, cdt)

    julia_type_attr = nothing
    written_type_attr = nothing
    for attr in attrs
        if attr.name == :julia_type || attr.name == Symbol("julia type")
            julia_type_attr = attr
        elseif attr.name == :written_type
            written_type_attr = attr
        end
    end
    isnothing(julia_type_attr) && return f.h5jltype[cdt] = jltype(f, dt)

    # Bootstrap: the datatype of datatype is a datatype
    if julia_type_attr.datatype == SharedDatatype(cdt.header_offset)
        if dt != H5TYPE_DATATYPE
            throw(InternalError("""The HDF5 datatype representing a Julia datatype does not match
                     the expectations of this version of JLD2.
                     You may need to update JLD2 to read this file."""))
        end
        f.jlh5type[DataType] = cdt
        f.datatypes[cdt.index] = dt
        return (f.h5jltype[cdt] = MappedRepr{DataType, DataTypeODR}())
    end

    f.plain && return f.h5jltype[cdt] = jltype(f, dt)

    datatype = with(TYPE_AS_DATA => false) do
        read_attr_data(f, julia_type_attr)
    end

    if !isnothing(written_type_attr)
        # Custom serialization
        custom_datatype = with(TYPE_AS_DATA => false) do
            read_attr_data(f, written_type_attr)
        end
        read_as = _readas(custom_datatype, datatype)
        if read_as <: UnknownType
            @warn("custom serialization of $(typestring(read_as))" *
                  " encountered, but the type does not exist in the workspace; the data will be read unconverted")
            rr, _ = constructrr(f, custom_datatype, dt, attrs)
            canonical = false
        else
            rr, canonical = constructrr(f, custom_datatype, dt, attrs)
            rr = MappedRepr{read_as, CustomSerialization{julia_repr(rr), file_repr(rr)}}()
            canonical &= writeas(read_as) === custom_datatype
        end
    else
        rr, canonical = constructrr(f, datatype, dt, attrs)
    end

    canonical && (f.jlh5type[datatype] = cdt)
    f.datatypes[cdt.index] = dt
    f.h5jltype[cdt] = rr
end



# Constructs a ReadRepresentation for a given opaque (bitstype) type
function constructrr(::JLDFile, T::DataType, dt::BasicDatatype, attrs::Vector{ReadAttribute})
    dt.class == DT_OPAQUE || throw(UnsupportedFeatureException())
    if sizeof(T) == dt.size && isempty(T.types)
        return (SameRepr{T}(), true)
    end
    empty = any(a->a.name==:empty, attrs)
    if empty
        !hasdata(T) && return (MappedRepr{T,nothing}(), true)
        @warn("$T has $(sizeof(T)*8) bytes, but written type was empty; reconstructing")
    elseif isempty(T.types)
        @warn("primitive type $T has $(sizeof(T)*8) bits, but written type has $(dt.size*8) bits; reconstructing")
    else
        @warn("$T is a non-primitive type, but written type is a primitive type with $(dt.size*8) bits; reconstructing")
    end
    reconstruct_bitstype(T.name.name, dt.size, empty)
end

struct TypeMappingException <: Exception end


unpack_odr(::Type{<:OnDiskRepresentation{Offsets,JLTypes,H5Types}}) where {Offsets,JLTypes,H5Types} =
    (Offsets, JLTypes.parameters, H5Types.parameters)



"""
    constructrr(f::JLDFile, T::DataType, dt::CompoundType, attrs::Vector{ReadAttribute},
                hard_failure::Bool=false)

Constructs a [`ReadRepresentation`](@ref) for a given type. This is the generic method for all
types not specially handled below.

If `hard_failure` is true, then throw a `TypeMappingException` instead of attempting
reconstruction. This helps in cases where we can't know if reconstructed parametric types
will have a matching memory layout without first inspecting the memory layout.
"""
@nospecializeinfer function constructrr(f::JLDFile, @nospecialize(T::DataType), dt::CompoundDatatype,
                     attrs::Vector{ReadAttribute},
                     hard_failure::Bool=false)
    field_datatypes = read_field_datatypes(f, dt, attrs)
    # If read type is not a leaf type, reconstruct
    if !isconcretetype(T)
        @warn("read type $T is not a leaf type in workspace; reconstructing")
        return reconstruct_compound(f, string(T), dt, field_datatypes)
    end
    dtnames = Dict{Symbol,Int}(sym => n for (n,sym) in enumerate(dt.names))
    mapped = falses(length(dt.names))

    offsets = Vector{Int}(undef, length(T.types))
    types = Vector{Any}(undef, length(T.types))
    odrs = Vector{Any}(undef, length(T.types))
    fn = fieldnames(T)
    samelayout = isbitstype(T) && sizeof(T) == dt.size
    dtindex = 0
    for i = 1:length(T.types)
        wstype = T.types[i]
        writtenas = writeas(wstype)
        if !hasfielddata(writtenas)
            types[i] = wstype
            odrs[i] = wstype === writtenas ? nothing : CustomSerialization{writtenas,nothing}
            offsets[i] = dtindex == 0 ? 0 : (dt.offsets[dtindex] + dt.members[dtindex].size::UInt32)
        else
            if !haskey(dtnames, fn[i])
                hard_failure && throw(TypeMappingException())
                @warn("saved type $T is missing field $(fn[i]) in workspace type; reconstructing")
                return reconstruct_compound(f, string(T), dt, field_datatypes)
            end

            dtindex = dtnames[fn[i]]
            if (ref = field_datatypes[string(fn[i])]) != NULL_REFERENCE
                dtrr = jltype(f, f.datatype_locations[ref])
            else
                dtrr = jltype(f, dt.members[dtindex])
            end

            readtype = julia_repr(dtrr)
            odrtype = file_repr(dtrr)

            if typeintersect(readtype, wstype) === Union{} &&
               !hasmethod(convert, Tuple{Type{wstype}, readtype})
                # Saved type does not match type in workspace and no
                # convert method exists, so we definitely need to reconstruct.
                hard_failure && throw(TypeMappingException())
                @warn("saved type $T has field $(fn[i])::$(readtype)" *
                      ", but workspace type has field $(fn[i])::$(wstype)" *
                      ", and no applicable convert method exists; reconstructing")
                return reconstruct_compound(f, string(T), dt, field_datatypes)
            end

            types[i] = readtype
            odrs[i] = odrtype
            offsets[i] = dt.offsets[dtindex]

            # The on disk representation of T can only be the same as in memory
            # if the offsets are the same, field type on disk (readtype) and in memory (wstype)
            # are the same and if no CustomSerialization is involved
            samelayout = samelayout && 
                offsets[i] == fieldoffset(T, i) && 
                types[i] === wstype && 
                # An OnDiskRepresentation as odr means that something "fixable" went wrong
                # for this field
                !(odrs[i] <: OnDiskRepresentation) && 
                !(odrs[i] <: CustomSerialization)
            mapped[dtindex] = true
        end
    end

    if !all(mapped)
        @warn("the following fields are present in type $T" *
              " saved in the file but not present in the type in the workspace:\n\n" *
              "$(join(dt.names[.!mapped], "\n"))," *
              "\n\nData in these fields will not be accessible")
    end

    samelayout && return (SameRepr{T}(), true)
    offsets = (offsets...,)
    if (wodr = odr(T)) <: OnDiskRepresentation
        odr_offsets, odr_types, odr_h5types = unpack_odr(wodr)
        tequal = length(odr_types) == length(types)
        for i = 1:length(types)
            tequal || break
            tequal &= odr_types[i] <: types[i]
            tequal &= odr_h5types[i] == odrs[i]
        end
        tequal &= odr_offsets == offsets
        tequal && return (MappedRepr{T,wodr}(), true)
    end
    return (MappedRepr{T,OnDiskRepresentation{offsets, Tuple{types...}, Tuple{odrs...}, Int(offsets[end]+odr_sizeof(odrs[end]))}}(), false)
end

function constructrr(f::JLDFile, u::Upgrade, dt::CompoundDatatype,
                     attrs::Vector{ReadAttribute},
                     hard_failure::Bool=false)
    field_datatypes = read_field_datatypes(f, dt, attrs)
    rodr = reconstruct_odr(f, dt, field_datatypes)
    fnames = tuple((Symbol(k) for k in keys(field_datatypes))...)
    T2 = NamedTuple{fnames, rodr.parameters[2]}
    return (MappedRepr{u.target, CustomSerialization{T2, rodr}}(), false)    
end

function constructrr(f::JLDFile, u::Upgrade, dt::BasicDatatype, 
                     attrs::Vector{ReadAttribute},
                     hard_failure::Bool=false)
    return (MappedRepr{u.target, CustomSerialization{NamedTuple{(), Tuple{}},nothing}}(), false)    
end

function constructrr(f::JLDFile, T::UnionAll, dt::CompoundDatatype,
                     attrs::Vector{ReadAttribute},
                     hard_failure::Bool=false)
    @warn("read type $T is not a leaf type in workspace; reconstructing")
    return reconstruct_compound(f, string(T), dt, read_field_datatypes(f, dt, attrs))
end

# Find types in modules
isunknowntype(x) = false
isunknowntype(::Type{Union{}}) = false
isunknowntype(x::Type) = x <: UnknownType ? true : false

function types_from_refs(f::JLDFile, ptr::Ptr)
    # Test for a potential null pointer indicating an empty array
    isinit = jlunsafe_load(pconvert(Ptr{UInt32}, ptr)) != 0
    with(TYPE_AS_DATA => true) do
        if isinit
            refs = jlconvert(MappedRepr{RelOffset, Vlen{RelOffset}}(), f, ptr, NULL_REFERENCE)
            params =  Any[let
                # If the reference is to a committed datatype, read the datatype
                cdt = get(f.datatype_locations, ref, NULL_COMMITTED_DATATYPE)
                if cdt !== NULL_COMMITTED_DATATYPE
                    julia_repr(jltype(f, cdt))
                else
                    res = load_dataset(f, ref)
                    # For cross-platform compatibility convert
                    # integer type parameters to system precision
                    res isa Union{Int64,Int32} && (res = Int(res))
                    res
                end
            end for ref in refs]
            return params
        end
        return []
    end
end

"""
    find_type(typepath::String)

Finds a type in the loaded modules by its path as a string.
The type path should be a dot-separated string, e.g. `"Main.MyModule.MyType"`.
If the type is found, it returns the corresponding `DataType` or `UnionAll`.
If the type is not found, it returns `nothing`.
"""
function find_type(typepath::String)
    parts = split(typepath, '.')
    # Find a type in the loaded modules by traversing the parts
    for mod in Base.loaded_modules_array()
        for part in parts
            sym = Symbol(part)
            (!isa(mod, Module) || !isdefined(mod, sym)) && break
            mod = getfield(mod, sym)
        end
        if mod isa DataType || mod isa UnionAll
            # We found a type, so we can stop searching
            return mod
        end
    end
    return nothing
end

"""
    default_typemap(f::JLDFile, typepath::String, params)

Default type mapping function used by JLD2 to resolve data types read from files.

Arguments:
- `f::JLDFile`: The JLD file being read.
- `typepath::String`: The path to the type as a string, e.g. `"Main.MyModule.MyType"`.
- `params`: A list of type parameters for the type (may be empty).
"""
function default_typemap(f::JLDFile, typepath::String, params::Vector)
    type = find_type(typepath)
    if isnothing(type)
        return UnknownType{Symbol(typepath), Tuple{params...}}
    elseif any(T -> isunknowntype(T) || isreconstructed(T), params)
        return UnknownType{type, Tuple{params...}}
    elseif !isempty(params)
        if f.plain && !(type === Tuple)
            return Any
        end
        try
            return type{params...}
        catch
            return UnknownType{type, Tuple{params...}}
        end
    elseif type === Tuple
        # Need to instantiate with no parameters, since Tuple is really
        # Tuple{Vararg{Any}}
        return Tuple{}
    end
    return type
end

"""
    TYPE_AS_DATA::ScopedValue{Bool}
Signal to the `jlconvert` function that the type being read will be treated as either data
or a type. This is needed to allow a custom typemap function to return an `Upgrade` object
when the type is going to be used for reconstructing an instance. (as a type)
"""
const TYPE_AS_DATA = ScopedValue(true)

# Read a type. Returns an instance of UnknownType if the type or parameters
# could not be resolved.
function jlconvert(rr::MappedRepr{<:Type,DataTypeODR}, f::JLDFile, ptr::Ptr, ::RelOffset)

    # Read name of type as string e.g. "Main.MyModule.MyType"
    mypath = jlconvert(MappedRepr{String,Vlen{String}}(), f, ptr, NULL_REFERENCE)
    # Read list of type parameters. `[]` if no parameters are present.
    params = types_from_refs(f, ptr+odr_sizeof(Vlen{UInt8}))

    # Legacy support for typemap as a Dict
    type = if f.typemap isa Dict
        if mypath in keys(f.typemap)
            f.typemap[mypath]
        else
            default_typemap(f, mypath, params)
        end
    else
        f.typemap(f, mypath, params)
    end
    return (type isa Upgrade && TYPE_AS_DATA[]) ? type.target : type
end

constructrr(::JLDFile, ::Type{T}, dt::CompoundDatatype, ::Vector{ReadAttribute}) where {T<:DataType} =
    dt == H5TYPE_DATATYPE ? (MappedRepr{DataType,DataTypeODR}(), true) :
                            throw(UnsupportedFeatureException())


## Type reconstruction
abstract type AbstractReconstructedType{N} end

struct ReconstructedPrimitive{N, T} <: AbstractReconstructedType{N}
    val::T
end
function Base.show(io::IO, f::ReconstructedPrimitive{N}) where {N}
    print(io, "Reconstruct@$N($(Int(f.val)))")
end


struct ReconstructedSingleton{N} <: AbstractReconstructedType{N} end

function Base.show(io::IO, ::ReconstructedSingleton{N}) where {N}
    print(io, "Reconstruct@$N()")
end

struct ReconstructedStatic{N, FN, NT} <: AbstractReconstructedType{N}
    fields::NamedTuple{FN, NT}
end

Base.getproperty(rc::ReconstructedStatic, s::Symbol) = getproperty(getfield(rc, 1),s)
Base.propertynames(rc::ReconstructedStatic) = propertynames(getfield(rc, 1))

# simple one-line display (without trailing line break)
function Base.show(io::IO, f::ReconstructedStatic{N, FN, FT}) where {N,FN,FT}
    print(io, "Reconstruct@$N($(values(getfield(f,1))))")
end

struct ReconstructedMutable{N, FN, FT} <: AbstractReconstructedType{N}
    fields::Vector{Any}
end

function Base.getproperty(rc::ReconstructedMutable{N,FN,FT}, s::Symbol) where {N,FN,FT}
    i = findfirst(==(s), FN)
    isnothing(i) && throw(ArgumentError("field $s not found"))
    getfield(rc, 1)[i]::FT.parameters[i]
end
Base.propertynames(::ReconstructedMutable{N,FN}) where {N, FN} = FN


function Base.show(io::IO, f::ReconstructedMutable{N, FN, FT}) where {N,FN,FT}
    print(io, "Reconstruct@$N($(getfield(f,1)))")
end



isreconstructed(x) = isreconstructed(typeof(x))
isreconstructed(x::Type{<:AbstractReconstructedType}) = true
isreconstructed(x::Type) = false
isreconstructed(x::Type{Union{}}) = false

function reconstruct_bitstype(name::Union{Symbol,String}, size::Integer, empty::Bool)
    if empty
        return (MappedRepr{ReconstructedSingleton{Symbol(name)}, nothing}(), false)
    else
        T = ReconstructedPrimitive{Symbol(name), uintofsize(size)}
        return (SameRepr{T}(), false)
    end
end

function constructrr(f::JLDFile, unk::Type{<:UnknownType}, dt::BasicDatatype,
                     attrs::Vector{ReadAttribute})
    @warn("type $(typestring(unk)) does not exist in workspace; reconstructing")
    reconstruct_bitstype(shorttypestring(unk), dt.size, any(a->a.name==:empty, attrs))
end

"""
    typestring(::Type{ <:UnknownType})

Convert an `UnknownType` to a corresponding string. This is
only used for warning during reconstruction errors.

See also [`shorttypestring`](@ref).
"""
function typestring(UT)# ::Type{<:UnknownType}
    if UT isa UnionAll
        UT = behead(UT)
        T = UT.parameters[1]
        params = ()
    else
        T = UT.parameters[1]
        params = UT.parameters[2].parameters
    end
    tn = IOBuffer()
    print(tn, T)
    if !isempty(params)
        write(tn, '{')
        join(tn, (isunknowntype(x) ? typestring(x) : x for x in params), ',')
        write(tn, '}')
    end
    String(take!(tn))
end


"""
    shorttypestring(::Type{ <:UnknownType})

Convert an `UnknownType` to a corresponding string. This is
only used to create names for reconstructed types.

See also [`typestring`](@ref).
"""
function shorttypestring(UT) #::Type{<:UnknownType}
    if UT isa UnionAll
        UT = behead(UT)
        T = UT.parameters[1]
        params = ()
    else
        T = UT.parameters[1]
        params = UT.parameters[2].parameters
    end
    tn = IOBuffer()
    print(tn, T isa Symbol ? split(string(T),'.')[end] : T)
    if !isempty(params)
        write(tn, '{')
        join(tn, (isunknowntype(x) ? shorttypestring(x) : x for x in params), ',')
        write(tn, '}')
    end
    String(take!(tn))
end

"""
    behead(T)

Given a `UnionAll` type, recursively eliminates the `where` clauses
"""
behead(T::UnionAll) = behead(T.body)
behead(@nospecialize T) = T


function constructrr(f::JLDFile, unk::Type{UnknownType{T,P}}, dt::CompoundDatatype,
    attrs::Vector{ReadAttribute}) where {T,P}
    field_datatypes = read_field_datatypes(f, dt, attrs)
    if T isa DataType
        if T === Tuple
            # For a tuple with unknown fields, we should reconstruct the fields
            rodr = reconstruct_odr(f, dt, field_datatypes)
            # This is a "pseudo-RR" since the tuple is not fully parametrized, but
            # the parameters must depend on the types actually encoded in the file
            return (MappedRepr{Tuple,rodr}(), false)
        else
            @warn("read type $(typestring(unk)) was parametrized, but type " *
            "$(T) in workspace is not; reconstructing")
        end
    elseif T isa UnionAll
        body = behead(T)
        if length(body.parameters) != length(P.parameters)
            @warn("read type $(T) has a different number of parameters from type " *
                "$(T) in workspace; reconstructing")
            reconstruct_compound(f, string(T), dt, field_datatypes)
        else
            params = [P.parameters...,]
            for i = 1:length(params)
                if isunknowntype(params[i])
                    param = body.parameters[i]::TypeVar
                    params[i] = param.ub
                end
            end

            # Try to construct the rr for the relaxed type. On failure, fall back to
            # reconstruct_compound.`
            T2 = try
                T{params...}
            catch err
                @warn("type parameters for $(typestring(unk)) do not match type $(T) in workspace; reconstructing")
                return reconstruct_compound(f, shorttypestring(unk), dt, field_datatypes)
            end

            try
                (rr,) = constructrr(f, T2, dt, attrs, true)
                @warn("some parameters could not be resolved for type $(typestring(unk)); reading as $T2")
                return (rr, false)
            catch err
                !isa(err, TypeMappingException) && rethrow(err)
                @warn("some parameters could not be resolved for type $(typestring(unk)); reconstructing")
            end
        end
    elseif T isa Symbol
        @warn("type $(typestring(unk)) does not exist in workspace; reconstructing")
    else
        throw(InternalError("Something went very wrong here."))
    end
    reconstruct_compound(f, shorttypestring(unk), dt, field_datatypes)
end



# Reconstruct the ODR of a type from the CompoundDatatype and field_datatypes
# attribute
function reconstruct_odr(f::JLDFile, dt::CompoundDatatype,
                         field_datatypes::OrderedDict{String,RelOffset})
    # Get the type and ODR information for each field
    types = []
    h5types = []
    offsets = Int[]
    offset = 0
    for (k,typeref) in field_datatypes
        i = findfirst(==(Symbol(k)), dt.names)
        if typeref != NULL_REFERENCE
            dtrr = jltype(f, f.datatype_locations[typeref])
        elseif !isnothing(i)
            offset == dt.offsets[i] || throw(InternalError("Field offsets were incorrectly mapped."))
            dtrr = jltype(f, dt.members[i])
        else
            throw(InternalError("Field $k not found in datatype"))
        end
        push!(types, julia_repr(dtrr))
        push!(h5types, file_repr(dtrr))
        push!(offsets, offset)
        offset += odr_sizeof(dtrr)
    end
    OnDiskRepresentation{(offsets...,), Tuple{types...}, Tuple{h5types...},Int(dt.size)}
end

# Reconstruct type that is a "lost cause": either we were not able to resolve
# the name, or the workspace type has additional fields, or cannot convert
# fields to workspace types
function reconstruct_compound(f::JLDFile, T::String, dt::H5Datatype,
                              field_datatypes::OrderedDict{String,RelOffset})
    rodr = reconstruct_odr(f, dt, field_datatypes)
    _, types, odrs = unpack_odr(rodr)
    fnames = tuple((Symbol(k) for k in keys(field_datatypes))...,)
    if !any(jlconvert_canbeuninitialized(ReadRepresentation(types[i], odrs[i])) for i = 1:length(types))
        rt = ReconstructedStatic{Symbol(T), fnames, Tuple{types...}}
        odr = OnDiskRepresentation{(0,), Tuple{NamedTuple{fnames,Tuple{types...}}}, Tuple{rodr}, Int(dt.size)}
        return (MappedRepr{rt, odr}(), false)
    end
    T = ReconstructedMutable{Symbol(T), fnames, Tuple{types...}}
    return MappedRepr{T, rodr}(), false
end

# At present, we write Union{} as an object of Core.TypeofBottom. The method above
# basically works, but `Expr(:new, Type{Union{}})` is a bit weird and causes problems for
# inference. Better to define a separate method.
jlconvert(::MappedRepr{Core.TypeofBottom,nothing}, f::JLDFile, ptr::Ptr,
          header_offset::RelOffset) = Union{}

function jlconvert(::MappedRepr{T,S}, f::JLDFile, ptr::Ptr, header_offset::RelOffset) where {T<:ReconstructedMutable, S<:OnDiskRepresentation}
    offsets, types, odrs = unpack_odr(S)
    res = Vector{Any}(undef, length(types))
    for i = 1:length(types)
        rr = ReadRepresentation(types[i],odrs[i])
        if !(jlconvert_canbeuninitialized(rr)) || jlconvert_isinitialized(rr, ptr+offsets[i]) 
            res[i] = jlconvert(rr, f, ptr+offsets[i], NULL_REFERENCE)
        end
    end
    return T(res)
end

jlconvert(::ReadRepresentation{T, S}, f::JLDFile, ptr::Ptr, header_offset::RelOffset) where {T,S} =
    rconvert(T, jlunsafe_load(pconvert(Ptr{S}, ptr)))

# This jlconvert method handles compound types with padding or references
@generated function jlconvert(::MappedRepr{T,S}, f::JLDFile, ptr::Ptr,
                              header_offset::RelOffset) where {T,S<:OnDiskRepresentation}
    offsets, types, odrs = unpack_odr(S)
    fn = T === Tuple ? [Symbol(i) for i = 1:length(types)] : fieldnames(T)

    if ismutabletype(T)
        blk = quote
            obj = $(Expr(:new, T))
            track_weakref_if_untracked!(f, header_offset, obj)
        end
        for i = 1:length(types)
            rtype = types[i]
            rr = ReadRepresentation(rtype,odrs[i])
            ttype = T.types[i]
            if isnothing(odrs[i])
                # Type is not stored or single instance
                fieldval = Expr(:new, ttype)               
            else
                fieldval = :(rconvert($ttype, jlconvert($rr, f, ptr+$(offsets[i]), NULL_REFERENCE)::$rtype)::$ttype)
            end
            # use jl_set_nth_field instead of setfield! since the former also works for const fields
            # in mutable structs.
            setfield = :(ccall(:jl_set_nth_field, Nothing, (Any, Csize_t, Any), obj, ($i)-1, $fieldval))
            if jlconvert_canbeuninitialized(rr)
                setfield = :(jlconvert_isinitialized($rr, ptr+$(offsets[i])) && $(setfield))
            end
            push!(blk.args, setfield)
        end
        push!(blk.args, (:obj))    
        return blk
    end
    blk = Expr(:block)
    fsyms = Symbol[]
    for i = 1:length(types)
        ptr = :(ptr + $(offsets[i]))
        rtype = types[i]
        fsym = Symbol("field_", fn[i])
        push!(fsyms, fsym)
        rr = ReadRepresentation(rtype,odrs[i])

        if isnothing(odrs[i])
            push!(blk.args, :($fsym = $(Expr(:new, rtype))))
            continue
        end
        if jlconvert_canbeuninitialized(rr)
            push!(blk.args, quote
                if !jlconvert_isinitialized($rr, $ptr)
                    $(if T <: Tuple || i <= ninitialized(T)
                        # Reference must always be initialized
                        :(throw(UndefinedFieldException(T,$(QuoteNode(fn[i])))))
                    else
                        Expr(:return, Expr(:new, T, fsyms[1:i-1]...))
                    end)
                end
            end)
        end
        fieldval = :(jlconvert($rr, f, $ptr, NULL_REFERENCE)::$rtype)
        if T !== Tuple
            # Special case for reconstructed tuples, where we don't know the
            # field types in advance
            fieldval = :(rconvert($(T.types[i]), $fieldval)::$(T.types[i]))
        end
        push!(blk.args, :($fsym = $fieldval))
    end
    push!(blk.args, T <: Tuple ? Expr(:tuple, fsyms...) : Expr(:new, T, fsyms...))
    blk
end

#
# Superblock
#

const SUPERBLOCK_SIGNATURE = htol(0x0a1a0a0d46444889) # UInt8[0o211, 'H', 'D', 'F', '\r', '\n', 0o032, '\n']

# Data starts after file header and after superblock
const DATA_START = FILE_HEADER_LENGTH +  (12+8*4+4)


function read_superblock(io::IO)
    cio = begin_checksum_read(io)

    # Signature
    signature = jlread(cio, UInt64)
    signature == SUPERBLOCK_SIGNATURE || throw(InvalidDataException())

    # Version
    version = jlread(cio, UInt8)
    if version == 0
        version_free_space_storage = jlread(cio, UInt8) # has to be zero
        version_root_group_symbol_table_entry = jlread(cio, UInt8) # has to be zero
        jlread(cio, UInt8)
        version_share_header_msg_format = jlread(cio, UInt8) # has to be zero
        size_of_offsets = jlread(cio, UInt8)
        size_of_lengths = jlread(cio, UInt8)
        size_of_lengths == 8 && size_of_offsets == 8 || throw(UnsupportedFeatureException("Only files with length and offset size of 8 bytes are supported."))
        jlread(cio, UInt8)
        group_leaf_node_k = jlread(cio, UInt16) # must be greater than zero
        group_internal_node_k = jlread(cio, UInt16) # must be greater than zero
        # Unused File consistency flags
        jlread(cio, UInt32)
        #indexed_storage_internal_node_k = jlread(cio, UInt16) # must be greater than zero
        #jlread(cio, UInt16)
        base_address = jlread(cio, UInt64) # base address for offsets within file (also absolute address of superblock)
        address_free_space_info = jlread(cio, RelOffset)  # Undefined Address
        end_of_file_address = jlread(cio, UInt64) # absolute address of first byte past end of data
        driver_info_block_address = jlread(cio, RelOffset) # undefined of relative address of driver info block
        #root_group_symbol_table_entry = jlread(cio, UInt32) # symbol table entry of root group

        link_name_offset = jlread(cio, RelOffset)
        root_group_object_header_address = jlread(cio, RelOffset)
        cachetype = jlread(cio, UInt32)
        reserved = jlread(cio, UInt32)
        scratchspace = jlread(cio, UInt128)

        # Discard Checksum
        end_checksum(cio)

        (; version, base_address, end_of_file_address, root_group_object_header_address)
    elseif version == 2 || version == 3
        
        # Size of offsets and size of lengths
        size_of_offsets = jlread(cio, UInt8)
        size_of_lengths = jlread(cio, UInt8)
        (size_of_offsets == 8 && size_of_lengths == 8) || throw(UnsupportedFeatureException("Only files with length and offset size of 8 bytes are supported."))

        # File consistency flags
        file_consistency_flags = jlread(cio, UInt8)

        # Addresses
        base_address = jlread(cio, UInt64)
        superblock_extension_address = jlread(cio, RelOffset)
        end_of_file_address = jlread(cio, UInt64)
        root_group_object_header_address = jlread(cio, RelOffset)

        # Checksum
        cs = end_checksum(cio)
        jlread(io, UInt32) == cs || throw(InvalidDataException())

        (; version, base_address, end_of_file_address, root_group_object_header_address)
    else
        throw(UnsupportedVersionException("superblock version $version is not supported."))
    end
end

function write_superblock(io::IO, f)
    cio = begin_checksum_write(io, 8+4+4*jlsizeof(RelOffset))
    jlwrite(cio, SUPERBLOCK_SIGNATURE::UInt64)    # Signature
    jlwrite(cio, UInt8(2))                        # Version
    jlwrite(cio, UInt8(8))                        # Size of offsets
    jlwrite(cio, UInt8(8))                        # Size of lengths
    jlwrite(cio, UInt8(0))                        # file_consistency_flags
    jlwrite(cio, f.base_address::UInt64)
    jlwrite(cio, UNDEFINED_ADDRESS)
    jlwrite(cio, UInt64(f.end_of_data))
    jlwrite(cio, f.root_group_offset::RelOffset)
    jlwrite(io, end_checksum(cio))
end

function find_superblock(f)
    # Search at 0, 512, 1024, 2048 ...
    for offset in (0, 512, 1024, 2048, 4096)
        seek(f.io, offset)
        # Signature
        signature = jlread(f.io, UInt64)
        if signature == SUPERBLOCK_SIGNATURE
            seek(f.io, offset)
            return read_superblock(f.io)
        end
    end
    throw(InvalidDataException("Did not find a Superblock."))
end

const Plain = Union{Int8, Int16,Int32,Int64,Int128,UInt8, UInt16,UInt32,UInt64,UInt128,Float16,Float32,
                    Float64}
const PlainType = Union{Type{Int8}, Type{Int16},Type{Int32}, Type{Int64}, Type{Int128},
                        Type{UInt8}, Type{UInt16}, Type{UInt32}, Type{UInt64}, Type{UInt128}, Type{Float16},
                        Type{Float32}, Type{Float64}}
# JLD2 requires two levels of read / write customization
# These need to use separate function names to avoid ambiguities
# Non-trivial structs get a custom jlread/jlwrite method for generic ::IO
# Different IO types should implement `_read` and `_write` for plain types.
jlwrite(io, x) = Base.write(io, x)
jlwrite(io, x::Plain) = _write(io, x)
_write(io, x) = Base.write(io, x)

jlread(io, T) = Base.read(io, T)
jlread(io, x::PlainType) = _read(io, x)
_read(io, T) = Base.read(io, T)

jlread(io::IO, ::Type{T}, n::Integer) where {T} = T[jlread(io, T) for _=1:n]

Base.read(io::MemoryBackedIO, T::Type{UInt8}) = _read(io, T)

function _read(io::MemoryBackedIO, T::DataType)
    n = jlsizeof(T)
    ensureroom(io, n)
    v = jlunsafe_load(Ptr{T}(io.curptr))
    io.curptr += n
    v
end

function Base.read(io::MemoryBackedIO, ::Type{T}, n::Int) where T
    m = jlsizeof(T) * n
    ensureroom(io, m)
    arr = Vector{T}(undef, n)
    unsafe_copyto!(pointer(arr), Ptr{T}(io.curptr), n)
    io.curptr += m
    arr
end

Base.read(io::MemoryBackedIO, ::Type{T}, n::Integer) where {T} = read(io, T, Int(n))
jlread(io::MemoryBackedIO, ::Type{T}, n::Integer) where {T} = read(io, T, Int(n))


function _write(io::MemoryBackedIO, x)
    n = jlsizeof(x)
    ensureroom(io, n)
    jlunsafe_store!(Ptr{typeof(x)}(io.curptr), x)
    io.curptr += n
    return n
end

function Base.unsafe_write(io::MemoryBackedIO, ptr::Ptr{UInt8}, n::UInt)
    ensureroom(io, n)
    unsafe_copyto!(Ptr{UInt8}(io.curptr), ptr, n)
    io.curptr += n
    n
end

function Base.seek(io::MemoryBackedIO, offset::Integer)
    offset < 0 && throw(ArgumentError("cannot seek before start of file"))
    ensureroom(io, offset-position(io))
    io.curptr = io.startptr + offset
    nothing
end

function Base.skip(io::MemoryBackedIO, offset::Integer)
    ensureroom(io, offset)
    io.curptr += offset
    nothing
end

"""
    read_scalar(f::JLDFile, rr, header_offset::RelOffset)

Read raw data representing a scalar with read representation `rr` from the current position
of JLDFile `f`. `header_offset` is the [`RelOffset`](@ref) of the object header, used to resolve
cycles.
"""
function read_scalar end

"""
    read_array!(v::Array, f::JLDFile, rr)

Fill the array `v` with the contents of JLDFile `f` at the current position, assuming a
[`ReadRepresentation`](@ref) `rr`.
"""
function read_array! end


"""
    read_compressed_array!(v::Array, f::JLDFile, rr, data_length::Int, Val(filter_id))

Fill the array `v` with the compressed contents of JLDFile `f` at the current position,
assuming a [`ReadRepresentation`](@ref) `rr` and that the compressed data has length `data_length`.
"""
function read_compressed_array! end

#
# MmapIO
#

# Cutoff for using ordinary IO instead of copying into mmapped region
const MMAP_CUTOFF = 1048576

@nospecializeinfer function read_scalar(f::JLDFile{<:MemoryBackedIO}, @nospecialize(rr), header_offset::RelOffset)
    io = f.io
    inptr = io.curptr
    obj = jlconvert(rr, f, inptr, header_offset)
    io.curptr = inptr + odr_sizeof(rr)::Int
    obj
end

function read_array!(v::ArrayMemory{T}, f::JLDFile{<:MemoryBackedIO}, ::SameRepr{T}) where T
    inptr = f.io.curptr
    n = length(v)
    unsafe_copyto!(pointer(v), pconvert(Ptr{T}, inptr), n)
    f.io.curptr = inptr + odr_sizeof(T) * n
    v
end

function read_array!(v::ArrayMemory{T}, f::JLDFile{<:MemoryBackedIO}, rr::ReadRepresentation{T}) where T
    cp0 = f.io.curptr
    @simd for i in eachindex(v)
        cp = cp0 + (i-1)*odr_sizeof(rr)
        if !jlconvert_canbeuninitialized(rr) || jlconvert_isinitialized(rr, cp)
            v[i] = jlconvert(rr, f, cp, NULL_REFERENCE)
        end
    end
    f.io.curptr = cp0 + odr_sizeof(rr) * length(v)
    v
end

function write_data(io::MemoryBackedIO, f::JLDFile, data, odr, ::ReferenceFree, wsession::JLDWriteSession)
    ensureroom(io, odr_sizeof(odr))
    cp = io.curptr
    h5convert!(cp, odr, f, data, wsession)
    io.curptr == cp || throw(InternalError())
    io.curptr = cp + odr_sizeof(odr)
    nothing
end

function write_data(io::MemoryBackedIO, f::JLDFile, data, odr, ::HasReferences, wsession::JLDWriteSession)
    ensureroom(io, odr_sizeof(odr))
    cp = IndirectPointer(io)
    h5convert!(cp, odr, f, data, wsession)
    io.curptr = pconvert(Ptr{Nothing}, cp) + odr_sizeof(odr)
    nothing
end

function write_data(io::MemoryBackedIO, f::JLDFile, data::ArrayMemory{T}, odr::Type, ::ReferenceFree, wsession::JLDWriteSession) where T
    ensureroom(io, odr_sizeof(odr) * length(data))
    cp0 = io.curptr
    @simd for i = 1:length(data)
        cp = cp0 + (i-1)*odr_sizeof(odr)
        @inbounds h5convert!(cp, odr, f, data[i], wsession)
    end
    io.curptr == cp0 || throw(InternalError())
    io.curptr = cp0 + length(data)*odr_sizeof(odr)
    nothing
end

function write_data(io::MemoryBackedIO, f::JLDFile, data::ArrayMemory, odr::ODR, ::HasReferences, wsession::JLDWriteSession) where ODR
    ensureroom(io, odr_sizeof(odr) * length(data))
    cp = IndirectPointer(io)

    for i = eachindex(data)
        if isassigned(data, i)
            h5convert!(cp, odr, f, data[i], wsession)
        else
            h5convert_uninitialized!(cp, odr)
        end
        cp += odr_sizeof(odr)
    end
    io.curptr = pconvert(Ptr{Nothing}, cp)
    nothing
end

write_data(io::MemoryBackedIO, ::JLDFile, data::ArrayMemory{T}, odr::Type{T}, ::ReferenceFree, ::JLDWriteSession) where {T} =
    unsafe_write(io, Ptr{UInt8}(pointer(data)), odr_sizeof(odr) * length(data))


#
# Fallback for non-memory-backed IO
#

function read_scalar(f::JLDFile, rr, header_offset::RelOffset)
    r = Vector{UInt8}(undef, odr_sizeof(rr))
    @GC.preserve r begin
        unsafe_read(f.io, pointer(r), odr_sizeof(rr))
        jlconvert(rr, f, pointer(r), header_offset)
    end
end


function read_array!(v::ArrayMemory{T}, f::JLDFile, ::SameRepr{T}) where {T}
    unsafe_read(f.io, pointer(v), odr_sizeof(T)*length(v))
    v
end

function read_array!(v::ArrayMemory{T}, f::JLDFile, rr::ReadRepresentation{T}) where {T}
    n = length(v)
    nb = odr_sizeof(rr)*n
    data = read!(f.io, Vector{UInt8}(undef, nb))
    @GC.preserve data begin
        p0 = Ptr{Cvoid}(pointer(data))
        @simd for i = eachindex(v)
            dataptr = p0 + odr_sizeof(rr)*(i-1)
            if !jlconvert_canbeuninitialized(rr) || jlconvert_isinitialized(rr, dataptr)
                v[i] = jlconvert(rr, f, dataptr, NULL_REFERENCE)
            end
        end
    end
    v
end


function write_data(io::IO, f::JLDFile, data::ArrayMemory{T}, odr::Type{T}, ::ReferenceFree,
                    wsession::JLDWriteSession) where T
    unsafe_write(io, Ptr{UInt8}(pointer(data)), odr_sizeof(odr) * length(data))
    nothing
end

function write_data(io::IO, f::JLDFile, data, odr, _, wsession::JLDWriteSession)
    buf = Vector{UInt8}(undef, odr_sizeof(odr))
    GC.@preserve buf begin
        cp = Ptr{Cvoid}(pointer(buf))
        h5convert!(cp, odr, f, data, wsession)
        unsafe_write(io, Ptr{UInt8}(pointer(buf)), odr_sizeof(odr))
    end
    nothing
end

function write_data(io::IO, f::JLDFile, data::ArrayMemory, odr, wm::DataMode, wsession::JLDWriteSession)
    nb = odr_sizeof(odr) * length(data)
    buf = Vector{UInt8}(undef, nb)
    pos = position(io)
    cp0 = Ptr{Cvoid}(pointer(buf))
    for i = eachindex(data)
        cp = cp0 + (i-1)*odr_sizeof(odr)
        if isassigned(data, i)
            h5convert!(cp, odr, f, data[i], wsession)
        else
            h5convert_uninitialized!(cp, odr)
        end
    end
    # We might seek around in the file as a consequence of writing stuff, so seek back. We
    # don't need to worry about this for a BufferedWriter, since it will seek back before
    # writing.
    !isa(wm, ReferenceFree) && seek(io, pos)
    jlwrite(io, buf)
    nothing
end


# The delimiter is excluded by default
# readuntil returns Vector{UInt8}, String() conversion is efficient
read_bytestring(io::Union{IOStream, IOBuffer}) = String(readuntil(io, 0x00))

# Late addition for MmapIO that can't be defined in mmapio.jl due to include ordering
function read_array!(v::ArrayMemory{T}, f::JLDFile{MmapIO}, ::SameRepr{T}) where T
    io = f.io
    inptr = io.curptr
    n = length(v)
    nb = odr_sizeof(T)*n
    if nb > MMAP_CUTOFF && (!Sys.iswindows() || !f.written)
        # It turns out that regular IO is faster here (at least on OS X), but on Windows,
        # we shouldn't use ordinary IO to read, since coherency with the memory map is not
        # guaranteed
        mmapio = f.io
        regulario = mmapio.f
        seek(regulario, inptr - io.startptr)
        unsafe_read(regulario, pointer(v), nb)
    else
        unsafe_copyto!(pointer(v), pconvert(Ptr{T}, inptr), n)
    end
    io.curptr = inptr + nb
    v
end


function read_compressed_array!(
    v::Array{T},
    f::JLDFile,
    rr::ReadRepresentation{T,RR},
    data_length::Integer,
    filter,
) where {T,RR}
    io = f.io
    data_offset = position(io)
    element_size = odr_sizeof(RR)
    uncompressed_size = length(v) * element_size
    data = Filters.decompress(filter, io, data_length, uncompressed_size)
    GC.@preserve data begin
        cp0 = Ptr{Cvoid}(pointer(data))
        @simd for i = eachindex(v)
            dataptr = cp0 + element_size * (i - 1)
            if !jlconvert_canbeuninitialized(rr) || jlconvert_isinitialized(rr, dataptr)
                v[i] = jlconvert(rr, f, dataptr, NULL_REFERENCE)
            end
        end
    end
    seek(io, data_offset + data_length)
    v
end

#
# Datasets
#
function load_dataset(f::JLDFile{IO}, offset::RelOffset) where IO
    if haskey(f.jloffset, offset)
        # There is a known (loaded) dataset at offset
        # Stored as WeakRefs and may no longer exist
        val = f.jloffset[offset].value
        val !== nothing && return val
    elseif haskey(f.loaded_groups, offset)
        # There is a known (loaded) group at offset
        return f.loaded_groups[offset]
    end

    dataspace = ReadDataspace()
    attrs = EMPTY_READ_ATTRIBUTES
    dt::H5Datatype = PlaceholderH5Datatype()
    layout::DataLayout = DataLayout(0,LcCompact,0,-1)
    filter_pipeline::FilterPipeline = FilterPipeline()

    for msg in HeaderMessageIterator(f, offset)
        if msg.type == HmDataspace
            dataspace = ReadDataspace(f, msg)
        elseif msg.type == HmDatatype
            dt = HmWrap(HmDatatype, msg).dt::H5Datatype
        elseif msg.type == HmDataLayout
            layout = DataLayout(f, msg)
        elseif msg.type == HmFilterPipeline
            filter_pipeline = FilterPipeline(msg)
        elseif msg.type == HmAttribute
            isempty(attrs) && (attrs = ReadAttribute[])
            push!(attrs, read_attribute(f, msg))
        elseif (msg.hflags & 2^3) != 0
            throw(UnsupportedFeatureException())
        end
    end
    if dt isa PlaceholderH5Datatype
        # checking whether something is a group is not cheap.
        # Do it only when it is not a dataset
        if isgroup(f, offset)
            # There is a not-yet loaded group at offset
            return get!(()->load_group(f, offset), f.loaded_groups, offset)
        end

        throw(InvalidDataException("No datatype message found"))
    end
    iscompressed(filter_pipeline) && !ischunked(layout) && throw(InvalidDataException("Compressed data must be chunked"))
    Base.inferencebarrier(read_data(f, dataspace, dt, layout, filter_pipeline, offset, attrs))
end


"""
    read_data(f::JLDFile, dataspace::ReadDataspace, datatype_class::UInt8,
              datatype_offset::Int64, data_offset::Int64[, filters::FilterPipeline,
              header_offset::RelOffset, attributes::Vector{ReadAttribute}])

Read data from a file. If `datatype_class` is `typemax(UInt8)`, the datatype is assumed to be
committed, and `datatype_offset` points to the offset of the committed datatype's header.
Otherwise, `datatype_offset` points to the offset of the datatype attribute.
"""
@nospecializeinfer function read_data(f::JLDFile, dataspace::ReadDataspace,
                   @nospecialize(dt::H5Datatype),
                   layout::DataLayout,
                   filters::FilterPipeline=FilterPipeline(),
                   header_offset::RelOffset=NULL_REFERENCE,
                   attributes::Union{Vector{ReadAttribute},Nothing}=nothing)
    rr = jltype(f, dt)
    if layout.data_offset == -1
        # There was no layout message.
        # That means, this dataset is just a datatype
        return julia_repr(rr)
    elseif layout.data_offset == typemax(Int64)
        T = julia_repr(rr)
        if layout.data_length > -1
            # TODO: this could use the fill value message to populate the array
            @warn "This array should be populated by a fill value. This is not (yet) implemented."
        end
        v = Array{T, 1}()
        track_weakref!(f, header_offset, v)
        return v
    end
    seek(f.io, layout.data_offset)
    read_dataspace = (dataspace, header_offset, layout, filters)
    read_data(f, rr, read_dataspace, attributes)
end

# Most types can only be scalars or arrays
@nospecializeinfer function read_data(f::JLDFile,
     @nospecialize(rr),
     read_dataspace::Tuple{ReadDataspace,RelOffset,DataLayout,FilterPipeline},
     attributes::Union{Vector{ReadAttribute},Nothing}=nothing)

    dataspace, header_offset, layout, filters = read_dataspace
    if dataspace.dataspace_type == DS_SCALAR
        iscompressed(filters) && throw(UnsupportedFeatureException())
        read_scalar(f, rr, header_offset)
    elseif dataspace.dataspace_type == DS_SIMPLE
        read_array(f, dataspace, rr, layout, filters, header_offset, attributes)
    elseif dataspace.dataspace_type == DS_V1 && dataspace.dimensionality == 0
        read_scalar(f, rr, header_offset)
    elseif dataspace.dataspace_type == DS_V1
        read_array(f, dataspace, rr, layout, filters, header_offset, attributes)
    elseif dataspace.dataspace_type == DS_NULL
        read_empty(f, rr, dataspace, attributes, header_offset)
    else
        throw(UnsupportedFeatureException())
    end
end

# Reference arrays can only be arrays or null dataspace (for Union{} case)
function read_data(f::JLDFile,
    ::MappedRepr{Any,RelOffset},
    read_dataspace::Tuple{ReadDataspace,RelOffset,DataLayout,FilterPipeline},
    attributes::Vector{ReadAttribute})

    dataspace, header_offset, layout, filters = read_dataspace
    iscompressed(filters) && throw(UnsupportedFeatureException())
    if dataspace.dataspace_type == DS_SIMPLE
        # Since this is an array of references, there should be an attribute
        # informing us of the type
        io = f.io
        startpos = position(io)
        for x in attributes
            if x.name == :julia_type
                T = read_attr_data(f, x)
                if isunknowntype(T)
                    str = typestring(T)
                    @warn "type $(str) does not exist in workspace; interpreting Array{$str} as Array{Any}" maxlog=1
                    rr = MappedRepr{Any,RelOffset}()
                elseif T isa Upgrade
                    rr = MappedRepr{T.target, RelOffset}()
                else
                    rr = ReadRepresentation(T, RelOffset)
                end
                seek(io, startpos)
                return read_array(f, dataspace, rr,
                                  layout, filters, header_offset, attributes)
            end
        end
    elseif dataspace.dataspace_type == DS_NULL
        return read_empty(f, MappedRepr{Union{},nothing}(), dataspace, attributes, header_offset)
    elseif dataspace.dataspace_type == DS_V1
        return read_array(f, dataspace, MappedRepr{Any,RelOffset}(),
                                  layout, filters, header_offset, attributes)
    end
    throw(UnsupportedFeatureException("Dataspace type $(dataspace.dataspace_type) not implemented"))
end

# Types with no payload can only be null dataspace
function read_data(f::JLDFile,
                   @nospecialize(rr::Union{ReadRepresentation{T,nothing} where T,
                             ReadRepresentation{T,CustomSerialization{S,nothing}} where {S,T}}),
                   read_dataspace::Tuple{ReadDataspace,RelOffset,DataLayout,FilterPipeline},
                   attributes::Vector{ReadAttribute})
    dataspace, header_offset, layout, filters = read_dataspace
    iscompressed(filters) && throw(UnsupportedFeatureException())
    dataspace.dataspace_type == DS_NULL || throw(UnsupportedFeatureException())
    if !any(a->a.name==:dimensions, attributes)
        jlconvert(rr, f, Ptr{Cvoid}(0), header_offset)
    else
        # dimensions attribute => array of empty type
        read_empty(f, rr, dataspace, attributes, header_offset)
    end
end

function find_dimensions_attr(attributes::Vector{ReadAttribute})
    dimensions_attr_index = 0
    for i = 1:length(attributes)
        x = attributes[i]
        if x.name == :dimensions
            dimensions_attr_index = i
        end
    end
    dimensions_attr_index
end

function read_empty(f::JLDFile, rr::ReadRepresentation{T}, dataspace, attributes, header_offset::RelOffset) where T
    ndims, offset = get_ndims_offset(f, dataspace, attributes)
    seek(f.io, offset)
    v = construct_array(f.io, T, Int(ndims))
    if isconcretetype(T)
        for i = 1:length(v)
            @inbounds v[i] = jlconvert(rr, f, Ptr{Cvoid}(0), header_offset)
        end
    end
    track_weakref!(f, header_offset, v)
    v
end

get_ndims_offset(f::JLDFile, dataspace::ReadDataspace, attributes::Nothing) =
    (dataspace.dimensionality, dataspace.dimensions_offset)

function get_ndims_offset(f::JLDFile, dataspace::ReadDataspace, attributes::AbstractVector)
    ndims = dataspace.dimensionality
    offset = dataspace.dimensions_offset
    if !isempty(attributes)
        for x in attributes
            if x.name == :dimensions
                (x.dataspace.dataspace_type == DS_SIMPLE &&
                 x.dataspace.dimensionality == 1) || throw(InvalidDataException())
                x.datatype == h5fieldtype(f, Int64, Int64, Val{true}) || throw(UnsupportedFeatureException())
                seek(f.io, x.dataspace.dimensions_offset)
                ndims = UInt8(jlread(f.io, Length))
                offset = x.data_offset
            end
        end
    end
    (ndims, offset)
end

"""
    construct_array(io::IO, eltype, ndims::Int)

Construct array by reading `ndims` dimensions from `io`. Assumes `io` has already been
seeked to the correct position.
"""
function construct_array(io::IO, ::Type{T}, N::Int) where {T}
    ds = reverse(ntuple(i->jlread(io, Int64), Val(N)))
    Array{T,N}(undef, ds...)
end

@nospecializeinfer function read_array(f::JLDFile, dataspace::ReadDataspace,
                    @nospecialize(rr::ReadRepresentation), layout::DataLayout,
                    filters::FilterPipeline, header_offset::RelOffset,
                    attributes::Union{Vector{ReadAttribute},Nothing})
    T = julia_repr(rr)
    io = f.io
    ndims, offset = get_ndims_offset(f, dataspace, attributes)
    seek(io, offset)
    # figure out whether to construct an Array or a Memory
    ismem = !isnothing(attributes) && any(attr->attr.name==:Memory, attributes)
    v = @static if VERSION >= v"1.11"
        if ismem
            Memory{T}(undef, Int(jlread(io, Int64)))
        else
            construct_array(io, T, Int(ndims))
        end
    else
        construct_array(io, T, Int(ndims))
    end

    if !ischunked(layout) || (layout.chunk_indexing_type == 1)
        n = length(v)
        seek(io, layout.data_offset)
        if iscompressed(filters)
            read_compressed_array!(v, f, rr, layout.data_length, filters)
        else
            read_array!(v, f, rr)
        end
        track_weakref!(f, header_offset, v)
        v
    else
        if layout.version == 3
            # version 1 B-tree
            # This version appears to be padding incomplete chunks
            chunks = read_v1btree_dataset_chunks(f, h5offset(f, layout.data_offset), layout.dimensionality)
            vchunk = Array{T, Int(ndims)}(undef, reverse(layout.chunk_dimensions)...)
            for chunk in chunks
                cidx = chunk.idx::NTuple{Int(ndims+1), Int}
                idx = reverse(cidx[1:end-1])
                seek(io, fileoffset(f, chunk.offset))
                indexview =  (:).(idx .+1, min.(idx .+ reverse(layout.chunk_dimensions), size(v)))
                indexview2 = (:).(1, length.(indexview))

                if iscompressed(filters)
                    if chunk.filter_mask == 0
                        read_compressed_array!(vchunk, f, rr, chunk.chunk_size, filters)
                        v[indexview...] = @view vchunk[indexview2...]
                    else
                        if length(filters.filters) == 1
                            read_array!(vchunk, f, rr)
                            v[indexview...] = @view vchunk[indexview2...]
                        else
                            mask = Bool[chunk.filter_mask & 2^(n-1) == 0 for n=eachindex(filters.filters)]
                            if any(mask)
                                rf = FilterPipeline(filters.filters[mask])
                                read_compressed_array!(vchunk, f, rr, chunk.chunk_size, rf)
                                v[indexview...] = @view vchunk[indexview2...]
                            else
                                read_array!(vchunk, f, rr)
                                v[indexview...] = @view vchunk[indexview2...]
                            end

                        end
                    end
                else
                    read_array!(vchunk, f, rr)
                    v[indexview...] = @view vchunk[indexview2...]
                end
            end
            return v
        end
        throw(UnsupportedVersionException("Encountered a chunked array ($layout) that is not implemented."))
    end
end


function payload_size_without_storage_message(dataspace::WriteDataspace, datatype::H5Datatype)
    sz = 6 + 4 + jlsizeof(dataspace)::Int + 4 + jlsizeof(datatype) + length(dataspace.attributes)*jlsizeof(HeaderMessage)
    for attr in dataspace.attributes
        sz += jlsizeof(attr)::Int
    end
    sz
end

@nospecializeinfer function write_dataset(f::JLDFile,
        dataspace::WriteDataspace,
        datatype::H5Datatype,
        @nospecialize(odr),
        @nospecialize(data),
        wsession::JLDWriteSession,
        @nospecialize(filters = f.compress),)
    io = f.io
    datasz = (odr_sizeof(odr)::Int * numel(dataspace))::Int
    psz = payload_size_without_storage_message(dataspace, datatype)
    psz += CONTINUATION_MSG_SIZE

    local_filters = FilterPipeline(map(filters) do filter
        Filters.set_local(filter, odr, dataspace, ())
    end)

    # Figure out the layout
    if datasz == 0 || (!(data isa ArrayMemory) && datasz < 8192)
        layout_class = LcCompact
        psz += jlsizeof(Val(HmDataLayout); layout_class, data_size=datasz)
    elseif data isa ArrayMemory && iscompressed(local_filters) && isconcretetype(eltype(data)) && isbitstype(eltype(data))
        layout_class = LcChunked
        psz += jlsizeof(Val(HmDataLayout);
            layout_class,
            dimensions = UInt64.((reverse(size(data))..., odr_sizeof(odr))),
            # Dummy values for message size computation
            data_size = 0, data_address = 0,
        )
        psz += Filters.pipeline_message_size(local_filters)
    else
        layout_class = LcContiguous
        psz += jlsizeof(Val(HmDataLayout); layout_class)
    end

    fullsz = jlsizeof(ObjectStart) + size_size(psz) + psz + 4

    header_offset = f.end_of_data
    seek(io, header_offset)
    f.end_of_data = header_offset + fullsz

    track!(wsession, data, h5offset(f, header_offset))
    cio = begin_checksum_write(io, fullsz - 4)
    jlwrite(cio, ObjectStart(size_flag(psz)))
    write_size(cio, psz)
    write_header_message(cio, Val(HmFillValue); flags=0x09)
    write_header_message(cio, Val(HmDataspace); dataspace.dataspace_type, dimensions=dataspace.size)
    for attr in dataspace.attributes
        write_header_message(cio, f, attr)
    end
    write_header_message(cio, Val(HmDatatype), 1 | (2*isa(datatype, CommittedDatatype)); dt=datatype)

    # Data storage layout
    if layout_class == LcCompact
        write_header_message(cio, Val(HmDataLayout); layout_class, data_size=datasz)
        if datasz != 0
            write_data(cio, f, data, odr, datamode(odr), wsession)
        end
        write_continuation_placeholder(cio)
        jlwrite(io, end_checksum(cio))
    elseif layout_class == LcChunked
        compressed, retcodes = Filters.compress(local_filters, data, odr, f, wsession)
        Filters.write_filter_pipeline_message(cio, local_filters)

        write_header_message(cio, Val(HmDataLayout);
            layout_class,
            # Reversed dimensions with element size as last dim
            dimensions=UInt64.((reverse(size(data))..., odr_sizeof(odr))),
            data_size=length(compressed),
            data_address=h5offset(f, f.end_of_data)
        )

        write_continuation_placeholder(cio)
        jlwrite(f.io, end_checksum(cio))

        seek(f.io, f.end_of_data)
        f.end_of_data += length(compressed)
        jlwrite(f.io, compressed)
    else
        data_address = f.end_of_data + 8 - mod1(f.end_of_data, 8)
        write_header_message(cio, Val(HmDataLayout);
            layout_class, data_address=h5offset(f, data_address), data_size=datasz)
        write_continuation_placeholder(cio)
        jlwrite(io, end_checksum(cio))

        f.end_of_data = data_address + datasz
        seek(io, data_address)
        write_data(io, f, data, odr, datamode(odr), wsession)
    end

    h5offset(f, header_offset)
end


@nospecializeinfer function write_dataset(f::JLDFile, @nospecialize(x), wsession::JLDWriteSession)::RelOffset
    offset = get_tracked(wsession, x)
    offset != UNDEFINED_ADDRESS && return offset
    odr = objodr(x)
    write_dataset(f, WriteDataspace(f, x, odr), h5type(f, x), odr, x, wsession)::RelOffset
end

write_ref(f::JLDFile, @nospecialize(x), wsession::JLDWriteSession) = write_dataset(f, x, wsession)::RelOffset
write_ref(f::JLDFile, x::RelOffset, wsession::JLDWriteSession) = x

Base.delete!(f::JLDFile, x::AbstractString) = delete!(f.root_group, x)

function Base.delete!(g::Group, name::AbstractString)
    g.f.writable || throw(ArgumentError("Cannot delete in read-only mode"))
    if !haskey(g, name)
        @warn "No entry named $name was found"
        return
    end
    (g, name) = pathize(g, name, false)

    # Simple case first. If it hasn't been written yet,
    # the file doesn't need to be altered.
    if haskey(g.unwritten_links, name)
        delete!(g.unwritten_links, name)
        return
    elseif haskey(g.unwritten_child_groups, name)
        delete!(g.unwritten_child_groups, name)
        return
    end

    # Dataset must already exist in the file
    # Retrieve offset of group in file
    offset = group_offset(g)
    offset == NULL_REFERENCE && throw(InternalError("Group could not be found."))
    delete_written_link!(g.f, offset, name)
    delete!(g.written_links, name)
    return
end


function group_offset(g::Group)
    # Given a group, retrieve its offset inside the parent file
    # Return a null reference when it can't be found. However, that
    # should never be the case as the calling functions checks for this
    if g === g.f.root_group
        return g.f.root_group_offset
    end
    for (offset, lg) in pairs(g.f.loaded_groups)
        if lg === g
            return offset
        end
    end
    return NULL_REFERENCE
end

function delete_written_link!(f::JLDFile, roffset::RelOffset, name::AbstractString)
    # Location of written link in group structure is not known a priory
    # The deletion is done by replacing that message by a placeholder nill message
    iter = HeaderMessageIterator(f, roffset)
    for msg in iter
        if msg.type == HmLinkMessage && HmWrap(HmLinkMessage, msg).link_name == name
            # delete link
            seek(f.io, fileoffset(f, msg.offset))
            write_header_message(f.io, Val(HmNil), 0, msg.size)
            update_checksum(f.io, iter.chunk.chunk_start, iter.chunk.chunk_end)
        end
    end
    return
end

using BenchmarkTools, JLD2, Serialization

const BACKEND = JLD2.MmapIO
# const BACKEND = IOStream
const TEMPFILE = begin
    tmp, io = mktemp()
    close(io)
    tmp
end

function jld_benchmark_write(x)
    f = jldopen(TEMPFILE, true, true, true, BACKEND)
    write(f, "x", x)
    close(f)
end

function jld_benchmark_read()
    f = jldopen(TEMPFILE, false, false, false, BACKEND)
    read(f, "x")
    close(f)
end

function serialize_benchmark_write(x)
    f = open(TEMPFILE, "w")
    serialize(f, x)
    close(f)
end

function serialize_benchmark_read()
    f = open(TEMPFILE)
    deserialize(f)
    close(f)
end

function bench(title, data)
    GC.gc()
    println(title, " JLD2 write")
    show(stdout, MIME("text/plain"), @benchmark jld_benchmark_write($data))
    println("\n")
    GC.gc()
    println(title, " JLD2 read")
    show(stdout, MIME("text/plain"), @benchmark jld_benchmark_read())
    println("\n")
    GC.gc()
    println(title, " Serialization.serialize")
    show(stdout, MIME("text/plain"), @benchmark serialize_benchmark_write($data))
    println("\n")
    GC.gc()
    println(title, " Serialization.deserialize")
    show(stdout, MIME("text/plain"), @benchmark serialize_benchmark_read())
    println("\n\n")
    isa(data, Array) && empty!(data)
end

# Vector{Int}
bench("int_vector", rand(typemin(Int):typemax(Int), 100000000))

# Vector{Any} of Ints
bench("any_int_vector", convert(Vector{Any}, rand(typemin(Int):typemax(Int), 1000000)))

# Vector{Integer} of Ints
bench("integer_int_vector", convert(Vector{Integer}, rand(typemin(Int):typemax(Int), 1000000)))

# Vector of non-builtin immutable
bench("complex128_vector", [complex(rand(), rand()) for i = 1:10000000])

# Vector{Any} of non-builtin immutable
struct IntWrapper
    x::Int
end
bench("any_complex128_vector", Any[complex(rand(), rand()) for i = 1:1000000])

# Many empty arrays
bench("empty_arrays", Any[Int[] for i = 1:1000000])

# Many one-element arrays
bench("one_element_arrays", [[rand(typemin(Int):typemax(Int))] for i = 1:1000000])

# Equivalent benchmark from https://github.com/timholy/HDF5.jl/issues/170
# This is 1/10 of the amount of data, but we don't have a problem with
# scaling, so this should be fine
mutable struct Cell
    a::Array{Float64,1}
    b::Array{Float64,1}
    c::Array{Float64,2}
    d::Float64
    e::Array{Float64,1}
end
bench("cell", [Cell(rand(3), rand(3), rand(8, 3), rand(), rand(3)) for i = 1:118138])

using JLD2, Test

struct Foo2 end

@testset "isreconstructed" begin
    @test !JLD2.isreconstructed(Foo2)
    a = Foo2()
    @test !JLD2.isreconstructed(a)
    @test JLD2.isreconstructed(JLD2.ReconstructedPrimitive{:Test, UInt8}(1))
    @test JLD2.isreconstructed(JLD2.ReconstructedStatic{:Test, (:a, :b), Tuple{Int, Float64}}((; a=1, b=2.0)))
    @test JLD2.isreconstructed(JLD2.ReconstructedMutable{:Test, (:a, :b), Tuple{Int, Float64}}(Any[1, 2.0]))
end

push!(LOAD_PATH, joinpath(@__DIR__,"testmodules/"))
module TestModule

using A
using B
using Test
using JLD2

x =  AType(1)

S = BType(x)

@testset "save and load" begin
	T = deepcopy(S)
	@test T == S
	fn = joinpath(mktempdir(), "test_out.jld")
	@save fn T
	T = nothing
	@load fn T
	@test T == S
end

@testset "name collisions" begin
    mods = Base.loaded_modules_array()
    # use whichever module would not be found first in a linear search
    M = findfirst(==(A), mods) < findfirst(==(B), mods) ? B : A
    x = M.SameNameType(42)
    file = joinpath(mktempdir(), "collision.jld")
    @save file x
    x = nothing
    @load file x
    @test x isa M.SameNameType
end

end

## Opaque Data
struct OpaqueData{N}
    data::Vector{UInt8}
    OpaqueData(data) = new{length(data)}(data)
end

function jlconvert(::MappedRepr{OpaqueData{N}, NTuple{N,UInt8}}, ::JLDFile, ptr::Ptr, ::RelOffset) where N
    data = Vector{UInt8}(undef, N)
    unsafe_copyto!(pointer(data), pconvert(Ptr{UInt8}, ptr), N)
    OpaqueData(data)
end


## Strings

const H5TYPE_VLEN_UTF8 = VariableLengthDatatype(DT_VARIABLE_LENGTH, 0x11, 0x01, 0x00,
                                                odr_sizeof(Vlen{UInt8}),
                                                FixedPointDatatype(1, false))

h5fieldtype(::JLDFile, ::Type{String}, ::Type{String}, ::Initialized) =
    H5TYPE_VLEN_UTF8
function h5fieldtype(f::JLDFile, writeas::Type{String},
                     readas::Type, init::Initialized)
    @lookup_committed f readas
    commit(f, h5fieldtype(f, writeas, writeas, init), writeas, readas)
end

fieldodr(::Type{String}, ::Bool) = Vlen{String}

# Stored as variable-length strings
odr_sizeof(x::FixedLengthString{String}) = x.length

h5type(f::JLDFile, writeas::Type{String}, x::String) =
    StringDatatype(typeof(x), jlsizeof(x))
h5type(f::JLDFile, writeas::Type{String}, x) =
    h5fieldtype(f, writeas, typeof(x), Val{true})
odr(::Type{String}) = fieldodr(String, true)
objodr(x::String) = FixedLengthString{String}(jlsizeof(x))

struct NullTerminated end
struct SpacePadded end
struct AsciiString{TERM}
    length::Int
end


struct FixedLengthAsciiString{TERM, N} end

function jltype(f::JLDFile, dt::BasicDatatype)
    class = dt.class
    if class >> 4 == 1
        if class%16 == DT_REFERENCE
            return MappedRepr{Any,RelOffset}()
        elseif class%16 == DT_STRING
            if dt.bitfield1 == 0x00 && dt.bitfield2 == 0x00 && dt.bitfield3 == 0x00
                #return AsciiString{NullTerminated}(dt.size)
                return MappedRepr{String, FixedLengthAsciiString{NullTerminated, dt.size}}()
            elseif dt.bitfield1 == 0x10 && dt.bitfield2 == 0x00 && dt.bitfield3 == 0x00
                return FixedLengthString{String}(dt.size)
            elseif dt.bitfield1 == 0x02 && dt.bitfield2 == 0x00 && dt.bitfield3 == 0x00
                return MappedRepr{String, FixedLengthAsciiString{SpacePadded, dt.size}}()
            else
                throw(UnsupportedFeatureException("Encountered an unsupported string type. $dt"))
            end
        elseif class%16 == DT_OPAQUE
            return MappedRepr{OpaqueData{Int(dt.size)},NTuple{Int(dt.size),UInt8}}()

        else
            throw(UnsupportedFeatureException("Encountered an unsupported type."))
        end
    end
    if class%16 == DT_STRING
        if (dt.bitfield1 == 0x01 || dt.bitfield1 == 0x11) && dt.bitfield2 == 0x00 && dt.bitfield3 == 0x00
            return FixedLengthString{String}(dt.size)
        elseif dt.bitfield1 == 0x10 && dt.bitfield2 == 0x00 && dt.bitfield3 == 0x00
            return FixedLengthString{String}(dt.size)
        else
            throw(UnsupportedFeatureException("Encountered an unsupported string type."))
        end
    elseif class%16 == DT_OPAQUE
        return MappedRepr{OpaqueData{Int(dt.size)},NTuple{Int(dt.size),UInt8}}()
    elseif class%16 == DT_REFERENCE
        return MappedRepr{Any,RelOffset}()
    else
        throw(UnsupportedFeatureException())
    end
end

function jltype(f::JLDFile, dt::VariableLengthDatatype)
    if dt == H5TYPE_VLEN_UTF8
        # this is the fully supported JLD2 string
        return MappedRepr{String,Vlen{String}}()
    elseif dt.bitfield1 & 0x1 == 0x1
        # it's some kind of string. Let's try
        return MappedRepr{String,Vlen{String}}()
    else#if dt.bitfield1 & 0x1 == 0x0 # it's a sequence
        rr = jltype(f, dt.basetype)
        T = julia_repr(rr)
        odr = file_repr(rr)
        return MappedRepr{Vector{T}, Vlen{odr}}()
    end
end

jlconvert(::MappedRepr{Vector{T},Vlen{ODR}}, f::JLDFile, ptr::Ptr, ::RelOffset) where {T, ODR} =
    jlconvert(MappedRepr{T,Vlen{ODR}}(), f, ptr, UNDEFINED_ADDRESS)


function h5convert!(out::Pointers, fls::FixedLengthString, f::JLDFile, x, ::JLDWriteSession)
    fls.length == jlsizeof(x) || throw(InvalidDataException())
    (unsafe_copyto!(pconvert(Ptr{UInt8}, out), pointer(x), fls.length); nothing)
end
h5convert!(out::Pointers, ::Type{Vlen{String}}, f::JLDFile, x, wsession::JLDWriteSession) =
    store_vlen!(out, UInt8, f, unsafe_wrap(Vector{UInt8}, x), wsession)

jlconvert(::MappedRepr{String,Vlen{String}}, f::JLDFile, ptr::Ptr, ::RelOffset) =
    String(jlconvert(MappedRepr{UInt8,Vlen{UInt8}}(), f, ptr, NULL_REFERENCE))
function jlconvert(rr::FixedLengthString{String}, ::JLDFile, ptr::Ptr, ::RelOffset)
    data = Vector{UInt8}(undef, rr.length)
    unsafe_copyto!(pointer(data), pconvert(Ptr{UInt8}, ptr), rr.length)
    String(data)
end


# Ascii String
function jlconvert(rr::AsciiString{NullTerminated}, ::JLDFile, ptr::Ptr, ::RelOffset)
    data = Vector{UInt8}(undef, rr.length)
    unsafe_copyto!(pointer(data), pconvert(Ptr{UInt8}, ptr), rr.length)
    String(data[1:end-1])
end
function jlconvert(::MappedRepr{String, FixedLengthAsciiString{NullTerminated,N}}, ::JLDFile, ptr::Ptr, ::RelOffset) where {N}
    data = Vector{UInt8}(undef, N)
    unsafe_copyto!(pointer(data), pconvert(Ptr{UInt8}, ptr), N)
    String(data)
end

function jlconvert(::MappedRepr{String, FixedLengthAsciiString{SpacePadded,N}}, ::JLDFile, ptr::Ptr, ::RelOffset) where {N}
    data = Vector{UInt8}(undef, N)
    unsafe_copyto!(pointer(data), pconvert(Ptr{UInt8}, ptr), N)
    rstrip(String(data))
end
odr_sizeof(x::AsciiString) = Int(x.length)
odr_sizeof(::Type{FixedLengthAsciiString{TERM, N}}) where {TERM, N} = Int(N)::Int





# Used only for custom serialization
constructrr(::JLDFile, ::Type{String}, dt::VariableLengthDatatype{FixedPointDatatype}, ::Vector{ReadAttribute}) =
    dt == H5TYPE_VLEN_UTF8 ?
        (MappedRepr{String,Vlen{String}}(), true) :
        throw(UnsupportedFeatureException())

## Symbols

function h5fieldtype(f::JLDFile, ::Type{Symbol}, readas::Type, ::Initialized)
    @lookup_committed f readas
    commit(f, H5TYPE_VLEN_UTF8, Symbol, readas)
end
fieldodr(::Type{Symbol}, ::Bool) = Vlen{String}

h5type(f::JLDFile, ::Type{Symbol}, x) = h5fieldtype(f, Symbol, typeof(x), Val{true})
odr(::Type{Symbol}) = Vlen{String}

function h5convert!(out::Pointers, ::Type{Vlen{String}}, f::JLDFile, x::Symbol, ::JLDWriteSession)
    s = String(x)
    store_vlen!(out, UInt8, f, unsafe_wrap(Vector{UInt8}, s), f.datatype_wsession)
end

constructrr(::JLDFile, ::Type{Symbol}, dt::VariableLengthDatatype{FixedPointDatatype}, ::Vector{ReadAttribute}) =
    dt == H5TYPE_VLEN_UTF8 ? (MappedRepr{Symbol,Vlen{String}}(), true) :
                             throw(UnsupportedFeatureException())

jlconvert(::MappedRepr{Symbol,Vlen{String}}, f::JLDFile, ptr::Ptr, ::RelOffset) =
    Symbol(jlconvert(MappedRepr{UInt8,Vlen{UInt8}}(), f, ptr, NULL_REFERENCE))

## BigInts and BigFloats

writeas(::Union{Type{BigInt},Type{BigFloat}}) = String
wconvert(::Type{String}, x::BigInt) = string(x, base = 62)
wconvert(::Type{String}, x::BigFloat) = string(x)
rconvert(::Type{BigInt}, x::String) = parse(BigInt, x, base = 62)
rconvert(::Type{BigFloat}, x::String) = parse(BigFloat, x)

# BigInts and BigFloats are defined as mutable structs but should be reconstructed like an
# immutable one. This overrides the default behavior.
function jlconvert(::MappedRepr{BN,CustomSerialization{String,Vlen{String}}},
        f::JLDFile, ptr::Ptr, header_offset::RelOffset) where BN <: Union{BigInt, BigFloat}
    rconvert(BN, jlconvert(MappedRepr{String, Vlen{String}}(), f, ptr, header_offset))
end

## Pointers

# Previously it was disallowed to serialize pointers.
# Due to popular demand and in particular to not error on serializing complex structures
# that contain non-essential pointers this has been changed to instead
# return null pointers.
writeas(::Type{Ptr{T}}) where {T} = Nothing
rconvert(::Type{Ptr{T}}, ::Nothing) where {T} = Ptr{T}(0)

## Arrays
# In most cases, Memory must be treated in the exact same way as arrays.
@static if VERSION >= v"1.11"
    const ArrayMemory{T} = Union{Array{T}, Memory{T}}
else
    const ArrayMemory{T} = Array{T}
end

h5fieldtype(::JLDFile, ::Type{T}, ::Type{T}, ::Initialized) where {T<:ArrayMemory} =
    ReferenceDatatype()
fieldodr(::Type{T}, ::Bool) where {T<:ArrayMemory} = RelOffset

function odr(A::Type{<:ArrayMemory})
    T = eltype(A)
    writtenas = writeas(T)
    CustomSerialization(writtenas, T, fieldodr(writtenas, false))
end

# This is all so that when you define a writeas method to write something as an
# array, it writes a reference to the actual array where the datatype is
# committed and has a written_type attribute.
function h5fieldtype(f::JLDFile, ::Type{T}, readas::DataType,
                     ::Initialized) where T<:ArrayMemory
    @lookup_committed f readas
    commit(f, ReferenceDatatype(), T, readas)
end
h5type(f::JLDFile, ::Type{T}, x) where {T<:ArrayMemory} =
    h5fieldtype(f, T, typeof(x), Val{true})

function h5type(f::JLDFile, ::Type{T}, ::T) where T<:ArrayMemory
    if T <: ArrayMemory{Union{}}
        return ReferenceDatatype()
    end
    ty = eltype(T)
    writtenas = writeas(ty)
    if !hasfielddata(writtenas)
        # This is a hacky way to generate an instance of ty
        # the instance isn't actually needed for anything except that inside
        # h5type ty is determined via typeof(x)
        # annoyingly for some types h5type needs the instance
        h5type(f, writtenas, rconvert(ty, newstruct(writtenas)))
    else
        h5fieldtype(f, writtenas, ty, Val{false})
    end
end

_odr(writtenas::Type{T}, readas::Type{T}, odr) where {T<:ArrayMemory} = odr
_odr(writtenas::Type{T}, readas::DataType, odr) where {T<:ArrayMemory} =
    CustomSerialization{writtenas,RelOffset}

function constructrr(::JLDFile, ::Type{T}, dt::BasicDatatype,
                     attrs::Vector{ReadAttribute}) where T<:ArrayMemory
    dt.class == DT_REFERENCE || throw(UnsupportedFeatureException())
    (MappedRepr{T, RelOffset}(), true)
end

## SimpleVectors

writeas(::Type{Core.SimpleVector}) = Vector{Any}
wconvert(::Type{Vector{Any}}, x::Core.SimpleVector) = collect(Any, x)
rconvert(::Type{Core.SimpleVector}, x::Vector{Any}) = Core.svec(x...)

## Standard Dictionary Types
# Custom dictionaries may need to store additional fields
mutable struct SerializedDict
    kvvec # Vector{Pair{K,V}}
end

writeas(::Type{Dict{K,V}}) where {K,V} = SerializedDict
writeas(::Type{IdDict{K,V}}) where {K,V} = SerializedDict
writeas(::Type{Base.ImmutableDict{K,V}}) where {K,V} = SerializedDict

wconvert(::Type{SerializedDict}, x::AbstractDict) = SerializedDict(collect(x))
rconvert(::Type{T}, x::SerializedDict) where {T<:Union{Dict,IdDict,Base.ImmutableDict}} = rconvert(T,x.kvvec)

# These are kept around for legacy
rconvert(::Type{T}, x::Vector{ <: Pair}) where {T<:Union{Dict,IdDict}} = T(x)
function rconvert(::Type{<:Base.ImmutableDict}, x::Vector{Pair{K,V}}) where {K,V}
    @assert !isempty(x)
    d = Base.ImmutableDict(x[1])
    for p in (@view x[2:end])
        d = Base.ImmutableDict(d, p)
    end
    d
end

## NTuples
# Immutable objects are stored as HDF5 structs and inlined into
# parent structures. HDF5 only allows typemax(Unt16) bytes
# for struct description. NTuples are the most common offender for
# exploding struct size. (e.g. in the form of large StaticArrays)
# The definitions below prevent inlining of large NTuples and
# convert to an array instead.
const NTUPLE_INLINE_THRESHOLD = 10

function writeas(NT::Type{Tuple{T, Vararg{T,N}}}) where {N,T}
    if (N+1) > NTUPLE_INLINE_THRESHOLD
        return Vector{T}
    else
        return NT
    end
end

wconvert(::Type{Vector{T}}, x::NTuple{N,T}) where {N,T} = collect(x)
rconvert(::Type{NTuple{N,T}}, x::Vector{T}) where {N,T} = NTuple{N,T}(x)

## Modules
# Modules are stored by name
writeas(::Type{Module}) = String
wconvert(::Type{String}, x::Module) = string(x)
function rconvert(::Type{Module}, x::String)
    pkg = Symbol(x)
    # Try to find the module
    for m in Base.loaded_modules_array()
        (Symbol(m) == pkg) && return m
    end
    @warn "Encountered reference to module $x, but it is not currently loaded."
    return try
        @eval Base.__toplevel__  import $pkg
        for m in Base.loaded_modules_array()
            (Symbol(m) == pkg) && return m
        end
    catch
       @warn "Could not load module $x. Returning a dummy module"
       Module(Symbol(x*"_dummy"))
    end
end

function jlconvert(::MappedRepr{Module,CustomSerialization{String,Vlen{String}}},
    f::JLDFile, ptr::Ptr, header_offset::RelOffset)
rconvert(Module, jlconvert(MappedRepr{String, Vlen{String}}(), f, ptr, header_offset))
end


## MemoryRef
@static if VERSION >= v"1.11"
    struct SerializedMemoryRef
        index::Int64
        ref::Memory
    end

    writeas(::Type{<:MemoryRef}) = SerializedMemoryRef
    wconvert(::Type{SerializedMemoryRef}, x::MemoryRef) =
        SerializedMemoryRef(1+(x.ptr_or_offset - x.mem.ptr)*x.mem.length÷sizeof(x.mem), x.mem)

    rconvert(::Type{<:MemoryRef}, x::SerializedMemoryRef) = memoryref(x.ref, Int(x.index))
end

using JLD2, FileIO
using Test

using Pkg

const in_tree = pkgdir(JLD2) == dirname(@__DIR__)
@show in_tree
if in_tree && VERSION < v"1.12.0"
    # No workspace support before 1.12
    filterpath = joinpath(pkgdir(JLD2), "filterpkgs")
    Pkg.develop([
        PackageSpec(name="JLD2Bzip2", path=joinpath(filterpath, "JLD2Bzip2")),
        PackageSpec(name="JLD2Lz4", path=joinpath(filterpath, "JLD2Lz4")),
    ])
end
using JLD2Bzip2, JLD2Lz4

const julia_proj_cmd = `$(Base.julia_cmd()) --project=$(Base.active_project())`

function better_success(cmd)
    fn1, _ = mktemp()
    fn2, _ = mktemp()
    try
       run(pipeline(cmd, stdout=fn1, stderr=fn2))
    catch
        println(String(read(fn1)))
        println(String(read(fn2)))
        return false
    end
    return true
end

include("bufferedreader.jl")
include("lookup3.jl")
include("internal.jl")
include("rw.jl")
include("append.jl")
include("groups.jl")
include("consistency.jl")
include("loadsave.jl")
include("modules.jl")
include("modules-nested.jl")
include("isreconstructed.jl")
include("backwards_compatibility.jl")
include("inlineunion.jl")
include("customserialization.jl")
include("compression.jl")
include("test_files.jl")
include("unpack_test.jl")
include("dataset_api.jl")
include("test_dataset_show.jl")
include("mmap_test.jl")
include("generic_io_tests.jl")  # Unified tests for all IO types

using TestItemRunner

@run_package_tests

if in_tree
    @testitem "Aqua Testing" begin
        using Aqua
        Aqua.test_all(JLD2;
            deps_compat = (;
                ignore = [:Mmap,],
            ),
            # There are a whole bunch of pseudo-ambiguities which can never be hit.
            ambiguities = false,
        )
    end
else
    @info "skipping Aqua tests when not in tree"
end

using Test, JLD2

#=
Generic IO Testing Framework for JLD2

This file provides a unified testing framework for all IO types supported by JLD2.
Instead of duplicating tests for each IO type (Vector{UInt8}, IOBuffer, etc.),
we define tests once and run them against all IO types.

## Adding a New IO Type

To test a new IO type, create a helper struct and implement the interface:

```julia
struct MyIOHelper <: IOTestHelper end

# Required methods:
create_io(::MyIOHelper) = MyCustomIO()              # Create fresh instance
get_bytes(::MyIOHelper, io) = extract_bytes(io)     # Get raw bytes
reset_for_reading!(::MyIOHelper, io) = prepare(io)  # Prepare for reading
supports_take!(::MyIOHelper) = false                # Does it support take!()?
io_name(::MyIOHelper) = "MyCustomIO"                # Display name

# Then add to the test suite:
run_generic_io_tests(MyIOHelper())
```

This automatically runs all generic tests for the new IO type!
=#

"""
    IOTestHelper

Abstract type for IO test helpers. Each concrete type provides methods to:
- Create a fresh IO instance
- Extract raw bytes (for disk compatibility tests)
- Reset for reading
"""
abstract type IOTestHelper end

"""
Helper for testing Vector{UInt8} IO
"""
struct ByteVectorHelper <: IOTestHelper end

create_io(::ByteVectorHelper) = UInt8[]
get_bytes(::ByteVectorHelper, io) = io
reset_for_reading!(::ByteVectorHelper, io) = nothing  # No-op, Vector is always ready
supports_take!(::ByteVectorHelper) = false
io_name(::ByteVectorHelper) = "Vector{UInt8}"

"""
Helper for testing IOBuffer
"""
struct IOBufferHelper <: IOTestHelper end

create_io(::IOBufferHelper) = IOBuffer()
get_bytes(::IOBufferHelper, io) = take!(io)
function reset_for_reading!(::IOBufferHelper, io)
    seekstart(io)
end
supports_take!(::IOBufferHelper) = true
io_name(::IOBufferHelper) = "IOBuffer"

"""
Helper for testing IOStream (temporary files)
"""
struct IOStreamHelper <: IOTestHelper end

function create_io(::IOStreamHelper)
    path = tempname()
    # We open in "w+" mode (read/write/create/truncate)
    # We need to track the file path to clean it up later, but IOTestHelper 
    # interface assumes just returning the IO. 
    # Since these are unit tests, we'll rely on OS/Julia temp cleanup or 
    # explicitly delete in the test runner if we changed the interface.
    # For now, let's just return the stream.
    return open(path, "w+")
end

function get_bytes(::IOStreamHelper, io)
    flush(io)
    path = io.name
    # Make sure we preserve position
    pos = position(io)
    seekstart(io)
    data = read(io)
    seek(io, pos)
    # If file was deleted, this might fail, but tests usually keep it open
    return data
end

function reset_for_reading!(::IOStreamHelper, io)
    seekstart(io)
end

supports_take!(::IOStreamHelper) = false
io_name(::IOStreamHelper) = "IOStream"

"""
    run_generic_io_tests(helper::IOTestHelper)

    Run a comprehensive suite of tests for an IO type.
"""
function run_generic_io_tests(helper::IOTestHelper)
    name = io_name(helper)

    # Helper to cleanup IO if it's an IOStream/file based
    function cleanup_io(io)
        if io isa IOStream
            path = io.name[7:end-1] # format is <file path>
            close(io)
            # Try to delete file if it exists
            try
                rm(path, force=true)
            catch
            end
        elseif io isa IO
            close(io)
        end
        # Arrays/Vectors don't need closing
    end

    @testset "$name - Basic read/write" begin
        io = create_io(helper)

        # Write data
        f = jldopen(io, "w")
        f["a"] = 42
        f["b"] = "hello"
        f["c"] = [1.0, 2.0, 3.0]
        close(f)

        # Read data back
        reset_for_reading!(helper, io)
        f = jldopen(io, "r")
        @test f["a"] == 42
        @test f["b"] == "hello"
        @test f["c"] == [1.0, 2.0, 3.0]
        close(f)
        
        cleanup_io(io)
    end

    @testset "$name - Append mode" begin
        io = create_io(helper)

        # Create initial file
        jldopen(io, "w") do f
            f["a"] = 1
        end

        # Append to existing file
        reset_for_reading!(helper, io)
        jldopen(io, "r+") do f
            @test f["a"] == 1
            f["b"] = 2
        end

        # Verify both values exist
        reset_for_reading!(helper, io)
        jldopen(io, "r") do f
            @test f["a"] == 1
            @test f["b"] == 2
        end
        
        cleanup_io(io)
    end

    @testset "$name - Complex types" begin
        io = create_io(helper)

        # Use a NamedTuple as a complex type
        original = (x=42, y="test", z=[1, 2, 3])

        jldopen(io, "w") do f
            f["custom"] = original
        end

        reset_for_reading!(helper, io)
        jldopen(io, "r") do f
            loaded = f["custom"]
            @test loaded == original
        end
        
        cleanup_io(io)
    end

    @testset "$name - Large data" begin
        io = create_io(helper)

        # Create large arrays
        large_array = rand(1000, 1000)

        jldopen(io, "w") do f
            f["large"] = large_array
        end

        reset_for_reading!(helper, io)
        jldopen(io, "r") do f
            loaded = f["large"]
            @test loaded == large_array
        end
        
        cleanup_io(io)
    end

    @testset "$name - Groups" begin
        io = create_io(helper)

        jldopen(io, "w") do f
            g = JLD2.Group(f, "mygroup")
            g["a"] = 1
            g["b"] = 2
        end

        reset_for_reading!(helper, io)
        jldopen(io, "r") do f
            @test f["mygroup/a"] == 1
            @test f["mygroup/b"] == 2
        end
        
        cleanup_io(io)
    end

    @testset "$name - Compression" begin
        io_plain = create_io(helper)
        io_compressed = create_io(helper)

        test_data = rand(100, 100)

        # Write without compression
        jldopen(io_plain, "w") do f
            f["data"] = test_data
        end

        # Write with compression
        jldopen(io_compressed, "w"; compress=true) do f
            f["data"] = test_data
        end

        # Both should read correctly
        reset_for_reading!(helper, io_plain)
        jldopen(io_plain, "r") do f
            @test f["data"] == test_data
        end

        reset_for_reading!(helper, io_compressed)
        jldopen(io_compressed, "r") do f
            @test f["data"] == test_data
        end
        
        cleanup_io(io_plain)
        cleanup_io(io_compressed)
    end

    @testset "$name - Truncate mode" begin
        io = create_io(helper)

        # Write initial data
        jldopen(io, "w") do f
            f["a"] = 1
        end

        # Overwrite with truncate
        reset_for_reading!(helper, io)
        jldopen(io, "w") do f
            f["b"] = 2
        end

        # Verify old data is gone and new data exists
        reset_for_reading!(helper, io)
        jldopen(io, "r") do f
            @test !haskey(f, "a")
            @test f["b"] == 2
        end
        
        cleanup_io(io)
    end

    @testset "$name - Compatibility with file-based IO" begin
        io = create_io(helper)

        test_value = [1, 2, 3, 4, 5]

        jldopen(io, "w") do f
            f["test"] = test_value
        end

        # Get bytes and write to disk
        bytes = get_bytes(helper, io)

        mktempdir() do dir
            filepath = joinpath(dir, "test.jld2")
            write(filepath, bytes)

            # Read from disk file
            jldopen(filepath, "r") do f
                @test f["test"] == test_value
            end

            # Read disk file into bytes and verify
            disk_data = read(filepath)
            @test disk_data == bytes
        end
        
        cleanup_io(io)
    end
end

# Run tests for all IO types
@testset "Generic IO Tests" begin
    @testset "All IO Types" begin
        run_generic_io_tests(ByteVectorHelper())
        run_generic_io_tests(IOBufferHelper())
        run_generic_io_tests(IOStreamHelper())

        # Adding a new IO type is easy! Just create a helper and add it here:
        # run_generic_io_tests(MyNewIOHelper())
    end

    @testset "IO Capability Validation" begin
        # Test that isreadable and iswritable are properly checked
        # These tests exercise the _isreadable and _iswritable checks in _wrap_io

        # Create a non-readable IO type by wrapping an IOBuffer
        struct NonReadableIO <: IO
            buf::IOBuffer
        end
        NonReadableIO() = NonReadableIO(IOBuffer())
        Base.isreadable(::NonReadableIO) = false
        Base.iswritable(::NonReadableIO) = true
        seekable(::NonReadableIO) = true
        for f in (:position, :seek, :seekend, :seekstart, :write, :read, :eof, :bytesavailable)
            @eval Base.$f(io::NonReadableIO, args...) = $f(io.buf, args...)
        end

        # Create a non-writable IO type by wrapping an IOBuffer
        struct NonWritableIO <: IO
            buf::IOBuffer
        end
        NonWritableIO(data::Vector{UInt8}) = NonWritableIO(IOBuffer(data))
        Base.isreadable(::NonWritableIO) = true
        Base.iswritable(::NonWritableIO) = false
        isseekable(::NonWritableIO) = true
        for f in (:position, :seek, :seekend, :seekstart, :write, :read, :eof, :bytesavailable)
            @eval Base.$f(io::NonWritableIO, args...) = $f(io.buf, args...)
        end

        # Test that non-readable IO throws an error
        @test_throws ArgumentError begin
            io = NonReadableIO()
            jldopen(io, "r")
        end

        # Test that non-writable IO throws an error when opened in writable mode
        @test_throws ArgumentError begin
            io = NonWritableIO(UInt8[])
            jldopen(io, "w")
        end
    end
end

@setup_workload begin
    a=1
    b=2.0
    c=[1.0,2.0]
    d=rand(ComplexF64,100,100)
    e=Dict(s => 2 for s in ["a", "b", "c"])
    f="A String"
    g=ntuple(i->i^2, 5)
    h=rand(2000)
    i=:asymbol

    @compile_workload begin
        mktemp() do path, _

            # jldsave
            jldsave(path; a, b, c, d, e, f, g, h, i)

            jldopen(path) do f
                for k in keys(f)
                    f[k]
                end
            end

            file = jldopen(path, "r")
            try 
                JLD2.loadnesteddict(file)
                JLD2.loadtodict!(Dict{String,Any}(), file)
            finally
                close(file)
            end
            nothing
        end
    end
end

"""
    Dataset

A mutable struct representing an HDF5/JLD2 dataset with explicit control over metadata.

The `Dataset` type allows low-level access to dataset metadata and provides fine-grained
control over how data is stored, including compression, chunking, and layout options.
This is useful for advanced use cases where you need more control than the standard
`jldsave`/`load` interface provides.
# Usage

Datasets are created using [`create_dataset`](@ref), written with [`write_dataset`](@ref),
and read with [`read_dataset`](@ref) or retrieved with [`get_dataset`](@ref).

# Example
```julia
jldopen("data.jld2", "w") do f
    # Create a dataset with compression
    dset = JLD2.create_dataset(f, "compressed_data")
    dset.filters = Deflate()
    JLD2.write_dataset(dset, rand(1000, 1000))

    # Add attributes
    JLD2.add_attribute(dset, "description", "Random data with compression")
end
```

See also: [`create_dataset`](@ref), [`write_dataset`](@ref), [`read_dataset`](@ref), [`get_dataset`](@ref)
"""
mutable struct Dataset
    parent::Group
    name::String
    offset::RelOffset
    datatype
    dataspace
    layout
    attributes::OrderedDict{String, Any}
    chunk
    filters
    header_chunk_info # chunk_start, chunk_end, next_msg_offset
end


"""
    create_dataset(parent, path, datatype=nothing, dataspace=nothing; layout=nothing, chunk=nothing, filters=FilterPipeline(), allocate=false)

Create a new [`Dataset`](@ref) object with specified metadata, ready for writing data.

This function creates a dataset specification but does not write any data to the file.
The dataset must be written using [`write_dataset`](@ref) to actually store data.
This two-step process allows you to configure compression, attributes, and other
metadata before writing.

# Arguments
- `parent::Union{JLDFile, Group}`: The containing file or group for the new dataset
- `path::Union{String, Nothing}`: Path to the dataset relative to `parent`.
  If `nothing`, creates an unnamed dataset
- `datatype`: HDF5 datatype specification OR a Julia `Type`.
  If `nothing`, will be inferred from data during writing.
- `dataspace`: Dataspace describing dimensions OR a `Tuple`/`Vector` of integers representing dimensions.
  If `nothing`, will be inferred from data during writing.
- `allocate::Bool`: (Experimental) If `true`, allocates space for the dataset in the file immediately.
  Requires `datatype` and `dataspace` to be provided.
  Returns an `ArrayDataset` wrapper that allows writing to the dataset via array indexing (e.g. `dset[i] = val`).

## Returns
- `Dataset` (or `ArrayDataset` if `allocate=true`): A mutable dataset object ready for configuration and writing

## Notes
- The dataset is not written to the file until [`write_dataset`](@ref) is called (unless `allocate=true`)
- Datatype and dataspace are usually inferred automatically from the data
- Compression filters can be added after creation but before writing
- Attributes can be added before or after writing (see [`add_attribute`](@ref))

See also: [`write_dataset`](@ref), [`Dataset`](@ref), [`add_attribute`](@ref), [`Deflate`](@ref)

## Usage Example

```julia
jldopen("data.jld2", "w") do f
    dset = JLD2.create_dataset(f, "my_data")
    JLD2.write_dataset(dset, [1, 2, 3, 4, 5])
end

jldopen("data.jld2", "w") do f
    dset = JLD2.create_dataset(f, "compressed_array")
    dset.filters = Deflate()  # Add gzip compression
    JLD2.add_attribute(dset, "experiment_id", "exp_001")
    JLD2.write_dataset(dset, rand(10000))
end

# Streaming write (pre-allocate space)
jldopen("data.jld2", "w") do f
    dset = JLD2.create_dataset(f, "streamed", Float64, (100,); allocate=true)
    for i in 1:100
        dset[i] = rand()
    end
end
```
"""
create_dataset(f::JLDFile, args...; kwargs...) = create_dataset(f.root_group, args...; kwargs...)
function create_dataset(
    g::Group,
    path::Union{Nothing,String},
    datatype=nothing,
    dataspace=nothing;
    layout = nothing,
    chunk=nothing,
    filters=FilterPipeline(),
    allocate::Bool=false,
)
    if !isnothing(path)
        (parent, name) = pathize(g, path, true)
    else
        name = ""
        parent = g
    end

    T = nothing
    if datatype isa Type
        T = datatype
        datatype = h5fieldtype(g.f, T, T, Val{false})
    end

    if dataspace isa NTuple{N, Integer} where N || dataspace isa Vector{<:Integer}
         dataspace = WriteDataspace(DS_SIMPLE, UInt64.(reverse(Tuple(dataspace))), ())
    end

    dset = Dataset(parent, name, UNDEFINED_ADDRESS, datatype, dataspace,
            layout, OrderedDict{String,Any}(), chunk, filters, nothing)

    if allocate
        allocate_early(dset, T)
        return ArrayDataset(dset)
    end

    return dset
end

iswritten(dset::Dataset) = (dset.offset != UNDEFINED_ADDRESS)

function Base.show(io::IO, ::MIME"text/plain", dset::Dataset)
    print_dataset_header(io, dset)
    prefix = "│  "
    print_datatype_info(io, dset, prefix)
    print_dataspace_info(io, dset, prefix)
    print_layout_info(io, dset, prefix)
    print_filters_info(io, dset, prefix)
    print_attributes_info(io, dset, prefix)
    println(io, "└─")
end

function print_dataset_header(io::IO, dset::Dataset)
    print(io, "┌─ Dataset:")
    print(io, isempty(dset.name) ? " (unnamed)" : " \"$(dset.name)\"")
    println(io, iswritten(dset) ? " at $(dset.offset)" : " (unwritten)")
end

function print_datatype_info(io::IO, dset::Dataset, prefix::String)
    isnothing(dset.datatype) && return

    dt = dset.datatype
    f = dset.parent.f
    iscommitted = isshared(dt)
    tpstr = replace(string(typeof(dt)), "JLD2."=>"")
    print(io, prefix, "datatype: ", tpstr)
    if iscommitted
        print(io, " (committed at ", dt.header_offset, ")\n")
    else
        print(io, "\n")
    end
    # print_datatype_structure
    if dt isa BasicDatatype && dt.class%16 == DT_REFERENCE
        println(io, prefix, "\ttype name: RelOffset")
        return
    end
    julia_type_str, _, field_strs = stringify_h5datatype(f, dt, showfields=true)

    println(io, prefix, "\ttype name: ", julia_type_str)
    if !isempty(field_strs)
        println(io, prefix, "\tstored fields:")
        foreach(field_str -> println(io, prefix, "\t\t", field_str), field_strs)
    end
end

function print_dataspace_info(io::IO, dset::Dataset, prefix::String)
    isnothing(dset.dataspace) && return

    ds = dset.dataspace
    if ds isa HmWrap{HmDataspace}
        spacetype_map = Dict(0x00=>"Scalar", 0x01=>"Simple", 0x02=>"Null", 0xff=>"V1")
        println(io, prefix, "dataspace:")
        println(io, prefix, "\ttype: ", spacetype_map[ds.dataspace_type])
        println(io, prefix, "\tdimensions: ", ds.dimensions)
    else
        println(io, prefix, "dataspace: ", ds)
    end
end

function print_layout_info(io::IO, dset::Dataset, prefix::String)
    isnothing(dset.layout) && return

    layout = dset.layout
    if layout isa HmWrap{HmDataLayout}
        println(io, prefix, "layout:")
        println(io, prefix, "\tclass: ", layout.layout_class)
    else
        println(io, prefix, "layout: ", layout)
    end
end

function print_filters_info(io::IO, dset::Dataset, prefix::String)
    (!isnothing(dset.filters) && !isempty(dset.filters.filters)) && println(io, prefix, "filters: ", dset.filters)
end

function print_attributes_info(io::IO, dset::Dataset, prefix::String)
    isempty(dset.attributes) && return

    println(io, prefix, "Attributes:")
    for (k, attr) in pairs(dset.attributes)
        if attr isa ReadAttribute
            attr_info = safe_read_attribute_info(dset.parent.f, attr)
            println(io, prefix, "\t", attr.name, " = ", attr_info)
        else
            println(io, prefix, "\t", k, " = ", attr)
        end
    end
end

"""
    write_dataset(dataset::Dataset, data, wsession=JLDWriteSession())

Write data to file using the metadata and configuration stored in the [`Dataset`](@ref) object.

This function performs the actual data writing operation after a dataset has been created
with [`create_dataset`](@ref). The dataset must not have been written before (each dataset
can only be written once). The data type and dataspace will be automatically inferred
from the provided data if they weren't specified during dataset creation.

## Arguments
- `dataset::Dataset`: The dataset object created with [`create_dataset`](@ref)
- `data`: The data to write. Can be any Julia object that JLD2 can serialize
- `wsession::JLDWriteSession`: Optional write session for advanced usage (default: new session)

## Returns
- `RelOffset`: The file offset where the dataset was written
"""
function write_dataset(dataset::Dataset, data, wsession::JLDWriteSession=JLDWriteSession())
    f = dataset.parent.f
    if dataset.offset != UNDEFINED_ADDRESS
        throw(ArgumentError("Dataset has already been written to file"))
    end
    # first need to figure out if data type and dataspace are defined / correct
    if isnothing(dataset.datatype)
        dataset.datatype = h5type(f, data)
    end
    datatype = dataset.datatype
    odr = objodr(data)
    if isnothing(dataset.dataspace)
        dataset.dataspace = WriteDataspace(f, data, odr)
    end
    dataspace = dataset.dataspace
    compressor = Filters.normalize_filters(dataset.filters)
    offset = write_dataset(f, dataspace, datatype, odr, data, wsession, compressor)
    !isempty(dataset.name) && (dataset.parent[dataset.name] = offset)
    # Attributes
    attrs = map(collect(keys(pairs(dataset.attributes)))) do name
       WrittenAttribute(f, name, dataset.attributes[name])
    end
    dataset = get_dataset(f, offset, dataset.parent, dataset.name)
    dataset.header_chunk_info =
        attach_message(f, dataset.offset, attrs, wsession;
            chunk_start=dataset.header_chunk_info[1],
            chunk_end=dataset.header_chunk_info[2],
            next_msg_offset=dataset.header_chunk_info[3],
            )

    return offset
end

"""
    read_dataset(dset::Dataset)

Read and return the complete dataset from the file and reconstructs the original
Julia object.
"""
function read_dataset(dset::Dataset)
    f = dset.parent.f
    read_data(f,
        ReadDataspace(f, dset.dataspace),
        dset.datatype,
        DataLayout(f, dset.layout),
        isnothing(dset.filters) ? FilterPipeline() : dset.filters,
        dset.offset,
        collect(ReadAttribute, values(dset.attributes)))
end

"""
    get_dataset(parent::Union{JLDFile, Group}, name::String)

Retrieve a [`Dataset`](@ref) object from a file without reading the actual data.
This is useful for inspecting dataset properties, accessing attributes, or preparing for selective data reading.
The returned `Dataset` object can be used with [`read_dataset`](@ref), [`readmmap`](@ref),
or array indexing operations.

## Arguments
- `parent`: The file or group containing the dataset
- `name::String`: Name or path of the dataset relative to the parent
"""
get_dataset(f::JLDFile, args...; kwargs...) =
    get_dataset(f.root_group, args...; kwargs...)

function get_dataset(g::Group, name::String)
    f = g.f
    f.n_times_opened == 0 && throw(ArgumentError("file is closed"))

    (g, name) = pathize(g, name, false)
    roffset = lookup_offset(g, name)
    if roffset == UNDEFINED_ADDRESS
        if isempty(name)
            # this is a group
            return get_dataset(f, group_offset(g), g, name)
        end
        throw(KeyError(name))
    end
    get_dataset(f, roffset, g, name)
end

function get_dataset(f::JLDFile, offset::RelOffset, g=f.root_group, name="")
    dset = Dataset(g, name, offset, nothing, nothing, nothing, OrderedDict{String,Any}(), false, FilterPipeline(), nothing)

    hmitr = HeaderMessageIterator(f, offset)
    for msg in hmitr
        if msg.type == HmDataspace
            dset.dataspace = HmWrap(HmDataspace, msg)
        elseif msg.type == HmDatatype
            dset.datatype = HmWrap(HmDatatype, msg).dt
        elseif msg.type == HmDataLayout
            dset.layout = HmWrap(HmDataLayout, msg)
        elseif msg.type == HmFilterPipeline
            dset.filters = FilterPipeline(msg)
        elseif msg.type == HmAttribute
            attr = read_attribute(f, msg)
            dset.attributes[string(attr.name)] = attr
        end
    end

    dset.header_chunk_info = (;
                hmitr.chunk.chunk_start,
                hmitr.chunk.chunk_end,
                next_msg_offset = hmitr.chunk.chunk_end-CONTINUATION_MSG_SIZE)
    return dset
end

# Attributes
message_size(msg::WrittenAttribute) = jlsizeof(HeaderMessage) + jlsizeof(msg)
function write_header_message(io,f::JLDFile, msg::WrittenAttribute, wsession=JLDWriteSession())
    jlwrite(io, HeaderMessage(HmAttribute, jlsizeof(msg), 0))
    write_attribute(io, f, msg, wsession)
    return nothing
end

# Links
message_size(msg::Pair{String, RelOffset}) = jlsizeof(Val(HmLinkMessage); link_name=msg.first)
write_header_message(io, f, msg::Pair{String, RelOffset}, _=nothing) =
    write_header_message(io, Val(HmLinkMessage); link_name=msg.first, target=msg.second)

function attach_message(f::JLDFile, offset, messages, wsession=JLDWriteSession();
    chunk_start,
    chunk_end,
    next_msg_offset,
    minimum_continuation_size::Int = 0
    )
    if chunk_start == UNDEFINED_ADDRESS || chunk_end == UNDEFINED_ADDRESS ||
            next_msg_offset == UNDEFINED_ADDRESS
        throw(UnsupportedFeatureException("Not implemented. pass all info"))
    end
    next_msg_offset == -1 && throw(InternalError("next_msg_offset should not be -1"))

    io = f.io
    seek(io, next_msg_offset)
    remaining_space = chunk_end  - 20 - next_msg_offset
    while !isempty(messages)

        msg = first(messages)
        sz = message_size(msg)
        if remaining_space ≥ sz + 4 || remaining_space == sz
            pos = position(io)
            write_header_message(io, f, msg)
            rsz = position(io) - pos
            if rsz != sz
                throw(InternalError("Message size mismatch. Expected $sz, got $rsz for message $msg"))
            end
            next_msg_offset += sz
            remaining_space -= sz
            popfirst!(messages)
        else
            break
        end
    end

    if isempty(messages)
        # Managed to add all messages
        # Cleanup and return
        # Mark remaining free space with a NIL message
        empty_space = chunk_end-position(io)-4 - 20
        if empty_space != -4
            empty_space < 0 && throw(InternalError("Negative empty space. This should not happen"))
            write_header_message(io, Val(HmNil), 0, empty_space)
        end
        # continuation space
        write_continuation_placeholder(io)

        # Re-calculate checksum
        update_checksum(io, chunk_start, chunk_end)

        return nothing
    end
    if !iszero(remaining_space)
        # Mark remaining free space with a NIL message
        write_header_message(io, Val(HmNil), 0, remaining_space-4)
    end
    # If we got to here then a new continuation needs to be created
    continuation_start = f.end_of_data
    continuation_size = jlsizeof(OBJECT_HEADER_CONTINUATION_SIGNATURE)
    continuation_size += sum(message_size(msg) for msg in messages)
    continuation_size += CONTINUATION_MSG_SIZE + 4 # Checksum
    tmp = max(continuation_size, minimum_continuation_size)
    # only replace if the gap is larger than 4 bytes
    tmp - continuation_size > 4 && (continuation_size = tmp)

    # Object continuation message
    write_header_message(io, Val(HmObjectHeaderContinuation);
        continuation_offset=h5offset(f, continuation_start),
        continuation_length=Length(continuation_size))

    # Re-calculate checksum
    update_checksum(io, chunk_start, chunk_end)

    # Object continuation
    seek(io, continuation_start)
    chunk_start = continuation_start
    chunk_end = continuation_start + continuation_size -4
    cio = begin_checksum_write(io, continuation_size - 4)
    jlwrite(cio, OBJECT_HEADER_CONTINUATION_SIGNATURE)
    remaining_space = continuation_size - jlsizeof(OBJECT_HEADER_CONTINUATION_SIGNATURE) - CONTINUATION_MSG_SIZE -4
    while !isempty(messages)
        msg = popfirst!(messages)
        sz = message_size(msg)
        write_header_message(cio, f, msg, wsession)
        next_msg_offset += sz
        remaining_space -= sz
    end
    if remaining_space > 0
        @assert remaining_space ≥ 4 "Gaps smaller than 4 bytes should not occur"
        write_header_message(cio, Val(HmNil), 0, remaining_space)
    end
    # Extra space for object continuation
    write_continuation_placeholder(cio)
    # Checksum
    jlwrite(io, end_checksum(cio))
    f.end_of_data = position(io)
    #g.last_chunk_checksum_offset = f.end_of_data - 4
    # TODO: last_chunk_checksum_offset is not updated
    return header_chunk_info = (
        chunk_start,
        chunk_end,
        position(io)-24)
end

"""
    add_attribute(dset::Dataset, name::String, data, wsession=JLDWriteSession())

Add an attribute with the specified name and data to a [`Dataset`](@ref).

Attributes are metadata key-value pairs associated with datasets. They can store
additional information about the data such as units, descriptions, creation dates,
or any other relevant metadata. Attributes can be added before or after the dataset
has been written to the file.

## Arguments
- `dset::Dataset`: The dataset to add the attribute to
- `name::String`: The attribute name (must be unique within the dataset)
- `data`: The attribute value (can be any JLD2-serializable Julia object)
- `wsession::JLDWriteSession`: Optional write session for advanced usage (default: new session)

"""
function add_attribute(dset::Dataset, name::String, data, wsession=JLDWriteSession())
    f = dset.parent.f
    prewrite(f) # assert writability

    for attrname in keys(dset.attributes)
        if name == attrname
            throw(ArgumentError("Attribute \"$name\" already exists. Attribute names must be unique."))
        end
    end
    dset.attributes[name] = data
    if iswritten(dset)
        dset.header_chunk_info =
        attach_message(f, dset.offset, [WrittenAttribute(f,name,data)], wsession;
            chunk_start=dset.header_chunk_info[1],
            chunk_end=dset.header_chunk_info[2],
            next_msg_offset=dset.header_chunk_info[3],
            )
        return nothing
    end
end

"""
    attributes(dset::Dataset; plain::Bool=false)

Return the attributes of a dataset as an `OrderedDict`.
If `plain` is set to `true` then the values are returned as stored in the dataset object.
"""
function attributes(dset::Dataset; plain::Bool=false)
    plain && return dset.attributes
    OrderedDict(keys(dset.attributes) .=> map(values(dset.attributes)) do attr
        read_attr_data(dset.parent.f, attr)
    end)
end

"""
    ismmappable(dset::Dataset)

Check if a dataset can be memory-mapped. This can be useful for large arrays and for editing written arrays.

An Array dataset may be mmapped if:
    - `JLD2.samelayout(T) == true`: The element type is `isbits` and has a size that either 1, 2, 4, or a multiple of 8 bytes.
    - Uncompressed: Compressed arrays cannot be memory-mapped
    - Uses a contiguous layout: This is true for all array datasets written by JLD2 with version ≥ v0.4.52
    - Windows: The file must be opened in read-only mode. This is a limitation of Mmap on Windows.
"""
function ismmappable(dset::Dataset)
    iswritten(dset) || return false
    f = dset.parent.f
    dt = dset.datatype
    rr = jltype(f, dt)
    T = julia_repr(rr)
    !(samelayout(T)) && return false
    !isempty(dset.filters.filters) && return false
    ret = false
    if (layout = dset.layout) isa HmWrap{HmDataLayout}
        ret = (layout.layout_class == LcContiguous && layout.data_address != UNDEFINED_ADDRESS)
    end
    if ret == true && Sys.iswindows() && dset.parent.f.writable
        @warn "On Windows memory-mapping is only possible for files in read-only mode."
        ret = false
    end
    return ret
end


"""
    readmmap(dset::Dataset)

Memory-map a dataset. This can be useful for large arrays and for editing written arrays.
See [`ismmappable`](@ref) for requirements.
"""
function readmmap(dset::Dataset)
    ismmappable(dset) || throw(ArgumentError("Dataset is not mmappable"))
    f = dset.parent.f

    # figure out the element type
    dt = dset.datatype
    rr = jltype(f, dt)
    T = julia_repr(rr)
    ndims, offset = get_ndims_offset(f, ReadDataspace(f, dset.dataspace), collect(values(dset.attributes)))

    io = f.io
    seek(io, offset)
    dims = reverse([jlread(io, Int64) for i in 1:ndims])
    iobackend = io isa IOStream ? io : io.f
    seek(iobackend, DataLayout(f, dset.layout).data_offset)
    # May be pos != data_offset for files with custom offset
    pos = position(iobackend)
    if (pos % 8 == 0) ||
       (pos % 2 == 0 && sizeof(T) == 2) ||
       (pos % 4 == 0 && sizeof(T) == 4) ||
       (sizeof(T) == 1)
        # These are cases where we can directly mmap the data.
        Mmap.mmap(iobackend, Array{T,Int(ndims)}, (dims...,))
    else
        dims[1] *= sizeof(T)
        # A fallback for all other cases is to mmap the data as UInt8 and reinterpret it.
        reinterpret(T,
            Mmap.mmap(iobackend, Array{UInt8,Int(ndims)}, (dims...);)
        )
    end
end

"""
    allocate_early(dset::Dataset, T::DataType)

Write a dataset to file without any actual data. Reserve space according to element type and dimensions.
This may be useful in conjunction with [`readmmap`](@ref) or by explicitly writing elements afterwards using [`ArrayDataset`](@ref).
"""
function allocate_early(dset::Dataset, T::DataType)
    iswritten(dset) && throw(ArgumentError("Dataset has already been written to file"))
    # for this to work, require all information to be provided
    isnothing(dset.datatype) && throw(ArgumentError("datatype must be provided"))
    isnothing(dset.dataspace) && throw(ArgumentError("dataspace must be provided"))
    datatype = dset.datatype
    dataspace = dset.dataspace

    f = dset.parent.f
    attributes = map(collect(dset.attributes)) do (name, attr)
        attr isa WrittenAttribute && return attr
        return WrittenAttribute(f, name, attr)
        throw(ArgumentError("Invalid attribute: $a"))
    end
    writtenas = writeas(T)
    odr_ = _odr(writtenas, T, odr(writtenas))
    datasz = odr_sizeof(odr_)::Int * numel(dataspace)::Int
    psz = payload_size_without_storage_message(dataspace, datatype)::Int
    psz += sum(message_size.(attributes), init=0)
    # minimum extra space for continuation message
    psz += jlsizeof(HeaderMessage) + jlsizeof(RelOffset) + jlsizeof(Length)

    # Layout class: Use contiguous for now
    layout_class = LcContiguous
    psz += jlsizeof(Val(HmDataLayout); layout_class)
    fullsz = jlsizeof(ObjectStart) + size_size(psz) + psz + 4

    header_offset = f.end_of_data
    io = f.io
    seek(io, header_offset)
    f.end_of_data = header_offset + fullsz

    cio = begin_checksum_write(io, fullsz - 4)
    jlwrite(cio, ObjectStart(size_flag(psz)))
    write_size(cio, psz)
    write_header_message(cio, Val(HmFillValue); flags=0x09)
    write_header_message(cio, Val(HmDataspace); dataspace.dataspace_type, dimensions=dataspace.size)
    for attr in dataspace.attributes
        write_header_message(cio, f, attr)
    end
    write_header_message(cio, Val(HmDatatype), 1 | (2*isa(datatype, CommittedDatatype)); dt=datatype)
    for a in attributes
        write_header_message(cio, f, a, wsession)
    end
    # Align contiguous chunk to 8 bytes in the file
    address = f.end_of_data + 8 - mod1(f.end_of_data, 8)
    data_address = h5offset(f, address)
    write_header_message(cio, Val(HmDataLayout);
        layout_class, data_address, data_size=datasz)

    dset.header_chunk_info = (header_offset, position(cio)+20, position(cio))
    # Add NIL message replacable by continuation message
    write_continuation_placeholder(cio)
    jlwrite(io, end_checksum(cio))

    f.end_of_data = address + datasz
    seek(io, f.end_of_data)

    offset = h5offset(f, header_offset)
    !isempty(dset.name) && (dset.parent[dset.name] = offset)
    #dset.offset = offset

    # load current dataset as new dataset
    ddset = get_dataset(f, offset, dset.parent, dset.name)
    for field in fieldnames(Dataset)
        setproperty!(dset, field, getfield(ddset, field))
    end
    return offset
end

struct ArrayDataset{T, N, RR<:ReadRepresentation{T}, io} <: AbstractArray{T, N}
    f::JLDFile{io}
    dset::Dataset
    dims::NTuple{N, Int}
    data_address::Int64
    rr::RR
    writable::Bool
end
function ArrayDataset(dset::Dataset)
    isarraydataset(dset) || throw(ArgumentError("Dataset is not an array"))
    iscompressed(dset.filters) && throw(UnsupportedFeatureException("Compressed datasets are not supported."))
    f = dset.parent.f
    dt = dset.datatype
    writable = f.writable && (dset.layout.layout_class == LcContiguous)
    rr = jltype(f, !(f.plain) && dt isa SharedDatatype ? get(f.datatype_locations, dt.header_offset, dt) : dt)
    return ArrayDataset(
        f, dset,
        Int.(reverse(dset.dataspace.dimensions)),
        fileoffset(f, dset.layout.data_address),
        rr,
        writable
        )
end

function isarraydataset(dset::Dataset)
    isnothing(dset.dataspace) && return false
    ds = dset.dataspace
    if ds isa HmWrap{HmDataspace}
        return ds.dataspace_type == DS_SIMPLE || ds.dataspace_type == DS_V1
    end
    return false
end

Base.IndexStyle(::Type{<:ArrayDataset}) = IndexLinear()
Base.size(A::ArrayDataset) = A.dims
Base.getindex(dset::Dataset, I...) = ArrayDataset(dset)[I...]
Base.getindex(dset::Dataset) = read_dataset(dset)
Base.setindex!(dset::Dataset, v, i, I...) = Base.setindex!(ArrayDataset(dset), v, i, I...)

function Base.getindex(A::ArrayDataset, i::Integer)
    @boundscheck checkbounds(A, i)
    seek(A.f.io, A.data_address + (i-1)*odr_sizeof(A.rr))
    return read_scalar(A.f, A.rr, UNDEFINED_ADDRESS)
end

function Base.setindex!(A::ArrayDataset{T,N,ODR}, v, i::Integer) where {T,N,ODR}
    @boundscheck checkbounds(A, i)
    A.f.writable || throw(ArgumentError("Cannot edit in read-only mode"))
    A.writable || throw(ArgumentError("Dataset cannot be edited"))
    seek(A.f.io, A.data_address + (i-1)*odr_sizeof(A.rr))
    write_data(A.f.io, A.f, v, odr(T), datamode(ODR), JLDWriteSession())
    return v
end

using JLD2
using UnPack
using Test

@testset "UnPack-Extension" begin

    x, y = rand(2)
    m, n = rand(Int64, 2)

    # Open file and group
    path = joinpath(mktempdir(), "temp_file.jld2")
    file = jldopen(path, "w")
    file_group = JLD2.Group(file, "mygroup")

    # write into file
    @pack! file = x, y
    @pack! file_group = n, m

    # Test that entries where created
    @test "x" ∈ keys(file)
    @test "y" ∈ keys(file)
    @test "n" ∈ keys(file_group)
    @test "m" ∈ keys(file_group)

    x_ref, y_ref = x, y
    n_ref, m_ref = n, m
    x, y = 0, 0
    n, m = 0, 0

    # Test extraction of entries
    @unpack x, y = file
    @unpack n, m = file_group

    @test (x, y) == (x_ref, y_ref)
    @test (n, m) == (n_ref, m_ref)

    # Cleanup
    close(file)
    rm(path)
end

#
# Attributes
#

# TODO: fix inference when there are attributes
struct WrittenAttribute{DS<:WriteDataspace,H5T<:H5Datatype,T}
    name::String
    dataspace::DS
    datatype::H5T
    data::T
end
WrittenAttribute(name, dataspace, datatype, data) = WrittenAttribute(String(name), dataspace, datatype, data)
function WrittenAttribute(f::JLDFile, name, data::T) where T
    WrittenAttribute(String(name), WriteDataspace(f, data, objodr(data)), h5type(f, data), data)
end

struct ReadAttribute
    name::Symbol
    dataspace::ReadDataspace
    datatype::H5Datatype
    data_offset::Int64
end

const EMPTY_READ_ATTRIBUTES = ReadAttribute[]

struct AttributeHeader
    version::UInt8
    flags::UInt8
    name_size::UInt16
    datatype_size::UInt16
    dataspace_size::UInt16
end
define_packed(AttributeHeader)

jlsizeof(attr::WrittenAttribute) = 8 + sizeof(attr.name) + 1 + jlsizeof(attr.datatype) + jlsizeof(attr.dataspace) +
                                     numel(attr.dataspace) * odr_sizeof(objodr(attr.data))

function write_attribute(io::IO, f::JLDFile, attr::WrittenAttribute, wsession::JLDWriteSession)
    namelen = sizeof(attr.name)
    jlwrite(io, AttributeHeader(0x02, isa(attr.datatype, CommittedDatatype), namelen+1,
                              jlsizeof(attr.datatype), jlsizeof(attr.dataspace)))
    jlwrite(io, attr.name)
    jlwrite(io, UInt8(0))
    jlwrite(io, attr.datatype)
    jlwrite(io, attr.dataspace)
    odr = objodr(attr.data)
    write_data(io, f, attr.data, odr, datamode(odr), wsession)
end

function read_attribute(f::JLDFile, msg)
    hm = HmWrap(HmAttribute, msg)
    committed = hm.flags == 1
    !committed && hm.flags != 0 && throw(UnsupportedFeatureException())

    hm.flags & 0x10 == 0x10 && @warn "We've got a shared dataspace"
    dsm = Message(HmDataspace, f, hm.dataspace_offset)
    dataspace = ReadDataspace(f, dsm)

    data_offset = fileoffset(f, hm.data_offset)
    ReadAttribute(Symbol(hm.name), dataspace, hm.datatype, data_offset)
end

"""
    load_attributes(f::JLDFile, name::AbstractString)
    load_attributes(g::Group, name::AbstractString)
    load_attributes(g::Group)
    load_attributes(f::JLDFile, offset::RelOffset)

Return a list of attributes attached to the dataset or group.
"""
function load_attributes end

load_attributes(g::Union{JLDFile,Group}, name::AbstractString) =
    attributes(get_dataset(g, name))

function load_attributes(g::JLD2.Group)
    offset = group_offset(g)
    offset == UNDEFINED_ADDRESS && throw(InternalError("Unable to find group in file."))
    attributes(get_dataset(g.f, offset, g, ""))
end

load_attributes(f::Union{JLDFile, Group}, offset::RelOffset) =
    attributes(get_dataset(f, offset))


"""
    read_attr_data(f::JLDFile, attr::ReadAttribute)

[`jlread`](@ref) data from an attribute.
"""
read_attr_data(f::JLDFile, attr::ReadAttribute) =
    read_data(f, attr.dataspace, attr.datatype,
              DataLayout(0,LcCompact,-1,attr.data_offset))

"""
    read_attr_data(f::JLDFile, attr::ReadAttribute, expected_datatype::H5Datatype,
                   rr::ReadRepresentation)

[`jlread`](@ref) data from an attribute, assuming a specific HDF5 datatype and
[`ReadRepresentation`](@ref). If the HDF5 datatype does not match, throws an
`UnsupportedFeatureException`. This allows better type stability while
simultaneously validating the data.
"""
function read_attr_data(f::JLDFile, attr::ReadAttribute, expected_datatype::H5Datatype,
                        rr::ReadRepresentation)
    if attr.datatype == expected_datatype
        seek(f.io, attr.data_offset)
        read_dataspace = (attr.dataspace, NULL_REFERENCE, DataLayout(0,LcCompact,-1,attr.data_offset), FilterPipeline())
        return read_data(f, rr, read_dataspace)
    end
    throw(UnsupportedFeatureException())
end

# Currently we specify a 512 byte header
const FILE_HEADER_LENGTH = 512

const FORMAT_VERSION = v"0.2.0"
# Range of file format versions that can be read
# Publish patch release relaxing upper version bound
# if the imminent major release is not breaking
const COMPATIBLE_VERSIONS = (lower=v"0.1", upper=v"0.3")
const REQUIRED_FILE_HEADER = "HDF5-based Julia Data Format, version "
const FILE_HEADER = "$(REQUIRED_FILE_HEADER)$(FORMAT_VERSION)\x00 (Julia $(VERSION) $(sizeof(Int)*8)-bit $(htol(1) == 1 ? "LE" : "BE"))\x00"
@assert length(FILE_HEADER) <= FILE_HEADER_LENGTH

# Legacy File Header
const LEGACY_REQUIRED_FILE_HEADER = "Julia data file (HDF5), version 0.2.0"


function verify_file_header(f)
    io = f.io
    fname = f.path
    if f.base_address != FILE_HEADER_LENGTH
        @warn "File likely not written by JLD2. Skipping header verification."
        return
    end
    seek(io, 0)
    headermsg = String(read!(io, Vector{UInt8}(undef, length(REQUIRED_FILE_HEADER))))
    if headermsg != REQUIRED_FILE_HEADER
        if !startswith(headermsg, LEGACY_REQUIRED_FILE_HEADER)
            throw(ArgumentError(string('"', fname, "\" is not a JLD2 file")))
        else
            #@warn("This file was written with an older version of JLD2. Attempting to load data.", maxlog=1)
            return
        end
    end

    ver = VersionNumber(read_bytestring(io))
    if ver > FORMAT_VERSION
        @warn("""This file was written in a newer version of the JLD2 file format.
        Please consider updating JLD2.""", maxlog=1)
    end
    if !(COMPATIBLE_VERSIONS.lower <= ver < COMPATIBLE_VERSIONS.upper)
        @warn("""This file was written with a different version of JLD2 that may not be compatible.
         Attempting to load data.""", maxlog=1)
    end
end

function write_file_header(f)
    io = f.io
    if f.base_address >= FILE_HEADER_LENGTH
        seek(io, f.base_address - FILE_HEADER_LENGTH)
        jlwrite(io, FILE_HEADER)
    end
    # Write superblock
    seek(io, f.base_address)
    write_superblock(io,f)
    return nothing
end

function allzeros(::Type{T}) where T
    if jlsizeof(T) > 0
        first(reinterpret(T,zeros(UInt8, jlsizeof(T))))
    else
        T()
    end
end

"""
    InlineUnionEl{T1,T2}(mask::UInt8, t1::T1, t2::T2)

Custom serialization struct for two member isbits union
fields e.g. in other structs or arrays.
To indicate that `t1` is relevant the `mask` takes the value `UInt8(0)`
and for `t2` the `mask` takes the value `UInt8(255)`.
"""
struct InlineUnionEl{T1,T2}
    mask::UInt8
    t1::T1
    t2::T2
    InlineUnionEl{T1,T2}(mask::UInt8, x::T1, y::T2) where {T1,T2} = new{T1,T2}(mask, x, y)
    InlineUnionEl{T1,T2}(x::T1) where {T1,T2} = new{T1,T2}(UInt8(0), x, allzeros(T2))
    InlineUnionEl{T1,T2}(x::T2) where {T1,T2} = new{T1,T2}(UInt8(255), allzeros(T1), x)
end

#convert2union(::Union, x::InlineUnionEl) = iszero(x.mask) ? x.t1 : x.t2
# The above convert method is ambiguous for Union{Nothing, Int}
# in julia v1.0
convert2union(x::InlineUnionEl) = iszero(x.mask) ? x.t1 : x.t2

function writeasbits(T::Union)
    types = Base.uniontypes(T)
    length(types) == 2 && isbitstype(types[1]) && isbitstype(types[2])
end

@nospecializeinfer function write_dataset(f::JLDFile, @nospecialize(x::Array), wsession::JLDWriteSession, @nospecialize(compress=f.compress))
    T = eltype(x)
    offset = get_tracked(wsession, x)
    offset != UNDEFINED_ADDRESS && return offset
    if T isa Union && writeasbits(T)
        # Conversion has to be done earlier here because
        # vectors are special cased in dispatch
        y = InlineUnionEl{Base.uniontypes(T)...}.(x)
    else
        y = x
    end
    odr = objodr(y)
    write_dataset(f, WriteDataspace(f, y, odr), h5type(f, y), odr, y, wsession, compress)::RelOffset
end

# This function is identical to the one in data.jl
# except for the ReadRepresentation and the very last line where the data is
# converted back into a Union Array
function read_array(f::JLDFile, dataspace::ReadDataspace,
                    rr::ReadRepresentation{InlineUnionEl{T1,T2},RR}, layout::DataLayout,
                    filters::FilterPipeline, header_offset::RelOffset,
                    attributes::Union{Vector{ReadAttribute},Nothing}) where {T1,T2,RR}
    io = f.io
    ndims, offset = get_ndims_offset(f, dataspace, attributes)
    seek(io, offset)
    v = construct_array(io, InlineUnionEl{T1,T2}, Int(ndims))
    n = length(v)
    seek(io, layout.data_offset)
    if iscompressed(filters)
        read_compressed_array!(v, f, rr, layout.data_length, filters)
    else
        read_array!(v, f, rr)
    end

    # Union{T1, T2}[v;]
    # The above syntax is not compatible to julia v1.0
    u = Union{T1, T2}[convert2union.(v);]
    track_weakref!(f, header_offset, u)
    return u
end

using JLD2, FileIO
using Test

struct Anint; x::Int; end
struct Bparam{T}; x::T; end

@testset "Inline Union Representation" begin
    fn = mktemp()[1]*".jld2"
    u = Union{Int,Float64}[1, 2.5, 3, 4.5]
    save(fn, "u", u)
    @test all(skipmissing(u) .== skipmissing(load(fn, "u")))
    
    jldopen(fn, "r") do f
        @test u == f["u"]
        # Test again to verify that the correct object was cached
        # See issue #348
        @test u == f["u"]
    end

    u = Union{Float64, Missing}[1.0, missing, 2.0, 10.5, missing]
    save(fn, "u", u; compress=true)
    @test all(skipmissing(u) .== skipmissing(load(fn, "u")))

    u = Union{Anint, Missing}[Anint(10), missing, missing, Anint(20)]
    save(fn, "u", u)
    @test all(skipmissing(u) .== skipmissing(load(fn, "u")))

    u = Union{Anint, Float64, Int}[Anint(1), 2.5, 3]
    save(fn, "u", u)
    @test u == load(fn, "u")

    u = Union{Anint,Bparam}[Anint(1), Bparam(3)]
    save(fn, "u", u)
    @test u == load(fn, "u")

    u = Bparam[Bparam(1), Bparam(2.0)]
    save(fn, "u", u)
    @test u == load(fn, "u")

    u = Union{Float32, Missing}[rand(5,5);]
    save(fn, "u", u)
    @test u == load(fn, "u")

    u = Union{Bool, Nothing}[true, nothing, false]
    save(fn, "u", u)
    @test u == load(fn, "u")
end

ENV["JULIA_PKG_PRECOMPILE_AUTO"]=0

old_jld2_version = v"0.6.4"
filter_adds = [
    (; name="JLD2Bzip2", version=v"0.1.2")
    (; name="JLD2Lz4",   version=v"0.1.1")
]

function run_out_tree_tests(;devs=nothing, adds=nothing)
    test_dir = cp(joinpath(@__DIR__, "test"), joinpath(mktempdir(), "test"))
    setup_code = """
    using Pkg
    isnothing($(devs)) || Pkg.develop($(devs))
    isnothing($(adds)) || Pkg.add($(adds))
    Pkg.instantiate()
    Pkg.precompile()
    Pkg.status(;mode=Pkg.PKGMODE_MANIFEST)
    """
    run(`$(Base.julia_cmd()) --project=$(test_dir) -e $setup_code`)
    run(`$(Base.julia_cmd()) --project=$(test_dir) $(joinpath(test_dir, "runtests.jl"))`)
end

# Run the old JLD2's own test suite with the current filter packages swapped
# into its source tree.
function run_old_jld2_tests(old_version)
    jld2_dir = joinpath(mktempdir(), "JLD2")
    copy_code = """
    using Pkg
    Pkg.activate(; temp=true)
    Pkg.add(name="JLD2", version=$(repr(old_version)))
    using JLD2
    cp(pkgdir(JLD2), $(repr(jld2_dir)))
    """
    run(`$(Base.julia_cmd()) -e $copy_code`)
    # Files copied out of the julia package store are read-only
    chmod(jld2_dir, 0o755; recursive=true)
    # Swap in the current filter packages
    cp(joinpath(@__DIR__, "filterpkgs"), joinpath(jld2_dir, "filterpkgs"); force=true)
    test_code = """
    using Pkg
    Pkg.activate($(repr(jld2_dir)))
    Pkg.test()
    """
    run(`$(Base.julia_cmd()) -e $test_code`)
end

main_devs = [(;path=@__DIR__,)]

# current JLD2, old filters
run_out_tree_tests(devs=main_devs, adds=filter_adds)
# old JLD2, current filters
run_old_jld2_tests(old_jld2_version)

@nospecializeinfer function jldopen(@nospecialize(f::Function), args...; kws...)
    jld = jldopen(args...; kws...)
    try
        return f(jld)
    finally
        close(jld)
    end
end

"""
    @save filename var1 [var2 ...]
    @save filename {compress=true} var1 name2=var2

Write one or more variables `var1,...` from the current scope to a JLD2 file
`filename`.

For interactive use you can save all variables in the current module's global
scope using `@save filename`. More permanent code should prefer the explicit
form to avoid saving unwanted variables.

# Example

To save the string `hello` and array `xs` to the JLD2 file example.jld2:

```julia
hello = "world"
xs = [1,2,3]
@save "example.jld2" hello xs
```

For passing options to the saving command use `{}`

```julia
@save "example.jld2" {compress=true} hello xs
```

For saving variables under a different name use regular assignment syntax

```julia
@save "example.jld2" greeting=hello xarray = xs
```
"""
macro save(filename, vars...)
    fields = []
    options = []
    for var in vars
        # Capture options of the form {compress = true, mmaparrays=false}
        if @capture(var, {opts__})
            for opt in opts
                if @capture(opt, key_ = val_)
                    push!(options, :($key = $(esc(val))))
                else
                    return :(throw(ArgumentError("Invalid option syntax")))
                end
            end
        # Allow assignment syntax a = b
        elseif @capture(var, a_ = b_)
            push!(fields, :(write(f, $(string(a)), $(esc(b)), wsession)))
        # Allow single arg syntax a   → "a" = a
        elseif @capture(var, a_Symbol)
            push!(fields, :(write(f, $(string(a)), $(esc(a)), wsession)))
        else
            return :(throw(ArgumentError("Invalid field syntax")))
        end
    end
    if !isempty(fields)
        return quote
            let
                f = jldopen($(esc(filename)), "w"; $(Expr(:tuple,options...))...)
                wsession = JLDWriteSession()
                try
                    $(Expr(:block, fields...))
                catch e
                    rethrow(e)
                finally
                    close(f)
                end
            end
        end
    else
        # The next part is old code that handles saving the whole workspace
        quote
            let
                m = $(__module__)
                f = jldopen($(esc(filename)), "w"; $(Expr(:tuple,options...))...)
                wsession = JLDWriteSession()
                try
                    for vname in names(m; all=true)
                        s = string(vname)
                        if !occursin(r"^_+[0-9]*$", s) # skip IJulia history vars
                            (startswith(s, "##") || s == "ans") && continue
                            v = getfield(m, vname)
                            if !isa(v, Module)
                                try
                                    write(f, s, v, wsession)
                                catch e
                                    if isa(e, PointerException)
                                        @warn("skipping $vname because it contains a pointer")
                                    else
                                        rethrow(e)
                                    end
                                end
                            end
                        end
                    end
                finally
                    close(f)
                end
            end
        end
    end
end

"""
    @load filename var1 [var2 ...]

Load one or more variables `var1,...` from JLD2 file `filename` into the
current scope and return a vector of the loaded variable names.

For interactive use, the form `@load "somefile.jld2"` will load all variables
from `"somefile.jld2"` into the current scope. This form only supports literal
file names and should be avoided in more permanent code so that it's clear
where the variables come from.

# Example

To load the variables `hello` and `foo` from the file example.jld2, use

```julia
@load "example.jld2" hello foo
```
"""
macro load(filename, vars...)
    if isempty(vars)
        if isa(filename, Expr)
            throw(ArgumentError("filename argument must be a string literal unless variable names are specified"))
        end
        # Load all variables in the top level of the file
        vars = Symbol[]
        f = jldopen(filename)
        try
            for n in keys(f)
                if !isgroup(f, lookup_offset(f.root_group, n))
                    push!(vars, Symbol(n))
                end
            end
        finally
            close(f)
        end
    end
    return quote
        ($([esc(x) for x in vars]...),) = jldopen($(esc(filename))) do f
            ($([:(read(f, $(string(x)))) for x in vars]...),)
        end
        $(Symbol[v for v in vars]) # convert to Array
    end
end


function loadtodict!(d::Dict, g::Union{JLDFile, Group}, prefix::String="")
    for k in keys(g)
        v = g[k]
        if v isa Group
            loadtodict!(d, v, prefix*k*"/")
        else
            d[prefix*k] = v
        end
    end
    return d
end

"""
    loadnesteddict(g::Union{JLDFile, Group})
Return a dictionary with all data contained in group or file.
Nested groups are loaded as nested dictionaries.
"""
function loadnesteddict(g::Union{JLDFile,Group})
    d = Dict{String, Any}()
    for k in keys(g)
        v = g[k]
        d[k] = v isa Group ? loadnesteddict(v) : v
    end
    return d
end

"""
    load_data_or_dict(g::Union{JLDFile,Group}, varname::AbstractString)
Return the value of key `varname` but if it represents a `Group` load the group as a nested dictionary.
"""
function load_data_or_dict(g::Union{JLDFile,Group}, varname::AbstractString)
    dataset = g[varname]
    if dataset isa Group
        return loadnesteddict(dataset)
    end
    return dataset
end

# Name used in JLD2 file to identify objects stored with `save_object`
const SINGLE_OBJECT_NAME = "single_stored_object"

"""
    save_object(filename, x)

Stores an object `x` in a new JLD2 file at `filename`. If a file exists at this
path, it will be overwritten.

Since the JLD2 format requires that all objects have a name, the object will be
stored as `single_stored_object`. If you want to store more than one object, use
[`@save`](@ref) macro, [`jldopen`](@ref) or the FileIO API.

# Example

To save the string `hello` to the JLD2 file example.jld2:

```julia
hello = "world"
save_object("example.jld2", hello)
```
"""
function save_object(filename, x; kwargs...)
  jldopen(filename, "w"; kwargs...) do file
    file[SINGLE_OBJECT_NAME] = x
  end
  return
end

"""
    load_object(filename)

Returns the only available object from the JLD2 file `filename` (The stored
object name is inconsequential). If the file contains more than one or no
objects, the function throws an `ArgumentError`.

For loading more than one object, use [`@load`](@ref) macro, [`jldopen`](@ref)
or the FileIO API.

# Example

To load the only object from the JLD2 file example.jld2:

```julia
hello = "world"
save_object("example.jld2", hello)
hello_loaded = load_object("example.jld2")
```
"""
function load_object(filename)
  jldopen(filename, "r") do file
    all_keys = keys(file)
    length(all_keys) == 0 && throw(ArgumentError("File $filename does not contain any object"))
    length(all_keys) > 1 && throw(ArgumentError("File $filename contains more than one object. Use `load` or `@load` instead"))
    file[all_keys[1]] #Uses HDF5 functionality of treating the file like a dict
  end
end


"""
    jldsave(filename; kwargs...)
    jldsave(filename, compress; kwargs...)
    jldsave(filename, compress, iotype; kwargs...)

Creates a JLD2 file at `filename` and stores the variables given as keyword arguments.

# Examples

```julia
jldsave("example.jld2"; a=1, b=2, c)
```

is equivalent to

```julia
jldopen("example.jld2", "w") do f
    f["a"] = 1
    f["b"] = 2
    f["c"] = c
end
```

To choose the io type `IOStream` instead of the default `MmapIO` use 
`jldsave(fn, IOStream; kwargs...)`.
"""
@nospecializeinfer function jldsave(
filename::AbstractString,
compress=false,
iotype::Union{Type{IOStream},Type{MmapIO}}=default_iotype(); 
                    @nospecialize(kwargs...)
                    )
    f = jldopen(filename, "w"; compress, iotype)
    try
        wsession = JLDWriteSession()
        for (k, v) in pairs(kwargs)
            write(f, string(k), v, wsession)
        end
    finally
        close(f)
    end
end

jldsave(filename::AbstractString, iotype::Union{Type{IOStream},Type{MmapIO}}; kwargs...) = 
    jldsave(filename, false, iotype; kwargs...)

#
# Datatypes
#

@enum DatatypeClass::UInt8 begin
    DT_FIXED_POINT = 0x00
    DT_FLOATING_POINT = 0x01
    DT_TIME = 0x02
    DT_STRING = 0x03
    DT_BITFIELD = 0x04
    DT_OPAQUE = 0x05
    DT_COMPOUND = 0x06
    DT_REFERENCE = 0x07
    DT_ENUMERATED = 0x08
    DT_VARIABLE_LENGTH = 0x09
    DT_ARRAY = 0x0a
    DT_SHARED = 0xff # placeholder for shared datatypes
end
Base.convert(::Type{UInt8}, l::DatatypeClass) = UInt8(l)

jlwrite(io::IO, dt::DatatypeClass) = jlwrite(io, UInt8(dt) | UInt8(3) << 4)
Base.:(==)(dt::DatatypeClass, x::Integer) = UInt8(dt) == x%16
Base.:(==)(x::Integer, dt::DatatypeClass) = UInt8(dt) == x%16

# This is the description for:
#    Strings
#    Opaque datatypes
#    References
struct BasicDatatype <: H5Datatype
    class::UInt8
    bitfield1::UInt8
    bitfield2::UInt8
    bitfield3::UInt8
    size::UInt32
end
define_packed(BasicDatatype)
StringDatatype(::Type{String}, size::Integer) =
    BasicDatatype(UInt8(DT_STRING) | 0x3<<4, 0x11, 0x00, 0x00, size)
OpaqueDatatype(size::Integer) =
    BasicDatatype(UInt8(DT_OPAQUE) | 0x3<<4, 0x00, 0x00, 0x00, size) # XXX make sure ignoring the tag is OK
ReferenceDatatype() =
    BasicDatatype(UInt8(DT_REFERENCE) | 0x3<<4, 0x00, 0x00, 0x00, jlsizeof(RelOffset))

function Base.:(==)(dt1::BasicDatatype, dt2::BasicDatatype)
    ret = true
    ret &= (dt1.class << 4) == (dt2.class << 4)
    ret &= dt1.bitfield1 == dt2.bitfield1
    ret &= dt1.bitfield2 == dt2.bitfield2
    ret &= dt1.bitfield3 == dt2.bitfield3
    ret &= dt1.size == dt2.size
    ret
end

function jlread(io::IO, ::Type{H5Datatype})
    dtclass = jlread(io, UInt8) % 16
    seek(io, position(io)-1)
    if dtclass == DT_FIXED_POINT
        jlread(io, FixedPointDatatype)
    elseif dtclass == DT_FLOATING_POINT
        jlread(io, FloatingPointDatatype)
    elseif dtclass in (DT_STRING, DT_OPAQUE, DT_REFERENCE)
        jlread(io, BasicDatatype)
    elseif dtclass == DT_COMPOUND
        jlread(io, CompoundDatatype)
    elseif dtclass == DT_VARIABLE_LENGTH
        jlread(io, VariableLengthDatatype)
    elseif dtclass == DT_BITFIELD
        jlread(io, BitFieldDatatype)
    elseif dtclass == DT_TIME
        throw(UnsupportedFeatureException("Time datatype (rarely used) not supported"))
    elseif dtclass == DT_ARRAY
        jlread(io, ArrayDatatype)
    elseif dtclass == DT_ENUMERATED
        jlread(io, EnumerationDatatype)
    else
        throw(UnsupportedFeatureException("invalid datatype class $dtclass"))
    end
end

struct FixedPointDatatype <: H5Datatype
    class::UInt8
    bitfield1::UInt8
    bitfield2::UInt8
    bitfield3::UInt8
    size::UInt32
    bitoffset::UInt16
    bitprecision::UInt16
end
define_packed(FixedPointDatatype)
FixedPointDatatype(size::Integer, signed::Bool) =
    FixedPointDatatype(UInt8(DT_FIXED_POINT) | 3<<4, ifelse(signed, 0x08, 0x00), 0x00, 0x00, size, 0, 8*size)

struct BitFieldDatatype <: H5Datatype
    class::UInt8
    bitfield1::UInt8
    bitfield2::UInt8
    bitfield3::UInt8
    size::UInt32
    bitoffset::UInt16
    bitprecision::UInt16
end
define_packed(BitFieldDatatype)
BitFieldDatatype(size) =
    BitFieldDatatype(UInt8(DT_BITFIELD) | 0x3<<4, 0x00, 0x00, 0x00, size, 0, 8*size)


struct FloatingPointDatatype <: H5Datatype
    class::UInt8
    bitfield1::UInt8
    bitfield2::UInt8
    bitfield3::UInt8
    size::UInt32
    bitoffset::UInt16
    bitprecision::UInt16
    exponentlocation::UInt8
    exponentsize::UInt8
    mantissalocation::UInt8
    mantissasize::UInt8
    exponentbias::UInt32
end
define_packed(FloatingPointDatatype)

class(dt::Union{BasicDatatype,FixedPointDatatype,FloatingPointDatatype}) = dt.class

function Base.:(==)(fp1::FloatingPointDatatype, fp2::FloatingPointDatatype)
    ret = true
    ret &= (fp1.class << 4) == (fp2.class << 4) # compare only class and not version
    ret &= fp1.bitfield1 == fp2.bitfield1
    ret &= fp1.bitfield2 == fp2.bitfield2
    ret &= fp1.bitfield3 == fp2.bitfield3
    ret &= fp1.size == fp2.size
    ret &= fp1.bitoffset == fp2.bitoffset
    ret &= fp1.bitprecision == fp2.bitprecision
    ret &= fp1.exponentlocation == fp2.exponentlocation
    ret &= fp1.exponentsize == fp2.exponentsize
    ret &= fp1.mantissalocation == fp2.mantissalocation
    ret &= fp1.mantissasize == fp2.mantissasize
    ret &= fp1.exponentbias == fp2.exponentbias
    ret
end

struct CompoundDatatype <: H5Datatype
    size::UInt32
    names::Vector{Symbol}
    offsets::Vector{Int}
    members::Vector{H5Datatype}

    function CompoundDatatype(size, names, offsets, members)
        length(names) == length(offsets) == length(members) ||
            throw(ArgumentError("names, offsets, and members must have same length"))
        new(size, names, offsets, members)
    end
end

function jltype(f::JLDFile, dt::CompoundDatatype)
    field_datatypes = OrderedDict{String, RelOffset}(string.(dt.names) .=> fill(NULL_REFERENCE, length(dt.names)))
    odr = reconstruct_odr(f, dt, field_datatypes)
    T = NamedTuple{tuple(dt.names...), odr.parameters[2]}
    return MappedRepr{T, odr}()    
end

Base.:(==)(x::CompoundDatatype, y::CompoundDatatype) =
    x.size == y.size && x.names == y.names && x.offsets == y.offsets &&
    x.members == y.members
Base.hash(::CompoundDatatype, h::UInt) = throw(ArgumentError("hash not defined for CompoundDatatype"))

class(dt::CompoundDatatype) = DT_COMPOUND
function jlsizeof(dt::CompoundDatatype)
    sz = jlsizeof(BasicDatatype) + size_size(dt.size)*length(dt.names)
    for i = 1:length(dt.names)
        # Extra byte for null padding of name
        sz += symbol_length(dt.names[i]) + 1 + jlsizeof(dt.members[i])
    end
    sz::Int
end

function jlwrite(io::IO, dt::CompoundDatatype)
    n = length(dt.names)
    jlwrite(io, BasicDatatype(UInt8(DT_COMPOUND) | 0x3<<4, n % UInt8, (n >> 8) % UInt8, 0x00, dt.size))
    for i = 1:length(dt.names)
        # Name
        name = dt.names[i]
        name_ptr = Base.unsafe_convert(Ptr{UInt8}, name)
        unsafe_write(io, name_ptr, symbol_length(name)+1)

        # Byte offset of member
        if dt.size <= typemax(UInt8)
            jlwrite(io, UInt8(dt.offsets[i]))
        elseif dt.size <= typemax(UInt16)
            jlwrite(io, UInt16(dt.offsets[i]))
        else
            jlwrite(io, UInt32(dt.offsets[i]))
        end

        # Member type message
        jlwrite(io, dt.members[i])
    end
end

function jlread(io::IO, ::Type{CompoundDatatype})
    dt = jlread(io, BasicDatatype)
    version = dt.class >> 4
    nfields = UInt16(dt.bitfield1) | UInt16(dt.bitfield2) << 8
    dt.bitfield3 == 0 || throw(UnsupportedFeatureException())

    names = Vector{Symbol}(undef, nfields)
    offsets = Vector{Int}(undef, nfields)
    members = Vector{H5Datatype}(undef, nfields)
    for i = 1:nfields
        # Name
        names[i] = Symbol(read_bytestring(io))
        # Byte offset of member
        if version == 2 || version == 1
            skip(io, 8-mod1(sizeof(names[i])+1,8))
            offsets[i] = jlread(io, UInt32)
        elseif dt.size <= typemax(UInt8)
            offsets[i] = jlread(io, UInt8)
        elseif dt.size <= typemax(UInt16)
            offsets[i] = jlread(io, UInt16)
        else
            offsets[i] = jlread(io, UInt32)
        end

        if version == 1
            # supports array members
            # can encode dimensionality here
            dimensionality = jlread(io, UInt8)
            skip(io, 3)
            skip(io, 4) # dimension permutation
            skip(io, 4)
            skip(io, 16)
        end

        # Member type message
        members[i] = jlread(io, H5Datatype)
    end

    CompoundDatatype(dt.size, names, offsets, members)
end

struct VariableLengthDatatype{T<:H5Datatype} <: H5Datatype
    class::UInt8
    bitfield1::UInt8
    bitfield2::UInt8
    bitfield3::UInt8
    size::UInt32
    basetype::T
end
VariableLengthDatatype(basetype::H5Datatype) =
    VariableLengthDatatype{typeof(basetype)}(UInt8(DT_VARIABLE_LENGTH) | 0x3<<4, 0x00, 0x00, 0x00, 8+jlsizeof(RelOffset), basetype)
VariableLengthDatatype(class, bitfield1, bitfield2, bitfield3, size, basetype::H5Datatype) =
    VariableLengthDatatype{typeof(basetype)}(class, bitfield1, bitfield2, bitfield3, size, basetype)

Base.:(==)(x::VariableLengthDatatype, y::VariableLengthDatatype) =
    x.class<<4 == y.class<<4 && x.bitfield1 == y.bitfield1 &&
    x.bitfield2 == y.bitfield2 && x.size == y.size &&
    x.basetype == y.basetype
Base.hash(::VariableLengthDatatype, h::UInt) = throw(ArgumentError("hash not defined for CompoundDatatype"))

class(dt::VariableLengthDatatype) = dt.class
jlsizeof(dt::VariableLengthDatatype) =
    jlsizeof(BasicDatatype) + jlsizeof(dt.basetype)

function jlwrite(io::IO, dt::VariableLengthDatatype)
    jlwrite(io, BasicDatatype(UInt8(DT_VARIABLE_LENGTH) | 0x3<<4, dt.bitfield1, dt.bitfield2, dt.bitfield3, dt.size))
    jlwrite(io, dt.basetype)
end

function jlread(io::IO, ::Type{VariableLengthDatatype})
    dtype = jlread(io, BasicDatatype)
    dt = jlread(io, H5Datatype)
    VariableLengthDatatype(dtype.class, dtype.bitfield1, dtype.bitfield2, dtype.bitfield3, dtype.size, dt)
end

jlsizeof(::CommittedDatatype) = 2 + jlsizeof(RelOffset)

function jlwrite(io::IO, dt::CommittedDatatype)
    jlwrite(io, UInt8(3))
    jlwrite(io, UInt8(2))
    jlwrite(io, dt.header_offset)
end

@nospecializeinfer function commit(f::JLDFile,
        @nospecialize(dt::H5Datatype), 
        attrs::Tuple{Vararg{WrittenAttribute}}=())
    psz = jlsizeof(Val(HmDatatype), 64; dt)
    psz += jlsizeof(HeaderMessage) * (length(attrs))
    for attr in attrs
        psz += jlsizeof(attr)
    end
    io = f.io

    sz = jlsizeof(ObjectStart) + size_size(psz) + psz
    offset = f.end_of_data
    seek(io, offset)
    f.end_of_data = offset + sz + 4

    cio = begin_checksum_write(io, sz)
    jlwrite(cio, ObjectStart(size_flag(psz)))
    write_size(cio, psz)
    write_header_message(cio, Val(HmDatatype), 64;  dt)
    for attr in attrs
        write_header_message(cio, f, attr)
    end
    jlwrite(io, end_checksum(cio))
end

# Read the actual datatype for a committed datatype
function read_shared_datatype(f::JLDFile, cdt::Union{SharedDatatype, CommittedDatatype})
    datatype::H5Datatype = PlaceholderH5Datatype()
    attrs = ReadAttribute[]

    for msg in HeaderMessageIterator(f, cdt.header_offset)
        if msg.type == HmDatatype
            datatype = HmWrap(HmDatatype, msg).dt
        elseif msg.type == HmAttribute
            push!(attrs, read_attribute(f, msg))
        elseif (msg.hflags & 2^3) != 0
            throw(UnsupportedFeatureException())
        end
    end
    if datatype isa PlaceholderH5Datatype
        throw(InvalidDataException("Did not find datatype message"))
    end
    return datatype, attrs
end

struct FixedLengthString{T<:AbstractString}
    length::Int
end

# Add julia_repr method for FixedLengthString
julia_repr(::FixedLengthString{T}) where T = T


struct ArrayDatatype <: H5Datatype
    class::UInt8
    bitfield1::UInt8
    bitfield2::UInt8
    bitfield3::UInt8
    dimensionality::UInt8
    dims::Vector{UInt32}
    base_type::H5Datatype
end

function jlread(io::IO, ::Type{ArrayDatatype})
    dt = jlread(io, BasicDatatype)
    version = dt.class >> 4
    dimensionality = jlread(io, UInt8)
    version == 2 && skip(io, 3)
    dims = jlread(io, UInt32, dimensionality)
    if version == 2
        # unsupported permutation index
        skip(io, 4*dimensionality)
    end
    base_type = jlread(io, H5Datatype)
    ArrayDatatype(dt.class, 0x0, 0x0, 0x0, dimensionality, dims, base_type)
end

struct ArrayPlaceHolder{T, D} end

odr_sizeof(::Type{ArrayPlaceHolder{T,D}}) where {T,D} = Int(odr_sizeof(T)*prod(D))

function jltype(f::JLDFile, dt::ArrayDatatype)
    rr = jltype(f, dt.base_type)
    T = julia_repr(rr)
    MappedRepr{Array{T, Int(dt.dimensionality)}, ArrayPlaceHolder{rr, tuple(dt.dims...)}}()
end


function jlconvert(::MappedRepr{Array{T,D}, ArrayPlaceHolder{RR, DIMS}}, f::JLDFile, ptr::Ptr, 
                    header_offset::RelOffset) where {T, D, RR, DIMS}
    v = Array{T, D}(undef, reverse(DIMS)...)
    for i=1:prod(DIMS)
        v[i] = jlconvert(RR, f, ptr, header_offset)
        ptr += jlsizeof(file_repr(RR))
    end
    return v
end

struct EnumerationDatatype <: H5Datatype
    class::UInt8
    bitfield1::UInt8
    bitfield2::UInt8
    bitfield3::UInt8
    base_type::DataType
    names::Vector{String}
    values::Vector{<:Any}
end

function jlread(io::IO, ::Type{EnumerationDatatype})
    dt = jlread(io, BasicDatatype)
    version = dt.class >> 4
    num_members = dt.bitfield1 | UInt16(dt.bitfield2)<<8
    base_type = jlread(io, BasicDatatype)
    T = uintofsize(base_type.size)
    # assume that it is an Integer
    names = String[]
    values = Any[]
    for _=1:num_members
        name = read_bytestring(io)
        push!(names, name)
        version < 3 && skip(io, 8-mod1(sizeof(name), 8))
        push!(values, jlread(io, T))
    end
    return EnumerationDatatype(dt.class, dt.bitfield1, dt.bitfield2, dt.bitfield3,
                                T, names, values)
end

function jltype(f::JLDFile, dt::EnumerationDatatype)
    SameRepr{dt.base_type}()
end

# Can't read big endian ints 

"""
JLD2.Filters

This module contains the interface for using filters in JLD2.jl.
"""
module Filters

using JLD2: JLD2, MemoryBackedIO, ensureroom, Hmessage, HmWrap, HmFilterPipeline, jlread, read_bytestring, HeaderMessage, Length, RelOffset, JLDFile, jlwrite
using JLD2: odr_sizeof, h5convert!

"""
    Filter

Abstract type to describe HDF5 Filters.
"""
abstract type Filter end

"""
    filterid(F) where {F <: Filter}


The internal filter id of a filter of type `F`.
"""
function filterid end
filterid(x::Filter) = filterid(typeof(x))

"""
    filtername(::Type{F}) where {F<:Filter}

What is the name of a filter? Defaults to "Unnamed Filter"
Returns a String describing the filter.
Filters with an id <= 255 do not need to define a filtername.
"""
filtername(::Type{F}) where {F<:Filter} = "Unnamed Filter"
filtername(x::Filter) = filtername(typeof(x))

"""
    client_values(::Filter)
Retrieve the client values of a filter.
Depending on the filter type, this may include something like a compression level.
"""
client_values(::Filter) = ()

"""
    filtertype(id)

Retrieve the filter type for a given id.
"""
function filtertype end
filtertype(id::Integer) = filtertype(Val(Int(id)))
filtertype(::Val) = nothing

"""
    apply_filter!(filter, ref, forward::Bool=true)

Apply the filter to the `UInt8` vector stored in `ref`.
By default, the filter is applied in the forward direction (compression).
Setting `forward` to `false` applies the filter in the reverse direction (decompression).
The result is stored back in `ref` and the function returns an integer return code (0 on success).
"""
function apply_filter! end

"""
    apply_filter!(filter, ref, forward::Bool=true, output_size::Union{Nothing,Integer}=nothing)

Apply the filter to the `UInt8` vector stored in `ref`.
By default, the filter is applied in the forward direction (compression).
Setting `forward` to `false` applies the filter in the reverse direction (decompression).
The result is stored back in `ref` and the function returns an integer return code (0 on success).
`output_size` is a hint for the expected output size, useful for decompression.
"""
apply_filter!(filter, ref, forward::Bool, output_size) = apply_filter!(filter, ref, forward)


"""
    set_local(filter, odr, dataspace, datasetcreationprops) -> filter

Some filters use information about the dataset, like element size, element type, and layout. Filters may optionally implement this function for this purpose.
"""
set_local(filter::Filter, odr, dataspace, datasetcreationprops) = filter

"""
    FilterPipeline(filters)

Container for a sequence of JLD2 compression filters.
"""
struct FilterPipeline{T}
    filters::T
    function FilterPipeline(filters::Vararg)
        @assert all(x -> x isa Filter, filters)
        new{typeof(filters)}(filters)
    end
end
FilterPipeline(filters::Array{<:Filter}) = FilterPipeline(filters...)
FilterPipeline(filters::Tuple) = FilterPipeline(filters...)

iscompressed(fp::FilterPipeline) = !isempty(fp.filters)
Base.iterate(fp::FilterPipeline, state=1) = iterate(fp.filters, state)
Base.length(fp::FilterPipeline) = length(fp.filters)

# General case: serialize data to a buffer, then compress it
function compress(fp::FilterPipeline, data::Array{T}, odr::Type, f::JLDFile, wsession) where {T}
    buf = Vector{UInt8}(undef, odr_sizeof(odr) * length(data))
    @GC.preserve buf begin
        cp = Ptr{Cvoid}(pointer(buf))
        @simd for i = 1:length(data)
            @inbounds h5convert!(cp, odr, f, data[i], wsession)
            cp += odr_sizeof(odr)
        end
    end
    ref = Ref(buf)
    retcodes = map(fil -> apply_filter!(fil, ref), fp)
    ref[], retcodes
end

# Special case of `samelayout` data: Use unsafe_wrap to avoid copying
function compress(fp::FilterPipeline, data::Array{T}, odr::Type{T}, f::JLDFile, wsession) where {T}
    GC.@preserve data begin
        buf = unsafe_wrap(
            Vector{UInt8},
            Ptr{UInt8}(pointer(data)),
            odr_sizeof(odr) * length(data)
        )
        ref = Ref(buf)
        retcodes = map(fil -> apply_filter!(fil, ref), fp)
        # Do a copy if all compression failed to not return the original unsafe_wrap
        ref[] === buf && (ref[] = copy(buf))
        ref[], retcodes
    end
end

function decompress(filter::FilterPipeline, io::IO, data_length, uncompressed_size::Union{Nothing,Integer}=nothing)
    buf = read!(io, Vector{UInt8}(undef, data_length))
    _decompress(filter, buf, uncompressed_size)
end

function decompress(filter::FilterPipeline, io::MemoryBackedIO, data_length, uncompressed_size::Union{Nothing,Integer}=nothing)
    ensureroom(io, data_length)
    buf = unsafe_wrap(Array, Ptr{UInt8}(io.curptr), data_length)
    _decompress(filter, buf, uncompressed_size)
end

function _decompress(fp::FilterPipeline, buf::Vector{UInt8}, uncompressed_size::Union{Nothing,Integer}=nothing)
    ref = Ref(buf)
    for filter in reverse(fp.filters)
        apply_filter!(filter, ref, false, uncompressed_size)
    end
    ref[]
end

# For loading need filter_ids as keys
const KNOWN_FILTERS = Dict(
    UInt16(1) => ("Deflate", "JLD2"),
    UInt16(2) => ("Shuffle", "JLD2"),
    UInt16(307) => ("Bzip2Filter", "JLD2Bzip2"),
    UInt16(32004) => ("LZ4Filter", "JLD2Lz4"),
    UInt16(32015) => ("ZstdFilter", "JLD2"),
)

function normalize_filters(compress)
    if compress isa Bool && compress == false
        return FilterPipeline(())
    elseif compress isa Bool && compress == true
        return FilterPipeline(Deflate())
    elseif compress isa FilterPipeline
        return compress
    elseif compress isa Filter
        return FilterPipeline(compress)
    elseif compress isa Vector && eltype(compress) <: Filter
        return FilterPipeline(compress)
    end
    throw(ArgumentError("Failed to interpret the compression argument."))
end


##############################################################################
## Shuffle Filter implementation
##############################################################################
"""
    Shuffle() <: Filter

The Shuffle filter can be used as part of a filter pipeline to compress datasets.
It rearranges the bytes of elements in an array to improve compression
efficiency. It is not a compression filter by itself, but can be used in conjunction
with other compression filters like `Deflate` or `ZstdFilter`.

It can be useful when the array, for example, contains unsigned integer `UInt64` and all
values are small. Then all the upper bytes of the eight byte integer are zero.
This filter will rearrange the bytes so that all the least significant bytes are at the
beginning of the array, followed by the second least significant bytes, and so on, which
simplifies the compression of the data.
"""
struct Shuffle <: Filter
    element_size::UInt32
end
Shuffle() = Shuffle(UInt32(0))
filterid(::Type{Shuffle}) = UInt16(2)
client_values(filter::Shuffle) = (filter.element_size,)
filtertype(::Val{2}) = Shuffle

function set_local(fil::Shuffle, odr, dataspace, datasetcreationprops)
    Shuffle(UInt32(odr_sizeof(odr)))
end

function apply_filter!(fil::Shuffle, ref, forward::Bool=true, output_size::Union{Nothing,Integer}=nothing)
    buf = ref[]
    (; element_size) = fil
    nbytes = length(buf)
    @assert length(buf) % element_size == 0
    nelems = nbytes ÷ element_size
    newbuf = similar(buf)
    for n = eachindex(newbuf)
        # Convert to an Int64 to avoid overflow on 32bit systems
        j = 1 + Int64(n - 1) * nelems
        i = mod1(j, nbytes) + (j - 1) ÷ nbytes
        if forward
            newbuf[i] = buf[n]
        else
            newbuf[n] = buf[i]
        end
    end
    ref[] = newbuf
    return 0
end

##############################################################################
## Deflate Filter implementation
##############################################################################
using ChunkCodecLibZlib: ZlibEncodeOptions, ZlibDecodeOptions, encode, decode

"""
    Deflate <: Filter

The Deflate filter can be used to compress datasets.
It uses the well-known and widely used zlib (deflate) compression algorithm.
This is filter id 1.

## Keyword arguments:
- `level::Integer = 5`: Compression level, between 0 and 9. Default is 5.

  Larger numbers lead to better compression, but also to longer runtime.
"""
struct Deflate <: Filter
    level::Cuint
    Deflate(level) = new(clamp(level, 0, 9))
end
Deflate(; level::Integer=5) = Deflate(level)

filterid(::Type{Deflate}) = UInt16(1)
client_values(filter::Deflate) = (filter.level, )
filtertype(::Val{1}) = Deflate

function apply_filter!(filter::Deflate, ref, forward::Bool=true, output_size::Union{Nothing,Integer}=nothing)
    if forward
        ref[] = encode(ZlibEncodeOptions(; filter.level), ref[])
    else
        if output_size !== nothing
             ref[] = decode(ZlibDecodeOptions(), ref[]; size_hint=output_size)
        else
             ref[] = decode(ZlibDecodeOptions(), ref[])
        end
    end
    return 0
end

##############################################################################
## Zstd Filter implementation
##############################################################################
using ChunkCodecLibZstd: ChunkCodecLibZstd, ZstdEncodeOptions, ZstdDecodeOptions

"""
    ZstdFilter <: Filter

The ZstdFilter can be used to compress datasets using the Zstandard compression algorithm.
This is filter id 32015.

## Keyword arguments:
- `level::Integer = 3`: Compression level, regular levels are 1-22.

  Levels ≥ 20 should be used with caution, as they require more memory.
  The zstd library also offers negative compression levels,
  which extend the range of speed vs. ratio preferences.
  The lower the level, the faster the speed (at the cost of compression).
  0 is a special value for the default level.
  The level will be clamped to the range allowed by the zstd library.

"""
struct ZstdFilter <: Filter
    level::Int32
    ZstdFilter(level) = new(min(level % Int32,
        ChunkCodecLibZstd.ZSTD_maxCLevel())
    )
end
function ZstdFilter(; level::Integer=Int32(3))
    # zstd c library requires Int32 level
    _level = clamp(level, Int32)
    ZstdFilter(_level)
end

filterid(::Type{ZstdFilter}) = UInt16(32015)
filtername(::Type{ZstdFilter}) = "ZSTD"
client_values(filter::ZstdFilter) = (filter.level % UInt32, )
filtertype(::Val{32015}) = ZstdFilter

function apply_filter!(filter::ZstdFilter, ref, forward::Bool=true, output_size::Union{Nothing,Integer}=nothing)
    if forward
        ref[] = encode(ZstdEncodeOptions(; filter.level), ref[])
    else
        if output_size !== nothing
             ref[] = decode(ZstdDecodeOptions(), ref[]; size_hint=output_size)
        else
             ref[] = decode(ZstdDecodeOptions(), ref[])
        end
    end
    return 0
end



############################################################################################
## Intermediate representation and reading/writing of filter pipelines to file
############################################################################################

struct WrittenFilter
    id::UInt16
    flags::UInt16
    name::String
    client_data::Vector{UInt32}
end

struct WrittenFilterPipeline
    filters::Vector{WrittenFilter}
end

WrittenFilterPipeline() = WrittenFilterPipeline(WrittenFilter[])
iscompressed(fp::WrittenFilterPipeline) = !isempty(fp.filters)

function WrittenFilterPipeline(msg_::Hmessage)
    msg = HmWrap(HmFilterPipeline, msg_)
    version = msg.version
    nfilters = msg.nfilters
    io = msg.m.io
    seek(io, msg.m.address + 2)
    version == 1 && skip(io, 6)
    filters = map(1:nfilters) do _
        id = jlread(io, UInt16)
        name_length = (version == 2 && id < 255) ? zero(UInt16) : jlread(io, UInt16)
        flags = jlread(io, UInt16)
        nclient_vals = jlread(io, UInt16)
        name = iszero(name_length) ? "" : read_bytestring(io)
        skip(io, max(0, name_length - length(name) - 1))
        client_data = jlread(io, UInt32, nclient_vals)
        (version == 1 && isodd(nclient_vals)) && skip(io, 4)
        WrittenFilter(id, flags, name, client_data)
    end
    return WrittenFilterPipeline(filters)
end

FilterPipeline(hm::Hmessage) =
    FilterPipeline(WrittenFilterPipeline(hm))

FilterPipeline(fp::WrittenFilterPipeline) =
    FilterPipeline(Filter[Filter(fil) for fil in fp.filters])


function Filter(fil::WrittenFilter)
    F = filtertype(fil.id)
    if isnothing(F)
        if haskey(KNOWN_FILTERS, fil.id)
            filname, pkg = KNOWN_FILTERS[fil.id]
            throw(ArgumentError("""
            Written dataset is encoded with filter $(filname) from package $(pkg).
            Make sure to load the package before reading the dataset.
            """))
        else
            throw(ArgumentError("""
            Written dataset is encoded with unknown filter with id $(fil.id) and
            description "$(fil.name)".
            If you think this is a bug, please open an issue at https://github.com/JuliaIO/JLD2.jl/
            """))
        end
    end
    return F(fil.client_data...)
end


function pipeline_message_size(fp::FilterPipeline)
    sz = 4 + 2
    for filter in fp
        sz += 6 + 4 * length(Filters.client_values(filter))
        if filterid(filter) > 255
            sz += 2
            fnamelen = length(filtername(filter)) + 1
            fnamelen += 8 - mod1(fnamelen, 8)
            sz += fnamelen
        end
    end
    sz
end

function write_filter_pipeline_message(io, fp::FilterPipeline)
    hmsize = pipeline_message_size(fp) - 4
    jlwrite(io, HeaderMessage(HmFilterPipeline, hmsize, 0))
    jlwrite(io, UInt8(2))                   # Version
    jlwrite(io, UInt8(length(fp.filters)))  # Number of Filters

    for filter in fp.filters
        filter_id = filterid(filter)
        client_data = client_values(filter)
        if filter_id > 255
            filter_name = filtername(filter)
            fnamelen = length(filter_name) + 1
            fnamelen += 8 - mod1(fnamelen, 8)
            padding = fnamelen - length(filter_name)
        end
        jlwrite(io, filter_id)                # Filter Identification Value
        filter_id > 255 && jlwrite(io, UInt16(fnamelen))
        # Length of Filter Name
        jlwrite(io, UInt16(0))                # Flags
        jlwrite(io, UInt16(length(client_data))) # Number of Client Data Values
        filter_id > 255 && jlwrite(io, filter_name) # Filter Name
        filter_id > 255 && (padding > 0) && jlwrite(io, zeros(UInt8, padding))
        for v in client_data
            jlwrite(io, UInt32(v))     # Client Data (Compression Level)
        end
    end
    nothing
end

end # module

# Initial ODR for DataType
const DataTypeODR = OnDiskRepresentation{(0, odr_sizeof(Vlen{String})),Tuple{String,Vector{Any}},Tuple{Vlen{String},Vlen{RelOffset}}, odr_sizeof(Vlen{String})+odr_sizeof(Vlen{RelOffset})}

const NULL_COMMITTED_DATATYPE = CommittedDatatype(UNDEFINED_ADDRESS, 0)

function track_weakref!(f::JLDFile, header_offset::RelOffset, @nospecialize v)
    header_offset !== NULL_REFERENCE && (f.jloffset[header_offset] = WeakRef(v))
    nothing
end

function track_weakref_if_untracked!(f::JLDFile, header_offset::RelOffset, @nospecialize v)
    if header_offset !== NULL_REFERENCE
        if !haskey(f.jloffset, header_offset) || isnothing(f.jloffset[header_offset].value)
            f.jloffset[header_offset] = WeakRef(v)
        end
    end
    nothing
end

## Generic machinery

# Carries the type and on-disk representation of data to be read from
# the disk
odr_sizeof(::ReadRepresentation{T,S}) where {T,S} = odr_sizeof(S)::Int

# Determines whether a specific field type should be saved in the file
function hasfielddata(@nospecialize(T), encounteredtypes=DataType[])::Bool
    T === Union{} && return false
    !isconcretetype(T) && return true
    T = T::DataType
    T in encounteredtypes && return true
    push!(encounteredtypes, T)
    (ismutabletype(T) || T <: Type) && return true
    hasdata(T, encounteredtypes)
end

# Determines whether a specific type has fields that should be saved in the file
@nospecializeinfer function hasdata(@nospecialize(T::DataType), encounteredtypes=DataType[])::Bool
    isempty(T.types) && sizeof(T) != 0 && return true
    for ty in T.types
        hasfielddata(writeas(ty), copy(encounteredtypes)) && return true
    end
    false
end

# Gets the size of an on-disk representation
function odr_sizeof(::Type{OnDiskRepresentation{Offsets,JLTypes,H5Types,Size}}) where {Offsets,JLTypes,H5Types,Size}
    Size::Int
end

# Determines whether a type will have the same layout on disk as in memory
function samelayout(@nospecialize(T::DataType))::Bool
    isempty(T.types) && return true
    offset = 0
    for i = 1:length(T.types)
        offset != fieldoffset(T, i) && return false
        ty = T.types[i]
        ty !== writeas(ty) && return false
        !samelayout(ty) && return false
        offset += sizeof(ty)
    end
    return offset == Base.aligned_sizeof(T)
end
samelayout(::Type) = false

fieldnames(@nospecialize(x::Type{<:Tuple})) = [Symbol(i) for i = 1:length(x.types)]
fieldnames(@nospecialize x) = collect(Base.fieldnames(x))

const MAX_INLINE_SIZE = 2^10
# fieldodr gives the on-disk representation of a field of a given type,
# which is either always initialized (initialized=true) or potentially
# uninitialized (initialized=false)
function fieldodr(::Type{T}, initialized::Bool) where T
    if isconcretetype(T)
        if !hasfielddata(T)
            # A ghost type, so no need to store at all
            return nothing
        elseif isa(T, DataType) && sizeof(T) ≤ MAX_INLINE_SIZE
            if isbitstype(T)
                return odr(T)
            elseif !ismutabletype(T)
                return initialized ? odr(T) : RelOffset
            end
        end
    end
    RelOffset
end

# h5fieldtype is fieldodr's HDF5 companion. It should give the HDF5
# datatype reflecting the on-disk representation.
@nospecializeinfer function h5fieldtype(f::JLDFile, @nospecialize(writeas), @nospecialize(readas::Type),
                                initialized::Initialized)::Union{CommittedDatatype, H5Datatype, Nothing}
    T = writeas
    if isconcretetype(T)
        if !hasfielddata(T)
            return nothing
        elseif (isbitstype(T) || (isa(initialized, Type{Val{true}}) && !ismutabletype(T))) && sizeof(T) ≤ MAX_INLINE_SIZE
            @lookup_committed f T
            if isempty(T.types)
                # Opaque datatype
                return commit(f, OpaqueDatatype(sizeof(T)), T, readas)
            else
                # Compound type
                return commit_compound(f, fieldnames(T), T, readas)
            end
        end
    end
    ReferenceDatatype()
end


# objodr gives the on-disk representation of a given object. This is
# almost always the on-disk representation of the type. The only
# exception is strings, where the length is encoded in the datatype in
# HDF5, but in the object in Julia.
@nospecializeinfer function objodr(@nospecialize(x))
    writtenas = writeas(typeof(x))
    _odr(writtenas, typeof(x), odr(writtenas))
end
_odr(writtenas::DataType, readas::DataType, odr) =
    CustomSerialization(writtenas, readas, odr)

# h5type is objodr's HDF5 companion. It should give the HDF5 datatype
# reflecting the on-disk representation
#
# Performance note: this should be inferable.
@nospecializeinfer function h5type(f::JLDFile, @nospecialize(writtenas), @nospecialize(x))
    check_writtenas_type(writtenas)
    T = typeof(x)
    @lookup_committed f T
    if !hasdata(writtenas)
        commit(f, OpaqueDatatype(1), writtenas, T, WrittenAttribute(f, :empty, UInt8(1)))
    elseif isempty(writtenas.types) # bitstype
        commit(f, OpaqueDatatype(sizeof(writtenas)), writtenas, T)
    else
        commit_compound(f, fieldnames(writtenas), writtenas, T)
    end
end
check_writtenas_type(::DataType) = nothing
check_writtenas_type(::Any) = throw(ArgumentError("writeas(leaftype) must return a leaf type"))
@nospecializeinfer h5type(f::JLDFile, @nospecialize(x)) = h5type(f, writeas(typeof(x)), x)

# Make a compound datatype from a set of names and types
@nospecializeinfer  function commit_compound(f::JLDFile, names::AbstractVector{Symbol},
                         @nospecialize(writtenas::DataType), @nospecialize(readas::Type))
    if f.disable_commit
        throw(ArgumentError("Attempted to commit DataType $writtenas but committing is disabled."))
    end
    types = writtenas.types
    offsets = Int[]
    h5names = Symbol[]
    members = H5Datatype[]
    field_names = String[]
    field_types = RelOffset[]
    anynondefault = false
    offset = 0
    for i = 1:length(types)
        fieldty = types[i]
        fieldwrittenas = writeas(fieldty)
        dtype = h5fieldtype(f, fieldwrittenas, fieldty, Val{i <= ninitialized(writtenas)})
        if isnothing(dtype)
            # this is the function body of h5type(f, fieldwrittenas, x) but x is an instance of fieldty unknownavailable here
            cdt = get(f.jlh5type, fieldty, nothing)
            dtype = if !isnothing(cdt)
                cdt
            elseif !hasdata(fieldwrittenas)
                commit(f, OpaqueDatatype(1), fieldwrittenas, fieldty, WrittenAttribute(f, :empty, UInt8(1)))
            elseif isempty(fieldwrittenas.types) # bitstype
                commit(f, OpaqueDatatype(sizeof(fieldwrittenas)), fieldwrittenas, fieldty)
            else
                commit_compound(f, fieldnames(fieldwrittenas), fieldwrittenas, fieldty)
            end
            push!(field_names, string(names[i]))
            push!(field_types, dtype.header_offset)
            anynondefault = true
            continue
        end

        if isa(dtype, CommittedDatatype)
            # HDF5 cannot store relationships among committed
            # datatypes. We store these separately in an attribute.
            type_offset = dtype.header_offset
            dtype = f.datatypes[dtype.index]
            anynondefault = true
        else
            type_offset = NULL_REFERENCE
        end
        push!(field_names, string(names[i]))
        push!(field_types, type_offset)
        push!(h5names, names[i])
        push!(members, dtype)
        push!(offsets, offset)
        offset += dtype.size::UInt32
    end

    @assert offset != 0
    compound = CompoundDatatype(offset, h5names, offsets, members)
    if anynondefault
        commit(f, compound, writtenas, readas,
            WrittenAttribute(:field_names,
                WriteDataspace(f, field_names, Vlen{String}),
                h5type(f, field_names),
                field_names),
            WrittenAttribute(:field_types,
                WriteDataspace(f, field_types, DataType),
                ReferenceDatatype(),
                field_types))
    else
        commit(f, compound, writtenas, readas)::CommittedDatatype
    end
end

# Write an HDF5 datatype to the file
@nospecializeinfer function commit(f::JLDFile,
        @nospecialize(dtype),#::H5Datatype,
        @nospecialize(writeas::DataType),
        @nospecialize(readas::DataType),
        attributes::WrittenAttribute...)
    if f.disable_commit
        throw(ArgumentError("Attempted to commit DataType $readas but committing is disabled."))
    end

    # This needs to be written this way or type inference gets unhappy...
    # Also needs to happen here so that we write the DataType type
    # before we try to find where this type will be written
    typeattr = WrittenAttribute(
        :julia_type, WriteDataspace(f, DataType, odr(DataType)), h5type(f, DataType, DataType), readas)

    offset = f.end_of_data

    seek(f.io, offset)
    id = length(f.datatypes)+1
    h5o = h5offset(f, offset)
    cdt = CommittedDatatype(h5o, id)
    f.datatype_locations[h5o] = cdt
    f.jlh5type[readas] = cdt
    push!(f.datatypes, dtype)
    f.types_group[string(id, pad=8)] = h5o

    if writeas !== readas
        wrtypeattr = WrittenAttribute(:written_type,
                                      WriteDataspace(f, DataType, odr(DataType)),
                                      h5type(f, DataType, DataType), writeas)
        f.h5jltype[cdt] = MappedRepr{readas,CustomSerialization{writeas, odr(writeas)}}()
        commit(f, dtype, tuple(typeattr, wrtypeattr, attributes...))
    else
        f.h5jltype[cdt] = ReadRepresentation(writeas,odr(writeas))
        commit(f, dtype, tuple(typeattr, attributes...))
    end

    cdt::CommittedDatatype
end



# h5convert! stores the HDF5 representation of Julia data to a pointer. This
# method handles types with no padding or references where this is just a simple
# store
h5convert!(out::Pointers, ::Type{T}, ::JLDFile, x, ::JLDWriteSession) where {T} =
    (jlunsafe_store!(pconvert(Ptr{T}, out), x); nothing)

# We pack types that have padding using a staged h5convert! method
@generated function h5convert!(out::Pointers,
       ::Type{OnDiskRepresentation{Offsets,Types,H5Types,Size}},
       file::JLDFile, x, wsession::JLDWriteSession) where {Offsets,Types,H5Types,Size}
    T = x
    types = Types.parameters
    members = H5Types.parameters

    getindex_fn = isa(T, Type{T} where T<:Tuple) ? (:getindex) : (:getfield)
    ex = Expr(:block)
    args = ex.args
    for i = 1:length(Offsets)
        member = members[i]
        isa(member, Nothing) && continue

        offset = Offsets[i]
        conv = :(h5convert!(out+$offset, $(member), file, convert($(types[i]), $getindex_fn(x, $i)), wsession))
        if i > ninitialized(T) && (!isconcretetype(x.types[i]) || !isbitstype(x.types[i]))
            push!(args, quote
                if !isdefined(x, $i)
                    h5convert_uninitialized!(out+$offset, $(member))
                else
                    $conv
                end
            end)
        else
            push!(args, conv)
        end
    end
    push!(args, nothing)
    ex
end

# jl_canbeuninitialized specifies whether a given ODR could be uninitialized,
# which determines whether or not we'll try to call jlconvert_isinitialized to
# determine whether or not it is actually defined when reconstructing types.
jlconvert_canbeuninitialized(::Any) = false

# jlconvert converts data from a pointer into a Julia object. This method
# handles types where this is just a simple load
jlconvert(::SameRepr{T}, ::JLDFile, ptr::Ptr, ::RelOffset) where {T} =
    jlunsafe_load(pconvert(Ptr{T}, ptr))

# When fields are undefined in the file but can't be in the workspace, we need
# to throw exceptions to prevent errors on null pointer loads
struct UndefinedFieldException
    ty::DataType
    fieldname::Symbol
end
Base.showerror(io::IO, x::UndefinedFieldException) =
    print(io, "field \"", x.fieldname, "\" of type ", x.ty,
          " must be defined in the current workspace, but was undefined in the file")


## References

h5type(::JLDFile, ::Type{RelOffset}, ::RelOffset) = ReferenceDatatype()
odr(::Type{RelOffset}) = RelOffset

function h5convert!(out::Pointers, odr::Type{RelOffset}, f::JLDFile, x::Any,
                            wsession::JLDWriteSession)
    ref = write_ref(f, x, wsession)
    jlunsafe_store!(pconvert(Ptr{RelOffset}, out), ref)
    nothing
end
h5convert_uninitialized!(out::Pointers, odr::Type{RelOffset}) =
    (jlunsafe_store!(pconvert(Ptr{RelOffset}, out), NULL_REFERENCE); nothing)

# Reading references as references
jlconvert(::SameRepr{RelOffset}, f::JLDFile, ptr::Ptr, ::RelOffset) =
    jlunsafe_load(pconvert(Ptr{RelOffset}, ptr))
jlconvert_canbeuninitialized(::SameRepr{RelOffset}) = false

# Reading references as other types
function jlconvert(::MappedRepr{T,RelOffset}, f::JLDFile, ptr::Ptr,
                           ::RelOffset) where T
    x = load_dataset(f, jlunsafe_load(pconvert(Ptr{RelOffset}, ptr)))
    (isa(x, T) ? x : rconvert(T, x))::T
end

jlconvert_canbeuninitialized(::MappedRepr{T,RelOffset}) where {T} = true
jlconvert_isinitialized(::MappedRepr{T,RelOffset}, ptr::Ptr) where {T} =
    jlunsafe_load(pconvert(Ptr{RelOffset}, ptr)) != NULL_REFERENCE

## Routines for variable-length datatypes

# Write variable-length data and store the offset and length to out pointer
function store_vlen!(out::Pointers, odr, f::JLDFile, x::AbstractVector,
                             wsession::JLDWriteSession)
    jlunsafe_store!(pconvert(Ptr{UInt32}, out), length(x))
    obj = write_heap_object(f, odr, x, wsession)
    jlunsafe_store!(pconvert(Ptr{GlobalHeapID}, out)+4, obj)
    nothing
end

h5convert!(out::Pointers, ::Type{Vlen{T}}, f::JLDFile, x, wsession::JLDWriteSession) where {T} =
    store_vlen!(out, T, f, x, wsession)

@assert odr_sizeof(Vlen) == jlsizeof(UInt128)
h5convert_uninitialized!(out::Pointers, odr::Type{T}) where {T<:Vlen} =
    (jlunsafe_store!(pconvert(Ptr{Int128}, out), 0); nothing)

# Read variable-length data given offset and length in ptr
jlconvert(::MappedRepr{T,Vlen{S}}, f::JLDFile, ptr::Ptr, ::RelOffset) where {T,S} =
    read_heap_object(f, jlunsafe_load(pconvert(Ptr{GlobalHeapID}, ptr+4)), ReadRepresentation(T, S))
jlconvert_canbeuninitialized(::MappedRepr{<: Any, <: Vlen}) = true
jlconvert_isinitialized(::MappedRepr{T,Vlen{S}}, ptr::Ptr) where {T,S} =
    jlunsafe_load(pconvert(Ptr{GlobalHeapID}, ptr+4)) != GlobalHeapID(RelOffset(0), 0)



## DataTypes

const H5TYPE_DATATYPE = CompoundDatatype(
    odr_sizeof(Vlen{String})+odr_sizeof(Vlen{RelOffset}),
    [:name, :parameters],
    [0, odr_sizeof(Vlen{String})],
    [H5TYPE_VLEN_UTF8, VariableLengthDatatype(ReferenceDatatype())]
)

function h5fieldtype(f::JLDFile, ::Type{T}, readas::Type, ::Initialized) where T<:DataType
    if f.disable_commit
        throw(ArgumentError("Attempted to commit DataType $readas but committing is disabled."))
    end
    if !(readas <: DataType) || (T isa Type{Type{T}} where T)
        @lookup_committed f readas
        return commit(f, H5TYPE_DATATYPE, DataType, readas)
    end

    @lookup_committed f DataType
    io = f.io
    offset = f.end_of_data

    seek(io, offset)
    id = length(f.datatypes)+1
    h5o = h5offset(f, offset)
    cdt = CommittedDatatype(h5o, id)
    f.datatype_locations[h5o] = cdt
    f.jlh5type[DataType] = cdt
    f.h5jltype[cdt] = MappedRepr{DataType,DataTypeODR}()
    push!(f.datatypes, H5TYPE_DATATYPE)
    f.types_group[string(id, pad=8)] = h5o


    commit(f, H5TYPE_DATATYPE, (WrittenAttribute(:julia_type, WriteDataspace(f, DataType, odr(DataType)), cdt, DataType),))

    cdt
end
fieldodr(::Type{T}, ::Bool) where {T<:DataType} = DataTypeODR

h5type(f::JLDFile, ::Type{T}, x) where {T<:DataType} =
    h5fieldtype(f, DataType, typeof(x), Val{true})
odr(::Type{T}) where {T<:DataType} = DataTypeODR

function typename(T::DataType)
    s = IOBuffer()
    join(s, fullname(T.name.module), '.')
    print(s, '.', T.name.name)
    return String(take!(s))
end

function refs_from_types(f::JLDFile, types, wsession::JLDWriteSession)
    refs = RelOffset[
        if isa(x, DataType)
            # The heuristic here is that, if the field type is a committed data type,
            # then we commit the datatype and write it as a reference to the committed
            # datatype. Otherwise we write it as a name. This ensures that type
            # parameters that affect the structure of a type are written to the file,
            # so that we can reconstruct the type when the layout depends on the
            # parameters.
            dt = h5fieldtype(f, writeas(x), x, Val{true})
            if isa(dt, CommittedDatatype)
                (dt::CommittedDatatype).header_offset
            else
                write_ref(f, x, wsession)
            end
        else
            write_ref(f, x, wsession)
        end
    for x in types]
end

function h5convert!(out::Pointers, ::Type{DataTypeODR}, f::JLDFile, T::DataType, wsession::JLDWriteSession)
    t = typename(T)
    if T <: Function && isgensym(Symbol(T))
        @warn LazyString("Attempting to store ", T, ".\n",
                         "JLD2 only stores functions by name.\n",
                         " This may not be useful for anonymous functions.")
    end
    store_vlen!(out, UInt8, f, unsafe_wrap(Vector{UInt8}, t), f.datatype_wsession)
    if isempty(T.parameters)
        h5convert_uninitialized!(out+odr_sizeof(Vlen{UInt8}), Vlen{UInt8})
    else
        refs = refs_from_types(f, T.parameters, wsession)
        store_vlen!(out+odr_sizeof(Vlen{UInt8}), RelOffset, f, refs, f.datatype_wsession)
    end
    nothing
end


# This is a trick to compactly write long NTuple
# This uses that NTuple{N,T} === Tuple{T,T,T,T,...,T}
function h5convert!(out::Pointers, ::Type{DataTypeODR}, f::JLDFile, T::Type{<: NTuple}, wsession::JLDWriteSession)
    params = T.parameters
    N = length(params)
    if N ≤ 1 || !(reduce(==, params))
        store_vlen!(out, UInt8, f, unsafe_wrap(Vector{UInt8}, "Tuple"), f.datatype_wsession)
        if N == 0
            h5convert_uninitialized!(out+odr_sizeof(Vlen{UInt8}), Vlen{UInt8})
        else # N==1
            # this also catches NTuples with indeterminate length
            refs = refs_from_types(f, params, wsession)
            store_vlen!(out+odr_sizeof(Vlen{UInt8}), RelOffset, f, refs, f.datatype_wsession)
        end
    else # actual NTuple with more than one entry
        store_vlen!(out, UInt8, f, unsafe_wrap(Vector{UInt8}, "NTuple"), f.datatype_wsession)
        ET = params[1] # T === Tuple{ET,ET,ET,...}
        refs = refs_from_types(f, Any[N,ET], wsession)
        store_vlen!(out+odr_sizeof(Vlen{UInt8}), RelOffset, f, refs, f.datatype_wsession)
    end
    nothing
end

## Union Types

const H5TYPE_UNION = CompoundDatatype(
      odr_sizeof(Vlen{String})+2*odr_sizeof(Vlen{RelOffset}),
      [:description, :datatype, :unionall],
      [0, odr_sizeof(Vlen{String}), odr_sizeof(Vlen{String})+odr_sizeof(Vlen{RelOffset})],
      [H5TYPE_VLEN_UTF8, VariableLengthDatatype(ReferenceDatatype()), VariableLengthDatatype(ReferenceDatatype())]
      )

# ODR for UnionDataType
const UnionTypeODR = OnDiskRepresentation{
      (0, odr_sizeof(Vlen{String}), odr_sizeof(Vlen{String})+odr_sizeof(Vlen{RelOffset})),
      Tuple{String, Vector{Any}, Vector{Any}},
      Tuple{Vlen{String}, Vlen{RelOffset}, Vlen{RelOffset}},
      odr_sizeof(Vlen{String})+2*odr_sizeof(Vlen{RelOffset})}

function h5fieldtype(f::JLDFile, ::Type{T}, readas::Type{S}, ::Initialized) where {T<:Union,S<:Union}
    @lookup_committed f Union
    commit(f, H5TYPE_UNION, Union, Union)
end
function h5fieldtype(f::JLDFile, ::Type{T}, readas::Type, ::Initialized) where T<:Union
    @lookup_committed f readas
    commit(f, H5TYPE_UNION, Union, readas)
end

fieldodr(::Type{T}, ::Bool) where {T<:Union} = UnionTypeODR
h5fieldtype(f::JLDFile, ::Type{Union{}}, ::Initialized) = nothing
fieldodr(::Type{Union{}}, initialized::Bool) = nothing

h5type(f::JLDFile, ::Type{T}, x::Any) where {T<:Union} =
    h5fieldtype(f, Union, typeof(x), Val{true})
odr(::Type{Union}) = fieldodr(Union, true)

function h5convert!(out::Pointers, ::Type{UnionTypeODR}, f::JLDFile, x::Union, wsession::JLDWriteSession)
    # Write a description of the union type
    # This is not needed for loading the file but makes h5dump output clearer
    t = string(x)
    store_vlen!(out, UInt8, f, unsafe_wrap(Vector{UInt8}, t), f.datatype_wsession)
    out += odr_sizeof(Vlen{String})
    dts = filter(t -> t isa DataType, Base.uniontypes(x))
    uls = filter(t -> t isa UnionAll, Base.uniontypes(x))
    if !isempty(dts)
        refs = refs_from_types(f, dts, wsession)
        store_vlen!(out, RelOffset, f, refs, f.datatype_wsession)
    else
        h5convert_uninitialized!(out, Vlen{RelOffset})
    end
    if !isempty(uls)
        refs = RelOffset[write_ref(f, x, wsession) for x in uls]
        store_vlen!(out+odr_sizeof(Vlen{RelOffset}), RelOffset, f, refs, f.datatype_wsession)
    else
        h5convert_uninitialized!(out+odr_sizeof(Vlen{RelOffset}), Vlen{RelOffset})
    end
end

function jlconvert(::MappedRepr{Union, UnionTypeODR}, f::JLDFile,
                   ptr::Ptr, header_offset::RelOffset)
    # Skip union type description in the beginning
    ptr += odr_sizeof(Vlen{String})
    # Reconstruct a Union by reading a list of DataTypes and UnionAlls
    # Lookup of RelOffsets is taken from jlconvert of DataTypes
    datatypes = types_from_refs(f, ptr)
    unionalls = types_from_refs(f, ptr+odr_sizeof(Vlen{RelOffset}))

    v = Union{datatypes..., unionalls...}
    track_weakref!(f, header_offset, v)
    v
end


function constructrr(::JLDFile, ::Type{T}, dt::CompoundDatatype, ::Vector{ReadAttribute}) where {T<:Union}
    dt == H5TYPE_UNION ? (MappedRepr{Union,UnionTypeODR}(), true) :
                         throw(UnsupportedFeatureException())
end

## UnionAll

const UnionAllODR = OnDiskRepresentation{(0, 8),Tuple{TypeVar,Any},Tuple{RelOffset,RelOffset}, 16}

# This needs its own h5convert! method, since otherwise we will attempt to specialize the
# generic h5convert! method for the specific UnionAll type rather than for UnionAll
# more generally.
function h5convert!(out::Pointers,
                    odr::Type{UnionAllODR},
                    f::JLDFile, x::UnionAll, wsession::JLDWriteSession)
    h5convert!(out, RelOffset, f, x.var, f.datatype_wsession)
    h5convert!(out+odr_sizeof(RelOffset), RelOffset, f, x.body, f.datatype_wsession)
end



# The following two definitions are borrowed from BSON.
# They are used to generate instances of arbitrary types
# given their fields regardless of potential constructors.
# It is unclear to the author whether this approach is
# optimal.
newstruct(T) = ccall(:jl_new_struct_uninit, Any, (Any,), T)

function newstruct(T, fields)
    if !ismutabletype(T)
        return ccall(:jl_new_structv, Any, (Any,Ptr{Cvoid},UInt32), T, fields, length(fields))
    else
        # Manual inline of newstruct! to work around bug
        # https://github.com/MikeInnes/BSON.jl/issues/2#issuecomment-452204339
        x = newstruct(T)

        for (i, f) = enumerate(fields)
            ccall(:jl_set_nth_field, Nothing, (Any, Csize_t, Any), x, i-1, f)
        end
        x
    end
end


# jlconvert for empty objects
function jlconvert(@nospecialize(rr::MappedRepr{T,nothing} where T), f::JLDFile, ptr::Ptr,
                              header_offset::RelOffset)::julia_repr(rr)
    T = julia_repr(rr)
    sizeof(T) == 0 && return newstruct(T)::T

    # In this case, T is a non-empty object, but the written data was empty
    # because the custom serializers for the fields all resulted in empty
    # objects
    fields = map(T.types) do ty
        writtenas = writeas(ty)
        @assert sizeof(writtenas) == 0
        if writtenas === ty
            # This will usually equal `ty()` unless ty does not have a
            # constructor without arguments
            jlconvert(MappedRepr{ty,nothing}(), f, ptr, header_offset)
        else
            rconvert(ty,
                jlconvert(MappedRepr{writtenas,nothing}(), f, ptr, header_offset)
            )
        end
    end
    if T <: Tuple
        # Tuples are weird in that you can't instantiate them with Tuple{T,S}(t,s)
        return (fields...,)::T
    end
    return newstruct(T, fields)::T
end

# odr gives the on-disk representation of a given type, similar to
# fieldodr, but actually encoding the data for things that odr stores
# as references
@nospecializeinfer function odr(@nospecialize(T::Type))
    if !hasdata(T)
        # A pointer singleton or ghost. We need to write something, but we'll
        # just write a single byte.
        return nothing
    elseif isbitstype(T) && samelayout(T)
        # Has a specialized convert method or is an unpadded type
        return T
    end

    offsets = zeros(Int, length(T.types))
    odrs = Vector{Any}(undef, length(T.types))
    offset = 0
    for i = 1:length(T.types)
        ty = T.types[i]
        writtenas = writeas(ty)
        fodr = fieldodr(writtenas, i <= ninitialized(T))
        if writtenas !== ty && fodr !== nothing
            odrs[i] = CustomSerialization{writtenas,fodr}
        else
            odrs[i] = fodr
        end
        offsets[i] = offset
        offset += odr_sizeof(fodr)
    end

    OnDiskRepresentation{(offsets...,), Tuple{T.types...}, Tuple{odrs...}, Int(offset)}
end

abstract type DataMode end
struct ReferenceFree <: DataMode end
struct HasReferences <: DataMode end

datamode(::Type{CustomSerialization{WrittenAs,ODR}}) where {WrittenAs,ODR} = datamode(ODR)
datamode(::Union{Type{<:Vlen},Type{RelOffset}}) = HasReferences()
datamode(::DataType) = ReferenceFree()
datamode(::FixedLengthString) = ReferenceFree()
datamode(::AsciiString) = ReferenceFree()
datamode(::Nothing) = ReferenceFree()
function datamode(::Type{OnDiskRepresentation{Offsets,JLTypes,H5Types,Size}}) where {Offsets,JLTypes,H5Types,Size}
    for ty in H5Types.parameters
        datamode(ty) == HasReferences() && return HasReferences()
    end
    return ReferenceFree()
end

using JLD2, Test

@testset "Dataset API" begin
    cd(mktempdir()) do
        fn = "test.jld2"
        jldopen(fn, "w") do f
            dset = JLD2.create_dataset(f, "d")
            JLD2.add_attribute(dset, "description", "A description of what this is for.")

            # Check that double attributes are not allowed
            @test_throws ArgumentError JLD2.add_attribute(dset, "description", "I changed my mind.")

            JLD2.write_dataset(dset, 42)
        end
        jldopen(fn, "a") do f
            @test f["d"] == 42
            dset = JLD2.get_dataset(f, "d")
            attrs = JLD2.attributes(dset)
            only(attrs) == ("description" => "A description of what this is for.")
             # Add another attribute that has to be attached to the existing (written dataset)
            JLD2.add_attribute(dset, "addition", "A different description.")

            # Check that double attributes are not allowed
            @test_throws ArgumentError JLD2.add_attribute(dset, "addition", "A very different description.")
        end

        jldopen(fn, "w") do f
            dset = JLD2.create_dataset(f, "d")
            dset.filters = Deflate()
            JLD2.write_dataset(dset, zeros(1000,1000))
        end
        @test load(fn)["d"] == zeros(1000,1000)
    end
end

@testset "Slicing & Updating" begin
    cd(mktempdir()) do
        fn = "test.jld2"
        jldsave(fn; a=42, b = [42 43 44; 45 46 47], c = [(0x00, 1f0), (0x42, 2f0)])
        jldopen(fn) do f
            dset = JLD2.get_dataset(f, "a")
            @test dset[] == 42

            dset = JLD2.get_dataset(f, "b")
            @test dset[] == [42 43 44; 45 46 47]
            @test dset[1] == 42
            @test dset[1,1] == 42
            @test dset[1:2, 1:2] == [42 43; 45 46]
            @test dset[1,1:2:3] == [42, 44]
            @test_throws BoundsError dset[7]
            @test_throws BoundsError dset[2,4]
            @test_throws ArgumentError dset[1] = 1
        end
        jldopen(fn, "a") do f
            dset = JLD2.get_dataset(f, "b")
            dset[2] = -1
            @test dset[] == [42 43 44; -1 46 47]
            dset[1,1:2:3] = [1,5]
            @test dset[] == [1 43 5; -1 46 47]

            dset = JLD2.get_dataset(f, "c")
            dset[1] = (0x12, 3f0)
            dset[2] = (0xff, 0f0)
            @test f["c"] == [(0x12, 3f0), (0xff, 0f0)]
        end
        @test load(fn, "c")  == [(0x12, 3f0), (0xff, 0f0)]
    end
end

#
# Groups
#

"""
    Group(f::JLDFile, name::AbstractString)

Construct an empty group named `name` at the top level of `JLDFile` `f`.
"""
Group(f::JLDFile, name::AbstractString; kwargs...) = Group(f.root_group, name; kwargs...)

"""
    Group(g::Group, name::AbstractString)

Construct a group named `name` as a child of group `g`.
"""
Group(g::Group{T}, name::AbstractString; kwargs...) where {T} = (g[name] = Group{T}(g.f; kwargs...))

"""
    lookup_offset(g::Group, name::AbstractString) -> RelOffset

Lookup the offset of a dataset in a group. Returns `UNDEFINED_ADDRESS` if the dataset is
not present. Does not inspect `unwritten_child_groups`.
"""
function lookup_offset(g::Group, name::AbstractString)
    if g.last_chunk_start_offset != -1
        # Has been saved to file, so written_links exists
        roffset = get(g.written_links, name, UNDEFINED_ADDRESS)
        roffset != UNDEFINED_ADDRESS && return roffset
    end
    roffset = get(g.unwritten_links, name, UNDEFINED_ADDRESS)
end

"""
    pathize(g::Group, name::AbstractString, create::Bool) -> Tuple{Group,String}

Converts a path to a group and name object. If `create` is true, any intermediate groups
will be created, and the dataset name will be checked for uniqueness with existing names.
"""
function pathize(g::Group, name::AbstractString, create::Bool)
    G = typeof(g)
    if '/' in name
        f = g.f
        dirs = split(name, '/')

        for i = 1:length(dirs)-1
            dir = dirs[i]
            if isempty(dir)
                # Handles the absolute path case where the name starts with /
                i == 1 && (g = g.f.root_group::G)
                continue
            end
            # See if a group already exists
            offset = lookup_offset(g, dir)
            if offset == UNDEFINED_ADDRESS
                if haskey(g.unwritten_child_groups, dir)
                    # It's possible that lookup_offset fails because the group has not yet
                    # been written to the file
                    g = g.unwritten_child_groups[dir]
                elseif create
                    # No group exists, so create a new group
                    newg = G(f)
                    g.unwritten_child_groups[dir] = newg
                    g = newg
                else
                    throw(KeyError(join(dirs[1:i], '/')))
                end
            elseif haskey(f.loaded_groups, offset)
                g = f.loaded_groups[offset]::G
            elseif !isgroup(f, offset)
                throw(ArgumentError("path $(join(dirs[1:i], '/')) points to a dataset, not a group"))
            else
                g = f.loaded_groups[offset] = load_group(f, offset)::G
            end
        end

        name = String(dirs[end])
    end

    if create && haskey(g, name)
        throw(ArgumentError("a group or dataset named $name is already present within this group"))
    end

    return (g::G, name)
end

function Base.getindex(g::Group, name::AbstractString)
    f = g.f
    f.n_times_opened == 0 && throw(ArgumentError("file is closed"))

    (g, name) = pathize(g, name, false)
    isempty(name) && return g
    roffset = lookup_offset(g, name)
    if roffset == UNDEFINED_ADDRESS
        haskey(g.unwritten_child_groups, name) && return g.unwritten_child_groups[name]
        throw(KeyError(name))
    end

    Base.inferencebarrier(load_dataset(f, roffset))
end

@nospecializeinfer function Base.write(
        g::Group,
        name::AbstractString,
        @nospecialize(obj),
        wsession::JLDWriteSession=JLDWriteSession();
        compress=nothing
        )
    f = g.f
    prewrite(f)
    (g, name) = pathize(g, name, true)
    if !isnothing(compress)
        if obj isa Array
            filters = Filters.normalize_filters(compress)
            g[name] = write_dataset(f, obj, wsession, filters)
            return nothing
        end
        @warn "Only arrays can be compressed."
    end
    g[name] = write_dataset(f, obj, wsession)
    nothing
end

function Base.setindex!(g::Group, obj, name::AbstractString)
    write(g, name, obj)
    g
end

function Base.setindex!(g::Group, child::Group, name::AbstractString)
    if child.last_chunk_start_offset != -1
        throw(ArgumentError("cannot re-link a group that has already been written"))
    end
    prewrite(g.f)
    (g, name) = pathize(g, name, true)
    g.unwritten_child_groups[name] = child
    g
end

# Internal use only
function Base.setindex!(g::Group, offset::RelOffset, name::AbstractString)
    if g.last_chunk_start_offset != -1 && g.continuation_message_goes_here == -1
        error("objects cannot be added to this group because it was created with a previous version of JLD2")
    end
    g.unwritten_links[name] = offset
    g
end

function Base.haskey(g::Group, name::AbstractString)
    G = typeof(g)
    if '/' in name
        f = g.f
        dirs = split(name, '/')

        for i = 1:length(dirs)-1
            dir = dirs[i]
            if isempty(dir)
                # Handles the absolute path case where the name starts with /
                i == 1 && (g = g.f.root_group::G)
                continue
            end

            # See if a group already exists
            offset = lookup_offset(g, dir)
            if offset == UNDEFINED_ADDRESS
                if haskey(g.unwritten_child_groups, dir)
                    # It's possible that lookup_offset fails because the group has not yet
                    # been written to the file
                    g = g.unwritten_child_groups[dir]::G
                else
                    return false
                end
            elseif haskey(f.loaded_groups, offset)
                g = f.loaded_groups[offset]::G
            elseif !isgroup(f, offset)
                return false
            else
                g = f.loaded_groups[offset] = load_group(f, offset)::G
            end
        end

        name = String(dirs[end])
    end
    (g.last_chunk_start_offset != -1 && haskey(g.written_links, name)) ||
        haskey(g.unwritten_links, name) || haskey(g.unwritten_child_groups, name)
end

Base.isempty(g::Group) =
    (g.last_chunk_start_offset == -1 || isempty(g.written_links)) &&
    isempty(g.unwritten_links) && isempty(g.unwritten_child_groups)

function Base.keys(g::Group)
    ks = String[]
    if g.last_chunk_start_offset != -1
        append!(ks, keys(g.written_links))
    end
    append!(ks, keys(g.unwritten_links))
    append!(ks, keys(g.unwritten_child_groups))
    ks
end

Base.keytype(::Group) = String

function load_group(f::JLDFile, offset::RelOffset)
    # Messages
    links = OrderedDict{String,RelOffset}()

    next_link_offset::Int64 = -1
    link_phase_change_max_compact::Int64 = -1
    link_phase_change_min_dense::Int64 = -1
    est_num_entries::Int64 = 4
    est_link_name_len::Int64 = 8
    fractal_heap_address::RelOffset = UNDEFINED_ADDRESS
    name_index_btree::RelOffset = UNDEFINED_ADDRESS

    v1btree_address::RelOffset = UNDEFINED_ADDRESS
    name_index_heap::RelOffset = UNDEFINED_ADDRESS
    hmitr = HeaderMessageIterator(f, offset)
    for msg in hmitr
        chunk_start, chunk_end = hmitr.chunk
        if msg.type == HmNil && hmitr.curpos + CONTINUATION_MSG_SIZE == chunk_end && msg.size >= 13
                # This is the remaining space at the end of a chunk
                # Use only if a message can potentially fit inside
                # Single Character Name Link Message has 13 bytes payload
                next_link_offset = fileoffset(f, msg.offset)
        elseif msg.type == HmLinkInfo
            wmsg = HmWrap(HmLinkInfo, msg)
            fractal_heap_address = wmsg.fractal_heap_address
            name_index_btree = wmsg.v2_btree_name_index
        elseif msg.type == HmGroupInfo
            wmsg = HmWrap(HmGroupInfo, msg)
            if wmsg.size > 2
                # Version Flag
                wmsg.version == 0 || throw(UnsupportedFeatureException())
                flag = wmsg.flags::UInt8
                if flag%2 == 1 # first bit set
                    link_phase_change_max_compact = wmsg.link_phase_change_max_compact
                    link_phase_change_min_dense = wmsg.link_phase_change_min_dense
                end
                if (flag >> 1)%2 == 1 # second bit set
                    # Verify that non-default group size is given
                    est_num_entries = wmsg.est_num_entries
                    est_link_name_len = wmsg.est_link_name_len
                end
            end
        elseif msg.type == HmLinkMessage
            wmsg = HmWrap(HmLinkMessage, msg)
            links[wmsg.link_name] = wmsg.target
        elseif msg.type == HmSymbolTable
            wmsg = HmWrap(HmSymbolTable, msg)
            v1btree_address = wmsg.v1btree_address
            name_index_heap = wmsg.name_index_heap
        end
    end

    if fractal_heap_address != UNDEFINED_ADDRESS
        records = read_btree(f, fractal_heap_address, name_index_btree)::Vector{Tuple{String, RelOffset}}
        for r in records
            links[r[1]] = r[2]
        end
    end

    if v1btree_address != UNDEFINED_ADDRESS
        records = read_oldstyle_group(f, v1btree_address, name_index_heap)::Vector{Tuple{String, RelOffset}}
        for r in records
            links[r[1]] = r[2]
        end
    end

    chunk_start, chunk_end = hmitr.chunk
    continuation_msg_address = chunk_end - CONTINUATION_MSG_SIZE
    chunk_start < next_link_offset < chunk_end || (next_link_offset = -1)

    Group{typeof(f)}(f, chunk_start, continuation_msg_address, chunk_end, next_link_offset,
                     est_num_entries, est_link_name_len,
                     OrderedDict{String,RelOffset}(), OrderedDict{String,Group}(), links)
end

"""
    links_size(pairs)

Returns the size of several link messages. `pairs` is an iterator of
`String => RelOffset` pairs.
"""
function links_size(pairs)
    sz = 0
    for (name::String,) in pairs
        sz += jlsizeof(Val(HmLinkMessage); link_name=name)
    end
    sz
end

function group_extra_space(g)
    remaining_entries = g.est_num_entries - length(g.unwritten_links)
    extraspace = remaining_entries * (12 + g.est_link_name_len + 4)
    # Can't create a placeholder NIL message larger than that
    clamp(extraspace, 0, typemax(UInt16))
end


"""
    save_group(g::Group) -> RelOffset

Stores a group to a file, updating it if it has already been saved. Returns
`UNDEFINED_ADDRESS` if the group was already stored, or the offset of the new group
otherwise.
"""
function save_group(g::Group)
    # Save unwritten child groups
    if !isempty(g.unwritten_child_groups)
        for (name, child_group) in g.unwritten_child_groups
            retval = save_group(child_group)
            g.unwritten_links[name] = retval
        end
        empty!(g.unwritten_child_groups)
    end

    # Save links
    f = g.f
    io = f.io
    # If the group has not been saved yet
    if g.last_chunk_start_offset == -1

        totalsize = jlsizeof(Val(HmLinkInfo))
        totalsize += jlsizeof(Val(HmGroupInfo); g.est_num_entries, g.est_link_name_len)
        totalsize += CONTINUATION_MSG_SIZE
        totalsize += links_size(g.unwritten_links)
        # add to size to make space for additional links
        totalsize += group_extra_space(g)

        sz = jlsizeof(ObjectStart) + size_size(totalsize) + totalsize

        g.last_chunk_start_offset = f.end_of_data
        g.last_chunk_checksum_offset = f.end_of_data + sz
        f.end_of_data += sz + 4
        seek(io, g.last_chunk_start_offset)

        # Object header
        jlwrite(io, ObjectStart(size_flag(totalsize)))
        write_size(io, totalsize)
        write_header_message(io, Val(HmLinkInfo))
        write_header_message(io, Val(HmGroupInfo); g.est_num_entries, g.est_link_name_len)

        g.next_link_offset = position(io)
    end
    next_msg_offset = g.next_link_offset == -1 ? g.continuation_message_goes_here : g.next_link_offset
    attach_message(f, g.last_chunk_start_offset, collect(g.unwritten_links);
        chunk_start = g.last_chunk_start_offset,
        chunk_end = g.last_chunk_checksum_offset,
        next_msg_offset)
    # this is clearly suboptimal
    # TODO: this should always return the object start
    # but for "continued" versions this is not the case
    return h5offset(f, g.last_chunk_start_offset)
end

function isgroup(f::JLDFile, offset::RelOffset)
    # trivial case -> It is already loaded
    haskey(f.loaded_groups, offset) && return true

    is_group = false
    determined = false
    hmitr = HeaderMessageIterator(f, offset)
    for msg in hmitr
        if msg.type in (HmLinkInfo, HmGroupInfo, HmLinkMessage, HmSymbolTable)
            is_group = true
            determined = true
            break
        elseif msg.type in (HmDataspace, HmDatatype, HmFillValue, HmDataLayout)
            determined = true
            break
        end
    end
    return is_group
end

function show_group(io::IO, g::Group, maxnumlines::Int=10, prefix::String=" ", skiptypes::Bool=false)
    iszero(maxnumlines) && return 0
    if g.f.n_times_opened == 0
        print(io, "  (closed)")
        return -1
    end

    ks = collect(keys(g))
    skiptypes && filter!(x -> x != "_types", ks)

    if isempty(ks) && prefix == " "
        print(io, "  (no datasets)")
        return -1
    end

    for i = 1:length(ks)
        k = ks[i]
        islast = i == length(ks)
        isagroup = haskey(g.unwritten_child_groups, k) || isgroup(g.f, lookup_offset(g, k))
        if (maxnumlines <= 1 && !islast) #|| (maxnumlines < 2 && isagroup))
            print(io, prefix, "└─ ⋯ ($(length(ks)-i+1) more entries)")
            return 0
        end
        print(io, prefix, islast ? "└─" : "├─", isagroup ? "📂 " : "🔢 ", k)
        maxnumlines = maxnumlines - 1
        if isagroup
            newg = g[k]
            if !isempty(newg)
                if (maxnumlines > 1 || (islast && maxnumlines >= 2))
                    print(io, '\n')
                    ret = show_group(io, newg, islast ? maxnumlines : maxnumlines-1, prefix*(islast ? "   " : "│  "), false)
                    if ret < 0
                        error("closed or empty dataset, this should not happen")
                    end
                    maxnumlines = ret
                    maxnumlines += islast ? 0 : 1
                else
                    nentries = length(keys(newg))
                    if nentries == 1
                        print(io, " (1 entry)")
                    else
                        print(io, " ($(nentries) entries)")
                    end
                end

            end
        end
        !islast && print(io, '\n')
    end
    return maxnumlines
end

Base.show(io::IO, g::Group) = print(io, "JLD2.Group")

function Base.show(io::IO, ::MIME"text/plain", g::Group)
    print(io, "JLD2.Group")
    if get(io, :compact, false)
        return
    else
        print(io, "\n")
        show_group(io, g, 10, " ", false)
    end
end

using JLD2
using Test
using Random

@testset "BufferedReader" begin
    mktemp() do path, io
        a = randn(100)
        write(io, a)
        close(io)
        b = open(path, "r") do ff
            br = JLD2.BufferedReader(ff)
            b = JLD2.jlread(br, Float64, 100)
        end
        @test a ≈ b
    end
end

@testset "BufferedReader: ensureroom appends at buffer end" begin
    # Read a few bytes (fills the 16 384-byte lookahead), then seek past the
    # 16 384 boundary.  A bug caused the second fill to write at the cursor
    # position instead of the end of the buffer, corrupting already-buffered
    # bytes and mapping subsequent offsets incorrectly.
    mktemp() do fn, io
        data = rand(UInt8, 40_000)
        write(io, data)
        close(io)
        open(fn, "r") do f
            br = JLD2.BufferedReader(f)
            for _ in 1:10
                JLD2.jlread(br, UInt8)   # advance cursor; triggers initial 16 384-byte fill
            end
            seek(br, 20_000)             # crosses the 16 384-byte boundary
            @test JLD2.jlread(br, UInt8) == data[20_001]
        end
    end
end

using JLD2, Test

for ioty in [JLD2.MmapIO, IOStream]
    local fn = joinpath(mktempdir(), "test.jld")

    # Ensure we can handle cases where the same file is open multiple times
    local f = jldopen(fn, true, true, true, ioty)
    write(f, "hello", "world")
    @test_throws ArgumentError jldopen(fn, true, true, true, ioty)
    f2 = jldopen(fn, true, false, false, ioty)
    write(f2, "this", "works")
    close(f2)
    write(f, "still", "works")
    close(f)

    f = jldopen(fn, false, false, false, ioty)
    @test read(f, "hello") == "world"
    @test read(f, "this") == "works"
    @test read(f, "still") == "works"
    @test_throws ArgumentError jldopen(fn, true, false, false, ioty)
    @test_throws ArgumentError jldopen(fn, false, false, false, ioty; compress=true)
    @test_throws ArgumentError jldopen(fn, false, false, false, ioty; mmaparrays=true)
    close(f)

    # Make sure that the file gets written properly regardless of the order in which the
    # IO and JLDFile are finalized
    for order in [[1, 2], [2, 1]]
        local f = jldopen(fn, true, true, true, ioty)
        write(f, "x", 1:10)

        objs = isa(f, JLD2.JLDFile{IOStream}) ? [f, f.io] : [f, f.io.f]
        for i in order
            finalize(objs[i])
        end

        f = jldopen(fn, false, false, false, ioty)
        @test read(f, "x") == 1:10
        close(f)
    end

end

# The following block allows reading Union types written prior to v0.2
const LEGACY_H5TYPE_UNION = VariableLengthDatatype(H5TYPE_DATATYPE)

function jlconvert(::MappedRepr{Union, Vlen{DataTypeODR}}, f::JLDFile,
                   ptr::Ptr, header_offset::RelOffset)
    v = Union{jlconvert(MappedRepr{DataType,Vlen{DataTypeODR}}(), f, ptr, NULL_REFERENCE)...}
    track_weakref!(f, header_offset, v)
    v
end

constructrr(::JLDFile, ::Type{T}, dt::VariableLengthDatatype, ::Vector{ReadAttribute}) where {T<:Union} =
    dt == LEGACY_H5TYPE_UNION ? (MappedRepr{Union,Vlen{DataTypeODR}}(), true) :
                         throw(UnsupportedFeatureException())

# The following definition is needed to correctly load Strings written
# with JLD2 with versions v0.1.12 - v0.3.1
function read_array(f::JLDFile, dataspace::ReadDataspace,
                    rr::FixedLengthString{String}, layout::DataLayout,
                    filters::FilterPipeline, header_offset::RelOffset,
                    attributes::Union{Vector{ReadAttribute},Nothing})
    rrv = SameRepr{UInt8}()
    v = read_array(f, dataspace, rrv, layout, filters, NULL_REFERENCE, attributes)
    String(v)
end


function julia_type(s::AbstractString)
    s = replace(s, r"ASCIIString|UTF8String|ByteString" => "String")
    if occursin("Base.UTF16String", s)
        error("file contains Base.UTF16String, must be converted and re-saved with JLD 0.9 or less")
    end
    _julia_type(s)
end


function constructrr(f::JLDFile, str::String, dt::CompoundDatatype, attrs::Vector{ReadAttribute})
    jl_type = julia_type(str)
    # for some reason JLD attaches a '_' at the end of member field names
    strnames = [string(name)[1:end-1] for name in dt.names]
    dt.names .= Symbol.(strnames)
    constructrr(f, jl_type, dt, attrs)
end


struct UnsupportedType; end
struct UnconvertedType; end

const _where_macrocall = Symbol("@where")
function expand_where_macro(e::Expr)
    e.head = :where
    popfirst!(e.args)
    popfirst!(e.args)  # source location
    return true
end

is_valid_type_ex(s::Symbol) = true
is_valid_type_ex(s::QuoteNode) = true
is_valid_type_ex(s) = isbitstype(typeof(s))
function is_valid_type_ex(e::Expr)
    if e.head === :curly || e.head == :tuple || e.head == :.
        return all(is_valid_type_ex, e.args)
    elseif e.head === :where
        return is_valid_type_ex(e.args[1])
    elseif e.head === :let && length(e.args) == 2
        return is_valid_type_ex(e.args[2]) &&
               is_valid_type_ex(e.args[1].args[2])
    elseif e.head == :call
        f = e.args[1]
        if f isa Expr
            if f.head === :core
                f = f.args[1]
                return f === :Union || f === :TypeVar || f === :UnionAll
            end
        elseif f isa Symbol
            return f === :Union || f === :TypeVar || f === :symbol
        end
    end
    return false
end

const typemap_Core = Dict(
    :Uint8 => :UInt8,
    :Uint16 => :Uint16,
    :Uint32 => :UInt32,
    :Uint64 => :UInt64,
    :Void => Symbol(Nothing)
)

const _typedict = Dict{String,Type}()

function fixtypes(typ)
    whereall = []
    typ = fixtypes(typ, whereall)
    while !isempty(whereall)
        var = pop!(whereall)
        typ = Expr(:let, var, Expr(:call, Expr(:core, :UnionAll), var.args[1], typ))
    end
    return typ
end
fixtypes(typ, whereall) = typ
function fixtypes(typ::Expr, whereall::Vector{Any})
    if typ.head === :macrocall && typ.args[1] === _where_macrocall
        expand_where_macro(typ) # @where => TypeVar format forwards compatibility
    end
    if typ.head === :.
        if length(typ.args) == 2 && typ.args[1] === :Core
            arg = typ.args[2].value
            return Expr(:., :Core, QuoteNode(get(typemap_Core, arg, arg)))
        else
            return typ
        end
    elseif typ == :(Core.Type{TypeVar(:T,Union(Core.Any,Core.Undef))}) || typ == :(Core.Type{TypeVar(:T)})
        # Work around https://github.com/JuliaLang/julia/issues/8226 and the removal of Top
        return :(Core.Type)
    end

    for i = 1:length(typ.args)
        typ.args[i] = fixtypes(typ.args[i], whereall)
    end

    if (typ.head === :call && !isempty(typ.args) &&
        typ.args[1] === :TypeVar) # TypeVar => where format backwards compatibility
        tv = gensym()
        push!(whereall, Expr(:(=), tv, typ))
        return tv
    end

    if (typ.head === :call && !isempty(typ.args) &&
        typ.args[1] === :Union)
        typ = Expr(:curly, typ.args...)
    end

    if typ.head === :tuple
        if !any(x->isa(x,QuoteNode) || isbits(x), typ.args)
            # guess that we have a tuple type represented as a tuple
            typ = Expr(:curly, :Tuple, typ.args...)
        end
    end

    if typ.head === :curly
        # assume literal TypeVar should work like `T{<:S}`
        while !isempty(whereall)
            var = pop!(whereall)
            typ = Expr(:let, var, Expr(:call, Expr(:core, :UnionAll), var.args[1], typ))
        end
    end
    return typ
end

function _julia_type(s::AbstractString)
    typ = get(_typedict, s, UnconvertedType)
    if typ == UnconvertedType
        sp = Meta.parse(s, raise=false)
        if (isa(sp, Expr) && (sp.head == :error || sp.head == :continue || sp.head == :incomplete))
            println("error parsing type string ", s)
            eval(sp)
        end
        typ = julia_type(fixtypes(sp))
        if typ != UnsupportedType
            _typedict[s] = typ
        end
    end
    if typ == UnconvertedType || typ == UnsupportedType
        return UnknownType{Symbol(s), Tuple{}}
    else
        return typ
    end
end

function julia_type(e::Union{Symbol, Expr})
    if is_valid_type_ex(e)
        try # `try` needed to catch undefined symbols
            # `e` should be fully qualified, and thus reachable from Main
            typ = Core.eval(Main, e)
            typ == Type && return Type
            isa(typ, Type) && return typ
        catch
        end
    end
    return UnsupportedType
end

using JLD2, Test

fn = joinpath(mktempdir(), "test.jld")
f = jldopen(fn, "w")
write(f, "x1", 1.0)
close(f)

f = jldopen(fn, "a")
write(f, "x2", 1.0+2.0im)
close(f)

struct AppendedStruct
    x::Int
end
f = jldopen(fn, "a")
write(f, "x3", AppendedStruct(9))
close(f)

f = jldopen(fn, "r")
@test read(f, "x1") === 1.0
@test read(f, "x2") === 1.0+2.0im
@test read(f, "x3") === AppendedStruct(9)
close(f)

# IOStream: continuation chunk on group overflow
# est_num_entries=1 leaves no spare space, so the first append forces a
# continuation chunk.  A bug caused link messages to be written to the raw
# IOStream instead of the BufferedWriter used for checksum tracking.
fn2 = joinpath(mktempdir(), "test_iostream_continuation.jld2")
jldopen(fn2, "w"; iotype=IOStream) do f
    g = JLD2.Group(f, "g"; est_num_entries=1)
    g["a"] = 1
end
jldopen(fn2, "a"; iotype=IOStream) do f
    f["g/b"] = 2
end
jldopen(fn2, "r"; iotype=IOStream) do f
    @test f["g/a"] == 1
    @test f["g/b"] == 2
end

"""
    JLD2Bzip2

Addition package to JLD2 implementing the Bzip compression filter for JLD2.
Loading this package provides the filter type `BzipFilter`.
"""
module JLD2Bzip2

using JLD2: JLD2, Filters
using ChunkCodecLibBzip2

"""
    Bzip2Filter <: Filter

The Bzip2Filter can be used to compress datasets using the bzip2 compression algorithm.
This is filter id 307.

## Keyword arguments:
- `blocksize100k::Integer = 9`: Specifies the block size to be used for compression.

  It should be a value between 1 and 9 inclusive, and the actual block size used
  is 100000 x this figure. The default 9 gives the best compression but takes the most memory.

# External Links
* [BZIP2 HDF5 Filter ID 307](https://github.com/HDFGroup/hdf5_plugins/blob/master/docs/RegisteredFilterPlugins.md)
* [BZIP2 HDF5 Plugin Repository (C code)](https://github.com/HDFGroup/hdf5_plugins/tree/master/BZIP2/src)
"""
struct Bzip2Filter <: Filters.Filter
    blocksize100k::Cuint
end
Bzip2Filter(; blocksize100k::Integer=9) = Bzip2Filter(blocksize100k)

Filters.filterid(::Type{Bzip2Filter}) = UInt16(307)
Filters.filtername(::Type{Bzip2Filter}) = "BZIP2"
Filters.client_values(filter::Bzip2Filter) = (filter.blocksize100k, )
Filters.filtertype(::Val{307}) = Bzip2Filter

function Filters.apply_filter!(filter::Bzip2Filter, ref::Ref, forward::Bool=true, output_size::Union{Nothing,Integer}=nothing)
    if forward
        ref[] = encode(
            BZ2EncodeOptions(;
                blockSize100k=filter.blocksize100k,
            ),
            ref[]
        )
    else
        if output_size !== nothing
            ref[] = decode(BZ2DecodeOptions(), ref[]; size_hint=output_size)
        else
            ref[] = decode(BZ2DecodeOptions(), ref[])
        end
    end
    return 0
end

export Bzip2Filter

end # module JLD2Bzip2

"""
    JLD2Lz4

Addition package to JLD2 implementing the Lz4 compression filter for JLD2.
Loading this package provides the filter type `Lz4Filter`.
"""
module JLD2Lz4
using JLD2: JLD2, Filters
using ChunkCodecLibLz4

const DEFAULT_BLOCK_SIZE = 1 << 30

"""

    Lz4Filter <: Filter

The Lz4Filter can be used to compress datasets using the lz4 compression algorithm.
This is filter id 32004.

## Keyword arguments:
- `blocksize::Integer = 2^30`: Block size in bytes at most 2,113,929,216 bytes. Default is 1 GiB.

# External Links
* [LZ4 HDF5 Filter ID 32004](https://github.com/HDFGroup/hdf5_plugins/blob/master/docs/RegisteredFilterPlugins.md)
* [LZ4 HDF5 Plugin Repository (C code)](https://github.com/HDFGroup/hdf5_plugins/tree/master/LZ4/src)
"""
struct Lz4Filter <: Filters.Filter
    blocksize::Cuint
end
Lz4Filter(; blocksize::Integer=DEFAULT_BLOCK_SIZE) = Lz4Filter(blocksize)


Filters.filterid(::Type{Lz4Filter}) = UInt16(32004)
Filters.filtername(::Type{Lz4Filter}) = "LZ4H5"
Filters.client_values(filter::Lz4Filter) = (filter.blocksize, )
Filters.filtertype(::Val{32004}) = Lz4Filter

function Filters.apply_filter!(filter::Lz4Filter, ref::Ref, forward::Bool=true, output_size::Union{Nothing,Integer}=nothing)
    if forward
        buf = ref[]
        # This check is to avoid confusion with LZ4 Frame magic
        # for backwards compatibility with pre 0.6 JLD2 files
        # This is never going to error unless someone can encode about 
        # 300 PB in a single chunk.
        if UInt64(length(buf))>>32 == 0x0422_4D18
            throw(UnsupportedFeatureException("This particular dataset size is disallowed for the Lz4Filter. Please use a different compression filter."))
        end
        ref[] = encode(
            LZ4HDF5EncodeOptions(;
                blockSize=filter.blocksize,
                compressionLevel = 0,
            ),
            ref[]
        )
    else
        buf = ref[]
        # For backwards compatibility with pre 0.6 JLD2 files
        # check if this is actually the LZ4 Frame format
        # Fortunately because LZ4 Frame and LZ4 HDF5 formats have incompatible
        # headers, we can distinguish the formats by looking at the first 4 bytes.
        # https://github.com/HDFGroup/hdf5_plugins/issues/134#issuecomment-2484434118
        if length(buf) ≥ 4 &&
                buf[1] == 0x04 &&
                buf[2] == 0x22 &&
                buf[3] == 0x4D &&
                buf[4] == 0x18
            if output_size !== nothing
                ref[] = decode(LZ4FrameDecodeOptions(), ref[]; size_hint=output_size)
            else
                ref[] = decode(LZ4FrameDecodeOptions(), ref[])
            end
        else
            if output_size !== nothing
                ref[] = decode(LZ4HDF5DecodeOptions(), ref[]; size_hint=output_size)
            else
                ref[] = decode(LZ4HDF5DecodeOptions(), ref[])
            end
        end
    end
    return 0
end

export Lz4Filter

end # module JLD2Lz4

module Lookup3
import JLD2: jlunsafe_load, pconvert

# Original source at http://www.burtleburtle.net/bob/c/lookup3.c

# -------------------------------------------------------------------------------
# mix -- mix 3 32-bit values reversibly.

# This is reversible, so any information in (a,b,c) before mix() is
# still in (a,b,c) after mix().

# If four pairs of (a,b,c) inputs are run through mix(), or through
# mix() in reverse, there are at least 32 bits of the output that
# are sometimes the same for one pair and different for another pair.
# This was tested for:
# * pairs that differed by one bit, by two bits, in any combination
#   of top bits of (a,b,c), or in any combination of bottom bits of
#   (a,b,c).
# * "differ" is defined as +, -, ^, or ~^.  For + and -, I transformed
#   the output delta to a Gray code (a^(a>>1)) so a string of 1's (as
#   is commonly produced by subtraction) look like a single 1-bit
#   difference.
# * the base values were pseudorandom, all zero but one bit set, or
#   all zero plus a counter that starts at zero.

# Some k values for my "a-=c; a^=rot(c,k); c+=b;" arrangement that
# satisfy this are
#     4  6  8 16 19  4
#     9 15  3 18 27 15
#    14  9  3  7 17  3
# Well, "9 15 3 18 27 15" didn't quite get 32 bits diffing
# for "differ" defined as + with a one-bit base and a two-bit delta.  I
# used http://burtleburtle.net/bob/hash/avalanche.html to choose
# the operations, constants, and arrangements of the variables.

# This does not achieve avalanche.  There are input bits of (a,b,c)
# that fail to affect some output bits of (a,b,c), especially of a.  The
# most thoroughly mixed value is c, but it doesn't really even achieve
# avalanche in c.

# This allows some parallelism.  Read-after-writes are good at doubling
# the number of bits affected, so the goal of mixing pulls in the opposite
# direction as the goal of parallelism.  I did what I could.  Rotates
# seem to cost as much as shifts on every machine I could lay my hands
# on, and rotates are much kinder to the top and bottom bits, so I used
# rotates.
# -------------------------------------------------------------------------------
@inline function mix(a, b, c)
    a -= c;  a ⊻= bitrotate(c, 4);  c += b
    b -= a;  b ⊻= bitrotate(a, 6);  a += c
    c -= b;  c ⊻= bitrotate(b, 8);  b += a
    a -= c;  a ⊻= bitrotate(c,16);  c += b
    b -= a;  b ⊻= bitrotate(a,19);  a += c
    c -= b;  c ⊻= bitrotate(b, 4);  b += a
    (a, b, c)
end

# # -------------------------------------------------------------------------------
# final -- final mixing of 3 32-bit values (a,b,c) into c

# Pairs of (a,b,c) values differing in only a few bits will usually
# produce values of c that look totally different.  This was tested for
# * pairs that differed by one bit, by two bits, in any combination
#   of top bits of (a,b,c), or in any combination of bottom bits of
#   (a,b,c).
# * "differ" is defined as +, -, ^, or ~^.  For + and -, I transformed
#   the output delta to a Gray code (a^(a>>1)) so a string of 1's (as
#   is commonly produced by subtraction) look like a single 1-bit
#   difference.
# * the base values were pseudorandom, all zero but one bit set, or
#   all zero plus a counter that starts at zero.

# These constants passed:
#  14 11 25 16 4 14 24
#  12 14 25 16 4 14 24
# and these came close:
#   4  8 15 26 3 22 24
#  10  8 15 26 3 22 24
#  11  8 15 26 3 22 24
# -------------------------------------------------------------------------------
@inline function final(a, b, c)
    c ⊻= b; c -= bitrotate(b,14)
    a ⊻= c; a -= bitrotate(c,11)
    b ⊻= a; b -= bitrotate(a,25)
    c ⊻= b; c -= bitrotate(b,16)
    a ⊻= c; a -= bitrotate(c, 4)
    b ⊻= a; b -= bitrotate(a,14)
    c ⊻= b; c -= bitrotate(b,24)
    c
end

# -------------------------------------------------------------------------------
# hashlittle() -- hash a variable-length key into a 32-bit value
#   k       : the key (the unaligned variable-length array of bytes)
#   length  : the length of the key, counting by bytes
#   initval : can be any 4-byte value
# Returns a 32-bit value.  Every bit of the key affects every bit of
# the return value.  Two keys differing by one or two bits will have
# totally different hash values.

# The best hash table sizes are powers of 2.  There is no need to do
# mod a prime (mod is sooo slow!).  If you need less than 32 bits,
# use a bitmask.  For example, if you need only 10 bits, do
#   h = (h & hashmask(10));
# In which case, the hash table should have hashsize(10) elements.

# If you are hashing n strings (uint8_t **)k, do it like this:
#   for (i=0, h=0; i<n; ++i) h = hashlittle( k[i], len[i], h);

# By Bob Jenkins, 2006.  bob_jenkins@burtleburtle.net.  You may use this
# code any way you wish, private, educational, or commercial.  It's free.

# Use for hash table lookup, or anything where one collision in 2^^32 is
# acceptable.  Do NOT use for cryptographic purposes.
# -------------------------------------------------------------------------------
function hash(k::AbstractVector{UInt8}, istart::Integer=1, n::Integer=length(k), initval::UInt32=UInt32(0))
    n <= length(k) || throw(BoundsError())
    GC.@preserve k hash(pointer(k, istart), n, initval)
end

function hash(k::Ptr{UInt8}, n::Integer=length(k), initval::UInt32=UInt32(0))
    # Set up the internal state
    a = b = c = 0xdeadbeef + n%UInt32 + initval

    # --------------- all but the last block: affect some 32 bits of (a,b,c)
    ptr = k
    # @inbounds while n > 12
    #     a += k[offset]
    #     a += convert(UInt32, k[offset+1])<<8
    #     a += convert(UInt32, k[offset+2])<<16
    #     a += convert(UInt32, k[offset+3])<<24
    #     @show a
    #     b += k[offset+4]
    #     b += convert(UInt32, k[offset+5])<<8
    #     b += convert(UInt32, k[offset+6])<<16
    #     b += convert(UInt32, k[offset+7])<<24
    #     @show b
    #     c += k[offset+8]
    #     c += convert(UInt32, k[offset+9])<<8
    #     c += convert(UInt32, k[offset+10])<<16
    #     c += convert(UInt32, k[offset+11])<<24
    #     @show c
    #     (a, b, c) = mix(a, b, c)
    #     n -= 12
    #     offset += 12
    # end
    @inbounds while n > 12
        a += jlunsafe_load(pconvert(Ptr{UInt32}, ptr))
        ptr += 4
        b += jlunsafe_load(pconvert(Ptr{UInt32}, ptr))
        ptr += 4
        c += jlunsafe_load(pconvert(Ptr{UInt32}, ptr))
        (a, b, c) = mix(a, b, c)
        ptr += 4
        n -= 12
    end

    # -------------------------------- last block: affect all 32 bits of (c)
    # @inbounds if n > 0
    #     n >= 12 && (c += convert(UInt32, k[offset+11])<<24)
    #     n >= 11 && (c += convert(UInt32, k[offset+10])<<16)
    #     n >= 10 && (c += convert(UInt32, k[offset+9])<<8)
    #     n >= 9  && (c += k[offset+8])
    #     n >= 8  && (b += convert(UInt32, k[offset+7])<<24)
    #     n >= 7  && (b += convert(UInt32, k[offset+6])<<16)
    #     n >= 6  && (b += convert(UInt32, k[offset+5])<<8)
    #     n >= 5  && (b += k[offset+4])
    #     n >= 4  && (a += convert(UInt32, k[offset+3])<<24)
    #     n >= 3  && (a += convert(UInt32, k[offset+2])<<16)
    #     n >= 2  && (a += convert(UInt32, k[offset+1])<<8)
    #     n >= 1  && (a += k[offset])
    #     c = final(a, b, c)
    # end
    @inbounds if n > 0
        if n == 12
            c += jlunsafe_load(pconvert(Ptr{UInt32}, ptr+8))
            @goto n8
        elseif n == 11
            c += UInt32(jlunsafe_load(Ptr{UInt8}(ptr+10)))<<16
            @goto n10
        elseif n == 10
            @label n10
            c += UInt32(jlunsafe_load(Ptr{UInt8}(ptr+9)))<<8
            @goto n9
        elseif n == 9
            @label n9
            c += jlunsafe_load(ptr+8)
            @goto n8
        elseif n == 8
            @label n8
            b += jlunsafe_load(pconvert(Ptr{UInt32}, ptr+4))
            @goto n4
        elseif n == 7
            @label n7
            b += UInt32(jlunsafe_load(Ptr{UInt8}(ptr+6)))<<16
            @goto n6
        elseif n == 6
            @label n6
            b += UInt32(jlunsafe_load(Ptr{UInt8}(ptr+5)))<<8
            @goto n5
        elseif n == 5
            @label n5
            b += jlunsafe_load(ptr+4)
            @goto n4
        elseif n == 4
            @label n4
            a += jlunsafe_load(pconvert(Ptr{UInt32}, ptr))
        elseif n == 3
            @label n3
            a += UInt32(jlunsafe_load(Ptr{UInt8}(ptr+2)))<<16
            @goto n2
        elseif n == 2
            @label n2
            a += UInt32(jlunsafe_load(Ptr{UInt8}(ptr+1)))<<8
            @goto n1
        elseif n == 1
            @label n1
            a += jlunsafe_load(ptr)
        end
        c = final(a, b, c)
    end
    c
end
end

## Primitive datatypes
# These get special handling only in that they have different HDF5 type
# representations than ordinary opaque types

# This construction prevents these methods from getting called on type unions
const SignedTypes        = [Int8, Int16, Int32, Int64, Int128]
const UnsignedTypes      = [UInt8, UInt16, UInt32, UInt64, UInt128]
const FloatTypes         = [Float16, Float32, Float64]
const PrimitiveTypes     = [SignedTypes; UnsignedTypes; FloatTypes; Bool]
const PrimitiveTypeTypes = Union{(Type{T} for T in PrimitiveTypes)...}

for T in SignedTypes
    @eval h5fieldtype(::JLDFile, ::Type{$T}, ::Type{$T}, ::Initialized) =
        FixedPointDatatype($(sizeof(T)), true)
end
for T in UnsignedTypes
    @eval h5fieldtype(::JLDFile, ::Type{$T}, ::Type{$T}, ::Initialized) =
        FixedPointDatatype($(sizeof(T)), false)
end

struct BENumber{T}
    x::T
end

jlconvert(::MappedRepr{T,BENumber{T}}, ::JLDFile, ptr::Ptr, ::RelOffset) where {T} =
    bswap(jlunsafe_load(pconvert(Ptr{T}, ptr)))

function jltype(f::JLDFile, dt::FixedPointDatatype)
    signed = Bool(dt.bitfield1 >> 3 & 0b1)
    endianness = dt.bitfield1 & 0b1 # 0 → little endian, 1 → big endian
    #endianness == 0 || throw(UnsupportedFeatureException("load big endian numbers is not implemented."))
    ((dt.bitfield2 == 0x00) & (dt.bitfield3 == 0x00) & (dt.bitoffset == 0) & (dt.bitprecision == dt.size*8)) ||
        throw(UnsupportedFeatureException())
    if endianness == 0
        if dt.size == 8
            return signed ? SameRepr{Int64}() : SameRepr{UInt64}()
        elseif dt.size == 1
            return signed ? SameRepr{Int8}() : SameRepr{UInt8}()
        elseif dt.size == 4
            return signed ? SameRepr{Int32}() : SameRepr{UInt32}()
        elseif dt.size == 2
            return signed ? SameRepr{Int16}() : SameRepr{UInt16}()
        elseif dt.size == 16
            return signed ? SameRepr{Int128}() : SameRepr{UInt128}()
        else
            throw(UnsupportedFeatureException())
        end
    else
        if dt.size == 8
            return signed ? MappedRepr{Int64,BENumber{Int64}}() : MappedRepr{UInt64,BENumber{UInt64}}()
        elseif dt.size == 1
            return signed ? MappedRepr{Int8,BENumber{Int8}}() : MappedRepr{UInt8,BENumber{UInt8}}()
        elseif dt.size == 4
            return signed ? MappedRepr{Int32,BENumber{Int32}}() : MappedRepr{UInt32,BENumber{UInt32}}()
        elseif dt.size == 2
            return signed ? MappedRepr{Int16,BENumber{Int16}}() : MappedRepr{UInt16,BENumber{UInt16}}()
        elseif dt.size == 16
            return signed ? MappedRepr{Int128,BENumber{Int128}}() : MappedRepr{UInt128,BENumber{UInt128}}()
        else
            throw(UnsupportedFeatureException())
        end
    end
end

# Special handling for booleans as they are not considered <: Integer in HDF5
h5fieldtype(::JLDFile, ::Type{Bool}, ::Type{Bool}, ::Initialized) =BitFieldDatatype(1)
jltype(::JLDFile, ::BitFieldDatatype) = SameRepr{Bool}()

h5fieldtype(::JLDFile, ::Type{Float16}, ::Type{Float16}, ::Initialized) =
    FloatingPointDatatype(UInt8(DT_FLOATING_POINT) + 0x3<<4, 0x20, 0x0f, 0x00, 2, 0, 16, 10, 5, 0, 10, 0x0000000f)
h5fieldtype(::JLDFile, ::Type{Float32}, ::Type{Float32}, ::Initialized) =
    FloatingPointDatatype(UInt8(DT_FLOATING_POINT) + 0x3<<4, 0x20, 0x1f, 0x00, 4, 0, 32, 23, 8, 0, 23, 0x0000007f)
h5fieldtype(::JLDFile, ::Type{Float64}, ::Type{Float64}, ::Initialized) =
    FloatingPointDatatype(UInt8(DT_FLOATING_POINT) + 0x3<<4, 0x20, 0x3f, 0x00, 8, 0, 64, 52, 11, 0, 52, 0x000003ff)

h5fieldtype(::JLDFile, ::Type{BENumber{Float16}}, ::Type{Float16}, ::Initialized) =
    FloatingPointDatatype(UInt8(DT_FLOATING_POINT) + 0x3<<4, 0x21, 0x0f, 0x00, 2, 0, 16, 10, 5, 0, 10, 0x0000000f)
h5fieldtype(::JLDFile, ::Type{BENumber{Float32}}, ::Type{Float32}, ::Initialized) =
    FloatingPointDatatype(UInt8(DT_FLOATING_POINT) + 0x3<<4, 0x21, 0x1f, 0x00, 4, 0, 32, 23, 8, 0, 23, 0x0000007f)
h5fieldtype(::JLDFile, ::Type{BENumber{Float64}}, ::Type{Float64}, ::Initialized) =
    FloatingPointDatatype(UInt8(DT_FLOATING_POINT) + 0x3<<4, 0x21, 0x3f, 0x00, 8, 0, 64, 52, 11, 0, 52, 0x000003ff)

function jltype(f::JLDFile, dt::FloatingPointDatatype)
    if dt == h5fieldtype(f, Float64, Float64, Val{true})
        return SameRepr{Float64}()
    elseif dt == h5fieldtype(f, Float32, Float32, Val{true})
        return SameRepr{Float32}()
    elseif dt == h5fieldtype(f, Float16, Float16, Val{true})
        return SameRepr{Float16}()
    elseif dt == h5fieldtype(f, BENumber{Float64}, Float64, Val{true})
        return MappedRepr{Float32,BENumber{Float32}}()
    elseif dt == h5fieldtype(f, BENumber{Float32}, Float32, Val{true})
        return MappedRepr{Float32,BENumber{Float32}}()
    elseif dt == h5fieldtype(f, BENumber{Float16}, Float16, Val{true})
        return MappedRepr{Float32,BENumber{Float32}}()
    else
        throw(UnsupportedFeatureException())
    end
end

function h5fieldtype(f::JLDFile, writeas::PrimitiveTypeTypes, readas::Type, init::Initialized)
    @lookup_committed f readas
    commit(f, h5fieldtype(f, writeas, writeas, init), writeas, readas)
end
h5type(f::JLDFile, writeas::PrimitiveTypeTypes, x) =
    h5fieldtype(f, writeas, typeof(x), Val{true})

# Used only for custom serialization
constructrr(f::JLDFile, T::PrimitiveTypeTypes, dt::Union{FixedPointDatatype,FloatingPointDatatype},
            ::Vector{ReadAttribute}) =
    dt == h5fieldtype(f, T, T, Val{true}) ? (SameRepr{T}(), true) :
                                            throw(UnsupportedFeatureException())

# —————————————————————————————————————————————————————————————————————————————————————— #
#             Extension of @unpack and @pack! function from UnPack.jl package            #
# —————————————————————————————————————————————————————————————————————————————————————— #
module UnPackExt
using JLD2
using JLD2: JLDFile, MmapIO, Group
using UnPack

"""
Unpack fields from JLD2-files created with e.g. `file = jldopen(path)`. Also works for JLD2 groups. Useful for quick extraction.

# Example
```julia
file = jldopen(path) # contains fields :x, :y
@unpack x, y = file # Extracts x and y from the struct
```
"""
@inline function UnPack.unpack(x::Union{T, Group{T}}, ::Val{f}) where {f, T<:JLDFile{MmapIO}}
    return x[string(f)]
end

"""
Pack variables into JLD2-files. Also works for JLD2 groups. Useful for quick saving.

# Example
```julia
x = rand(10)
path = "temp.jld2"
file = jldopen(path, "w")
@pack! file = x # Creates entry with name x
close(file)
```
"""
@inline function UnPack.pack!(file::Union{T, Group{T}}, ::Val{f}, val) where {f, T<:JLDFile{MmapIO}}
    file[string(f)] = val
end

end

using Documenter
using JLD2
using Documenter.Remotes: GitHub

makedocs(;
    modules = [JLD2],
    sitename = "Julia Data Format",
    build = "build",
    clean = true,
    doctest = true,
    checkdocs = :exports,
    #root = "./",
    #src = "src",
    repo = GitHub("JuliaIO/JLD2.jl"),
    pages = [
        "Home" => "index.md",
        "Basic Usage" => "basic_usage.md",
        "Custom Serialization" => "customserialization.md",
        "Compression" => "compression.md",
        "Internals & Design" => "internals.md",
        "HDF5 Compatibility" => "hdf5compat.md",
        "Advanced Usage" => "advanced.md",
        "Legacy" => "legacy.md",
        "Troubleshooting" => "troubleshooting.md"
    ],
    warnonly = [:cross_references],
)

deploydocs(
    repo = "github.com/JuliaIO/JLD2.jl.git",
    target = "build",
    push_preview = true,
)

#
# Miscellaneous functions
#

"""
    read_size(io::IO, flags::UInt8)

Loads a variable-length size according to flags

Expects that the first two bits of flags mean:
- 0:   The size of the Length of Link Name field is 1 byte.
- 1:   The size of the Length of Link Name field is 2 bytes.
- 2:   The size of the Length of Link Name field is 4 bytes.
- 3:   The size of the Length of Link Name field is 8 bytes.

Returns the size as an `Int`.
"""
function read_size(io::IO, flags::UInt8)
    if (flags & 3) == 0
        Int(jlread(io, UInt8))
    elseif (flags & 3) == 1
        Int(jlread(io, UInt16))
    elseif (flags & 3) == 2
        Int(jlread(io, UInt32))
    else
        Int(jlread(io, UInt64))
    end
end

"""
    size_flag(sz::Integer)::UInt8

Return the flag that represents the smallest integer type that can represent `sz`.
0 -> UInt8, 1 -> UInt16, 2 -> UInt32, 3 -> UInt64
"""
function size_flag(sz::Integer)
    if sz <= typemax(UInt8)
        UInt8(0)
    elseif sz <= typemax(UInt16)
        UInt8(1)
    elseif sz <= typemax(UInt32)
        UInt8(2)
    else
        UInt8(3)
    end
end

"""
    write_size(io::IO, sz::Integer)

Write the mininum number of bytes required to represent `sz` as (valid) unsigned integer.
"""
function write_size(io::IO, sz::Integer)
    if sz <= typemax(UInt8)
        jlwrite(io, UInt8(sz))
    elseif sz <= typemax(UInt16)
        jlwrite(io, UInt16(sz))
    elseif sz <= typemax(UInt32)
        jlwrite(io, UInt32(sz))
    else
        jlwrite(io, UInt64(sz))
    end
end

"""
    size_size(sz::Integer)

Return the number of bytes required to represent `sz` as an unsigned integer
that actually exists. (e.g. UInt8, UInt16, UInt32, UInt64)
"""
function size_size(sz::Integer)
    if sz <= typemax(UInt8)
        1
    elseif sz <= typemax(UInt16)
        2
    elseif sz <= typemax(UInt32)
        4
    else
        8
    end
end

"""
    size_size2(sz::Integer)

Return the number of bytes required to represent `sz` as an unsigned integer.
Note: this does not check if the integer is a valid julia integer.
"""
function size_size2(sz::Integer)
    if sz < 2^8
        1
    elseif sz < 2^16
        2
    elseif sz < 2^24
        3
    elseif sz < 2^32
        4
    elseif sz < 2^40
        5
    elseif sz < 2^48
        6
    elseif sz < 2^56
        7
    else
        8
    end
end


"""
    symbol_length(x::Symbol)

Returns the length of the string represented by `x`.
"""
symbol_length(x::Symbol) = ccall(:strlen, Int, (Cstring,), x)

"""
    uintofsize(sz::Integer)

Return the `UInt` type that has `sz` bytes.
"""
function uintofsize(sz)
    if sz == 1
        UInt8 
    elseif sz == 2
        UInt16
    elseif sz == 4
        UInt32
    elseif sz == 8 
        UInt64
    else
        throw(ArgumentError("There is no UInt type with $sz bytes"))
    end
end

"""
    skip_to_aligned!(io, rel=0)

Skip to nearest position aligned to a multiple of 8 bytes relative to `rel`.
"""
function skip_to_aligned!(io, rel=0)
    pos = position(io)
    pos += 8 - mod1(pos-rel, 8)
    seek(io, pos)
    return nothing
end


"""
    jlwrite(io::IO, x::Tuple)

Attempt to write a tuple to `io` by writing each element of the tuple in order.
"""
function jlwrite(io::IO, x::Tuple) 
    for y in x
        jlwrite(io, y)
    end
end

"""
    write_zerobytes(io, n)

Write `n` zero bytes to `io`.
"""
function write_zerobytes(io, n)
    for i in 1:n
        jlwrite(io, UInt8(0))
    end
end

"""
    isset(flag, bit)

Return true if the bit-th bit of `flag` is set. (starting from 0)   
"""
function isset(flag, bit)
    #return !iszero(flag & UInt8(2^(bit-1)))
    return Bool(flag >> (bit) & 1)
end

"""
    flag2uint(flag::UInt8)
I
Map the lowest to bits of `flag` to a `UInt` type, mapping 0 to `UInt8`, 1 to `UInt16`, 2 to `UInt32`, and 3 to `UInt64`.
"""
function flag2uint(flag::UInt8)
    # use lowest two bits
    value = flag << 6 >> 6
    if value == 0
        UInt8
    elseif value == 1
        UInt16
    elseif value == 2
        UInt32
    else
        UInt64
    end
end


jlread(io::IO, ::Type{Tuple{T, Vararg{T,N}}}) where {N,T} = ntuple(_->jlread(io, T), Val{N+1}())
jlread(io::IO, ::Type{Tuple{}}) = ()

function write_nb_int(io::IO, sz::Integer, nb::Integer)
    for i = 1:nb
        jlwrite(io, UInt8((sz >> (8*(i-1))) & 0xff))
    end
end

function read_nb_uint(io::IO, nb)
    val = zero(UInt64)
    for i = 1:nb
        val += jlread(io, UInt8) * 2^(8*(i-1))
    end
    val
end

@testset "Nested modules" begin
    @testset "issue #112 - Random.DSFMT" begin
        tmpdir = mktempdir()
        atexit(() -> rm(tmpdir; force = true, recursive = true))

        mycustomload_filename = joinpath(tmpdir, "mycustomload.jl")
        my_rng_filename = joinpath(tmpdir, "my_rng.jld2")
        saving_filename = joinpath(tmpdir, "saving.jl")
        loading_filename = joinpath(tmpdir, "loading.jl")

        mycustomload_contents = """
        module MyCustomLoad
        using FileIO, JLD2

        function load_my_rng(filename::AbstractString)
            d = FileIO.load(filename)
            my_rng = d["my_rng"]
            return my_rng
        end

        end # module
        """

        saving_contents = """
            using FileIO, JLD2, Random
            my_rng = Random.MersenneTwister(1)
            my_rng_filename = "$(my_rng_filename)"
            rm(my_rng_filename; force = true, recursive = true)
            FileIO.save(my_rng_filename, Dict("my_rng" => my_rng))
        """

        loading_contents = """
            tmpdir = "$(tmpdir)"
            include(joinpath(tmpdir, "mycustomload.jl"))
            using Random, Test
            my_rng_filename = "$(my_rng_filename)"
            my_rng = @test_nowarn MyCustomLoad.load_my_rng(my_rng_filename)
            @test my_rng isa Random.MersenneTwister
            using JLD2
            @test !JLD2.isreconstructed(my_rng)
            @test !JLD2.isreconstructed(Random.MersenneTwister)
        """

        rm(mycustomload_filename; force = true, recursive = true)
        rm(my_rng_filename; force = true, recursive = true)
        rm(saving_filename; force = true, recursive = true)
        rm(loading_filename; force = true, recursive = true)

        if Sys.iswindows()
            saving_contents = replace(saving_contents, '\\' => "\\\\")
            loading_contents = replace(loading_contents, '\\' => "\\\\")
        end

        open(mycustomload_filename, "w") do io
            println(io, mycustomload_contents)
        end
        open(saving_filename, "w") do io
            println(io, saving_contents)
        end
        open(loading_filename, "w") do io
            println(io, loading_contents)
        end

        saving_cmd = `$(julia_proj_cmd) $(saving_filename)`
        loading_cmd = `$(julia_proj_cmd) $(loading_filename)`

        rm(my_rng_filename; force = true, recursive = true)

        @test better_success(saving_cmd)
        @test better_success(loading_cmd)

        rm(tmpdir; force = true, recursive = true)
    end
    @testset "Struct that exists in Main" begin
        tmpdir = mktempdir()
        atexit(() -> rm(tmpdir; force = true, recursive = true))

        mycustomload_filename = joinpath(tmpdir, "mycustomload.jl")
        my_object_filename = joinpath(tmpdir, "my_object.jld2")
        saving_filename = joinpath(tmpdir, "saving.jl")
        loading_filename = joinpath(tmpdir, "loading.jl")

        mycustomload_contents = """
        module MyCustomLoad
        using FileIO, JLD2

        function load_my_object(filename::AbstractString)
            d = FileIO.load(filename)
            my_object = d["my_object"]
            return my_object
        end

        end # module
        """

        saving_contents = """
            using FileIO, JLD2
            abstract type AbstractFoo end
            abstract type AbstractBar <: AbstractFoo end
            struct Baz <: AbstractBar
                x::Int
                y::Int
                z::Int
            end
            my_object = Baz(1, 2, 3)
            my_object_filename = "$(my_object_filename)"
            rm(my_object_filename; force = true, recursive = true)
            FileIO.save(my_object_filename, Dict("my_object" => my_object))
        """

        loading_contents = """
            tmpdir = "$(tmpdir)"
            include(joinpath(tmpdir, "mycustomload.jl"))
            using Test
            my_object_filename = "$(my_object_filename)"
            abstract type AbstractFoo end
            abstract type AbstractBar <: AbstractFoo end
            struct Baz <: AbstractBar
                x::Int
                y::Int
                z::Int
            end
            my_object = @test_nowarn MyCustomLoad.load_my_object(my_object_filename)
            @test my_object isa Baz
            @test my_object.x == 1
            @test my_object.y == 2
            @test my_object.z == 3
            using JLD2
            @test !JLD2.isreconstructed(my_object)
            @test !JLD2.isreconstructed(Baz)
        """

        rm(mycustomload_filename; force = true, recursive = true)
        rm(my_object_filename; force = true, recursive = true)
        rm(saving_filename; force = true, recursive = true)
        rm(loading_filename; force = true, recursive = true)

        if Sys.iswindows()
            saving_contents = replace(saving_contents, '\\' => "\\\\")
            loading_contents = replace(loading_contents, '\\' => "\\\\")
        end

        open(mycustomload_filename, "w") do io
            println(io, mycustomload_contents)
        end
        open(saving_filename, "w") do io
            println(io, saving_contents)
        end
        open(loading_filename, "w") do io
            println(io, loading_contents)
        end

        saving_cmd = `$(julia_proj_cmd) $(saving_filename)`
        loading_cmd = `$(julia_proj_cmd) $(loading_filename)`

        rm(my_object_filename; force = true, recursive = true)

        @test better_success(saving_cmd)
        @test better_success(loading_cmd)

        rm(tmpdir; force = true, recursive = true)
    end
    @testset "Struct that cannot be found and needs to be reconstruct" begin
        tmpdir = mktempdir()
        atexit(() -> rm(tmpdir; force = true, recursive = true))

        mycustomload_filename = joinpath(tmpdir, "mycustomload.jl")
        my_object_filename = joinpath(tmpdir, "my_object.jld2")
        saving_filename = joinpath(tmpdir, "saving.jl")
        loading_filename = joinpath(tmpdir, "loading.jl")

        mycustomload_contents = """
        module MyCustomLoad
        using FileIO, JLD2

        function load_my_object(filename::AbstractString)
            d = FileIO.load(filename)
            my_object = d["my_object"]
            return my_object
        end

        end # module
        """

        saving_contents = """
            using FileIO, JLD2
            abstract type AbstractFoo end
            abstract type AbstractBar <: AbstractFoo end
            struct Baz <: AbstractBar
                x::Int
                y::Int
                z::Int
            end
            my_object = Baz(1, 2, 3)
            my_object_filename = "$(my_object_filename)"
            rm(my_object_filename; force = true, recursive = true)
            FileIO.save(my_object_filename, Dict("my_object" => my_object))
        """

        loading_contents = """
            tmpdir = "$(tmpdir)"
            include(joinpath(tmpdir, "mycustomload.jl"))
            using Test
            my_object_filename = "$(my_object_filename)"
            my_object = @test_logs (:warn, "type Main.Baz does not exist in workspace; reconstructing") MyCustomLoad.load_my_object(my_object_filename)
            @test my_object.x == 1
            @test my_object.y == 2
            @test my_object.z == 3
            using JLD2
            @test JLD2.isreconstructed(my_object)
        """

        rm(mycustomload_filename; force = true, recursive = true)
        rm(my_object_filename; force = true, recursive = true)
        rm(saving_filename; force = true, recursive = true)
        rm(loading_filename; force = true, recursive = true)

        if Sys.iswindows()
            saving_contents = replace(saving_contents, '\\' => "\\\\")
            loading_contents = replace(loading_contents, '\\' => "\\\\")
        end

        open(mycustomload_filename, "w") do io
            println(io, mycustomload_contents)
        end
        open(saving_filename, "w") do io
            println(io, saving_contents)
        end
        open(loading_filename, "w") do io
            println(io, loading_contents)
        end

        saving_cmd = `$(julia_proj_cmd) $(saving_filename)`
        loading_cmd = `$(julia_proj_cmd) $(loading_filename)`

        rm(my_object_filename; force = true, recursive = true)

        @test better_success(saving_cmd)
        @test better_success(loading_cmd)

        rm(tmpdir; force = true, recursive = true)
    end
    @testset "issue #154 - type exists in child module but not in parent module" begin
        code = """
        using JLD2

        # Always start fresh
        rm("test.jld"; force=true)

        # Write out jld file in child module
        module Child
        using JLD2, LinearAlgebra, Pkg
        jldopen("test.jld", "w") do io
            # Symmetric is correctly loadable
            io["linalg_obj"] = Symmetric(randn(2,2,))

            # PackageSpec is actually Pkg.Types.PackageSpec
            io["pkg_types_obj"] = PackageSpec(;name = "Foo")
        end
        @info("Wrote out to test.jld")

        # Parent module will call do_read()
        function do_read()
            jldopen("test.jld", "r") do io
                io["linalg_obj"], io["pkg_types_obj"]
            end
        end
        end # module Child

        # Read it out in parent module (where Pkg and LinearAlgebra don't exist)
        import .Child

        result = Child.do_read()

        import Test

        Test.@test result isa Tuple
        Test.@test length(result) == 2

        Test.@test size(result[1]) == (2, 2)
        Test.@test length(result[1]) == 4
        Test.@test result[1][1] isa Float64
        Test.@test result[1][2] isa Float64
        Test.@test result[1][3] isa Float64
        Test.@test result[1][4] isa Float64

        Test.@test result[2].name isa String
        Test.@test result[2].name == "Foo"

        Test.@test !JLD2.isreconstructed(result)

        Test.@test !JLD2.isreconstructed(result[1])
        Test.@test !JLD2.isreconstructed(result[1][1])
        Test.@test !JLD2.isreconstructed(result[1][2])
        Test.@test !JLD2.isreconstructed(result[1][3])
        Test.@test !JLD2.isreconstructed(result[1][4])

        Test.@test !JLD2.isreconstructed(result[2])
        Test.@test !JLD2.isreconstructed(result[2].name)

        # NOTE: we do not import Pkg and LinearAlgebra into the parent
        # module until AFTER we have run `Child.do_read()`
        import Pkg
        import LinearAlgebra

        Test.@test result[1] isa LinearAlgebra.Symmetric{Float64,Array{Float64,2}}
        Test.@test result[2] isa Pkg.Types.PackageSpec
        """
        my_cmd = `$(julia_proj_cmd) -e $(code)`
        cd(mktempdir()) do
            @test better_success(my_cmd)
        end
    end
end

using JLD2, Test, LinearAlgebra, Random

data = Dict{String, Any}()
# Seed random so that we get the same values every time
Random.seed!(1337)

# Define variables of different types
data["x"] = 3.7
data["A"] = A = reshape(1:15, 3, 5)
data["A3"] = reshape(1:30, 3, 5, 2)
data["A4"] = reshape(1:120, 2, 3, 4, 5)
data["Aarray"] = Vector{Float64}[[1.2,1.3],[2.2,2.3,2.4]]
data["basic_types"] = Any[UInt8(42), UInt16(42), UInt32(42), UInt64(42), UInt128(42),
                  Int8(42), Int16(42), Int32(42), Int64(42), Int128(42),
                  Float16(42), Float32(42), Float64(42)]
data["str"] = "Hello"
data["str_unicode"] = "pandapanda🐼panda"
data["str_embedded_null"] = "there is a null\0 in the middle of this string"
data["strings"] = String["It", "was", "a", "dark", "and", "stormy", "night"]
data["empty_string"] = ""
data["empty_string_array"] = String[]
data["empty_array_of_strings"] = String[""]
data["tf"] = true
data["TF"] = A .> 10
data["B"] = B = [-1.5 sqrt(2) NaN 6;
     0.0  Inf eps() -Inf]
data["AB"] = Any[A, B]
data["t"] = (3, "cat")
data["c"] = Complex{Float32}(3,7)
data["cint"] = 1+im  # issue 108
data["C"] = reshape(reinterpret(Complex{Float64}, B), (4,))
data["emptyA"] = zeros(0,2)
data["emptyB"] = zeros(2,0)
try
    global MyStruct
    mutable struct MyStruct
        len::Int
        data::Array{Float64}
        MyStruct(len::Int) = new(len)
        MyStruct(len::Int, data::Array{Float64}) = new(len, data)
    end
catch
end
data["ms"] = MyStruct(2, [3.2, -1.7])
data["msempty"] = MyStruct(5, Float64[])
data["sym"] = :TestSymbol
data["syms"] = syms = [:a, :b]
data["d"] = Dict([(syms[1],"aardvark"), (syms[2], "banana")])
data["oidd"] = IdDict([(syms[1],"aardvark"), (syms[2], "banana")])
# Incremental construction due to lacking constructor method in v1.0
data["imdd"] = Base.ImmutableDict(Base.ImmutableDict(syms[1]=>"aardvark"), syms[2]=>"banana")
data["ex"] = quote
    function incrementby1(x::Int)
        x+1
    end
end
data["T"] = UInt8
data["Tarr"] = DataType[UInt8, UInt16, UInt32, UInt64, UInt128]
data["char"] = 'x'
data["unicode_char"] = '\U10ffff'
data["α"] = 22
data["β"] = Any[[1, 2], [3, 4]]  # issue #93
data["vv"] = Vector{Int}[[1,2,3]]  # issue #123
data["typevar"] = Array{Int}[[1]]
data["typevar_lb"] = (Vector{U} where U<:Integer)[[1]]
data["typevar_ub"] = (Vector{U} where U>:Int)[[1]]
data["typevar_lb_ub"] = (Vector{U} where Int<:U<:Real)[[1]]
data["arr_undef"] = Vector{Any}(undef, 1)
data["arr_undefs"] = Matrix{Any}(undef, 2, 2)
data["ms_undef"] = MyStruct(0)
# Unexported type:
data["version_info"] = Base.GIT_VERSION_INFO
# Immutable type:
data["rng"] = 1:5
# Custom BitsType (#99)
primitive type MyBT 64 end
data["bt"] = bt = reinterpret(MyBT, Int64(55))
data["btarray"] = fill(bt, 5, 7)
# Symbol arrays (#100)
data["sa_asc"] = [:a, :b]
data["sa_utf8"] = [:α, :β]
# SubArray (to test tuple type params)
data["subarray"] = view([1:5;], 1:5)
# Array of empty tuples (to test tuple type params)
data["arr_empty_tuple"] = Tuple{}[]
struct EmptyImmutable end
data["emptyimmutable"] = emptyimmutable = EmptyImmutable()
data["arr_emptyimmutable"] = [emptyimmutable]
data["empty_arr_emptyimmutable"] = EmptyImmutable[]
mutable struct EmptyType end
data["emptytype"] = EmptyType()
data["arr_emptytype"] = [EmptyType()]
data["empty_arr_emptytype"] = EmptyImmutable[]
data["uninitialized_arr_emptytype"] = Vector{EmptyType}(undef, 1)
struct EmptyII
    x::EmptyImmutable
end
data["emptyii"] = EmptyII(EmptyImmutable())
struct EmptyIT
    x::EmptyType
end
data["emptyit"] = EmptyIT(EmptyType())
mutable struct EmptyTI
    x::EmptyImmutable
end
data["emptyti"] = EmptyTI(EmptyImmutable())
mutable struct EmptyTT
    x::EmptyType
end
data["emptytt"] = EmptyTT(EmptyType())
struct EmptyIIOtherField
    x::EmptyImmutable
    y::Float64
end
data["emptyiiotherfield"] = EmptyIIOtherField(EmptyImmutable(), 5.0)
struct EmptyIIType
    x::Type{Float64}
    y::EmptyImmutable
end
data["emptyiitype"] = EmptyIIType(Float64, EmptyImmutable())

# Unicode type field names (#118)
mutable struct MyUnicodeStruct☺{τ}
    α::τ
    ∂ₓα::τ
    MyUnicodeStruct☺{τ}(α::τ, ∂ₓα::τ) where τ = new(α, ∂ₓα)
end
data["unicodestruct☺"] = MyUnicodeStruct☺{Float64}(1.0, -1.0)
# Arrays of matrices (#131)
data["array_of_matrices"] = Matrix{Int}[[1 2; 3 4], [5 6; 7 8]]
# Tuple of arrays and bitstype
data["tup"] = (1, 2, [1, 2], [1 2; 3 4], bt)
# Empty tuple
data["empty_tup"] = ()
# Non-pointer-free struct
struct MyImmutable{T}
    x::Int
    y::Vector{T}
    z::Bool
end
data["nonpointerfree_immutable_1"] = MyImmutable(1, [1., 2., 3.], false)
data["nonpointerfree_immutable_2"] = MyImmutable(2, Any[3., 4., 5.], true)
struct MyImmutable2
    x::Vector{Int}
    MyImmutable2() = new()
end
data["nonpointerfree_immutable_3"] = MyImmutable2()
struct Vague
    name::String
end
data["vague"] = Vague("foo")
# Immutable with a union of BitsTypes
struct BitsUnion
    x::Union{Int64,Float64}
end
data["bitsunion"] = BitsUnion(5.0)
# Immutable with a union of Types
struct TypeUnionField
    x::Type{T} where T<:Union{Int64,Float64}
end
data["typeunionfield"] = TypeUnionField(Int64)
# Generic union type field
struct GenericUnionField
    x::Union{Vector{Int},Int}
end
data["genericunionfield"] = GenericUnionField(1)
# Array references
data["arr_contained"] = arr_contained = [1, 2, 3]
data["arr_ref"] = arr_ref = typeof(arr_contained)[]
push!(arr_ref, arr_contained, arr_contained)
# Object references
mutable struct ObjRefType
    x::ObjRefType
    y::ObjRefType
    ObjRefType() = new()
    ObjRefType(x, y) = new(x, y)
end
ref1 =ObjRefType()
data["obj_ref"] = ObjRefType(ObjRefType(ref1, ref1), ObjRefType(ref1, ref1))
# Immutable that requires padding between elements in array
struct PaddingTest
    x::Int64
    y::Int8
end
data["padding_test"] = PaddingTest[PaddingTest(i, i) for i = 1:8]
# Empty arrays of various types and sizes
data["empty_arr_1"] = Int[]
data["empty_arr_2"] = Matrix{Int}(undef, 56, 0)
data["empty_arr_3"] = Any[]
data["empty_arr_4"] = Matrix{Any}(undef, 0, 97)
# Moderately big dataset (which will be mmapped)
data["bigdata"] = [1:1000000;]
# BigFloats and BigInts
data["bigint"] = big(3)
data["bigfloat"] = big(3.2)
data["bigints"] = big(3).^(1:100)
data["bigfloats"] = big(3.2).^(1:100)
struct BigFloatIntObject
    bigfloat::BigFloat
    bigint::BigInt
end
data["bigfloatintobj"] = BigFloatIntObject(big(pi), big(typemax(UInt128))+1)
# None
data["none"] = Union{}
data["nonearr"] = Vector{Union{}}(undef, 5)
# nothing/Nothing
data["scalar_nothing"] = nothing
data["vector_nothing"] = Union{Int,Nothing}[1,nothing]

# some data big enough to ensure that compression is used:
data["Abig"] = kron(Matrix{Float64}(I, 10, 10), rand(20, 20))
data["Bbig"] = Any[i for i=1:3000]
data["Sbig"] = "A test string "^1000

# Bitstype type parameters
mutable struct BitsParams{x}; end
data["bitsparamfloat"]  = BitsParams{1.0}()
data["bitsparambool"]   = BitsParams{true}()
data["bitsparamsymbol"] = BitsParams{:x}()
data["bitsparamint"]    = BitsParams{1}()
data["bitsparamuint"]   = BitsParams{0x01}()
data["bitsparamint16"]  = BitsParams{Int16(1)}()

# Tuple of tuples
data["tuple_of_tuples"] = (1, 2, (3, 4, [5, 6]), [7, 8])

# Zero-dimensional arrays
data["zerod"] = zerod = Array{Int}(undef)
zerod[] = 1
data["zerod_any"] = zerod_any = Array{Any}(undef)
zerod_any[] = 1.0+1.0im

# Cyclic object
mutable struct CyclicObject
    x::CyclicObject

    CyclicObject() = new()
    CyclicObject(x) = new(x)
end
data["cyclicobject"] = CyclicObject()
data["cyclicobject"].x = data["cyclicobject"]

# SimpleVector
data["simplevec"] = Core.svec(1, 2, Int64, "foo")
iseq(x::Core.SimpleVector, y::Core.SimpleVector) = collect(x) == collect(y)

# JLD issue #243
# Type that overloads != so that it is not boolean
mutable struct NALikeType; end
Base.:!=(::NALikeType, ::NALikeType) = NALikeType()
Base.:!=(::NALikeType, ::Nothing) = NALikeType()
Base.:!=(::Nothing, ::NALikeType) = NALikeType()
data["natyperef"] = Any[NALikeType(), NALikeType()]

# JLD2 issue #31 (lots of strings)
data["lotsastrings"] = fill("a", 100000)

iseq(x,y) = isequal(x,y)
function iseq(x::Array{EmptyType}, y::Array{EmptyType})
    size(x) != size(y) && return false
    for i = 1:length(x)
        def = isassigned(x, i)
        def != isassigned(y, i) && return false
        if def
            iseq(x[i], y[i]) || return false
        end
    end
    return true
end
iseq(x::MyStruct, y::MyStruct) = (x.len == y.len && x.data == y.data)
iseq(x::MyImmutable, y::MyImmutable) = (isequal(x.x, y.x) && isequal(x.y, y.y) && isequal(x.z, y.z))
iseq(x::Union{EmptyTI,EmptyTT,EmptyIT}, y::Union{EmptyTI,EmptyTT,EmptyIT}) = iseq(x.x, y.x)
iseq(c1::Array, c2::Array) = length(c1) == length(c2) && all(p->iseq(p...), zip(c1, c2))
function iseq(c1::Base.Sys.CPUinfo, c2::Base.Sys.CPUinfo)
    for n in fieldnames(Base.Sys.CPUinfo)
        if getfield(c1, n) != getfield(c2, n)
            return false
        end
    end
    true
end
iseq(x::MyUnicodeStruct☺, y::MyUnicodeStruct☺) = (x.α == y.α && x.∂ₓα == y.∂ₓα)
iseq(x::Array{Union{}}, y::Array{Union{}}) = size(x) == size(y)
iseq(x::BigFloatIntObject, y::BigFloatIntObject) = (x.bigfloat == y.bigfloat && x.bigint == y.bigint)
iseq(x::T, y::T) where {T<:Union{EmptyType,EmptyImmutable,NALikeType}} = true
iseq(x::BitsParams{T}, y::BitsParams{S}) where {T,S} = (T == S)


# Test for equality of expressions, skipping line numbers
checkexpr(a, b) = @assert a == b
function checkexpr(a::Expr, b::Expr)
    @assert a.head == b.head
    i = 1
    j = 1
    while i <= length(a.args) && j <= length(b.args)
        if isa(a.args[i], Expr) && a.args[i].head == :line
            i += 1
            continue
        end
        if isa(b.args[j], Expr) && b.args[j].head == :line
            j += 1
            continue
        end
        checkexpr(a.args[i], b.args[j])
        i += 1
        j += 1
    end
    @assert i >= length(a.args) && j >= length(b.args)
end

fn = joinpath(mktempdir(), "test.jld")
openfuns = [
    (writef=() -> jldopen(fn, "w"; iotype=JLD2.MmapIO, compress=false),
     readf=() -> jldopen(fn, "r"; iotype=JLD2.MmapIO),
     inf="Mmap, uncompressed"),
    (writef=() -> jldopen(fn, "w"; iotype=IOStream, compress=false),
     readf=() -> jldopen(fn, "r"; iotype=IOStream),
     info="IOStream, uncompressed"),
     (writef=() -> jldopen(fn, "w"; iotype=JLD2.MmapIO, compress=true),
     readf=() -> jldopen(fn, "r"; iotype=JLD2.MmapIO),
     inf="Mmap, compressed"),
    (writef=() -> jldopen(fn, "w"; iotype=IOStream, compress=true),
     readf=() -> jldopen(fn, "r"; iotype=IOStream),
     inf="IOStream, compressed"),
    (writef=() -> (global io_buffer=IOBuffer(); jldopen(io_buffer, "w"; compress=false)),
     readf=() -> (seekstart(io_buffer); jldopen(io_buffer)),
     inf="IOBuffer, uncompressed"),
    (writef=() -> (global io_buffer=IOBuffer(); jldopen(io_buffer, "w"; compress=true)),
     readf=() -> (seekstart(io_buffer); jldopen(io_buffer)),
     inf="IOBuffer, compressed"),
]

function write_all(openfun, data)
    f = openfun()
    try
        for key in keys(data)
            write(f, key, data[key])
        end
    finally
        close(f)
    end
    nothing
end 

function check_all(openfun, data)
    f = openfun()
    try
        for key in keys(data)
            value = data[key]
            tmp = read(f, key)

            # Special cases for reading undefs
            if key=="arr_undef"
                !isa(tmp, Array{Any, 1}) || length(tmp) != 1 || isassigned(tmp, 1) &&
                error("For arr_undef, read value does not agree with written value")
            elseif key=="arr_undefs"
                !isa(tmp, Array{Any, 2}) || length(tmp) != 4 || any(map(i->isassigned(tmp, i), 1:4)) &&
                error("For arr_undefs, read value does not agree with written value")
            elseif key=="ms_undef"
                !isa(tmp, MyStruct) || tmp.len != 0 || isdefined(tmp, :data) &&
                error("For ms_undef, read value does not agree with written value")
            elseif key=="ex"
                checkexpr(value, tmp)
            elseif key=="vague"
                @test typeof(tmp) == typeof(value) && tmp.name == value.name
            elseif key=="arr_ref"
                @test tmp == arr_ref
                @test tmp[1] === tmp[2]
            elseif key=="obj_ref"
                @test tmp.x.x === tmp.x.y == tmp.y.x === tmp.y.y
                @test tmp.x !== tmp.y
            elseif key=="cyclicobject"
                @test tmp.x === tmp
            else
                written_type = typeof(value)
                if typeof(tmp) != written_type
                    error("For $key, read type $(typeof(tmp)) does not agree with written type $(written_type)")
                end
                try
                    @test iseq(tmp, value)
                catch
                    println("For $key, read value $tmp does not agree with written value $value")
                end
            end
        end
    finally
        close(f)
    end
    nothing
end


for (writef, readf, inf) in openfuns
    @info(inf)
    @info("  Write time:")
    @time write_all(writef, data)
    @info("  Read time:")
    @time check_all(readf, data)
end

# Gotchas & Troubleshooting

## Objects are cached during loading
JLD2 caches objects during loading. It may give you the same object twice.
This can lead to surprising results if you edit loaded arrays. Note, the underlying file is not being edited!

```@repl
using JLD2 #hide
jldsave("demo.jld2", a=zeros(2))
f = jldopen("demo.jld2")
a = f["a"] # bind loaded array to name `a`
a[1] = 42; # editing the underlying array
f["a"]
a = nothing # remove all references to the loaded array
GC.gc(true) # call GC to remove the cache
f["a"] # a new copy is loaded from the file
close(f) #hide
```

## Cross-compatibility
JLD2 tries to write files in a way that allows you to load them on different operating systems and in particular both on 32bit and 64bit systems.
However, many julia structs may be inherently different on different architectures making this task impossible.
In particular, moving data from a 64bit system to a 32bit system is only guaranteed to work for basic datatypes.

## Security
Beware of opening JLD2 files from untrusted sources. A malicious file may execute code on your computer.
See e.g. this project's [issue #117](https://github.com/JuliaIO/JLD2.jl/issues/117).
To check a file, you can use debug tooling provided by `JLD2` to view what kinds of objects are stored.
Details on the available tools are described below.

## Viewing header messages
Following the HDF5 format specification, JLD2 stores metadata and all information required
to interpret the stored data for each dataset in the form of so-called *header messages*.
Each hdf5 group, dataset, and committed datatype consist of and object header followed by a
variable number of header messages.

There exist different types of these to encode for the data type or the layout i.e. single
element or array.

These can be printed for inspection using JLD2:
```@repl headermsg
using JLD2 #hide
jldsave("test.jld2";
    a = 42,
    b = [1,2,3,4,5],
    c = (1,2),
)
f = jldopen("test.jld2")
JLD2.print_header_messages(f, "a")
```

Here we see, among other things, a
 * dataspace message which states that `"a"` is a single (scalar) element
 * datatype message
 * datalayout message of the *compact* type which means that the data is so small it was
 directly stored as part of the message.


```@repl headermsg
JLD2.print_header_messages(f, "b")
```

Important differences to `"a"` are that the dataspace now reports the dimensions of the
array as `(5,)` and the the data layout has changed to *contiguous* which means that it is
stored as a single block starting at the offset reported in `data_address`.

```@repl headermsg
JLD2.print_header_messages(f, "c")
```

For dataset `c` we see that the datatype is a *shared* datatype which is stored elsewhere
in the file and is referenced by its offset. This is, of course, also a regular hdf5 object
and we can print its header messages by supplying the offset:

```@repl headermsg
JLD2.print_header_messages(f, JLD2.RelOffset(4520))
close(f) #hide
```

This object consists of just two messages:

 * The datatype message defines the hdf5 datatype and therefore describes the byte layout
and field types.
 * The attribute message has the name `julia_type` and as payload the julia `DataType`
 signature `Tuple{Int64, Int64}` which is needed for reconstruction.

# Welcome to **JLD2.jl**

**JLD2.jl** is a high-performance, pure Julia library for saving and loading arbitrary Julia data structures. It's designed as a fast binary serialization format that produces files according to the well-known HDF5 format but doesn't rely on external libraries like the HDF5 C-library — making it an ideal choice for native Julia workflows.

---

## 📦 What is JLD2.jl?

JLD2 stands for **Julia Data Format 2**, a file format and serialization library tailored to work seamlessly with native Julia types. Whether you're working with arrays, dictionaries, structs, or custom types, JLD2 provides a reliable way to store your data to disk and retrieve it later — all in pure Julia.

---

## 🚀 Why Use JLD2?

* ✅ **Save and load any Julia type**, including custom structs
* ✅ **Fast and efficient**, thanks to native Julia code
* ✅ **Custom IO support** — can read and write to either `Vector{UInt8}` or custom IO implementations
* ✅ **Portable within Julia versions** — great for caching, prototyping, and long-term storage
* ✅ **Customizable type loading** — offers fine-grained control to update outdated stored structures upon load


---

## ✨ Example: Saving and Loading Data

```julia
using JLD2

# Some sample data
model = (name = "Transformer", layers = 12, params = 300_000_000)
scores = [0.91, 0.87, 0.93]

# Save to a file
@save "model_state.jld2" model scores

# Load back later
@load "model_state.jld2" model scores

println(model.name)  # Output: Transformer
```

You can also save individual variables or load just what you need:

```julia
@save "data.jld2" a=1 b=[1,2,3] c="hi"
@load "data.jld2" b c
```

---

## 📊 Related Serialization libraries in Julia

Below is a comparison of JLD2 and other common Julia libraries for data storage and serialization.
Choose the tool that best fits your needs:

| Library         | Best For                                         | Notes                                                                                 |
|-----------------|--------------------------------------------------|---------------------------------------------------------------------------------------|
| **JLD2.jl**        | Native Julia data (structs, arrays, Dicts, etc.) | Fast, flexible, pure Julia, HDF5-compatible, no external dependencies                 |
| **Serialization.jl** | Any Julia object         | Built-in, very fast, but not cross-version safe or portable outside Julia             |
| **MAT.jl**      | Interop with MATLAB `.mat` files                 | Read/write MATLAB files, good for sharing with MATLAB users                           |
| **HDF5.jl**     | Full-featured HDF5 access                        | Direct interface to HDF5 C library, cross-language, supports advanced HDF5 features   |
| **Arrow.jl**    | Tabular data, dataframes, analytics              | Excellent for columnar data, cross-language (Python, R, etc.), DataFrame support      |
| **CSV.jl**      | Lightweight table exports/imports                | Great for human-readable, row-based data, simple and widely supported                 |
| **JSON.jl**     | Web services, config files, nested dicts         | Portable, text-based, less efficient for complex Julia types                          |

If your goal is to store structured tables (like `DataFrame`s) for analysis or sharing between tools, **Arrow.jl** or **CSV.jl** may be a better fit. But if you're dealing with **rich, nested, Julia-native data**, or just want a fast way to persist your models, simulations, or internal state, **JLD2** is the right tool.

---

## 💬 Contributing

JLD2 is community-driven! We welcome contributions, bug reports, and suggestions at the [GitHub repository](https://github.com/JuliaIO/JLD2.jl).

If you're interested in improving documentation, fixing issues, or proposing new features, we’d love your help.

---

## 🧭 Next Steps

Use the sidebar to navigate:

* [Usage Guide](./basic_usage.md)
* [Custom serialization](./advanced.md)
* [Compression](./compression.md)
* [Advanced Tips](./advanced.md)
* [HDF5 compatibility](./hdf5compat.md)
* [Gotchas & Troubleshooting](./troubleshooting.md)

```@meta
    ShareDefaultModule=false
```

# Advanced Usage

## Loading plain types

```@repl
using JLD2 #hide
jldsave("test.jld2"; z= 1.0 + im * 2.0)
load("test.jld2", "z")
load("test.jld2", "z"; plain=true)
@__MODULE__
```


## Explicit Type Remapping

Sometimes you store data using `struct`s that you defined yourself or are
shipped with some package and weeks later, when you want to
load the data, the structs have changed.

```@example
using JLD2 #hide
struct A
    x::Int
end
jldsave("example.jld2"; a = A(42))
```

This results in warnings and sometimes even errors when trying to load the
file as demonstrated here.
```@repl
using JLD2 #hide
struct A{T}
    x::T
end
load("example.jld2")
```

The `JLDFile` struct contains a `typemap` field that allows for explicit type remapping.
You can define a struct that matches the old definition and load your data.

```@repl
using JLD2 #hide
struct A_old
    x::Int
end
f = jldopen("example.jld2","r"; typemap=Dict("Main.A" => A_old))
f["a"]
close(f)
```

## Upgrading old structures on load
The section above explains how you can make JLD2 load old structs with a different Datatype name as target.
A different method for loading old data is described here:

```@example
using JLD2 #hide
# This is the old version of the struct stored in the file
struct OldStructVersion
    x::Int
    y::Float64
end
orig = OldStructVersion(1,2.0)
jldsave("test.jld2"; data=orig)
```
```@example
using JLD2 #hide
### new session

# This is the new version of your struct
struct UpdatedStruct
    x::Float64 # no longer int
    y::Float64
    z::Float64 # = x*y
end

# When upgrading a struct, JLD2 will load the fields of the old struct into a `NamedTuple`
# and call `rconvert` on it. Here we implement a conversion method that returns an `UpdatedStruct`
JLD2.rconvert(::Type{UpdatedStruct}, nt::NamedTuple) = UpdatedStruct(Float64(nt.x), nt.y, nt.x*nt.y)

# Here we provide the `typemap` keyword argument. It is a dictionary mapping the stored struct name
# to an `Upgrade` instance with the new struct.
load("test.jld2", "data"; typemap=Dict("Main.OldStructVersion" => JLD2.Upgrade(UpdatedStruct)))
```

## Full control over type reconstruction
The recommended and more powerful option is to take full control over type mapping by
providing a custom mapping function that gets full access to all stored information
including the type parameters.
Example like above:

```julia
struct OldStruct{T}
    x::T
end

old_int = OldStruct(42)
old_float = OldStruct(3.14)
jldsave("test.jld2"; old_int, old_float, inttype=OldStruct{Int}, floattype=OldStruct{Float64}, )

struct NormalStruct{T}
    x::T
end

struct SquaredStruct{T}
    xsquared::T
end

JLD2.rconvert(::Type{SquaredStruct{T}}, nt) where T = SquaredStruct{T}(nt.x^2)

typemap = function(f::JLD2.JLDFile, typepath::String, params::Vector)
    if typepath == "Main.OldStruct"
        if params[1] == Int
            @info "Mapping an OldStruct{Int} to SquaredStruct{Int} with conversion"
            # If the type param is Int, map to squared struct
            # and wrap in `Upgrade` to trigger custom conversion with `rconvert`
            return JLD2.Upgrade(SquaredStruct{Int})
        else
            @info "Mapping an OldStruct{T} to NormalStruct{T} without conversion"
            # All other OldStructs just get updated to NormalStruct
            return NormalStruct{params...}
        end
    end
    # This typemap functino is called for every single type that is decoded.
    # All types that do not need special handling should be forwarded to the default
    # implementation.
    @info "Forwarding $typepath with parameters $params to default type mapping"
    return JLD2.default_typemap(f, typepath, params)
end

load("test.jld2"; typemap)
```

```
[ Info: Forwarding Core.Int64 with parameters Any[] to default type mapping
[ Info: Mapping an OldStruct{Int} to SquaredStruct{Int} with conversion
[ Info: Forwarding Core.Float64 with parameters Any[] to default type mapping
[ Info: Mapping an OldStruct{T} to NormalStruct{T} without conversion
[ Info: Forwarding Core.Int64 with parameters Any[] to default type mapping
[ Info: Mapping an OldStruct{Int} to SquaredStruct{Int} with conversion
[ Info: Forwarding Core.Float64 with parameters Any[] to default type mapping
[ Info: Mapping an OldStruct{T} to NormalStruct{T} without conversion
Dict{String, Any} with 4 entries:
  "inttype"   => SquaredStruct{Int64}
  "old_float" => NormalStruct{Float64}(3.14)
  "old_int"   => SquaredStruct{Int64}(1764)
  "floattype" => NormalStruct{Float64}
```


Note that the dictionary approach and the mapping function are mutually exclusive.



## Groups - Appending to files


Group objects can be constructed with two optional keyword arguments:
```julia
g = Group(file;
          est_num_entries=4
          est_link_name_len=8)
```

These determine how much (additional) empty space should be allocated for the group description. (list of entries)
This can be useful for performance when one expects to append many additional datasets after first writing the file.


## Fallback Behaviour
By default JLD2 will attempt to open files using the `MmapIO` backend. If that fails, it retries using `IOStream`.

# Compression

JLD2 supports compression of `isbits` arrays. This includes the typical `Array{Float64}`
but also arrays of custom structs that are immutable and only consist of basic number
type fields.

To enable the default compression, you can write:
```julia
using JLD2
save("example.jld2", "large_array", zeros(10000); compress = true)
```
Alternatively use
```julia
jldsave("example.jld2", true; large_array=zeros(10000))
```
or
```julia
jldopen("example.jld2", "w"; compress = true) do f
    f["large_array"] = zeros(10000)
end
```

When reading a file `JLD2` detects compression and automatically decompresses the data
so it is not necessary to pass any extra parameters for that case.
However, `JLD2` will prompt you to install and load the necessary filter packages if they are
not yet available.

## Compression Filter API

JLD2 can use a number of different compression algorithms, also called *filter*s.
These can be used individually and even chained which can be useful for some types of data.
The filter used by `compress = true` is the `Deflate()` compression filter.

!!! note
    The default `Deflate()` compression is always available but some others will need to be
    installed separately.
    `JLD2` will throw an error if the required filter package is not loaded, prompting
    you to install and load the appropriate package e.g. : `using JLD2, JLD2Lz4`.

### Installing Filter Packages

To use compression filters, you need to install and load the corresponding packages:

```julia
using Pkg
# For other compression algorithms
Pkg.add("JLD2Lz4")
using JLD2, JLD2Lz4  # Load the package you need
```

### Available Compression Filters

This compression system is analogous to that of HDF5 and uses the same underlying compression
libraries. JLD2 files with compressed datasets can in many cases be opened using HDF5 and
similarly, JLD2 will be able to read most HDF5 files even with compression.
The compression filters available for JLD2 are:

| Filter Package | Filter Type       | Notes                                                        |
|:---------------|:------------------|:-------------------------------------------------------------|
| *built in*     | `Shuffle`         | Rearrangement of bytes useful as a preprocess filter         |
| *built in*     | `Deflate`         | Default compression, very widely used, good compatibility    |
| *built in*     | `ZstdFilter`      | Fast, wide range of compression size vs speed trade-offs     |
| JLD2Bzip2      | `Bzip2Filter`     | Good compression ratio, can be slower                        |
| JLD2Lz4        | `Lz4Filter`       | Very fast compression/decompression                          |

### Using Specific Filters

To use a specific compression filter, pass an instance of the filter instead of `true`:

```julia
using JLD2, JLD2Lz4

# Using Lz4 compression
jldopen("example.jld2", "w"; compress = Lz4Filter()) do f
    f["large_array"] = zeros(10000)
end

# Zstd with non-standard compression level
jldopen("example.jld2", "w"; compress = ZstdFilter(9)) do f
    f["large_array"] = zeros(10000)
end
```


### Using Multiple Filters

JLD2 supports combining multiple filters for advanced compression strategies.
This is particularly useful when combining preprocessing filters (like shuffling) with
compression filters. Simply provide a vector of filters:

```julia
using JLD2

# Combine Shuffle preprocessing with Deflate compression
filters = [Shuffle(), Deflate()]

jldopen("example.jld2", "w"; compress = filters) do f
    # Benefits from byte shuffling
    # Only the lowest byte of each element is non-zero
    # Shuffle() reorders the bytes of all elements from e.g.
    # [123123123] to [111222333]
    # where each digit refers to the nth byte of an array element.
    f["numeric_data"] = UInt.(rand(UInt8, 10000))
end
```

!!! note
    Filters in a pipeline are applied in order during compression and in reverse
    order during decompression. Preprocessing filters (like `Shuffle`)
    should typically come before compression filters.


### Filter Configuration Examples

Different filters support various configuration options:

```julia
using JLD2, JLD2Lz4, JLD2Bzip2

# Zstd with different compression levels
zstd_fast = ZstdFilter(level=1)    # Fast compression
zstd_best = ZstdFilter(level=22)   # Best compression

# Bzip2 with custom block size
bzip2_filter = Bzip2Filter(blocksize100k=4)

# Example usage
jldopen("example.jld2", "w") do f
    write(f, "fast_data", zeros(UInt8, 10000); compress=zstd_fast)
    write(f, "small_data", randn(10000); compress=zstd_best)
    write(f, "archive_data", randn(1000); compress=bzip2_filter)
end
```

Depending on the characteristics of your datasets, some configurations may be more efficient
than others.

### Manually selecting compression for datasets

Sometimes you may know that some of your arrays are easily compressible and
that for others it is not worth the effort. For precise control, the
`write` function takes an optional keyword argument to override the file compression
settings.

```julia
using JLD2

jldopen("example.jld2", "w"; compress=ZstdFilter()) do f
    # This gets compressed with the ZstdFilter
    write(f, "default_array", zeros(10000))

    # Don't compress this
    write(f, "random_array", rand(10000); compress=false)

    # Override the above compression filter and use a different one
    write(f, "zlib_array", zeros(10000); compress=Deflate())

    # Alternatively, use the same filter but with different configuration
    write(f, "fast_compressed", rand(10000); compress=ZstdFilter(level= -20))
end
```

### Compatibility and Migration from v0.5 to v0.6

- **File Compatibility**: Files created with the old API can be read with the new system.
  Files created with the v0.6 filter API may not be able to read by older versions of JLD2, see the compatibility table below for more information.
- **Performance**: Compression performance and file sizes remain the same as the
  underlying compression libraries are unchanged.
- **HDF5 Compatibility**: The new API is analogous to HDF5.jl, making it easier to
  work with HDF5 files and improving interoperability.

#### Filter Compatibility Table

The following table shows which JLD2 versions can decode data compressed using different filter features:

| Filter feature | JLD2 versions able to decode |
|:------------|:---------------|
| `Deflate` | Since 0.2.0|
| `Bzip2Filter` | Since 0.4.4|
| `ZstdFilter` | Since 0.4.49|
| `Shuffle` | Since 0.6.0 |
| `Lz4Filter` | Since 0.6.0 |
| multiple filters | Since 0.6.0 |

**Notes:**
- Data compressed with `LZ4FrameCompressor` in previous versions
can be read if `JLD2Lz4` is loaded.
Data compressed with `Lz4Filter` cannot be read by JLD2 versions before 0.6.0.

For code migration, the main change is in how you specify compression filters:

```julia
# Old API
# using JLD2, CodecZlib
# jldopen("file.jld2", "w"; compress = ZlibCompressor()) do f

# New API
using JLD2
jldopen("file.jld2", "w"; compress = Deflate()) do f
    # ...
end
```

The simplest usage option of `compress=true` still works as before.


### API Docstrings

```@docs
JLD2.Filters
JLD2.Filters.Deflate
JLD2.Filters.Shuffle
JLD2.Filters.ZstdFilter
```

# Internals & Design

## File Interface
The JLDFile object mimics the API of `Base.Dict` as much as it can.
In particular, `keys`, `length`, `haskey`, `isempty`, `get`, `get!` should work as expected.



```@autodocs
Modules = [JLD2]
```

## Basic usages: reading and writing data
JLD2 provides a few different options to save and load data:

 - [FileIO interface](@ref)
 - [Single object storage](@ref)
 - [File handles](@ref)
 - [UnPack Extension](@ref)

### FileIO interface
The `save` and `load` functions, provided by [FileIO](https://github.com/JuliaIO/FileIO.jl), are one of the simplest ways to use `JLD2`.
The `save` function accepts an `AbstractDict` yielding the key/value pairs, where the key is a string representing the name of the dataset and the value represents its contents:

```@repl
using JLD2
save("example.jld2", Dict("hello" => "world", "foo" => :bar))
```

The `save` function can also accept the dataset names and contents as arguments:

```@repl
using JLD2
save("example.jld2", "hello", "world", "foo", :bar)
```

For `save` and `load` to automatically detect that you want to save a JLD2 file use the file suffix `".jld2"`.

If called with a filename argument only, the `load` function loads all datasets from the given file into a `Dict`:

```@repl
using JLD2
load("example.jld2")
```

When called with a single dataset name, `load` returns the contents of that dataset from the file:

```@repl
using JLD2
load("example.jld2", "hello")
```

When called with multiple dataset names, `load` returns the contents of the given datasets as a tuple:

```@repl
using JLD2
load("example.jld2", "foo", "hello")
```

### jldsave

`jldsave` makes use of julia's keyword argument syntax to store files.
This can be useful, when your data variables already have the correct name, e.g. use
`jldsave(file; variablename)` instead of `save(file, "variablename", variablename)

```@docs
jldsave
```

### Single object storage
If only a single object needs to stored and loaded from a file, one can use
`save_object` and `load_object` functions.

```@docs
save_object
load_object
```

### File handles

It is also possible to interact with JLD2 files using a file-like interface. The `jldopen` function accepts a file name and an argument specifying how the file should be opened:

```@docs
jldopen
```

Data can be written to the file using `write(f, "name", data)` or `f["name"] = data`, or read from the file using `read(f, "name")` or `f["name"]`. When you are done with the file, remember to call `close(f)`.

Like `open`, `jldopen` also accepts a function as the first argument, permitting `do`-block syntax:

```@example
using JLD2
jldopen("example.jld2", "w") do f
    write(f, "variant1", 1.0)
    f["variant2"] = (rand(5), rand(Bool, 3))
end

f = jldopen("example.jld2")
v1 = read(f, "variant1")
v2 = f["variant2"]
close(f)
v1, v2
```

#### Groups
JLD2 files allow for nesting datasets into groups which may be useful for organizing your data.
You may construct groups explicitly:
```@example
using JLD2
jldopen("example.jld2", "w") do file
    mygroup = JLD2.Group(file, "mygroup")
    mygroup["mystuff"] = 42
    display(file)
end
```

or implicitly, by saving a variable with a name containing slashes as path delimiters:
```@example
using JLD2
save("example.jld2", "mygroup/mystuff", 42)
```

Similarly, you can access groups directly:

```@example
using JLD2
jldopen("example.jld2") do file
    file["mygroup"]["mystuff"]
end
```

or using slashes as path delimiters:

```@example
using JLD2
load("example.jld2", "mygroup/mystuff")
```

When loading files with nested groups these will be unrolled into paths by default but
yield nested dictionaries but with the `nested` keyword argument.
```@repl
using JLD2
load("example.jld2")
load("example.jld2"; nested=true)
```

### UnPack Extension

When additionally loading the [UnPack.jl](https://github.com/mauro3/UnPack.jl) package, its `@unpack` and `@pack!` macros can be used to quickly save and load data from the file-like interface. Example:

```@example
using JLD2, UnPack
file = jldopen("example.jld2", "w")
x, y = rand(2)

@pack! file = x, y # equivalent to file["x"] = x; file["y"] = y
@unpack x, y = file # equivalent to x = file["x"]; y = file["y"]
close(file)
```

# Legacy

This page lists features of JLD2 that are kept for legacy purposes.
In particular, the following sections describes the `@load` and `@save` macros.
They have been the default for many users but they unnecessarily introduce
new macro-based syntax. Over time a range of issues have been opened by
new users struggling with them. Since their inception, the Julia language
has improved significantly and macros may no longer be necessary in this case.


### `@save` and `@load` macros

The `@save` and `@load` macros are the simplest way to interact with a JLD2 file. The `@save` macro writes one or more variables from the current scope to the JLD2 file. For example:

```julia
using JLD2
hello = "world"
foo = :bar
@save "example.jld2" hello foo
```

This writes the variables `hello` and `foo` to datasets in a new JLD2 file named `example.jld2`. The `@load` macro loads variables out of a JLD2 file:

```julia
@load "example.jld2" hello foo
```

This assigns the contents of the `hello` and `foo` datasets to variables of the same name in the current scope.

It is best practice to explicitly name the variables to be loaded and saved from a file, so that it is clear from whence these variables arise. However, for convenience, JLD2 also provides variants of `@load` and `@save` that do not require variables to be named explicitly. When called with no variable arguments, `@save <filename>` writes all variables in the global scope of the current module to file `<filename>`, while `@load <filename>` loads all variables in file `<filename>`. When called with no variable arguments, `@load` requires that the file name is provided as a string literal, i.e., it is not possible to select the file at runtime.

Additional customization is possible using assignment syntax and option passing:

```julia
@save "example.jld2" bye=hello bar=foo
@save "example.jld2" {compress=true} hello bar=foo
```

```@docs
@save
@load
```

# HDF5 Compatibility

JLD2 is built upon the [HDF5 Format Specification](https://support.hdfgroup.org/HDF5/doc/H5.format.html) and produces files that are compatible with the official [HDF5](https://www.hdfgroup.org/solutions/hdf5) C library.

This has the advantage that other libraries that use HDF5 such as the Julia
wrapper [`HDF5.jl`](https://github.com/JuliaIO/HDF5.jl) or 
even with [`h5py`](https://www.h5py.org/) using Python. In addition to that, adhering
to the HDF5 standards allows you to use the file introspection tools 
such as `h5dump` and `h5debug` provided by the HDF5 group.

!!! warning

    General compatibility only holds for a list of basic types:

    - Numbers `FloatXX`, `IntXX` and `UIntXX`

    - Bools

    - Strings

    - Arrays of those types

    Other structures can in principle also be decoded but may involve work.
    See below for more information
    

## Understanding how Julia `struct`s are encoded

The HDF5 standard supports so-called `compound datatypes` that comprise of a set of 
already known datatypes. This is very similar to julia's `struct`s. 
When a user wants to write a non-default type to disk then JLD2
will create the corresponding compound datatypes and _commit_ them to the
file. All custom type definitions in a JLD2 file will be stored 
in a `_types/` group.
This way, the type definitions only needs to be written to the file
once and all instances of that `struct` reference it.

#### Example

```julia
using JLD2

struct MyCustomStruct
    x::Int64
    y::Float64
end

@save "test.jld2" a=MyCustomStruct(42, π)
```
Let's see what JLD2 makes out of my simple `MyCustomStruct`. To do that
we view the output of `h5dump`

```bash
$ h5dump test.jld2
HDF5 "test.jld2" {
GROUP "/" {
   GROUP "_types" {
      DATATYPE "00000001" H5T_COMPOUND {
         H5T_STRING {
            STRSIZE H5T_VARIABLE;
            STRPAD H5T_STR_NULLPAD;
            CSET H5T_CSET_UTF8;
            CTYPE H5T_C_S1;
         } "name";
         H5T_VLEN { H5T_REFERENCE { H5T_STD_REF_OBJECT }} "parameters";
      }
         ATTRIBUTE "julia_type" {
            DATATYPE  "/_types/00000001"
            DATASPACE  SCALAR
            DATA {
            (0): {
                  "Core.DataType",
                  ()
               }
            }
         }
      DATATYPE "00000002" H5T_COMPOUND {
         H5T_STD_I64LE "x";
         H5T_IEEE_F64LE "y";
      }
         ATTRIBUTE "julia_type" {
            DATATYPE  "/_types/00000001"
            DATASPACE  SCALAR
            DATA {
            (0): {
                  "Main.MyCustomStruct",
                  ()
               }
            }
         }
   }
   DATASET "a" {
      DATATYPE  "/_types/00000002"
      DATASPACE  SCALAR
      DATA {
      (0): {
            42,
            3.14159
         }
      }
   }
}
}
```

We can see that the file contains two things at top-level. There is a dataset `"a"`
(that is what we wanted to store) and there is a group `_types` which is where
all the necessary type information is stored.

You can see that JLD2 _committed_ two compound datatypes. The first one is `Core.Datatype`
which at first seems rather unintuitive. It is needed to tell HDF5 what a serialized 
julia datatype looks like (a name and a list of parameters).

Below that is the definition of `MyCustomStruct` with two fields 
`H5T_STD_I64LE "x"` and `H5T_IEEE_F64LE "y"` defining the integer field `x` and
the float field `y`.

## A note on pointers

In the julia programming language pointers `Ptr` are not needed very often. However,
when binary dependencies come into play and memory is passed back and forth,
pointers do become relevant. Pointers are addresses to locations in memory and
thus lose their meaning after a program has terminated.

In principle, there is little point in storing a pointer to a file but
in order to allow for a more seamless experience JLD2 will, similar to `Base.Serialization`
silently accept pointers. This is useful when storing large structures such as
a `DifferentialEquations.jl` solution object that might contain a pointer somewhere.
Upon deserialization any pointer fields are instantiated as null pointers.

This is done with just three lines of code utilizing the custom serialization logic and 
it is shown here as it serves as a good example for usage of that feature.

```julia
writeas(::Type{<:Ptr}) = Nothing
rconvert(::Type{Ptr{T}}, ::Nothing) where {T} = Ptr{T}()
```

Usually one would also have to define a method for `wconvert`. However, in this 
case JLD2 figures out that no explicit conversion is needed to construct `nothing`.

# Custom Serialization

JLD2 makes it easy to define custom serialization for your own types. To do this, define a new type (e.g. `ASerialization`) that contains the fields you want to store, and then tell JLD2 how to convert between your type and the serialization type.

For example:

```julia
struct A
    x::Int
end

struct ASerialization
    x::Vector{Int}
end

JLD2.writeas(::Type{A}) = ASerialization
Base.convert(::Type{ASerialization}, a::A) = ASerialization([a.x])
Base.convert(::Type{A}, a::ASerialization) = A(only(a.x))
```

JLD2 will automatically use these conversions when saving and loading objects of type `A`.

!!! warning "Already defined custom serialization"
    Some Julia built-in types already use custom serialization, and JLD2 cannot nest these. To avoid unexpected behavior, always define a wrapper type for your serialization (as in the example above, where `ASerialization` is used instead of a plain `Vector{Int}`). In particular, avoid using built-in types like `<: AbstractDict` or `<: Array` directly as your serialization type.

If you prefer not to overload `Base.convert`, you can instead define the following methods:

```julia
JLD2.wconvert(::Type{ASerialization}, a::A) = ASerialization([a.x])
JLD2.rconvert(::Type{A}, a::ASerialization) = A(only(a.x))
```

This approach is especially useful if you do not own the type you want to serialize, or want to avoid extending `Base`.

Here's another example:

```julia
struct B
    x::Float64
end

JLD2.writeas(::Type{B}) = Float64
JLD2.wconvert(::Type{Float64}, b::B) = b.x
JLD2.rconvert(::Type{B}, x::Float64) = B(x)

arr = [B(rand()) for i in 1:10]

@save "test.jld2" arr
```

In this example, JLD2 converts the array of `B` structs to a plain `Vector{Float64}` before storing it to disk.
